library Example;

{$mode objfpc}{$H+}

uses
	JassAPI, jass_common_j;

{$R *.res}

function RawCode(Chars: String): Integer;
begin
	Result:= SwapEndian(PInteger(@Chars[1])^);
end;

function Action: Dword; stdcall;
var
	Target: HUNIT;
	x, y: Single;
	BloodEffect, BlowEffect, StompEffect: String;
begin
	if GetSpellAbilityId() <> RawCode('A000') then exit(0);

	Target:= GetSpellTargetUnit();
	x:= GetUnitX(Target);
	y:= GetUnitY(Target);

	SetUnitExploded(Target, True);
	KillUnit(Target);

	StompEffect:= GetAbilityEffectById(RawCode('Arng'), EFFECT_TYPE_CASTER, 0);
	BloodEffect:= GetAbilityEffectById(RawCode('Arng'), EFFECT_TYPE_SPECIAL, 0);
	BlowEffect:= GetAbilityEffectById(RawCode('Arng'), EFFECT_TYPE_TARGET, 0);

	DestroyEffect(AddSpecialEffect(StompEffect, x, y));
	DestroyEffect(AddSpecialEffect(BloodEffect, x, y));
	DestroyEffect(AddSpecialEffect(BlowEffect, x, y));

	Result:= 0;
end;

procedure CreateMeat;
var
	i: Integer;
begin
	for i:= 1 to 10 do begin
		CreateUnit(Player(i), RawCode('hpea'), 300, 300, 0);
	end;
end;

procedure InitSpell;
var
	Trigger: HTRIGGER;
begin
	Trigger:= CreateTrigger();
	TriggerAddAction(Trigger, @Action);
	TriggerRegisterPlayerUnitEvent(Trigger, Player(0), EVENT_PLAYER_UNIT_SPELL_EFFECT, 0);
end;

procedure CreateAngryWorker;
var
	Worker: HUNIT;
begin
	Worker:= CreateUnit(Player(0), RawCode('h000'), 0, 0, 0);

	if GetLocalPlayer() = Player(0) then begin
		SelectUnit(Worker, True);
		SetCameraPosition(GetUnitX(Worker), GetUnitY(Worker));
	end;
end;

begin
	InitSpell;
	CreateAngryWorker;
	CreateMeat;
end.

