unit jass_common_j;

interface

uses
	JassAPI;

type
	TJassCallback = function: Dword; stdcall;
	HAGENT = TJassObjectHandle;
	HEVENT = HAGENT;
	HPLAYER = HAGENT;
	HWIDGET = HAGENT;
	HUNIT = HWIDGET;
	HDESTRUCTABLE = HWIDGET;
	HITEM = HWIDGET;
	HABILITY = HAGENT;
	HBUFF = HABILITY;
	HFORCE = HAGENT;
	HGROUP = HAGENT;
	HTRIGGER = HAGENT;
	HTRIGGERCONDITION = HAGENT;
	HTRIGGERACTION = TJassObjectHandle;
	HTIMER = HAGENT;
	HLOCATION = HAGENT;
	HREGION = HAGENT;
	HRECT = HAGENT;
	HBOOLEXPR = HAGENT;
	HSOUND = HAGENT;
	HCONDITIONFUNC = HBOOLEXPR;
	HFILTERFUNC = HBOOLEXPR;
	HUNITPOOL = TJassObjectHandle;
	HITEMPOOL = TJassObjectHandle;
	HRACE = TJassObjectHandle;
	HALLIANCETYPE = TJassObjectHandle;
	HRACEPREFERENCE = TJassObjectHandle;
	HGAMESTATE = TJassObjectHandle;
	HIGAMESTATE = HGAMESTATE;
	HFGAMESTATE = HGAMESTATE;
	HPLAYERSTATE = TJassObjectHandle;
	HPLAYERSCORE = TJassObjectHandle;
	HPLAYERGAMERESULT = TJassObjectHandle;
	HUNITSTATE = TJassObjectHandle;
	HAIDIFFICULTY = TJassObjectHandle;
	HEVENTID = TJassObjectHandle;
	HGAMEEVENT = HEVENTID;
	HPLAYEREVENT = HEVENTID;
	HPLAYERUNITEVENT = HEVENTID;
	HUNITEVENT = HEVENTID;
	HLIMITOP = HEVENTID;
	HWIDGETEVENT = HEVENTID;
	HDIALOGEVENT = HEVENTID;
	HUNITTYPE = TJassObjectHandle;
	HGAMESPEED = TJassObjectHandle;
	HGAMEDIFFICULTY = TJassObjectHandle;
	HGAMETYPE = TJassObjectHandle;
	HMAPFLAG = TJassObjectHandle;
	HMAPVISIBILITY = TJassObjectHandle;
	HMAPSETTING = TJassObjectHandle;
	HMAPDENSITY = TJassObjectHandle;
	HMAPCONTROL = TJassObjectHandle;
	HPLAYERSLOTSTATE = TJassObjectHandle;
	HVOLUMEGROUP = TJassObjectHandle;
	HCAMERAFIELD = TJassObjectHandle;
	HCAMERASETUP = TJassObjectHandle;
	HPLAYERCOLOR = TJassObjectHandle;
	HPLACEMENT = TJassObjectHandle;
	HSTARTLOCPRIO = TJassObjectHandle;
	HRARITYCONTROL = TJassObjectHandle;
	HBLENDMODE = TJassObjectHandle;
	HTEXMAPFLAGS = TJassObjectHandle;
	HEFFECT = HAGENT;
	HEFFECTTYPE = TJassObjectHandle;
	HWEATHEREFFECT = TJassObjectHandle;
	HTERRAINDEFORMATION = TJassObjectHandle;
	HFOGSTATE = TJassObjectHandle;
	HFOGMODIFIER = HAGENT;
	HDIALOG = HAGENT;
	HBUTTON = HAGENT;
	HQUEST = HAGENT;
	HQUESTITEM = HAGENT;
	HDEFEATCONDITION = HAGENT;
	HTIMERDIALOG = HAGENT;
	HLEADERBOARD = HAGENT;
	HMULTIBOARD = HAGENT;
	HMULTIBOARDITEM = HAGENT;
	HTRACKABLE = HAGENT;
	HGAMECACHE = HAGENT;
	HVERSION = TJassObjectHandle;
	HITEMTYPE = TJassObjectHandle;
	HTEXTTAG = TJassObjectHandle;
	HATTACKTYPE = TJassObjectHandle;
	HDAMAGETYPE = TJassObjectHandle;
	HWEAPONTYPE = TJassObjectHandle;
	HSOUNDTYPE = TJassObjectHandle;
	HLIGHTNING = TJassObjectHandle;
	HPATHINGTYPE = TJassObjectHandle;
	HIMAGE = TJassObjectHandle;
	HUBERSPLAT = TJassObjectHandle;
	HHASHTABLE = HAGENT;

var
	FALSE_: Boolean;
	TRUE_: Boolean;
	JASS_MAX_ARRAY_SIZE: Integer;
	PLAYER_NEUTRAL_PASSIVE: Integer;
	PLAYER_NEUTRAL_AGGRESSIVE: Integer;
	PLAYER_COLOR_RED: HPLAYERCOLOR;
	PLAYER_COLOR_BLUE: HPLAYERCOLOR;
	PLAYER_COLOR_CYAN: HPLAYERCOLOR;
	PLAYER_COLOR_PURPLE: HPLAYERCOLOR;
	PLAYER_COLOR_YELLOW: HPLAYERCOLOR;
	PLAYER_COLOR_ORANGE: HPLAYERCOLOR;
	PLAYER_COLOR_GREEN: HPLAYERCOLOR;
	PLAYER_COLOR_PINK: HPLAYERCOLOR;
	PLAYER_COLOR_LIGHT_GRAY: HPLAYERCOLOR;
	PLAYER_COLOR_LIGHT_BLUE: HPLAYERCOLOR;
	PLAYER_COLOR_AQUA: HPLAYERCOLOR;
	PLAYER_COLOR_BROWN: HPLAYERCOLOR;
	RACE_HUMAN: HRACE;
	RACE_ORC: HRACE;
	RACE_UNDEAD: HRACE;
	RACE_NIGHTELF: HRACE;
	RACE_DEMON: HRACE;
	RACE_OTHER: HRACE;
	PLAYER_GAME_RESULT_VICTORY: HPLAYERGAMERESULT;
	PLAYER_GAME_RESULT_DEFEAT: HPLAYERGAMERESULT;
	PLAYER_GAME_RESULT_TIE: HPLAYERGAMERESULT;
	PLAYER_GAME_RESULT_NEUTRAL: HPLAYERGAMERESULT;
	ALLIANCE_PASSIVE: HALLIANCETYPE;
	ALLIANCE_HELP_REQUEST: HALLIANCETYPE;
	ALLIANCE_HELP_RESPONSE: HALLIANCETYPE;
	ALLIANCE_SHARED_XP: HALLIANCETYPE;
	ALLIANCE_SHARED_SPELLS: HALLIANCETYPE;
	ALLIANCE_SHARED_VISION: HALLIANCETYPE;
	ALLIANCE_SHARED_CONTROL: HALLIANCETYPE;
	ALLIANCE_SHARED_ADVANCED_CONTROL: HALLIANCETYPE;
	ALLIANCE_RESCUABLE: HALLIANCETYPE;
	ALLIANCE_SHARED_VISION_FORCED: HALLIANCETYPE;
	VERSION_REIGN_OF_CHAOS: HVERSION;
	VERSION_FROZEN_THRONE: HVERSION;
	ATTACK_TYPE_NORMAL: HATTACKTYPE;
	ATTACK_TYPE_MELEE: HATTACKTYPE;
	ATTACK_TYPE_PIERCE: HATTACKTYPE;
	ATTACK_TYPE_SIEGE: HATTACKTYPE;
	ATTACK_TYPE_MAGIC: HATTACKTYPE;
	ATTACK_TYPE_CHAOS: HATTACKTYPE;
	ATTACK_TYPE_HERO: HATTACKTYPE;
	DAMAGE_TYPE_UNKNOWN: HDAMAGETYPE;
	DAMAGE_TYPE_NORMAL: HDAMAGETYPE;
	DAMAGE_TYPE_ENHANCED: HDAMAGETYPE;
	DAMAGE_TYPE_FIRE: HDAMAGETYPE;
	DAMAGE_TYPE_COLD: HDAMAGETYPE;
	DAMAGE_TYPE_LIGHTNING: HDAMAGETYPE;
	DAMAGE_TYPE_POISON: HDAMAGETYPE;
	DAMAGE_TYPE_DISEASE: HDAMAGETYPE;
	DAMAGE_TYPE_DIVINE: HDAMAGETYPE;
	DAMAGE_TYPE_MAGIC: HDAMAGETYPE;
	DAMAGE_TYPE_SONIC: HDAMAGETYPE;
	DAMAGE_TYPE_ACID: HDAMAGETYPE;
	DAMAGE_TYPE_FORCE: HDAMAGETYPE;
	DAMAGE_TYPE_DEATH: HDAMAGETYPE;
	DAMAGE_TYPE_MIND: HDAMAGETYPE;
	DAMAGE_TYPE_PLANT: HDAMAGETYPE;
	DAMAGE_TYPE_DEFENSIVE: HDAMAGETYPE;
	DAMAGE_TYPE_DEMOLITION: HDAMAGETYPE;
	DAMAGE_TYPE_SLOW_POISON: HDAMAGETYPE;
	DAMAGE_TYPE_SPIRIT_LINK: HDAMAGETYPE;
	DAMAGE_TYPE_SHADOW_STRIKE: HDAMAGETYPE;
	DAMAGE_TYPE_UNIVERSAL: HDAMAGETYPE;
	WEAPON_TYPE_WHOKNOWS: HWEAPONTYPE;
	WEAPON_TYPE_METAL_LIGHT_CHOP: HWEAPONTYPE;
	WEAPON_TYPE_METAL_MEDIUM_CHOP: HWEAPONTYPE;
	WEAPON_TYPE_METAL_HEAVY_CHOP: HWEAPONTYPE;
	WEAPON_TYPE_METAL_LIGHT_SLICE: HWEAPONTYPE;
	WEAPON_TYPE_METAL_MEDIUM_SLICE: HWEAPONTYPE;
	WEAPON_TYPE_METAL_HEAVY_SLICE: HWEAPONTYPE;
	WEAPON_TYPE_METAL_MEDIUM_BASH: HWEAPONTYPE;
	WEAPON_TYPE_METAL_HEAVY_BASH: HWEAPONTYPE;
	WEAPON_TYPE_METAL_MEDIUM_STAB: HWEAPONTYPE;
	WEAPON_TYPE_METAL_HEAVY_STAB: HWEAPONTYPE;
	WEAPON_TYPE_WOOD_LIGHT_SLICE: HWEAPONTYPE;
	WEAPON_TYPE_WOOD_MEDIUM_SLICE: HWEAPONTYPE;
	WEAPON_TYPE_WOOD_HEAVY_SLICE: HWEAPONTYPE;
	WEAPON_TYPE_WOOD_LIGHT_BASH: HWEAPONTYPE;
	WEAPON_TYPE_WOOD_MEDIUM_BASH: HWEAPONTYPE;
	WEAPON_TYPE_WOOD_HEAVY_BASH: HWEAPONTYPE;
	WEAPON_TYPE_WOOD_LIGHT_STAB: HWEAPONTYPE;
	WEAPON_TYPE_WOOD_MEDIUM_STAB: HWEAPONTYPE;
	WEAPON_TYPE_CLAW_LIGHT_SLICE: HWEAPONTYPE;
	WEAPON_TYPE_CLAW_MEDIUM_SLICE: HWEAPONTYPE;
	WEAPON_TYPE_CLAW_HEAVY_SLICE: HWEAPONTYPE;
	WEAPON_TYPE_AXE_MEDIUM_CHOP: HWEAPONTYPE;
	WEAPON_TYPE_ROCK_HEAVY_BASH: HWEAPONTYPE;
	PATHING_TYPE_ANY: HPATHINGTYPE;
	PATHING_TYPE_WALKABILITY: HPATHINGTYPE;
	PATHING_TYPE_FLYABILITY: HPATHINGTYPE;
	PATHING_TYPE_BUILDABILITY: HPATHINGTYPE;
	PATHING_TYPE_PEONHARVESTPATHING: HPATHINGTYPE;
	PATHING_TYPE_BLIGHTPATHING: HPATHINGTYPE;
	PATHING_TYPE_FLOATABILITY: HPATHINGTYPE;
	PATHING_TYPE_AMPHIBIOUSPATHING: HPATHINGTYPE;
	RACE_PREF_HUMAN: HRACEPREFERENCE;
	RACE_PREF_ORC: HRACEPREFERENCE;
	RACE_PREF_NIGHTELF: HRACEPREFERENCE;
	RACE_PREF_UNDEAD: HRACEPREFERENCE;
	RACE_PREF_DEMON: HRACEPREFERENCE;
	RACE_PREF_RANDOM: HRACEPREFERENCE;
	RACE_PREF_USER_SELECTABLE: HRACEPREFERENCE;
	MAP_CONTROL_USER: HMAPCONTROL;
	MAP_CONTROL_COMPUTER: HMAPCONTROL;
	MAP_CONTROL_RESCUABLE: HMAPCONTROL;
	MAP_CONTROL_NEUTRAL: HMAPCONTROL;
	MAP_CONTROL_CREEP: HMAPCONTROL;
	MAP_CONTROL_NONE: HMAPCONTROL;
	GAME_TYPE_MELEE: HGAMETYPE;
	GAME_TYPE_FFA: HGAMETYPE;
	GAME_TYPE_USE_MAP_SETTINGS: HGAMETYPE;
	GAME_TYPE_BLIZ: HGAMETYPE;
	GAME_TYPE_ONE_ON_ONE: HGAMETYPE;
	GAME_TYPE_TWO_TEAM_PLAY: HGAMETYPE;
	GAME_TYPE_THREE_TEAM_PLAY: HGAMETYPE;
	GAME_TYPE_FOUR_TEAM_PLAY: HGAMETYPE;
	MAP_FOG_HIDE_TERRAIN: HMAPFLAG;
	MAP_FOG_MAP_EXPLORED: HMAPFLAG;
	MAP_FOG_ALWAYS_VISIBLE: HMAPFLAG;
	MAP_USE_HANDICAPS: HMAPFLAG;
	MAP_OBSERVERS: HMAPFLAG;
	MAP_OBSERVERS_ON_DEATH: HMAPFLAG;
	MAP_FIXED_COLORS: HMAPFLAG;
	MAP_LOCK_RESOURCE_TRADING: HMAPFLAG;
	MAP_RESOURCE_TRADING_ALLIES_ONLY: HMAPFLAG;
	MAP_LOCK_ALLIANCE_CHANGES: HMAPFLAG;
	MAP_ALLIANCE_CHANGES_HIDDEN: HMAPFLAG;
	MAP_CHEATS: HMAPFLAG;
	MAP_CHEATS_HIDDEN: HMAPFLAG;
	MAP_LOCK_SPEED: HMAPFLAG;
	MAP_LOCK_RANDOM_SEED: HMAPFLAG;
	MAP_SHARED_ADVANCED_CONTROL: HMAPFLAG;
	MAP_RANDOM_HERO: HMAPFLAG;
	MAP_RANDOM_RACES: HMAPFLAG;
	MAP_RELOADED: HMAPFLAG;
	MAP_PLACEMENT_RANDOM: HPLACEMENT;
	MAP_PLACEMENT_FIXED: HPLACEMENT;
	MAP_PLACEMENT_USE_MAP_SETTINGS: HPLACEMENT;
	MAP_PLACEMENT_TEAMS_TOGETHER: HPLACEMENT;
	MAP_LOC_PRIO_LOW: HSTARTLOCPRIO;
	MAP_LOC_PRIO_HIGH: HSTARTLOCPRIO;
	MAP_LOC_PRIO_NOT: HSTARTLOCPRIO;
	MAP_DENSITY_NONE: HMAPDENSITY;
	MAP_DENSITY_LIGHT: HMAPDENSITY;
	MAP_DENSITY_MEDIUM: HMAPDENSITY;
	MAP_DENSITY_HEAVY: HMAPDENSITY;
	MAP_DIFFICULTY_EASY: HGAMEDIFFICULTY;
	MAP_DIFFICULTY_NORMAL: HGAMEDIFFICULTY;
	MAP_DIFFICULTY_HARD: HGAMEDIFFICULTY;
	MAP_DIFFICULTY_INSANE: HGAMEDIFFICULTY;
	MAP_SPEED_SLOWEST: HGAMESPEED;
	MAP_SPEED_SLOW: HGAMESPEED;
	MAP_SPEED_NORMAL: HGAMESPEED;
	MAP_SPEED_FAST: HGAMESPEED;
	MAP_SPEED_FASTEST: HGAMESPEED;
	PLAYER_SLOT_STATE_EMPTY: HPLAYERSLOTSTATE;
	PLAYER_SLOT_STATE_PLAYING: HPLAYERSLOTSTATE;
	PLAYER_SLOT_STATE_LEFT: HPLAYERSLOTSTATE;
	SOUND_VOLUMEGROUP_UNITMOVEMENT: HVOLUMEGROUP;
	SOUND_VOLUMEGROUP_UNITSOUNDS: HVOLUMEGROUP;
	SOUND_VOLUMEGROUP_COMBAT: HVOLUMEGROUP;
	SOUND_VOLUMEGROUP_SPELLS: HVOLUMEGROUP;
	SOUND_VOLUMEGROUP_UI: HVOLUMEGROUP;
	SOUND_VOLUMEGROUP_MUSIC: HVOLUMEGROUP;
	SOUND_VOLUMEGROUP_AMBIENTSOUNDS: HVOLUMEGROUP;
	SOUND_VOLUMEGROUP_FIRE: HVOLUMEGROUP;
	GAME_STATE_DIVINE_INTERVENTION: HIGAMESTATE;
	GAME_STATE_DISCONNECTED: HIGAMESTATE;
	GAME_STATE_TIME_OF_DAY: HFGAMESTATE;
	PLAYER_STATE_GAME_RESULT: HPLAYERSTATE;
	PLAYER_STATE_RESOURCE_GOLD: HPLAYERSTATE;
	PLAYER_STATE_RESOURCE_LUMBER: HPLAYERSTATE;
	PLAYER_STATE_RESOURCE_HERO_TOKENS: HPLAYERSTATE;
	PLAYER_STATE_RESOURCE_FOOD_CAP: HPLAYERSTATE;
	PLAYER_STATE_RESOURCE_FOOD_USED: HPLAYERSTATE;
	PLAYER_STATE_FOOD_CAP_CEILING: HPLAYERSTATE;
	PLAYER_STATE_GIVES_BOUNTY: HPLAYERSTATE;
	PLAYER_STATE_ALLIED_VICTORY: HPLAYERSTATE;
	PLAYER_STATE_PLACED: HPLAYERSTATE;
	PLAYER_STATE_OBSERVER_ON_DEATH: HPLAYERSTATE;
	PLAYER_STATE_OBSERVER: HPLAYERSTATE;
	PLAYER_STATE_UNFOLLOWABLE: HPLAYERSTATE;
	PLAYER_STATE_GOLD_UPKEEP_RATE: HPLAYERSTATE;
	PLAYER_STATE_LUMBER_UPKEEP_RATE: HPLAYERSTATE;
	PLAYER_STATE_GOLD_GATHERED: HPLAYERSTATE;
	PLAYER_STATE_LUMBER_GATHERED: HPLAYERSTATE;
	PLAYER_STATE_NO_CREEP_SLEEP: HPLAYERSTATE;
	UNIT_STATE_LIFE: HUNITSTATE;
	UNIT_STATE_MAX_LIFE: HUNITSTATE;
	UNIT_STATE_MANA: HUNITSTATE;
	UNIT_STATE_MAX_MANA: HUNITSTATE;
	AI_DIFFICULTY_NEWBIE: HAIDIFFICULTY;
	AI_DIFFICULTY_NORMAL: HAIDIFFICULTY;
	AI_DIFFICULTY_INSANE: HAIDIFFICULTY;
	PLAYER_SCORE_UNITS_TRAINED: HPLAYERSCORE;
	PLAYER_SCORE_UNITS_KILLED: HPLAYERSCORE;
	PLAYER_SCORE_STRUCT_BUILT: HPLAYERSCORE;
	PLAYER_SCORE_STRUCT_RAZED: HPLAYERSCORE;
	PLAYER_SCORE_TECH_PERCENT: HPLAYERSCORE;
	PLAYER_SCORE_FOOD_MAXPROD: HPLAYERSCORE;
	PLAYER_SCORE_FOOD_MAXUSED: HPLAYERSCORE;
	PLAYER_SCORE_HEROES_KILLED: HPLAYERSCORE;
	PLAYER_SCORE_ITEMS_GAINED: HPLAYERSCORE;
	PLAYER_SCORE_MERCS_HIRED: HPLAYERSCORE;
	PLAYER_SCORE_GOLD_MINED_TOTAL: HPLAYERSCORE;
	PLAYER_SCORE_GOLD_MINED_UPKEEP: HPLAYERSCORE;
	PLAYER_SCORE_GOLD_LOST_UPKEEP: HPLAYERSCORE;
	PLAYER_SCORE_GOLD_LOST_TAX: HPLAYERSCORE;
	PLAYER_SCORE_GOLD_GIVEN: HPLAYERSCORE;
	PLAYER_SCORE_GOLD_RECEIVED: HPLAYERSCORE;
	PLAYER_SCORE_LUMBER_TOTAL: HPLAYERSCORE;
	PLAYER_SCORE_LUMBER_LOST_UPKEEP: HPLAYERSCORE;
	PLAYER_SCORE_LUMBER_LOST_TAX: HPLAYERSCORE;
	PLAYER_SCORE_LUMBER_GIVEN: HPLAYERSCORE;
	PLAYER_SCORE_LUMBER_RECEIVED: HPLAYERSCORE;
	PLAYER_SCORE_UNIT_TOTAL: HPLAYERSCORE;
	PLAYER_SCORE_HERO_TOTAL: HPLAYERSCORE;
	PLAYER_SCORE_RESOURCE_TOTAL: HPLAYERSCORE;
	PLAYER_SCORE_TOTAL: HPLAYERSCORE;
	EVENT_GAME_VICTORY: HGAMEEVENT;
	EVENT_GAME_END_LEVEL: HGAMEEVENT;
	EVENT_GAME_VARIABLE_LIMIT: HGAMEEVENT;
	EVENT_GAME_STATE_LIMIT: HGAMEEVENT;
	EVENT_GAME_TIMER_EXPIRED: HGAMEEVENT;
	EVENT_GAME_ENTER_REGION: HGAMEEVENT;
	EVENT_GAME_LEAVE_REGION: HGAMEEVENT;
	EVENT_GAME_TRACKABLE_HIT: HGAMEEVENT;
	EVENT_GAME_TRACKABLE_TRACK: HGAMEEVENT;
	EVENT_GAME_SHOW_SKILL: HGAMEEVENT;
	EVENT_GAME_BUILD_SUBMENU: HGAMEEVENT;
	EVENT_PLAYER_STATE_LIMIT: HPLAYEREVENT;
	EVENT_PLAYER_ALLIANCE_CHANGED: HPLAYEREVENT;
	EVENT_PLAYER_DEFEAT: HPLAYEREVENT;
	EVENT_PLAYER_VICTORY: HPLAYEREVENT;
	EVENT_PLAYER_LEAVE: HPLAYEREVENT;
	EVENT_PLAYER_CHAT: HPLAYEREVENT;
	EVENT_PLAYER_END_CINEMATIC: HPLAYEREVENT;
	EVENT_PLAYER_UNIT_ATTACKED: HPLAYERUNITEVENT;
	EVENT_PLAYER_UNIT_RESCUED: HPLAYERUNITEVENT;
	EVENT_PLAYER_UNIT_DEATH: HPLAYERUNITEVENT;
	EVENT_PLAYER_UNIT_DECAY: HPLAYERUNITEVENT;
	EVENT_PLAYER_UNIT_DETECTED: HPLAYERUNITEVENT;
	EVENT_PLAYER_UNIT_HIDDEN: HPLAYERUNITEVENT;
	EVENT_PLAYER_UNIT_SELECTED: HPLAYERUNITEVENT;
	EVENT_PLAYER_UNIT_DESELECTED: HPLAYERUNITEVENT;
	EVENT_PLAYER_UNIT_CONSTRUCT_START: HPLAYERUNITEVENT;
	EVENT_PLAYER_UNIT_CONSTRUCT_CANCEL: HPLAYERUNITEVENT;
	EVENT_PLAYER_UNIT_CONSTRUCT_FINISH: HPLAYERUNITEVENT;
	EVENT_PLAYER_UNIT_UPGRADE_START: HPLAYERUNITEVENT;
	EVENT_PLAYER_UNIT_UPGRADE_CANCEL: HPLAYERUNITEVENT;
	EVENT_PLAYER_UNIT_UPGRADE_FINISH: HPLAYERUNITEVENT;
	EVENT_PLAYER_UNIT_TRAIN_START: HPLAYERUNITEVENT;
	EVENT_PLAYER_UNIT_TRAIN_CANCEL: HPLAYERUNITEVENT;
	EVENT_PLAYER_UNIT_TRAIN_FINISH: HPLAYERUNITEVENT;
	EVENT_PLAYER_UNIT_RESEARCH_START: HPLAYERUNITEVENT;
	EVENT_PLAYER_UNIT_RESEARCH_CANCEL: HPLAYERUNITEVENT;
	EVENT_PLAYER_UNIT_RESEARCH_FINISH: HPLAYERUNITEVENT;
	EVENT_PLAYER_UNIT_ISSUED_ORDER: HPLAYERUNITEVENT;
	EVENT_PLAYER_UNIT_ISSUED_POINT_ORDER: HPLAYERUNITEVENT;
	EVENT_PLAYER_UNIT_ISSUED_TARGET_ORDER: HPLAYERUNITEVENT;
	EVENT_PLAYER_UNIT_ISSUED_UNIT_ORDER: HPLAYERUNITEVENT;
	EVENT_PLAYER_HERO_LEVEL: HPLAYERUNITEVENT;
	EVENT_PLAYER_HERO_SKILL: HPLAYERUNITEVENT;
	EVENT_PLAYER_HERO_REVIVABLE: HPLAYERUNITEVENT;
	EVENT_PLAYER_HERO_REVIVE_START: HPLAYERUNITEVENT;
	EVENT_PLAYER_HERO_REVIVE_CANCEL: HPLAYERUNITEVENT;
	EVENT_PLAYER_HERO_REVIVE_FINISH: HPLAYERUNITEVENT;
	EVENT_PLAYER_UNIT_SUMMON: HPLAYERUNITEVENT;
	EVENT_PLAYER_UNIT_DROP_ITEM: HPLAYERUNITEVENT;
	EVENT_PLAYER_UNIT_PICKUP_ITEM: HPLAYERUNITEVENT;
	EVENT_PLAYER_UNIT_USE_ITEM: HPLAYERUNITEVENT;
	EVENT_PLAYER_UNIT_LOADED: HPLAYERUNITEVENT;
	EVENT_UNIT_DAMAGED: HUNITEVENT;
	EVENT_UNIT_DEATH: HUNITEVENT;
	EVENT_UNIT_DECAY: HUNITEVENT;
	EVENT_UNIT_DETECTED: HUNITEVENT;
	EVENT_UNIT_HIDDEN: HUNITEVENT;
	EVENT_UNIT_SELECTED: HUNITEVENT;
	EVENT_UNIT_DESELECTED: HUNITEVENT;
	EVENT_UNIT_STATE_LIMIT: HUNITEVENT;
	EVENT_UNIT_ACQUIRED_TARGET: HUNITEVENT;
	EVENT_UNIT_TARGET_IN_RANGE: HUNITEVENT;
	EVENT_UNIT_ATTACKED: HUNITEVENT;
	EVENT_UNIT_RESCUED: HUNITEVENT;
	EVENT_UNIT_CONSTRUCT_CANCEL: HUNITEVENT;
	EVENT_UNIT_CONSTRUCT_FINISH: HUNITEVENT;
	EVENT_UNIT_UPGRADE_START: HUNITEVENT;
	EVENT_UNIT_UPGRADE_CANCEL: HUNITEVENT;
	EVENT_UNIT_UPGRADE_FINISH: HUNITEVENT;
	EVENT_UNIT_TRAIN_START: HUNITEVENT;
	EVENT_UNIT_TRAIN_CANCEL: HUNITEVENT;
	EVENT_UNIT_TRAIN_FINISH: HUNITEVENT;
	EVENT_UNIT_RESEARCH_START: HUNITEVENT;
	EVENT_UNIT_RESEARCH_CANCEL: HUNITEVENT;
	EVENT_UNIT_RESEARCH_FINISH: HUNITEVENT;
	EVENT_UNIT_ISSUED_ORDER: HUNITEVENT;
	EVENT_UNIT_ISSUED_POINT_ORDER: HUNITEVENT;
	EVENT_UNIT_ISSUED_TARGET_ORDER: HUNITEVENT;
	EVENT_UNIT_HERO_LEVEL: HUNITEVENT;
	EVENT_UNIT_HERO_SKILL: HUNITEVENT;
	EVENT_UNIT_HERO_REVIVABLE: HUNITEVENT;
	EVENT_UNIT_HERO_REVIVE_START: HUNITEVENT;
	EVENT_UNIT_HERO_REVIVE_CANCEL: HUNITEVENT;
	EVENT_UNIT_HERO_REVIVE_FINISH: HUNITEVENT;
	EVENT_UNIT_SUMMON: HUNITEVENT;
	EVENT_UNIT_DROP_ITEM: HUNITEVENT;
	EVENT_UNIT_PICKUP_ITEM: HUNITEVENT;
	EVENT_UNIT_USE_ITEM: HUNITEVENT;
	EVENT_UNIT_LOADED: HUNITEVENT;
	EVENT_WIDGET_DEATH: HWIDGETEVENT;
	EVENT_DIALOG_BUTTON_CLICK: HDIALOGEVENT;
	EVENT_DIALOG_CLICK: HDIALOGEVENT;
	EVENT_GAME_LOADED: HGAMEEVENT;
	EVENT_GAME_TOURNAMENT_FINISH_SOON: HGAMEEVENT;
	EVENT_GAME_TOURNAMENT_FINISH_NOW: HGAMEEVENT;
	EVENT_GAME_SAVE: HGAMEEVENT;
	EVENT_PLAYER_ARROW_LEFT_DOWN: HPLAYEREVENT;
	EVENT_PLAYER_ARROW_LEFT_UP: HPLAYEREVENT;
	EVENT_PLAYER_ARROW_RIGHT_DOWN: HPLAYEREVENT;
	EVENT_PLAYER_ARROW_RIGHT_UP: HPLAYEREVENT;
	EVENT_PLAYER_ARROW_DOWN_DOWN: HPLAYEREVENT;
	EVENT_PLAYER_ARROW_DOWN_UP: HPLAYEREVENT;
	EVENT_PLAYER_ARROW_UP_DOWN: HPLAYEREVENT;
	EVENT_PLAYER_ARROW_UP_UP: HPLAYEREVENT;
	EVENT_PLAYER_UNIT_SELL: HPLAYERUNITEVENT;
	EVENT_PLAYER_UNIT_CHANGE_OWNER: HPLAYERUNITEVENT;
	EVENT_PLAYER_UNIT_SELL_ITEM: HPLAYERUNITEVENT;
	EVENT_PLAYER_UNIT_SPELL_CHANNEL: HPLAYERUNITEVENT;
	EVENT_PLAYER_UNIT_SPELL_CAST: HPLAYERUNITEVENT;
	EVENT_PLAYER_UNIT_SPELL_EFFECT: HPLAYERUNITEVENT;
	EVENT_PLAYER_UNIT_SPELL_FINISH: HPLAYERUNITEVENT;
	EVENT_PLAYER_UNIT_SPELL_ENDCAST: HPLAYERUNITEVENT;
	EVENT_PLAYER_UNIT_PAWN_ITEM: HPLAYERUNITEVENT;
	EVENT_UNIT_SELL: HUNITEVENT;
	EVENT_UNIT_CHANGE_OWNER: HUNITEVENT;
	EVENT_UNIT_SELL_ITEM: HUNITEVENT;
	EVENT_UNIT_SPELL_CHANNEL: HUNITEVENT;
	EVENT_UNIT_SPELL_CAST: HUNITEVENT;
	EVENT_UNIT_SPELL_EFFECT: HUNITEVENT;
	EVENT_UNIT_SPELL_FINISH: HUNITEVENT;
	EVENT_UNIT_SPELL_ENDCAST: HUNITEVENT;
	EVENT_UNIT_PAWN_ITEM: HUNITEVENT;
	LESS_THAN: HLIMITOP;
	LESS_THAN_OR_EQUAL: HLIMITOP;
	EQUAL: HLIMITOP;
	GREATER_THAN_OR_EQUAL: HLIMITOP;
	GREATER_THAN: HLIMITOP;
	NOT_EQUAL: HLIMITOP;
	UNIT_TYPE_HERO: HUNITTYPE;
	UNIT_TYPE_DEAD: HUNITTYPE;
	UNIT_TYPE_STRUCTURE: HUNITTYPE;
	UNIT_TYPE_FLYING: HUNITTYPE;
	UNIT_TYPE_GROUND: HUNITTYPE;
	UNIT_TYPE_ATTACKS_FLYING: HUNITTYPE;
	UNIT_TYPE_ATTACKS_GROUND: HUNITTYPE;
	UNIT_TYPE_MELEE_ATTACKER: HUNITTYPE;
	UNIT_TYPE_RANGED_ATTACKER: HUNITTYPE;
	UNIT_TYPE_GIANT: HUNITTYPE;
	UNIT_TYPE_SUMMONED: HUNITTYPE;
	UNIT_TYPE_STUNNED: HUNITTYPE;
	UNIT_TYPE_PLAGUED: HUNITTYPE;
	UNIT_TYPE_SNARED: HUNITTYPE;
	UNIT_TYPE_UNDEAD: HUNITTYPE;
	UNIT_TYPE_MECHANICAL: HUNITTYPE;
	UNIT_TYPE_PEON: HUNITTYPE;
	UNIT_TYPE_SAPPER: HUNITTYPE;
	UNIT_TYPE_TOWNHALL: HUNITTYPE;
	UNIT_TYPE_ANCIENT: HUNITTYPE;
	UNIT_TYPE_TAUREN: HUNITTYPE;
	UNIT_TYPE_POISONED: HUNITTYPE;
	UNIT_TYPE_POLYMORPHED: HUNITTYPE;
	UNIT_TYPE_SLEEPING: HUNITTYPE;
	UNIT_TYPE_RESISTANT: HUNITTYPE;
	UNIT_TYPE_ETHEREAL: HUNITTYPE;
	UNIT_TYPE_MAGIC_IMMUNE: HUNITTYPE;
	ITEM_TYPE_PERMANENT: HITEMTYPE;
	ITEM_TYPE_CHARGED: HITEMTYPE;
	ITEM_TYPE_POWERUP: HITEMTYPE;
	ITEM_TYPE_ARTIFACT: HITEMTYPE;
	ITEM_TYPE_PURCHASABLE: HITEMTYPE;
	ITEM_TYPE_CAMPAIGN: HITEMTYPE;
	ITEM_TYPE_MISCELLANEOUS: HITEMTYPE;
	ITEM_TYPE_UNKNOWN: HITEMTYPE;
	ITEM_TYPE_ANY: HITEMTYPE;
	ITEM_TYPE_TOME: HITEMTYPE;
	CAMERA_FIELD_TARGET_DISTANCE: HCAMERAFIELD;
	CAMERA_FIELD_FARZ: HCAMERAFIELD;
	CAMERA_FIELD_ANGLE_OF_ATTACK: HCAMERAFIELD;
	CAMERA_FIELD_FIELD_OF_VIEW: HCAMERAFIELD;
	CAMERA_FIELD_ROLL: HCAMERAFIELD;
	CAMERA_FIELD_ROTATION: HCAMERAFIELD;
	CAMERA_FIELD_ZOFFSET: HCAMERAFIELD;
	BLEND_MODE_NONE: HBLENDMODE;
	BLEND_MODE_DONT_CARE: HBLENDMODE;
	BLEND_MODE_KEYALPHA: HBLENDMODE;
	BLEND_MODE_BLEND: HBLENDMODE;
	BLEND_MODE_ADDITIVE: HBLENDMODE;
	BLEND_MODE_MODULATE: HBLENDMODE;
	BLEND_MODE_MODULATE_2X: HBLENDMODE;
	RARITY_FREQUENT: HRARITYCONTROL;
	RARITY_RARE: HRARITYCONTROL;
	TEXMAP_FLAG_NONE: HTEXMAPFLAGS;
	TEXMAP_FLAG_WRAP_U: HTEXMAPFLAGS;
	TEXMAP_FLAG_WRAP_V: HTEXMAPFLAGS;
	TEXMAP_FLAG_WRAP_UV: HTEXMAPFLAGS;
	FOG_OF_WAR_MASKED: HFOGSTATE;
	FOG_OF_WAR_FOGGED: HFOGSTATE;
	FOG_OF_WAR_VISIBLE: HFOGSTATE;
	CAMERA_MARGIN_LEFT: Integer;
	CAMERA_MARGIN_RIGHT: Integer;
	CAMERA_MARGIN_TOP: Integer;
	CAMERA_MARGIN_BOTTOM: Integer;
	EFFECT_TYPE_EFFECT: HEFFECTTYPE;
	EFFECT_TYPE_TARGET: HEFFECTTYPE;
	EFFECT_TYPE_CASTER: HEFFECTTYPE;
	EFFECT_TYPE_SPECIAL: HEFFECTTYPE;
	EFFECT_TYPE_AREA_EFFECT: HEFFECTTYPE;
	EFFECT_TYPE_MISSILE: HEFFECTTYPE;
	EFFECT_TYPE_LIGHTNING: HEFFECTTYPE;
	SOUND_TYPE_EFFECT: HSOUNDTYPE;
	SOUND_TYPE_EFFECT_LOOPED: HSOUNDTYPE;

function ConvertRace(i: Integer): HRACE;
function ConvertAllianceType(i: Integer): HALLIANCETYPE;
function ConvertRacePref(i: Integer): HRACEPREFERENCE;
function ConvertIGameState(i: Integer): HIGAMESTATE;
function ConvertFGameState(i: Integer): HFGAMESTATE;
function ConvertPlayerState(i: Integer): HPLAYERSTATE;
function ConvertPlayerScore(i: Integer): HPLAYERSCORE;
function ConvertPlayerGameResult(i: Integer): HPLAYERGAMERESULT;
function ConvertUnitState(i: Integer): HUNITSTATE;
function ConvertAIDifficulty(i: Integer): HAIDIFFICULTY;
function ConvertGameEvent(i: Integer): HGAMEEVENT;
function ConvertPlayerEvent(i: Integer): HPLAYEREVENT;
function ConvertPlayerUnitEvent(i: Integer): HPLAYERUNITEVENT;
function ConvertWidgetEvent(i: Integer): HWIDGETEVENT;
function ConvertDialogEvent(i: Integer): HDIALOGEVENT;
function ConvertUnitEvent(i: Integer): HUNITEVENT;
function ConvertLimitOp(i: Integer): HLIMITOP;
function ConvertUnitType(i: Integer): HUNITTYPE;
function ConvertGameSpeed(i: Integer): HGAMESPEED;
function ConvertPlacement(i: Integer): HPLACEMENT;
function ConvertStartLocPrio(i: Integer): HSTARTLOCPRIO;
function ConvertGameDifficulty(i: Integer): HGAMEDIFFICULTY;
function ConvertGameType(i: Integer): HGAMETYPE;
function ConvertMapFlag(i: Integer): HMAPFLAG;
function ConvertMapVisibility(i: Integer): HMAPVISIBILITY;
function ConvertMapSetting(i: Integer): HMAPSETTING;
function ConvertMapDensity(i: Integer): HMAPDENSITY;
function ConvertMapControl(i: Integer): HMAPCONTROL;
function ConvertPlayerColor(i: Integer): HPLAYERCOLOR;
function ConvertPlayerSlotState(i: Integer): HPLAYERSLOTSTATE;
function ConvertVolumeGroup(i: Integer): HVOLUMEGROUP;
function ConvertCameraField(i: Integer): HCAMERAFIELD;
function ConvertBlendMode(i: Integer): HBLENDMODE;
function ConvertRarityControl(i: Integer): HRARITYCONTROL;
function ConvertTexMapFlags(i: Integer): HTEXMAPFLAGS;
function ConvertFogState(i: Integer): HFOGSTATE;
function ConvertEffectType(i: Integer): HEFFECTTYPE;
function ConvertVersion(i: Integer): HVERSION;
function ConvertItemType(i: Integer): HITEMTYPE;
function ConvertAttackType(i: Integer): HATTACKTYPE;
function ConvertDamageType(i: Integer): HDAMAGETYPE;
function ConvertWeaponType(i: Integer): HWEAPONTYPE;
function ConvertSoundType(i: Integer): HSOUNDTYPE;
function ConvertPathingType(i: Integer): HPATHINGTYPE;
function OrderId(orderIdString: String): Integer;
function OrderId2String(orderId: Integer): String;
function UnitId(unitIdString: String): Integer;
function UnitId2String(unitId: Integer): String;
function AbilityId(abilityIdString: String): Integer;
function AbilityId2String(abilityId: Integer): String;
function GetObjectName(objectId: Integer): String;
function Deg2Rad(degrees: Single): Single;
function Rad2Deg(radians: Single): Single;
function Sin(radians: Single): Single;
function Cos(radians: Single): Single;
function Tan(radians: Single): Single;
function Asin(y: Single): Single;
function Acos(x: Single): Single;
function Atan(x: Single): Single;
function Atan2(y: Single; x: Single): Single;
function SquareRoot(x: Single): Single;
function Pow(x: Single; power: Single): Single;
function I2R(i: Integer): Single;
function R2I(r: Single): Integer;
function I2S(i: Integer): String;
function R2S(r: Single): String;
function R2SW(r: Single; width: Integer; precision: Integer): String;
function S2I(s: String): Integer;
function S2R(s: String): Single;
function GetHandleId(h: TJassObjectHandle): Integer;
function SubString(source: String; start: Integer; end_: Integer): String;
function StringLength(s: String): Integer;
function StringCase(source: String; upper: Boolean): String;
function StringHash(s: String): Integer;
function GetLocalizedString(source: String): String;
function GetLocalizedHotkey(source: String): Integer;
procedure SetMapName(name: String);
procedure SetMapDescription(description: String);
procedure SetTeams(teamcount: Integer);
procedure SetPlayers(playercount: Integer);
procedure DefineStartLocation(whichStartLoc: Integer; x: Single; y: Single);
procedure DefineStartLocationLoc(whichStartLoc: Integer; whichLocation: HLOCATION);
procedure SetStartLocPrioCount(whichStartLoc: Integer; prioSlotCount: Integer);
procedure SetStartLocPrio(whichStartLoc: Integer; prioSlotIndex: Integer; otherStartLocIndex: Integer; priority: HSTARTLOCPRIO);
function GetStartLocPrioSlot(whichStartLoc: Integer; prioSlotIndex: Integer): Integer;
function GetStartLocPrio(whichStartLoc: Integer; prioSlotIndex: Integer): HSTARTLOCPRIO;
procedure SetGameTypeSupported(whichGameType: HGAMETYPE; value: Boolean);
procedure SetMapFlag(whichMapFlag: HMAPFLAG; value: Boolean);
procedure SetGamePlacement(whichPlacementType: HPLACEMENT);
procedure SetGameSpeed(whichspeed: HGAMESPEED);
procedure SetGameDifficulty(whichdifficulty: HGAMEDIFFICULTY);
procedure SetResourceDensity(whichdensity: HMAPDENSITY);
procedure SetCreatureDensity(whichdensity: HMAPDENSITY);
function GetTeams: Integer;
function GetPlayers: Integer;
function IsGameTypeSupported(whichGameType: HGAMETYPE): Boolean;
function GetGameTypeSelected: HGAMETYPE;
function IsMapFlagSet(whichMapFlag: HMAPFLAG): Boolean;
function GetGamePlacement: HPLACEMENT;
function GetGameSpeed: HGAMESPEED;
function GetGameDifficulty: HGAMEDIFFICULTY;
function GetResourceDensity: HMAPDENSITY;
function GetCreatureDensity: HMAPDENSITY;
function GetStartLocationX(whichStartLocation: Integer): Single;
function GetStartLocationY(whichStartLocation: Integer): Single;
function GetStartLocationLoc(whichStartLocation: Integer): HLOCATION;
procedure SetPlayerTeam(whichPlayer: HPLAYER; whichTeam: Integer);
procedure SetPlayerStartLocation(whichPlayer: HPLAYER; startLocIndex: Integer);
procedure ForcePlayerStartLocation(whichPlayer: HPLAYER; startLocIndex: Integer);
procedure SetPlayerColor(whichPlayer: HPLAYER; color: HPLAYERCOLOR);
procedure SetPlayerAlliance(sourcePlayer: HPLAYER; otherPlayer: HPLAYER; whichAllianceSetting: HALLIANCETYPE; value: Boolean);
procedure SetPlayerTaxRate(sourcePlayer: HPLAYER; otherPlayer: HPLAYER; whichResource: HPLAYERSTATE; rate: Integer);
procedure SetPlayerRacePreference(whichPlayer: HPLAYER; whichRacePreference: HRACEPREFERENCE);
procedure SetPlayerRaceSelectable(whichPlayer: HPLAYER; value: Boolean);
procedure SetPlayerController(whichPlayer: HPLAYER; controlType: HMAPCONTROL);
procedure SetPlayerName(whichPlayer: HPLAYER; name: String);
procedure SetPlayerOnScoreScreen(whichPlayer: HPLAYER; flag: Boolean);
function GetPlayerTeam(whichPlayer: HPLAYER): Integer;
function GetPlayerStartLocation(whichPlayer: HPLAYER): Integer;
function GetPlayerColor(whichPlayer: HPLAYER): HPLAYERCOLOR;
function GetPlayerSelectable(whichPlayer: HPLAYER): Boolean;
function GetPlayerController(whichPlayer: HPLAYER): HMAPCONTROL;
function GetPlayerSlotState(whichPlayer: HPLAYER): HPLAYERSLOTSTATE;
function GetPlayerTaxRate(sourcePlayer: HPLAYER; otherPlayer: HPLAYER; whichResource: HPLAYERSTATE): Integer;
function IsPlayerRacePrefSet(whichPlayer: HPLAYER; pref: HRACEPREFERENCE): Boolean;
function GetPlayerName(whichPlayer: HPLAYER): String;
function CreateTimer: HTIMER;
procedure DestroyTimer(whichTimer: HTIMER);
procedure TimerStart(whichTimer: HTIMER; timeout: Single; periodic: Boolean; handlerFunc: TJassCallback);
function TimerGetElapsed(whichTimer: HTIMER): Single;
function TimerGetRemaining(whichTimer: HTIMER): Single;
function TimerGetTimeout(whichTimer: HTIMER): Single;
procedure PauseTimer(whichTimer: HTIMER);
procedure ResumeTimer(whichTimer: HTIMER);
function GetExpiredTimer: HTIMER;
function CreateGroup: HGROUP;
procedure DestroyGroup(whichGroup: HGROUP);
procedure GroupAddUnit(whichGroup: HGROUP; whichUnit: HUNIT);
procedure GroupRemoveUnit(whichGroup: HGROUP; whichUnit: HUNIT);
procedure GroupClear(whichGroup: HGROUP);
procedure GroupEnumUnitsOfType(whichGroup: HGROUP; unitname: String; filter: HBOOLEXPR);
procedure GroupEnumUnitsOfPlayer(whichGroup: HGROUP; whichPlayer: HPLAYER; filter: HBOOLEXPR);
procedure GroupEnumUnitsOfTypeCounted(whichGroup: HGROUP; unitname: String; filter: HBOOLEXPR; countLimit: Integer);
procedure GroupEnumUnitsInRect(whichGroup: HGROUP; r: HRECT; filter: HBOOLEXPR);
procedure GroupEnumUnitsInRectCounted(whichGroup: HGROUP; r: HRECT; filter: HBOOLEXPR; countLimit: Integer);
procedure GroupEnumUnitsInRange(whichGroup: HGROUP; x: Single; y: Single; radius: Single; filter: HBOOLEXPR);
procedure GroupEnumUnitsInRangeOfLoc(whichGroup: HGROUP; whichLocation: HLOCATION; radius: Single; filter: HBOOLEXPR);
procedure GroupEnumUnitsInRangeCounted(whichGroup: HGROUP; x: Single; y: Single; radius: Single; filter: HBOOLEXPR; countLimit: Integer);
procedure GroupEnumUnitsInRangeOfLocCounted(whichGroup: HGROUP; whichLocation: HLOCATION; radius: Single; filter: HBOOLEXPR; countLimit: Integer);
procedure GroupEnumUnitsSelected(whichGroup: HGROUP; whichPlayer: HPLAYER; filter: HBOOLEXPR);
function GroupImmediateOrder(whichGroup: HGROUP; order: String): Boolean;
function GroupImmediateOrderById(whichGroup: HGROUP; order: Integer): Boolean;
function GroupPointOrder(whichGroup: HGROUP; order: String; x: Single; y: Single): Boolean;
function GroupPointOrderLoc(whichGroup: HGROUP; order: String; whichLocation: HLOCATION): Boolean;
function GroupPointOrderById(whichGroup: HGROUP; order: Integer; x: Single; y: Single): Boolean;
function GroupPointOrderByIdLoc(whichGroup: HGROUP; order: Integer; whichLocation: HLOCATION): Boolean;
function GroupTargetOrder(whichGroup: HGROUP; order: String; targetWidget: HWIDGET): Boolean;
function GroupTargetOrderById(whichGroup: HGROUP; order: Integer; targetWidget: HWIDGET): Boolean;
procedure ForGroup(whichGroup: HGROUP; callback: TJassCallback);
function FirstOfGroup(whichGroup: HGROUP): HUNIT;
function CreateForce: HFORCE;
procedure DestroyForce(whichForce: HFORCE);
procedure ForceAddPlayer(whichForce: HFORCE; whichPlayer: HPLAYER);
procedure ForceRemovePlayer(whichForce: HFORCE; whichPlayer: HPLAYER);
procedure ForceClear(whichForce: HFORCE);
procedure ForceEnumPlayers(whichForce: HFORCE; filter: HBOOLEXPR);
procedure ForceEnumPlayersCounted(whichForce: HFORCE; filter: HBOOLEXPR; countLimit: Integer);
procedure ForceEnumAllies(whichForce: HFORCE; whichPlayer: HPLAYER; filter: HBOOLEXPR);
procedure ForceEnumEnemies(whichForce: HFORCE; whichPlayer: HPLAYER; filter: HBOOLEXPR);
procedure ForForce(whichForce: HFORCE; callback: TJassCallback);
function Rect(minx: Single; miny: Single; maxx: Single; maxy: Single): HRECT;
function RectFromLoc(min: HLOCATION; max: HLOCATION): HRECT;
procedure RemoveRect(whichRect: HRECT);
procedure SetRect(whichRect: HRECT; minx: Single; miny: Single; maxx: Single; maxy: Single);
procedure SetRectFromLoc(whichRect: HRECT; min: HLOCATION; max: HLOCATION);
procedure MoveRectTo(whichRect: HRECT; newCenterX: Single; newCenterY: Single);
procedure MoveRectToLoc(whichRect: HRECT; newCenterLoc: HLOCATION);
function GetRectCenterX(whichRect: HRECT): Single;
function GetRectCenterY(whichRect: HRECT): Single;
function GetRectMinX(whichRect: HRECT): Single;
function GetRectMinY(whichRect: HRECT): Single;
function GetRectMaxX(whichRect: HRECT): Single;
function GetRectMaxY(whichRect: HRECT): Single;
function CreateRegion: HREGION;
procedure RemoveRegion(whichRegion: HREGION);
procedure RegionAddRect(whichRegion: HREGION; r: HRECT);
procedure RegionClearRect(whichRegion: HREGION; r: HRECT);
procedure RegionAddCell(whichRegion: HREGION; x: Single; y: Single);
procedure RegionAddCellAtLoc(whichRegion: HREGION; whichLocation: HLOCATION);
procedure RegionClearCell(whichRegion: HREGION; x: Single; y: Single);
procedure RegionClearCellAtLoc(whichRegion: HREGION; whichLocation: HLOCATION);
function Location(x: Single; y: Single): HLOCATION;
procedure RemoveLocation(whichLocation: HLOCATION);
procedure MoveLocation(whichLocation: HLOCATION; newX: Single; newY: Single);
function GetLocationX(whichLocation: HLOCATION): Single;
function GetLocationY(whichLocation: HLOCATION): Single;
function GetLocationZ(whichLocation: HLOCATION): Single;
function IsUnitInRegion(whichRegion: HREGION; whichUnit: HUNIT): Boolean;
function IsPointInRegion(whichRegion: HREGION; x: Single; y: Single): Boolean;
function IsLocationInRegion(whichRegion: HREGION; whichLocation: HLOCATION): Boolean;
function GetWorldBounds: HRECT;
function CreateTrigger: HTRIGGER;
procedure DestroyTrigger(whichTrigger: HTRIGGER);
procedure ResetTrigger(whichTrigger: HTRIGGER);
procedure EnableTrigger(whichTrigger: HTRIGGER);
procedure DisableTrigger(whichTrigger: HTRIGGER);
function IsTriggerEnabled(whichTrigger: HTRIGGER): Boolean;
procedure TriggerWaitOnSleeps(whichTrigger: HTRIGGER; flag: Boolean);
function IsTriggerWaitOnSleeps(whichTrigger: HTRIGGER): Boolean;
function GetFilterUnit: HUNIT;
function GetEnumUnit: HUNIT;
function GetFilterDestructable: HDESTRUCTABLE;
function GetEnumDestructable: HDESTRUCTABLE;
function GetFilterItem: HITEM;
function GetEnumItem: HITEM;
function GetFilterPlayer: HPLAYER;
function GetEnumPlayer: HPLAYER;
function GetTriggeringTrigger: HTRIGGER;
function GetTriggerEventId: HEVENTID;
function GetTriggerEvalCount(whichTrigger: HTRIGGER): Integer;
function GetTriggerExecCount(whichTrigger: HTRIGGER): Integer;
procedure ExecuteFunc(funcName: String);
function And_(operandA: HBOOLEXPR; operandB: HBOOLEXPR): HBOOLEXPR;
function Or_(operandA: HBOOLEXPR; operandB: HBOOLEXPR): HBOOLEXPR;
function Not_(operand: HBOOLEXPR): HBOOLEXPR;
function Condition(func: TJassCallback): HCONDITIONFUNC;
procedure DestroyCondition(c: HCONDITIONFUNC);
function Filter(func: TJassCallback): HFILTERFUNC;
procedure DestroyFilter(f: HFILTERFUNC);
procedure DestroyBoolExpr(e: HBOOLEXPR);
function TriggerRegisterVariableEvent(whichTrigger: HTRIGGER; varName: String; opcode: HLIMITOP; limitval: Single): HEVENT;
function TriggerRegisterTimerEvent(whichTrigger: HTRIGGER; timeout: Single; periodic: Boolean): HEVENT;
function TriggerRegisterTimerExpireEvent(whichTrigger: HTRIGGER; t: HTIMER): HEVENT;
function TriggerRegisterGameStateEvent(whichTrigger: HTRIGGER; whichState: HGAMESTATE; opcode: HLIMITOP; limitval: Single): HEVENT;
function TriggerRegisterDialogEvent(whichTrigger: HTRIGGER; whichDialog: HDIALOG): HEVENT;
function TriggerRegisterDialogButtonEvent(whichTrigger: HTRIGGER; whichButton: HBUTTON): HEVENT;
function GetEventGameState: HGAMESTATE;
function TriggerRegisterGameEvent(whichTrigger: HTRIGGER; whichGameEvent: HGAMEEVENT): HEVENT;
function GetWinningPlayer: HPLAYER;
function TriggerRegisterEnterRegion(whichTrigger: HTRIGGER; whichRegion: HREGION; filter: HBOOLEXPR): HEVENT;
function GetTriggeringRegion: HREGION;
function GetEnteringUnit: HUNIT;
function TriggerRegisterLeaveRegion(whichTrigger: HTRIGGER; whichRegion: HREGION; filter: HBOOLEXPR): HEVENT;
function GetLeavingUnit: HUNIT;
function TriggerRegisterTrackableHitEvent(whichTrigger: HTRIGGER; t: HTRACKABLE): HEVENT;
function TriggerRegisterTrackableTrackEvent(whichTrigger: HTRIGGER; t: HTRACKABLE): HEVENT;
function GetTriggeringTrackable: HTRACKABLE;
function GetClickedButton: HBUTTON;
function GetClickedDialog: HDIALOG;
function GetTournamentFinishSoonTimeRemaining: Single;
function GetTournamentFinishNowRule: Integer;
function GetTournamentFinishNowPlayer: HPLAYER;
function GetTournamentScore(whichPlayer: HPLAYER): Integer;
function GetSaveBasicFilename: String;
function TriggerRegisterPlayerEvent(whichTrigger: HTRIGGER; whichPlayer: HPLAYER; whichPlayerEvent: HPLAYEREVENT): HEVENT;
function GetTriggerPlayer: HPLAYER;
function TriggerRegisterPlayerUnitEvent(whichTrigger: HTRIGGER; whichPlayer: HPLAYER; whichPlayerUnitEvent: HPLAYERUNITEVENT; filter: HBOOLEXPR): HEVENT;
function GetLevelingUnit: HUNIT;
function GetLearningUnit: HUNIT;
function GetLearnedSkill: Integer;
function GetLearnedSkillLevel: Integer;
function GetRevivableUnit: HUNIT;
function GetRevivingUnit: HUNIT;
function GetAttacker: HUNIT;
function GetRescuer: HUNIT;
function GetDyingUnit: HUNIT;
function GetKillingUnit: HUNIT;
function GetDecayingUnit: HUNIT;
function GetConstructingStructure: HUNIT;
function GetCancelledStructure: HUNIT;
function GetConstructedStructure: HUNIT;
function GetResearchingUnit: HUNIT;
function GetResearched: Integer;
function GetTrainedUnitType: Integer;
function GetTrainedUnit: HUNIT;
function GetDetectedUnit: HUNIT;
function GetSummoningUnit: HUNIT;
function GetSummonedUnit: HUNIT;
function GetTransportUnit: HUNIT;
function GetLoadedUnit: HUNIT;
function GetSellingUnit: HUNIT;
function GetSoldUnit: HUNIT;
function GetBuyingUnit: HUNIT;
function GetSoldItem: HITEM;
function GetChangingUnit: HUNIT;
function GetChangingUnitPrevOwner: HPLAYER;
function GetManipulatingUnit: HUNIT;
function GetManipulatedItem: HITEM;
function GetOrderedUnit: HUNIT;
function GetIssuedOrderId: Integer;
function GetOrderPointX: Single;
function GetOrderPointY: Single;
function GetOrderPointLoc: HLOCATION;
function GetOrderTarget: HWIDGET;
function GetOrderTargetDestructable: HDESTRUCTABLE;
function GetOrderTargetItem: HITEM;
function GetOrderTargetUnit: HUNIT;
function GetSpellAbilityUnit: HUNIT;
function GetSpellAbilityId: Integer;
function GetSpellAbility: HABILITY;
function GetSpellTargetLoc: HLOCATION;
function GetSpellTargetX: Single;
function GetSpellTargetY: Single;
function GetSpellTargetDestructable: HDESTRUCTABLE;
function GetSpellTargetItem: HITEM;
function GetSpellTargetUnit: HUNIT;
function TriggerRegisterPlayerAllianceChange(whichTrigger: HTRIGGER; whichPlayer: HPLAYER; whichAlliance: HALLIANCETYPE): HEVENT;
function TriggerRegisterPlayerStateEvent(whichTrigger: HTRIGGER; whichPlayer: HPLAYER; whichState: HPLAYERSTATE; opcode: HLIMITOP; limitval: Single): HEVENT;
function GetEventPlayerState: HPLAYERSTATE;
function TriggerRegisterPlayerChatEvent(whichTrigger: HTRIGGER; whichPlayer: HPLAYER; chatMessageToDetect: String; exactMatchOnly: Boolean): HEVENT;
function GetEventPlayerChatString: String;
function GetEventPlayerChatStringMatched: String;
function TriggerRegisterDeathEvent(whichTrigger: HTRIGGER; whichWidget: HWIDGET): HEVENT;
function GetTriggerUnit: HUNIT;
function TriggerRegisterUnitStateEvent(whichTrigger: HTRIGGER; whichUnit: HUNIT; whichState: HUNITSTATE; opcode: HLIMITOP; limitval: Single): HEVENT;
function GetEventUnitState: HUNITSTATE;
function TriggerRegisterUnitEvent(whichTrigger: HTRIGGER; whichUnit: HUNIT; whichEvent: HUNITEVENT): HEVENT;
function GetEventDamage: Single;
function GetEventDamageSource: HUNIT;
function GetEventDetectingPlayer: HPLAYER;
function TriggerRegisterFilterUnitEvent(whichTrigger: HTRIGGER; whichUnit: HUNIT; whichEvent: HUNITEVENT; filter: HBOOLEXPR): HEVENT;
function GetEventTargetUnit: HUNIT;
function TriggerRegisterUnitInRange(whichTrigger: HTRIGGER; whichUnit: HUNIT; range: Single; filter: HBOOLEXPR): HEVENT;
function TriggerAddCondition(whichTrigger: HTRIGGER; condition: HBOOLEXPR): HTRIGGERCONDITION;
procedure TriggerRemoveCondition(whichTrigger: HTRIGGER; whichCondition: HTRIGGERCONDITION);
procedure TriggerClearConditions(whichTrigger: HTRIGGER);
function TriggerAddAction(whichTrigger: HTRIGGER; actionFunc: TJassCallback): HTRIGGERACTION;
procedure TriggerRemoveAction(whichTrigger: HTRIGGER; whichAction: HTRIGGERACTION);
procedure TriggerClearActions(whichTrigger: HTRIGGER);
procedure TriggerSleepAction(timeout: Single);
procedure TriggerWaitForSound(s: HSOUND; offset: Single);
function TriggerEvaluate(whichTrigger: HTRIGGER): Boolean;
procedure TriggerExecute(whichTrigger: HTRIGGER);
procedure TriggerExecuteWait(whichTrigger: HTRIGGER);
procedure TriggerSyncStart;
procedure TriggerSyncReady;
function GetWidgetLife(whichWidget: HWIDGET): Single;
procedure SetWidgetLife(whichWidget: HWIDGET; newLife: Single);
function GetWidgetX(whichWidget: HWIDGET): Single;
function GetWidgetY(whichWidget: HWIDGET): Single;
function GetTriggerWidget: HWIDGET;
function CreateDestructable(objectid: Integer; x: Single; y: Single; face: Single; scale: Single; variation: Integer): HDESTRUCTABLE;
function CreateDestructableZ(objectid: Integer; x: Single; y: Single; z: Single; face: Single; scale: Single; variation: Integer): HDESTRUCTABLE;
function CreateDeadDestructable(objectid: Integer; x: Single; y: Single; face: Single; scale: Single; variation: Integer): HDESTRUCTABLE;
function CreateDeadDestructableZ(objectid: Integer; x: Single; y: Single; z: Single; face: Single; scale: Single; variation: Integer): HDESTRUCTABLE;
procedure RemoveDestructable(d: HDESTRUCTABLE);
procedure KillDestructable(d: HDESTRUCTABLE);
procedure SetDestructableInvulnerable(d: HDESTRUCTABLE; flag: Boolean);
function IsDestructableInvulnerable(d: HDESTRUCTABLE): Boolean;
procedure EnumDestructablesInRect(r: HRECT; filter: HBOOLEXPR; actionFunc: TJassCallback);
function GetDestructableTypeId(d: HDESTRUCTABLE): Integer;
function GetDestructableX(d: HDESTRUCTABLE): Single;
function GetDestructableY(d: HDESTRUCTABLE): Single;
procedure SetDestructableLife(d: HDESTRUCTABLE; life: Single);
function GetDestructableLife(d: HDESTRUCTABLE): Single;
procedure SetDestructableMaxLife(d: HDESTRUCTABLE; max: Single);
function GetDestructableMaxLife(d: HDESTRUCTABLE): Single;
procedure DestructableRestoreLife(d: HDESTRUCTABLE; life: Single; birth: Boolean);
procedure QueueDestructableAnimation(d: HDESTRUCTABLE; whichAnimation: String);
procedure SetDestructableAnimation(d: HDESTRUCTABLE; whichAnimation: String);
procedure SetDestructableAnimationSpeed(d: HDESTRUCTABLE; speedFactor: Single);
procedure ShowDestructable(d: HDESTRUCTABLE; flag: Boolean);
function GetDestructableOccluderHeight(d: HDESTRUCTABLE): Single;
procedure SetDestructableOccluderHeight(d: HDESTRUCTABLE; height: Single);
function GetDestructableName(d: HDESTRUCTABLE): String;
function GetTriggerDestructable: HDESTRUCTABLE;
function CreateItem(itemid: Integer; x: Single; y: Single): HITEM;
procedure RemoveItem(whichItem: HITEM);
function GetItemPlayer(whichItem: HITEM): HPLAYER;
function GetItemTypeId(i: HITEM): Integer;
function GetItemX(i: HITEM): Single;
function GetItemY(i: HITEM): Single;
procedure SetItemPosition(i: HITEM; x: Single; y: Single);
procedure SetItemDropOnDeath(whichItem: HITEM; flag: Boolean);
procedure SetItemDroppable(i: HITEM; flag: Boolean);
procedure SetItemPawnable(i: HITEM; flag: Boolean);
procedure SetItemPlayer(whichItem: HITEM; whichPlayer: HPLAYER; changeColor: Boolean);
procedure SetItemInvulnerable(whichItem: HITEM; flag: Boolean);
function IsItemInvulnerable(whichItem: HITEM): Boolean;
procedure SetItemVisible(whichItem: HITEM; show: Boolean);
function IsItemVisible(whichItem: HITEM): Boolean;
function IsItemOwned(whichItem: HITEM): Boolean;
function IsItemPowerup(whichItem: HITEM): Boolean;
function IsItemSellable(whichItem: HITEM): Boolean;
function IsItemPawnable(whichItem: HITEM): Boolean;
function IsItemIdPowerup(itemId: Integer): Boolean;
function IsItemIdSellable(itemId: Integer): Boolean;
function IsItemIdPawnable(itemId: Integer): Boolean;
procedure EnumItemsInRect(r: HRECT; filter: HBOOLEXPR; actionFunc: TJassCallback);
function GetItemLevel(whichItem: HITEM): Integer;
function GetItemType(whichItem: HITEM): HITEMTYPE;
procedure SetItemDropID(whichItem: HITEM; unitId: Integer);
function GetItemName(whichItem: HITEM): String;
function GetItemCharges(whichItem: HITEM): Integer;
procedure SetItemCharges(whichItem: HITEM; charges: Integer);
function GetItemUserData(whichItem: HITEM): Integer;
procedure SetItemUserData(whichItem: HITEM; data: Integer);
function CreateUnit(id: HPLAYER; unitid: Integer; x: Single; y: Single; face: Single): HUNIT;
function CreateUnitByName(whichPlayer: HPLAYER; unitname: String; x: Single; y: Single; face: Single): HUNIT;
function CreateUnitAtLoc(id: HPLAYER; unitid: Integer; whichLocation: HLOCATION; face: Single): HUNIT;
function CreateUnitAtLocByName(id: HPLAYER; unitname: String; whichLocation: HLOCATION; face: Single): HUNIT;
function CreateCorpse(whichPlayer: HPLAYER; unitid: Integer; x: Single; y: Single; face: Single): HUNIT;
procedure KillUnit(whichUnit: HUNIT);
procedure RemoveUnit(whichUnit: HUNIT);
procedure ShowUnit(whichUnit: HUNIT; show: Boolean);
procedure SetUnitState(whichUnit: HUNIT; whichUnitState: HUNITSTATE; newVal: Single);
procedure SetUnitX(whichUnit: HUNIT; newX: Single);
procedure SetUnitY(whichUnit: HUNIT; newY: Single);
procedure SetUnitPosition(whichUnit: HUNIT; newX: Single; newY: Single);
procedure SetUnitPositionLoc(whichUnit: HUNIT; whichLocation: HLOCATION);
procedure SetUnitFacing(whichUnit: HUNIT; facingAngle: Single);
procedure SetUnitFacingTimed(whichUnit: HUNIT; facingAngle: Single; duration: Single);
procedure SetUnitMoveSpeed(whichUnit: HUNIT; newSpeed: Single);
procedure SetUnitFlyHeight(whichUnit: HUNIT; newHeight: Single; rate: Single);
procedure SetUnitTurnSpeed(whichUnit: HUNIT; newTurnSpeed: Single);
procedure SetUnitPropWindow(whichUnit: HUNIT; newPropWindowAngle: Single);
procedure SetUnitAcquireRange(whichUnit: HUNIT; newAcquireRange: Single);
procedure SetUnitCreepGuard(whichUnit: HUNIT; creepGuard: Boolean);
function GetUnitAcquireRange(whichUnit: HUNIT): Single;
function GetUnitTurnSpeed(whichUnit: HUNIT): Single;
function GetUnitPropWindow(whichUnit: HUNIT): Single;
function GetUnitFlyHeight(whichUnit: HUNIT): Single;
function GetUnitDefaultAcquireRange(whichUnit: HUNIT): Single;
function GetUnitDefaultTurnSpeed(whichUnit: HUNIT): Single;
function GetUnitDefaultPropWindow(whichUnit: HUNIT): Single;
function GetUnitDefaultFlyHeight(whichUnit: HUNIT): Single;
procedure SetUnitOwner(whichUnit: HUNIT; whichPlayer: HPLAYER; changeColor: Boolean);
procedure SetUnitColor(whichUnit: HUNIT; whichColor: HPLAYERCOLOR);
procedure SetUnitScale(whichUnit: HUNIT; scaleX: Single; scaleY: Single; scaleZ: Single);
procedure SetUnitTimeScale(whichUnit: HUNIT; timeScale: Single);
procedure SetUnitBlendTime(whichUnit: HUNIT; blendTime: Single);
procedure SetUnitVertexColor(whichUnit: HUNIT; red: Integer; green: Integer; blue: Integer; alpha: Integer);
procedure QueueUnitAnimation(whichUnit: HUNIT; whichAnimation: String);
procedure SetUnitAnimation(whichUnit: HUNIT; whichAnimation: String);
procedure SetUnitAnimationByIndex(whichUnit: HUNIT; whichAnimation: Integer);
procedure SetUnitAnimationWithRarity(whichUnit: HUNIT; whichAnimation: String; rarity: HRARITYCONTROL);
procedure AddUnitAnimationProperties(whichUnit: HUNIT; animProperties: String; add: Boolean);
procedure SetUnitLookAt(whichUnit: HUNIT; whichBone: String; lookAtTarget: HUNIT; offsetX: Single; offsetY: Single; offsetZ: Single);
procedure ResetUnitLookAt(whichUnit: HUNIT);
procedure SetUnitRescuable(whichUnit: HUNIT; byWhichPlayer: HPLAYER; flag: Boolean);
procedure SetUnitRescueRange(whichUnit: HUNIT; range: Single);
procedure SetHeroStr(whichHero: HUNIT; newStr: Integer; permanent: Boolean);
procedure SetHeroAgi(whichHero: HUNIT; newAgi: Integer; permanent: Boolean);
procedure SetHeroInt(whichHero: HUNIT; newInt: Integer; permanent: Boolean);
function GetHeroStr(whichHero: HUNIT; includeBonuses: Boolean): Integer;
function GetHeroAgi(whichHero: HUNIT; includeBonuses: Boolean): Integer;
function GetHeroInt(whichHero: HUNIT; includeBonuses: Boolean): Integer;
function UnitStripHeroLevel(whichHero: HUNIT; howManyLevels: Integer): Boolean;
function GetHeroXP(whichHero: HUNIT): Integer;
procedure SetHeroXP(whichHero: HUNIT; newXpVal: Integer; showEyeCandy: Boolean);
function GetHeroSkillPoints(whichHero: HUNIT): Integer;
function UnitModifySkillPoints(whichHero: HUNIT; skillPointDelta: Integer): Boolean;
procedure AddHeroXP(whichHero: HUNIT; xpToAdd: Integer; showEyeCandy: Boolean);
procedure SetHeroLevel(whichHero: HUNIT; level: Integer; showEyeCandy: Boolean);
function GetHeroLevel(whichHero: HUNIT): Integer;
function GetUnitLevel(whichUnit: HUNIT): Integer;
function GetHeroProperName(whichHero: HUNIT): String;
procedure SuspendHeroXP(whichHero: HUNIT; flag: Boolean);
function IsSuspendedXP(whichHero: HUNIT): Boolean;
procedure SelectHeroSkill(whichHero: HUNIT; abilcode: Integer);
function GetUnitAbilityLevel(whichUnit: HUNIT; abilcode: Integer): Integer;
function DecUnitAbilityLevel(whichUnit: HUNIT; abilcode: Integer): Integer;
function IncUnitAbilityLevel(whichUnit: HUNIT; abilcode: Integer): Integer;
function SetUnitAbilityLevel(whichUnit: HUNIT; abilcode: Integer; level: Integer): Integer;
function ReviveHero(whichHero: HUNIT; x: Single; y: Single; doEyecandy: Boolean): Boolean;
function ReviveHeroLoc(whichHero: HUNIT; loc: HLOCATION; doEyecandy: Boolean): Boolean;
procedure SetUnitExploded(whichUnit: HUNIT; exploded: Boolean);
procedure SetUnitInvulnerable(whichUnit: HUNIT; flag: Boolean);
procedure PauseUnit(whichUnit: HUNIT; flag: Boolean);
function IsUnitPaused(whichHero: HUNIT): Boolean;
procedure SetUnitPathing(whichUnit: HUNIT; flag: Boolean);
procedure ClearSelection;
procedure SelectUnit(whichUnit: HUNIT; flag: Boolean);
function GetUnitPointValue(whichUnit: HUNIT): Integer;
function GetUnitPointValueByType(unitType: Integer): Integer;
function UnitAddItem(whichUnit: HUNIT; whichItem: HITEM): Boolean;
function UnitAddItemById(whichUnit: HUNIT; itemId: Integer): HITEM;
function UnitAddItemToSlotById(whichUnit: HUNIT; itemId: Integer; itemSlot: Integer): Boolean;
procedure UnitRemoveItem(whichUnit: HUNIT; whichItem: HITEM);
function UnitRemoveItemFromSlot(whichUnit: HUNIT; itemSlot: Integer): HITEM;
function UnitHasItem(whichUnit: HUNIT; whichItem: HITEM): Boolean;
function UnitItemInSlot(whichUnit: HUNIT; itemSlot: Integer): HITEM;
function UnitInventorySize(whichUnit: HUNIT): Integer;
function UnitDropItemPoint(whichUnit: HUNIT; whichItem: HITEM; x: Single; y: Single): Boolean;
function UnitDropItemSlot(whichUnit: HUNIT; whichItem: HITEM; slot: Integer): Boolean;
function UnitDropItemTarget(whichUnit: HUNIT; whichItem: HITEM; target: HWIDGET): Boolean;
function UnitUseItem(whichUnit: HUNIT; whichItem: HITEM): Boolean;
function UnitUseItemPoint(whichUnit: HUNIT; whichItem: HITEM; x: Single; y: Single): Boolean;
function UnitUseItemTarget(whichUnit: HUNIT; whichItem: HITEM; target: HWIDGET): Boolean;
function GetUnitX(whichUnit: HUNIT): Single;
function GetUnitY(whichUnit: HUNIT): Single;
function GetUnitLoc(whichUnit: HUNIT): HLOCATION;
function GetUnitFacing(whichUnit: HUNIT): Single;
function GetUnitMoveSpeed(whichUnit: HUNIT): Single;
function GetUnitDefaultMoveSpeed(whichUnit: HUNIT): Single;
function GetUnitState(whichUnit: HUNIT; whichUnitState: HUNITSTATE): Single;
function GetOwningPlayer(whichUnit: HUNIT): HPLAYER;
function GetUnitTypeId(whichUnit: HUNIT): Integer;
function GetUnitRace(whichUnit: HUNIT): HRACE;
function GetUnitName(whichUnit: HUNIT): String;
function GetUnitFoodUsed(whichUnit: HUNIT): Integer;
function GetUnitFoodMade(whichUnit: HUNIT): Integer;
function GetFoodMade(unitId: Integer): Integer;
function GetFoodUsed(unitId: Integer): Integer;
procedure SetUnitUseFood(whichUnit: HUNIT; useFood: Boolean);
function GetUnitRallyPoint(whichUnit: HUNIT): HLOCATION;
function GetUnitRallyUnit(whichUnit: HUNIT): HUNIT;
function GetUnitRallyDestructable(whichUnit: HUNIT): HDESTRUCTABLE;
function IsUnitInGroup(whichUnit: HUNIT; whichGroup: HGROUP): Boolean;
function IsUnitInForce(whichUnit: HUNIT; whichForce: HFORCE): Boolean;
function IsUnitOwnedByPlayer(whichUnit: HUNIT; whichPlayer: HPLAYER): Boolean;
function IsUnitAlly(whichUnit: HUNIT; whichPlayer: HPLAYER): Boolean;
function IsUnitEnemy(whichUnit: HUNIT; whichPlayer: HPLAYER): Boolean;
function IsUnitVisible(whichUnit: HUNIT; whichPlayer: HPLAYER): Boolean;
function IsUnitDetected(whichUnit: HUNIT; whichPlayer: HPLAYER): Boolean;
function IsUnitInvisible(whichUnit: HUNIT; whichPlayer: HPLAYER): Boolean;
function IsUnitFogged(whichUnit: HUNIT; whichPlayer: HPLAYER): Boolean;
function IsUnitMasked(whichUnit: HUNIT; whichPlayer: HPLAYER): Boolean;
function IsUnitSelected(whichUnit: HUNIT; whichPlayer: HPLAYER): Boolean;
function IsUnitRace(whichUnit: HUNIT; whichRace: HRACE): Boolean;
function IsUnitType(whichUnit: HUNIT; whichUnitType: HUNITTYPE): Boolean;
function IsUnit(whichUnit: HUNIT; whichSpecifiedUnit: HUNIT): Boolean;
function IsUnitInRange(whichUnit: HUNIT; otherUnit: HUNIT; distance: Single): Boolean;
function IsUnitInRangeXY(whichUnit: HUNIT; x: Single; y: Single; distance: Single): Boolean;
function IsUnitInRangeLoc(whichUnit: HUNIT; whichLocation: HLOCATION; distance: Single): Boolean;
function IsUnitHidden(whichUnit: HUNIT): Boolean;
function IsUnitIllusion(whichUnit: HUNIT): Boolean;
function IsUnitInTransport(whichUnit: HUNIT; whichTransport: HUNIT): Boolean;
function IsUnitLoaded(whichUnit: HUNIT): Boolean;
function IsHeroUnitId(unitId: Integer): Boolean;
function IsUnitIdType(unitId: Integer; whichUnitType: HUNITTYPE): Boolean;
procedure UnitShareVision(whichUnit: HUNIT; whichPlayer: HPLAYER; share: Boolean);
procedure UnitSuspendDecay(whichUnit: HUNIT; suspend: Boolean);
function UnitAddType(whichUnit: HUNIT; whichUnitType: HUNITTYPE): Boolean;
function UnitRemoveType(whichUnit: HUNIT; whichUnitType: HUNITTYPE): Boolean;
function UnitAddAbility(whichUnit: HUNIT; abilityId: Integer): Boolean;
function UnitRemoveAbility(whichUnit: HUNIT; abilityId: Integer): Boolean;
function UnitMakeAbilityPermanent(whichUnit: HUNIT; permanent: Boolean; abilityId: Integer): Boolean;
procedure UnitRemoveBuffs(whichUnit: HUNIT; removePositive: Boolean; removeNegative: Boolean);
procedure UnitRemoveBuffsEx(whichUnit: HUNIT; removePositive: Boolean; removeNegative: Boolean; magic: Boolean; physical: Boolean; timedLife: Boolean; aura: Boolean; autoDispel: Boolean);
function UnitHasBuffsEx(whichUnit: HUNIT; removePositive: Boolean; removeNegative: Boolean; magic: Boolean; physical: Boolean; timedLife: Boolean; aura: Boolean; autoDispel: Boolean): Boolean;
function UnitCountBuffsEx(whichUnit: HUNIT; removePositive: Boolean; removeNegative: Boolean; magic: Boolean; physical: Boolean; timedLife: Boolean; aura: Boolean; autoDispel: Boolean): Integer;
procedure UnitAddSleep(whichUnit: HUNIT; add: Boolean);
function UnitCanSleep(whichUnit: HUNIT): Boolean;
procedure UnitAddSleepPerm(whichUnit: HUNIT; add: Boolean);
function UnitCanSleepPerm(whichUnit: HUNIT): Boolean;
function UnitIsSleeping(whichUnit: HUNIT): Boolean;
procedure UnitWakeUp(whichUnit: HUNIT);
procedure UnitApplyTimedLife(whichUnit: HUNIT; buffId: Integer; duration: Single);
function UnitIgnoreAlarm(whichUnit: HUNIT; flag: Boolean): Boolean;
function UnitIgnoreAlarmToggled(whichUnit: HUNIT): Boolean;
procedure UnitResetCooldown(whichUnit: HUNIT);
procedure UnitSetConstructionProgress(whichUnit: HUNIT; constructionPercentage: Integer);
procedure UnitSetUpgradeProgress(whichUnit: HUNIT; upgradePercentage: Integer);
procedure UnitPauseTimedLife(whichUnit: HUNIT; flag: Boolean);
procedure UnitSetUsesAltIcon(whichUnit: HUNIT; flag: Boolean);
function UnitDamagePoint(whichUnit: HUNIT; delay: Single; radius: Single; x: Single; y: Single; amount: Single; attack: Boolean; ranged: Boolean; attackType: HATTACKTYPE; damageType: HDAMAGETYPE; weaponType: HWEAPONTYPE): Boolean;
function UnitDamageTarget(whichUnit: HUNIT; target: HWIDGET; amount: Single; attack: Boolean; ranged: Boolean; attackType: HATTACKTYPE; damageType: HDAMAGETYPE; weaponType: HWEAPONTYPE): Boolean;
function IssueImmediateOrder(whichUnit: HUNIT; order: String): Boolean;
function IssueImmediateOrderById(whichUnit: HUNIT; order: Integer): Boolean;
function IssuePointOrder(whichUnit: HUNIT; order: String; x: Single; y: Single): Boolean;
function IssuePointOrderLoc(whichUnit: HUNIT; order: String; whichLocation: HLOCATION): Boolean;
function IssuePointOrderById(whichUnit: HUNIT; order: Integer; x: Single; y: Single): Boolean;
function IssuePointOrderByIdLoc(whichUnit: HUNIT; order: Integer; whichLocation: HLOCATION): Boolean;
function IssueTargetOrder(whichUnit: HUNIT; order: String; targetWidget: HWIDGET): Boolean;
function IssueTargetOrderById(whichUnit: HUNIT; order: Integer; targetWidget: HWIDGET): Boolean;
function IssueInstantPointOrder(whichUnit: HUNIT; order: String; x: Single; y: Single; instantTargetWidget: HWIDGET): Boolean;
function IssueInstantPointOrderById(whichUnit: HUNIT; order: Integer; x: Single; y: Single; instantTargetWidget: HWIDGET): Boolean;
function IssueInstantTargetOrder(whichUnit: HUNIT; order: String; targetWidget: HWIDGET; instantTargetWidget: HWIDGET): Boolean;
function IssueInstantTargetOrderById(whichUnit: HUNIT; order: Integer; targetWidget: HWIDGET; instantTargetWidget: HWIDGET): Boolean;
function IssueBuildOrder(whichPeon: HUNIT; unitToBuild: String; x: Single; y: Single): Boolean;
function IssueBuildOrderById(whichPeon: HUNIT; unitId: Integer; x: Single; y: Single): Boolean;
function IssueNeutralImmediateOrder(forWhichPlayer: HPLAYER; neutralStructure: HUNIT; unitToBuild: String): Boolean;
function IssueNeutralImmediateOrderById(forWhichPlayer: HPLAYER; neutralStructure: HUNIT; unitId: Integer): Boolean;
function IssueNeutralPointOrder(forWhichPlayer: HPLAYER; neutralStructure: HUNIT; unitToBuild: String; x: Single; y: Single): Boolean;
function IssueNeutralPointOrderById(forWhichPlayer: HPLAYER; neutralStructure: HUNIT; unitId: Integer; x: Single; y: Single): Boolean;
function IssueNeutralTargetOrder(forWhichPlayer: HPLAYER; neutralStructure: HUNIT; unitToBuild: String; target: HWIDGET): Boolean;
function IssueNeutralTargetOrderById(forWhichPlayer: HPLAYER; neutralStructure: HUNIT; unitId: Integer; target: HWIDGET): Boolean;
function GetUnitCurrentOrder(whichUnit: HUNIT): Integer;
procedure SetResourceAmount(whichUnit: HUNIT; amount: Integer);
procedure AddResourceAmount(whichUnit: HUNIT; amount: Integer);
function GetResourceAmount(whichUnit: HUNIT): Integer;
function WaygateGetDestinationX(waygate: HUNIT): Single;
function WaygateGetDestinationY(waygate: HUNIT): Single;
procedure WaygateSetDestination(waygate: HUNIT; x: Single; y: Single);
procedure WaygateActivate(waygate: HUNIT; activate: Boolean);
function WaygateIsActive(waygate: HUNIT): Boolean;
procedure AddItemToAllStock(itemId: Integer; currentStock: Integer; stockMax: Integer);
procedure AddItemToStock(whichUnit: HUNIT; itemId: Integer; currentStock: Integer; stockMax: Integer);
procedure AddUnitToAllStock(unitId: Integer; currentStock: Integer; stockMax: Integer);
procedure AddUnitToStock(whichUnit: HUNIT; unitId: Integer; currentStock: Integer; stockMax: Integer);
procedure RemoveItemFromAllStock(itemId: Integer);
procedure RemoveItemFromStock(whichUnit: HUNIT; itemId: Integer);
procedure RemoveUnitFromAllStock(unitId: Integer);
procedure RemoveUnitFromStock(whichUnit: HUNIT; unitId: Integer);
procedure SetAllItemTypeSlots(slots: Integer);
procedure SetAllUnitTypeSlots(slots: Integer);
procedure SetItemTypeSlots(whichUnit: HUNIT; slots: Integer);
procedure SetUnitTypeSlots(whichUnit: HUNIT; slots: Integer);
function GetUnitUserData(whichUnit: HUNIT): Integer;
procedure SetUnitUserData(whichUnit: HUNIT; data: Integer);
function Player(number: Integer): HPLAYER;
function GetLocalPlayer: HPLAYER;
function IsPlayerAlly(whichPlayer: HPLAYER; otherPlayer: HPLAYER): Boolean;
function IsPlayerEnemy(whichPlayer: HPLAYER; otherPlayer: HPLAYER): Boolean;
function IsPlayerInForce(whichPlayer: HPLAYER; whichForce: HFORCE): Boolean;
function IsPlayerObserver(whichPlayer: HPLAYER): Boolean;
function IsVisibleToPlayer(x: Single; y: Single; whichPlayer: HPLAYER): Boolean;
function IsLocationVisibleToPlayer(whichLocation: HLOCATION; whichPlayer: HPLAYER): Boolean;
function IsFoggedToPlayer(x: Single; y: Single; whichPlayer: HPLAYER): Boolean;
function IsLocationFoggedToPlayer(whichLocation: HLOCATION; whichPlayer: HPLAYER): Boolean;
function IsMaskedToPlayer(x: Single; y: Single; whichPlayer: HPLAYER): Boolean;
function IsLocationMaskedToPlayer(whichLocation: HLOCATION; whichPlayer: HPLAYER): Boolean;
function GetPlayerRace(whichPlayer: HPLAYER): HRACE;
function GetPlayerId(whichPlayer: HPLAYER): Integer;
function GetPlayerUnitCount(whichPlayer: HPLAYER; includeIncomplete: Boolean): Integer;
function GetPlayerTypedUnitCount(whichPlayer: HPLAYER; unitName: String; includeIncomplete: Boolean; includeUpgrades: Boolean): Integer;
function GetPlayerStructureCount(whichPlayer: HPLAYER; includeIncomplete: Boolean): Integer;
function GetPlayerState(whichPlayer: HPLAYER; whichPlayerState: HPLAYERSTATE): Integer;
function GetPlayerScore(whichPlayer: HPLAYER; whichPlayerScore: HPLAYERSCORE): Integer;
function GetPlayerAlliance(sourcePlayer: HPLAYER; otherPlayer: HPLAYER; whichAllianceSetting: HALLIANCETYPE): Boolean;
function GetPlayerHandicap(whichPlayer: HPLAYER): Single;
function GetPlayerHandicapXP(whichPlayer: HPLAYER): Single;
procedure SetPlayerHandicap(whichPlayer: HPLAYER; handicap: Single);
procedure SetPlayerHandicapXP(whichPlayer: HPLAYER; handicap: Single);
procedure SetPlayerTechMaxAllowed(whichPlayer: HPLAYER; techid: Integer; maximum: Integer);
function GetPlayerTechMaxAllowed(whichPlayer: HPLAYER; techid: Integer): Integer;
procedure AddPlayerTechResearched(whichPlayer: HPLAYER; techid: Integer; levels: Integer);
procedure SetPlayerTechResearched(whichPlayer: HPLAYER; techid: Integer; setToLevel: Integer);
function GetPlayerTechResearched(whichPlayer: HPLAYER; techid: Integer; specificonly: Boolean): Boolean;
function GetPlayerTechCount(whichPlayer: HPLAYER; techid: Integer; specificonly: Boolean): Integer;
procedure SetPlayerUnitsOwner(whichPlayer: HPLAYER; newOwner: Integer);
procedure CripplePlayer(whichPlayer: HPLAYER; toWhichPlayers: HFORCE; flag: Boolean);
procedure SetPlayerAbilityAvailable(whichPlayer: HPLAYER; abilid: Integer; avail: Boolean);
procedure SetPlayerState(whichPlayer: HPLAYER; whichPlayerState: HPLAYERSTATE; value: Integer);
procedure RemovePlayer(whichPlayer: HPLAYER; gameResult: HPLAYERGAMERESULT);
procedure CachePlayerHeroData(whichPlayer: HPLAYER);
procedure SetFogStateRect(forWhichPlayer: HPLAYER; whichState: HFOGSTATE; where: HRECT; useSharedVision: Boolean);
procedure SetFogStateRadius(forWhichPlayer: HPLAYER; whichState: HFOGSTATE; centerx: Single; centerY: Single; radius: Single; useSharedVision: Boolean);
procedure SetFogStateRadiusLoc(forWhichPlayer: HPLAYER; whichState: HFOGSTATE; center: HLOCATION; radius: Single; useSharedVision: Boolean);
procedure FogMaskEnable(enable: Boolean);
function IsFogMaskEnabled: Boolean;
procedure FogEnable(enable: Boolean);
function IsFogEnabled: Boolean;
function CreateFogModifierRect(forWhichPlayer: HPLAYER; whichState: HFOGSTATE; where: HRECT; useSharedVision: Boolean; afterUnits: Boolean): HFOGMODIFIER;
function CreateFogModifierRadius(forWhichPlayer: HPLAYER; whichState: HFOGSTATE; centerx: Single; centerY: Single; radius: Single; useSharedVision: Boolean; afterUnits: Boolean): HFOGMODIFIER;
function CreateFogModifierRadiusLoc(forWhichPlayer: HPLAYER; whichState: HFOGSTATE; center: HLOCATION; radius: Single; useSharedVision: Boolean; afterUnits: Boolean): HFOGMODIFIER;
procedure DestroyFogModifier(whichFogModifier: HFOGMODIFIER);
procedure FogModifierStart(whichFogModifier: HFOGMODIFIER);
procedure FogModifierStop(whichFogModifier: HFOGMODIFIER);
function VersionGet: HVERSION;
function VersionCompatible(whichVersion: HVERSION): Boolean;
function VersionSupported(whichVersion: HVERSION): Boolean;
procedure EndGame(doScoreScreen: Boolean);
procedure ChangeLevel(newLevel: String; doScoreScreen: Boolean);
procedure RestartGame(doScoreScreen: Boolean);
procedure ReloadGame;
procedure SetCampaignMenuRace(r: HRACE);
procedure SetCampaignMenuRaceEx(campaignIndex: Integer);
procedure ForceCampaignSelectScreen;
procedure LoadGame(saveFileName: String; doScoreScreen: Boolean);
procedure SaveGame(saveFileName: String);
function RenameSaveDirectory(sourceDirName: String; destDirName: String): Boolean;
function RemoveSaveDirectory(sourceDirName: String): Boolean;
function CopySaveGame(sourceSaveName: String; destSaveName: String): Boolean;
function SaveGameExists(saveName: String): Boolean;
procedure SyncSelections;
procedure SetFloatGameState(whichFloatGameState: HFGAMESTATE; value: Single);
function GetFloatGameState(whichFloatGameState: HFGAMESTATE): Single;
procedure SetIntegerGameState(whichIntegerGameState: HIGAMESTATE; value: Integer);
function GetIntegerGameState(whichIntegerGameState: HIGAMESTATE): Integer;
procedure SetTutorialCleared(cleared: Boolean);
procedure SetMissionAvailable(campaignNumber: Integer; missionNumber: Integer; available: Boolean);
procedure SetCampaignAvailable(campaignNumber: Integer; available: Boolean);
procedure SetOpCinematicAvailable(campaignNumber: Integer; available: Boolean);
procedure SetEdCinematicAvailable(campaignNumber: Integer; available: Boolean);
function GetDefaultDifficulty: HGAMEDIFFICULTY;
procedure SetDefaultDifficulty(g: HGAMEDIFFICULTY);
procedure SetCustomCampaignButtonVisible(whichButton: Integer; visible: Boolean);
function GetCustomCampaignButtonVisible(whichButton: Integer): Boolean;
procedure DoNotSaveReplay;
function DialogCreate: HDIALOG;
procedure DialogDestroy(whichDialog: HDIALOG);
procedure DialogClear(whichDialog: HDIALOG);
procedure DialogSetMessage(whichDialog: HDIALOG; messageText: String);
function DialogAddButton(whichDialog: HDIALOG; buttonText: String; hotkey: Integer): HBUTTON;
function DialogAddQuitButton(whichDialog: HDIALOG; doScoreScreen: Boolean; buttonText: String; hotkey: Integer): HBUTTON;
procedure DialogDisplay(whichPlayer: HPLAYER; whichDialog: HDIALOG; flag: Boolean);
function ReloadGameCachesFromDisk: Boolean;
function InitGameCache(campaignFile: String): HGAMECACHE;
function SaveGameCache(whichCache: HGAMECACHE): Boolean;
procedure StoreInteger(cache: HGAMECACHE; missionKey: String; key: String; value: Integer);
procedure StoreReal(cache: HGAMECACHE; missionKey: String; key: String; value: Single);
procedure StoreBoolean(cache: HGAMECACHE; missionKey: String; key: String; value: Boolean);
function StoreUnit(cache: HGAMECACHE; missionKey: String; key: String; whichUnit: HUNIT): Boolean;
function StoreString(cache: HGAMECACHE; missionKey: String; key: String; value: String): Boolean;
procedure SyncStoredInteger(cache: HGAMECACHE; missionKey: String; key: String);
procedure SyncStoredReal(cache: HGAMECACHE; missionKey: String; key: String);
procedure SyncStoredBoolean(cache: HGAMECACHE; missionKey: String; key: String);
procedure SyncStoredUnit(cache: HGAMECACHE; missionKey: String; key: String);
procedure SyncStoredString(cache: HGAMECACHE; missionKey: String; key: String);
function HaveStoredInteger(cache: HGAMECACHE; missionKey: String; key: String): Boolean;
function HaveStoredReal(cache: HGAMECACHE; missionKey: String; key: String): Boolean;
function HaveStoredBoolean(cache: HGAMECACHE; missionKey: String; key: String): Boolean;
function HaveStoredUnit(cache: HGAMECACHE; missionKey: String; key: String): Boolean;
function HaveStoredString(cache: HGAMECACHE; missionKey: String; key: String): Boolean;
procedure FlushGameCache(cache: HGAMECACHE);
procedure FlushStoredMission(cache: HGAMECACHE; missionKey: String);
procedure FlushStoredInteger(cache: HGAMECACHE; missionKey: String; key: String);
procedure FlushStoredReal(cache: HGAMECACHE; missionKey: String; key: String);
procedure FlushStoredBoolean(cache: HGAMECACHE; missionKey: String; key: String);
procedure FlushStoredUnit(cache: HGAMECACHE; missionKey: String; key: String);
procedure FlushStoredString(cache: HGAMECACHE; missionKey: String; key: String);
function GetStoredInteger(cache: HGAMECACHE; missionKey: String; key: String): Integer;
function GetStoredReal(cache: HGAMECACHE; missionKey: String; key: String): Single;
function GetStoredBoolean(cache: HGAMECACHE; missionKey: String; key: String): Boolean;
function GetStoredString(cache: HGAMECACHE; missionKey: String; key: String): String;
function RestoreUnit(cache: HGAMECACHE; missionKey: String; key: String; forWhichPlayer: HPLAYER; x: Single; y: Single; facing: Single): HUNIT;
function InitHashtable: HHASHTABLE;
procedure SaveInteger(table: HHASHTABLE; parentKey: Integer; childKey: Integer; value: Integer);
procedure SaveReal(table: HHASHTABLE; parentKey: Integer; childKey: Integer; value: Single);
procedure SaveBoolean(table: HHASHTABLE; parentKey: Integer; childKey: Integer; value: Boolean);
function SaveStr(table: HHASHTABLE; parentKey: Integer; childKey: Integer; value: String): Boolean;
function SavePlayerHandle(table: HHASHTABLE; parentKey: Integer; childKey: Integer; whichPlayer: HPLAYER): Boolean;
function SaveWidgetHandle(table: HHASHTABLE; parentKey: Integer; childKey: Integer; whichWidget: HWIDGET): Boolean;
function SaveDestructableHandle(table: HHASHTABLE; parentKey: Integer; childKey: Integer; whichDestructable: HDESTRUCTABLE): Boolean;
function SaveItemHandle(table: HHASHTABLE; parentKey: Integer; childKey: Integer; whichItem: HITEM): Boolean;
function SaveUnitHandle(table: HHASHTABLE; parentKey: Integer; childKey: Integer; whichUnit: HUNIT): Boolean;
function SaveAbilityHandle(table: HHASHTABLE; parentKey: Integer; childKey: Integer; whichAbility: HABILITY): Boolean;
function SaveTimerHandle(table: HHASHTABLE; parentKey: Integer; childKey: Integer; whichTimer: HTIMER): Boolean;
function SaveTriggerHandle(table: HHASHTABLE; parentKey: Integer; childKey: Integer; whichTrigger: HTRIGGER): Boolean;
function SaveTriggerConditionHandle(table: HHASHTABLE; parentKey: Integer; childKey: Integer; whichTriggercondition: HTRIGGERCONDITION): Boolean;
function SaveTriggerActionHandle(table: HHASHTABLE; parentKey: Integer; childKey: Integer; whichTriggeraction: HTRIGGERACTION): Boolean;
function SaveTriggerEventHandle(table: HHASHTABLE; parentKey: Integer; childKey: Integer; whichEvent: HEVENT): Boolean;
function SaveForceHandle(table: HHASHTABLE; parentKey: Integer; childKey: Integer; whichForce: HFORCE): Boolean;
function SaveGroupHandle(table: HHASHTABLE; parentKey: Integer; childKey: Integer; whichGroup: HGROUP): Boolean;
function SaveLocationHandle(table: HHASHTABLE; parentKey: Integer; childKey: Integer; whichLocation: HLOCATION): Boolean;
function SaveRectHandle(table: HHASHTABLE; parentKey: Integer; childKey: Integer; whichRect: HRECT): Boolean;
function SaveBooleanExprHandle(table: HHASHTABLE; parentKey: Integer; childKey: Integer; whichBoolexpr: HBOOLEXPR): Boolean;
function SaveSoundHandle(table: HHASHTABLE; parentKey: Integer; childKey: Integer; whichSound: HSOUND): Boolean;
function SaveEffectHandle(table: HHASHTABLE; parentKey: Integer; childKey: Integer; whichEffect: HEFFECT): Boolean;
function SaveUnitPoolHandle(table: HHASHTABLE; parentKey: Integer; childKey: Integer; whichUnitpool: HUNITPOOL): Boolean;
function SaveItemPoolHandle(table: HHASHTABLE; parentKey: Integer; childKey: Integer; whichItempool: HITEMPOOL): Boolean;
function SaveQuestHandle(table: HHASHTABLE; parentKey: Integer; childKey: Integer; whichQuest: HQUEST): Boolean;
function SaveQuestItemHandle(table: HHASHTABLE; parentKey: Integer; childKey: Integer; whichQuestitem: HQUESTITEM): Boolean;
function SaveDefeatConditionHandle(table: HHASHTABLE; parentKey: Integer; childKey: Integer; whichDefeatcondition: HDEFEATCONDITION): Boolean;
function SaveTimerDialogHandle(table: HHASHTABLE; parentKey: Integer; childKey: Integer; whichTimerdialog: HTIMERDIALOG): Boolean;
function SaveLeaderboardHandle(table: HHASHTABLE; parentKey: Integer; childKey: Integer; whichLeaderboard: HLEADERBOARD): Boolean;
function SaveMultiboardHandle(table: HHASHTABLE; parentKey: Integer; childKey: Integer; whichMultiboard: HMULTIBOARD): Boolean;
function SaveMultiboardItemHandle(table: HHASHTABLE; parentKey: Integer; childKey: Integer; whichMultiboarditem: HMULTIBOARDITEM): Boolean;
function SaveTrackableHandle(table: HHASHTABLE; parentKey: Integer; childKey: Integer; whichTrackable: HTRACKABLE): Boolean;
function SaveDialogHandle(table: HHASHTABLE; parentKey: Integer; childKey: Integer; whichDialog: HDIALOG): Boolean;
function SaveButtonHandle(table: HHASHTABLE; parentKey: Integer; childKey: Integer; whichButton: HBUTTON): Boolean;
function SaveTextTagHandle(table: HHASHTABLE; parentKey: Integer; childKey: Integer; whichTexttag: HTEXTTAG): Boolean;
function SaveLightningHandle(table: HHASHTABLE; parentKey: Integer; childKey: Integer; whichLightning: HLIGHTNING): Boolean;
function SaveImageHandle(table: HHASHTABLE; parentKey: Integer; childKey: Integer; whichImage: HIMAGE): Boolean;
function SaveUbersplatHandle(table: HHASHTABLE; parentKey: Integer; childKey: Integer; whichUbersplat: HUBERSPLAT): Boolean;
function SaveRegionHandle(table: HHASHTABLE; parentKey: Integer; childKey: Integer; whichRegion: HREGION): Boolean;
function SaveFogStateHandle(table: HHASHTABLE; parentKey: Integer; childKey: Integer; whichFogState: HFOGSTATE): Boolean;
function SaveFogModifierHandle(table: HHASHTABLE; parentKey: Integer; childKey: Integer; whichFogModifier: HFOGMODIFIER): Boolean;
function SaveAgentHandle(table: HHASHTABLE; parentKey: Integer; childKey: Integer; whichAgent: HAGENT): Boolean;
function SaveHashtableHandle(table: HHASHTABLE; parentKey: Integer; childKey: Integer; whichHashtable: HHASHTABLE): Boolean;
function LoadInteger(table: HHASHTABLE; parentKey: Integer; childKey: Integer): Integer;
function LoadReal(table: HHASHTABLE; parentKey: Integer; childKey: Integer): Single;
function LoadBoolean(table: HHASHTABLE; parentKey: Integer; childKey: Integer): Boolean;
function LoadStr(table: HHASHTABLE; parentKey: Integer; childKey: Integer): String;
function LoadPlayerHandle(table: HHASHTABLE; parentKey: Integer; childKey: Integer): HPLAYER;
function LoadWidgetHandle(table: HHASHTABLE; parentKey: Integer; childKey: Integer): HWIDGET;
function LoadDestructableHandle(table: HHASHTABLE; parentKey: Integer; childKey: Integer): HDESTRUCTABLE;
function LoadItemHandle(table: HHASHTABLE; parentKey: Integer; childKey: Integer): HITEM;
function LoadUnitHandle(table: HHASHTABLE; parentKey: Integer; childKey: Integer): HUNIT;
function LoadAbilityHandle(table: HHASHTABLE; parentKey: Integer; childKey: Integer): HABILITY;
function LoadTimerHandle(table: HHASHTABLE; parentKey: Integer; childKey: Integer): HTIMER;
function LoadTriggerHandle(table: HHASHTABLE; parentKey: Integer; childKey: Integer): HTRIGGER;
function LoadTriggerConditionHandle(table: HHASHTABLE; parentKey: Integer; childKey: Integer): HTRIGGERCONDITION;
function LoadTriggerActionHandle(table: HHASHTABLE; parentKey: Integer; childKey: Integer): HTRIGGERACTION;
function LoadTriggerEventHandle(table: HHASHTABLE; parentKey: Integer; childKey: Integer): HEVENT;
function LoadForceHandle(table: HHASHTABLE; parentKey: Integer; childKey: Integer): HFORCE;
function LoadGroupHandle(table: HHASHTABLE; parentKey: Integer; childKey: Integer): HGROUP;
function LoadLocationHandle(table: HHASHTABLE; parentKey: Integer; childKey: Integer): HLOCATION;
function LoadRectHandle(table: HHASHTABLE; parentKey: Integer; childKey: Integer): HRECT;
function LoadBooleanExprHandle(table: HHASHTABLE; parentKey: Integer; childKey: Integer): HBOOLEXPR;
function LoadSoundHandle(table: HHASHTABLE; parentKey: Integer; childKey: Integer): HSOUND;
function LoadEffectHandle(table: HHASHTABLE; parentKey: Integer; childKey: Integer): HEFFECT;
function LoadUnitPoolHandle(table: HHASHTABLE; parentKey: Integer; childKey: Integer): HUNITPOOL;
function LoadItemPoolHandle(table: HHASHTABLE; parentKey: Integer; childKey: Integer): HITEMPOOL;
function LoadQuestHandle(table: HHASHTABLE; parentKey: Integer; childKey: Integer): HQUEST;
function LoadQuestItemHandle(table: HHASHTABLE; parentKey: Integer; childKey: Integer): HQUESTITEM;
function LoadDefeatConditionHandle(table: HHASHTABLE; parentKey: Integer; childKey: Integer): HDEFEATCONDITION;
function LoadTimerDialogHandle(table: HHASHTABLE; parentKey: Integer; childKey: Integer): HTIMERDIALOG;
function LoadLeaderboardHandle(table: HHASHTABLE; parentKey: Integer; childKey: Integer): HLEADERBOARD;
function LoadMultiboardHandle(table: HHASHTABLE; parentKey: Integer; childKey: Integer): HMULTIBOARD;
function LoadMultiboardItemHandle(table: HHASHTABLE; parentKey: Integer; childKey: Integer): HMULTIBOARDITEM;
function LoadTrackableHandle(table: HHASHTABLE; parentKey: Integer; childKey: Integer): HTRACKABLE;
function LoadDialogHandle(table: HHASHTABLE; parentKey: Integer; childKey: Integer): HDIALOG;
function LoadButtonHandle(table: HHASHTABLE; parentKey: Integer; childKey: Integer): HBUTTON;
function LoadTextTagHandle(table: HHASHTABLE; parentKey: Integer; childKey: Integer): HTEXTTAG;
function LoadLightningHandle(table: HHASHTABLE; parentKey: Integer; childKey: Integer): HLIGHTNING;
function LoadImageHandle(table: HHASHTABLE; parentKey: Integer; childKey: Integer): HIMAGE;
function LoadUbersplatHandle(table: HHASHTABLE; parentKey: Integer; childKey: Integer): HUBERSPLAT;
function LoadRegionHandle(table: HHASHTABLE; parentKey: Integer; childKey: Integer): HREGION;
function LoadFogStateHandle(table: HHASHTABLE; parentKey: Integer; childKey: Integer): HFOGSTATE;
function LoadFogModifierHandle(table: HHASHTABLE; parentKey: Integer; childKey: Integer): HFOGMODIFIER;
function LoadHashtableHandle(table: HHASHTABLE; parentKey: Integer; childKey: Integer): HHASHTABLE;
function HaveSavedInteger(table: HHASHTABLE; parentKey: Integer; childKey: Integer): Boolean;
function HaveSavedReal(table: HHASHTABLE; parentKey: Integer; childKey: Integer): Boolean;
function HaveSavedBoolean(table: HHASHTABLE; parentKey: Integer; childKey: Integer): Boolean;
function HaveSavedString(table: HHASHTABLE; parentKey: Integer; childKey: Integer): Boolean;
function HaveSavedHandle(table: HHASHTABLE; parentKey: Integer; childKey: Integer): Boolean;
procedure RemoveSavedInteger(table: HHASHTABLE; parentKey: Integer; childKey: Integer);
procedure RemoveSavedReal(table: HHASHTABLE; parentKey: Integer; childKey: Integer);
procedure RemoveSavedBoolean(table: HHASHTABLE; parentKey: Integer; childKey: Integer);
procedure RemoveSavedString(table: HHASHTABLE; parentKey: Integer; childKey: Integer);
procedure RemoveSavedHandle(table: HHASHTABLE; parentKey: Integer; childKey: Integer);
procedure FlushParentHashtable(table: HHASHTABLE);
procedure FlushChildHashtable(table: HHASHTABLE; parentKey: Integer);
function GetRandomInt(lowBound: Integer; highBound: Integer): Integer;
function GetRandomReal(lowBound: Single; highBound: Single): Single;
function CreateUnitPool: HUNITPOOL;
procedure DestroyUnitPool(whichPool: HUNITPOOL);
procedure UnitPoolAddUnitType(whichPool: HUNITPOOL; unitId: Integer; weight: Single);
procedure UnitPoolRemoveUnitType(whichPool: HUNITPOOL; unitId: Integer);
function PlaceRandomUnit(whichPool: HUNITPOOL; forWhichPlayer: HPLAYER; x: Single; y: Single; facing: Single): HUNIT;
function CreateItemPool: HITEMPOOL;
procedure DestroyItemPool(whichItemPool: HITEMPOOL);
procedure ItemPoolAddItemType(whichItemPool: HITEMPOOL; itemId: Integer; weight: Single);
procedure ItemPoolRemoveItemType(whichItemPool: HITEMPOOL; itemId: Integer);
function PlaceRandomItem(whichItemPool: HITEMPOOL; x: Single; y: Single): HITEM;
function ChooseRandomCreep(level: Integer): Integer;
function ChooseRandomNPBuilding: Integer;
function ChooseRandomItem(level: Integer): Integer;
function ChooseRandomItemEx(whichType: HITEMTYPE; level: Integer): Integer;
procedure SetRandomSeed(seed: Integer);
procedure SetTerrainFog(a: Single; b: Single; c: Single; d: Single; e: Single);
procedure ResetTerrainFog;
procedure SetUnitFog(a: Single; b: Single; c: Single; d: Single; e: Single);
procedure SetTerrainFogEx(style: Integer; zstart: Single; zend: Single; density: Single; red: Single; green: Single; blue: Single);
procedure DisplayTextToPlayer(toPlayer: HPLAYER; x: Single; y: Single; message: String);
procedure DisplayTimedTextToPlayer(toPlayer: HPLAYER; x: Single; y: Single; duration: Single; message: String);
procedure DisplayTimedTextFromPlayer(toPlayer: HPLAYER; x: Single; y: Single; duration: Single; message: String);
procedure ClearTextMessages;
procedure SetDayNightModels(terrainDNCFile: String; unitDNCFile: String);
procedure SetSkyModel(skyModelFile: String);
procedure EnableUserControl(b: Boolean);
procedure EnableUserUI(b: Boolean);
procedure SuspendTimeOfDay(b: Boolean);
procedure SetTimeOfDayScale(r: Single);
function GetTimeOfDayScale: Single;
procedure ShowInterface(flag: Boolean; fadeDuration: Single);
procedure PauseGame(flag: Boolean);
procedure UnitAddIndicator(whichUnit: HUNIT; red: Integer; green: Integer; blue: Integer; alpha: Integer);
procedure AddIndicator(whichWidget: HWIDGET; red: Integer; green: Integer; blue: Integer; alpha: Integer);
procedure PingMinimap(x: Single; y: Single; duration: Single);
procedure PingMinimapEx(x: Single; y: Single; duration: Single; red: Integer; green: Integer; blue: Integer; extraEffects: Boolean);
procedure EnableOcclusion(flag: Boolean);
procedure SetIntroShotText(introText: String);
procedure SetIntroShotModel(introModelPath: String);
procedure EnableWorldFogBoundary(b: Boolean);
procedure PlayModelCinematic(modelName: String);
procedure PlayCinematic(movieName: String);
procedure ForceUIKey(key: String);
procedure ForceUICancel;
procedure DisplayLoadDialog;
procedure SetAltMinimapIcon(iconPath: String);
procedure DisableRestartMission(flag: Boolean);
function CreateTextTag: HTEXTTAG;
procedure DestroyTextTag(t: HTEXTTAG);
procedure SetTextTagText(t: HTEXTTAG; s: String; height: Single);
procedure SetTextTagPos(t: HTEXTTAG; x: Single; y: Single; heightOffset: Single);
procedure SetTextTagPosUnit(t: HTEXTTAG; whichUnit: HUNIT; heightOffset: Single);
procedure SetTextTagColor(t: HTEXTTAG; red: Integer; green: Integer; blue: Integer; alpha: Integer);
procedure SetTextTagVelocity(t: HTEXTTAG; xvel: Single; yvel: Single);
procedure SetTextTagVisibility(t: HTEXTTAG; flag: Boolean);
procedure SetTextTagSuspended(t: HTEXTTAG; flag: Boolean);
procedure SetTextTagPermanent(t: HTEXTTAG; flag: Boolean);
procedure SetTextTagAge(t: HTEXTTAG; age: Single);
procedure SetTextTagLifespan(t: HTEXTTAG; lifespan: Single);
procedure SetTextTagFadepoint(t: HTEXTTAG; fadepoint: Single);
procedure SetReservedLocalHeroButtons(reserved: Integer);
function GetAllyColorFilterState: Integer;
procedure SetAllyColorFilterState(state: Integer);
function GetCreepCampFilterState: Boolean;
procedure SetCreepCampFilterState(state: Boolean);
procedure EnableMinimapFilterButtons(enableAlly: Boolean; enableCreep: Boolean);
procedure EnableDragSelect(state: Boolean; ui: Boolean);
procedure EnablePreSelect(state: Boolean; ui: Boolean);
procedure EnableSelect(state: Boolean; ui: Boolean);
function CreateTrackable(trackableModelPath: String; x: Single; y: Single; facing: Single): HTRACKABLE;
function CreateQuest: HQUEST;
procedure DestroyQuest(whichQuest: HQUEST);
procedure QuestSetTitle(whichQuest: HQUEST; title: String);
procedure QuestSetDescription(whichQuest: HQUEST; description: String);
procedure QuestSetIconPath(whichQuest: HQUEST; iconPath: String);
procedure QuestSetRequired(whichQuest: HQUEST; required: Boolean);
procedure QuestSetCompleted(whichQuest: HQUEST; completed: Boolean);
procedure QuestSetDiscovered(whichQuest: HQUEST; discovered: Boolean);
procedure QuestSetFailed(whichQuest: HQUEST; failed: Boolean);
procedure QuestSetEnabled(whichQuest: HQUEST; enabled: Boolean);
function IsQuestRequired(whichQuest: HQUEST): Boolean;
function IsQuestCompleted(whichQuest: HQUEST): Boolean;
function IsQuestDiscovered(whichQuest: HQUEST): Boolean;
function IsQuestFailed(whichQuest: HQUEST): Boolean;
function IsQuestEnabled(whichQuest: HQUEST): Boolean;
function QuestCreateItem(whichQuest: HQUEST): HQUESTITEM;
procedure QuestItemSetDescription(whichQuestItem: HQUESTITEM; description: String);
procedure QuestItemSetCompleted(whichQuestItem: HQUESTITEM; completed: Boolean);
function IsQuestItemCompleted(whichQuestItem: HQUESTITEM): Boolean;
function CreateDefeatCondition: HDEFEATCONDITION;
procedure DestroyDefeatCondition(whichCondition: HDEFEATCONDITION);
procedure DefeatConditionSetDescription(whichCondition: HDEFEATCONDITION; description: String);
procedure FlashQuestDialogButton;
procedure ForceQuestDialogUpdate;
function CreateTimerDialog(t: HTIMER): HTIMERDIALOG;
procedure DestroyTimerDialog(whichDialog: HTIMERDIALOG);
procedure TimerDialogSetTitle(whichDialog: HTIMERDIALOG; title: String);
procedure TimerDialogSetTitleColor(whichDialog: HTIMERDIALOG; red: Integer; green: Integer; blue: Integer; alpha: Integer);
procedure TimerDialogSetTimeColor(whichDialog: HTIMERDIALOG; red: Integer; green: Integer; blue: Integer; alpha: Integer);
procedure TimerDialogSetSpeed(whichDialog: HTIMERDIALOG; speedMultFactor: Single);
procedure TimerDialogDisplay(whichDialog: HTIMERDIALOG; display: Boolean);
function IsTimerDialogDisplayed(whichDialog: HTIMERDIALOG): Boolean;
procedure TimerDialogSetRealTimeRemaining(whichDialog: HTIMERDIALOG; timeRemaining: Single);
function CreateLeaderboard: HLEADERBOARD;
procedure DestroyLeaderboard(lb: HLEADERBOARD);
procedure LeaderboardDisplay(lb: HLEADERBOARD; show: Boolean);
function IsLeaderboardDisplayed(lb: HLEADERBOARD): Boolean;
function LeaderboardGetItemCount(lb: HLEADERBOARD): Integer;
procedure LeaderboardSetSizeByItemCount(lb: HLEADERBOARD; count: Integer);
procedure LeaderboardAddItem(lb: HLEADERBOARD; label_: String; value: Integer; p: HPLAYER);
procedure LeaderboardRemoveItem(lb: HLEADERBOARD; index: Integer);
procedure LeaderboardRemovePlayerItem(lb: HLEADERBOARD; p: HPLAYER);
procedure LeaderboardClear(lb: HLEADERBOARD);
procedure LeaderboardSortItemsByValue(lb: HLEADERBOARD; ascending: Boolean);
procedure LeaderboardSortItemsByPlayer(lb: HLEADERBOARD; ascending: Boolean);
procedure LeaderboardSortItemsByLabel(lb: HLEADERBOARD; ascending: Boolean);
function LeaderboardHasPlayerItem(lb: HLEADERBOARD; p: HPLAYER): Boolean;
function LeaderboardGetPlayerIndex(lb: HLEADERBOARD; p: HPLAYER): Integer;
procedure LeaderboardSetLabel(lb: HLEADERBOARD; label_: String);
function LeaderboardGetLabelText(lb: HLEADERBOARD): String;
procedure PlayerSetLeaderboard(toPlayer: HPLAYER; lb: HLEADERBOARD);
function PlayerGetLeaderboard(toPlayer: HPLAYER): HLEADERBOARD;
procedure LeaderboardSetLabelColor(lb: HLEADERBOARD; red: Integer; green: Integer; blue: Integer; alpha: Integer);
procedure LeaderboardSetValueColor(lb: HLEADERBOARD; red: Integer; green: Integer; blue: Integer; alpha: Integer);
procedure LeaderboardSetStyle(lb: HLEADERBOARD; showLabel: Boolean; showNames: Boolean; showValues: Boolean; showIcons: Boolean);
procedure LeaderboardSetItemValue(lb: HLEADERBOARD; whichItem: Integer; val: Integer);
procedure LeaderboardSetItemLabel(lb: HLEADERBOARD; whichItem: Integer; val: String);
procedure LeaderboardSetItemStyle(lb: HLEADERBOARD; whichItem: Integer; showLabel: Boolean; showValue: Boolean; showIcon: Boolean);
procedure LeaderboardSetItemLabelColor(lb: HLEADERBOARD; whichItem: Integer; red: Integer; green: Integer; blue: Integer; alpha: Integer);
procedure LeaderboardSetItemValueColor(lb: HLEADERBOARD; whichItem: Integer; red: Integer; green: Integer; blue: Integer; alpha: Integer);
function CreateMultiboard: HMULTIBOARD;
procedure DestroyMultiboard(lb: HMULTIBOARD);
procedure MultiboardDisplay(lb: HMULTIBOARD; show: Boolean);
function IsMultiboardDisplayed(lb: HMULTIBOARD): Boolean;
procedure MultiboardMinimize(lb: HMULTIBOARD; minimize: Boolean);
function IsMultiboardMinimized(lb: HMULTIBOARD): Boolean;
procedure MultiboardClear(lb: HMULTIBOARD);
procedure MultiboardSetTitleText(lb: HMULTIBOARD; label_: String);
function MultiboardGetTitleText(lb: HMULTIBOARD): String;
procedure MultiboardSetTitleTextColor(lb: HMULTIBOARD; red: Integer; green: Integer; blue: Integer; alpha: Integer);
function MultiboardGetRowCount(lb: HMULTIBOARD): Integer;
function MultiboardGetColumnCount(lb: HMULTIBOARD): Integer;
procedure MultiboardSetColumnCount(lb: HMULTIBOARD; count: Integer);
procedure MultiboardSetRowCount(lb: HMULTIBOARD; count: Integer);
procedure MultiboardSetItemsStyle(lb: HMULTIBOARD; showValues: Boolean; showIcons: Boolean);
procedure MultiboardSetItemsValue(lb: HMULTIBOARD; value: String);
procedure MultiboardSetItemsValueColor(lb: HMULTIBOARD; red: Integer; green: Integer; blue: Integer; alpha: Integer);
procedure MultiboardSetItemsWidth(lb: HMULTIBOARD; width: Single);
procedure MultiboardSetItemsIcon(lb: HMULTIBOARD; iconPath: String);
function MultiboardGetItem(lb: HMULTIBOARD; row: Integer; column: Integer): HMULTIBOARDITEM;
procedure MultiboardReleaseItem(mbi: HMULTIBOARDITEM);
procedure MultiboardSetItemStyle(mbi: HMULTIBOARDITEM; showValue: Boolean; showIcon: Boolean);
procedure MultiboardSetItemValue(mbi: HMULTIBOARDITEM; val: String);
procedure MultiboardSetItemValueColor(mbi: HMULTIBOARDITEM; red: Integer; green: Integer; blue: Integer; alpha: Integer);
procedure MultiboardSetItemWidth(mbi: HMULTIBOARDITEM; width: Single);
procedure MultiboardSetItemIcon(mbi: HMULTIBOARDITEM; iconFileName: String);
procedure MultiboardSuppressDisplay(flag: Boolean);
procedure SetCameraPosition(x: Single; y: Single);
procedure SetCameraQuickPosition(x: Single; y: Single);
procedure SetCameraBounds(x1: Single; y1: Single; x2: Single; y2: Single; x3: Single; y3: Single; x4: Single; y4: Single);
procedure StopCamera;
procedure ResetToGameCamera(duration: Single);
procedure PanCameraTo(x: Single; y: Single);
procedure PanCameraToTimed(x: Single; y: Single; duration: Single);
procedure PanCameraToWithZ(x: Single; y: Single; zOffsetDest: Single);
procedure PanCameraToTimedWithZ(x: Single; y: Single; zOffsetDest: Single; duration: Single);
procedure SetCinematicCamera(cameraModelFile: String);
procedure SetCameraRotateMode(x: Single; y: Single; radiansToSweep: Single; duration: Single);
procedure SetCameraField(whichField: HCAMERAFIELD; value: Single; duration: Single);
procedure AdjustCameraField(whichField: HCAMERAFIELD; offset: Single; duration: Single);
procedure SetCameraTargetController(whichUnit: HUNIT; xoffset: Single; yoffset: Single; inheritOrientation: Boolean);
procedure SetCameraOrientController(whichUnit: HUNIT; xoffset: Single; yoffset: Single);
function CreateCameraSetup: HCAMERASETUP;
procedure CameraSetupSetField(whichSetup: HCAMERASETUP; whichField: HCAMERAFIELD; value: Single; duration: Single);
function CameraSetupGetField(whichSetup: HCAMERASETUP; whichField: HCAMERAFIELD): Single;
procedure CameraSetupSetDestPosition(whichSetup: HCAMERASETUP; x: Single; y: Single; duration: Single);
function CameraSetupGetDestPositionLoc(whichSetup: HCAMERASETUP): HLOCATION;
function CameraSetupGetDestPositionX(whichSetup: HCAMERASETUP): Single;
function CameraSetupGetDestPositionY(whichSetup: HCAMERASETUP): Single;
procedure CameraSetupApply(whichSetup: HCAMERASETUP; doPan: Boolean; panTimed: Boolean);
procedure CameraSetupApplyWithZ(whichSetup: HCAMERASETUP; zDestOffset: Single);
procedure CameraSetupApplyForceDuration(whichSetup: HCAMERASETUP; doPan: Boolean; forceDuration: Single);
procedure CameraSetupApplyForceDurationWithZ(whichSetup: HCAMERASETUP; zDestOffset: Single; forceDuration: Single);
procedure CameraSetTargetNoise(mag: Single; velocity: Single);
procedure CameraSetSourceNoise(mag: Single; velocity: Single);
procedure CameraSetTargetNoiseEx(mag: Single; velocity: Single; vertOnly: Boolean);
procedure CameraSetSourceNoiseEx(mag: Single; velocity: Single; vertOnly: Boolean);
procedure CameraSetSmoothingFactor(factor: Single);
procedure SetCineFilterTexture(filename: String);
procedure SetCineFilterBlendMode(whichMode: HBLENDMODE);
procedure SetCineFilterTexMapFlags(whichFlags: HTEXMAPFLAGS);
procedure SetCineFilterStartUV(minu: Single; minv: Single; maxu: Single; maxv: Single);
procedure SetCineFilterEndUV(minu: Single; minv: Single; maxu: Single; maxv: Single);
procedure SetCineFilterStartColor(red: Integer; green: Integer; blue: Integer; alpha: Integer);
procedure SetCineFilterEndColor(red: Integer; green: Integer; blue: Integer; alpha: Integer);
procedure SetCineFilterDuration(duration: Single);
procedure DisplayCineFilter(flag: Boolean);
function IsCineFilterDisplayed: Boolean;
procedure SetCinematicScene(portraitUnitId: Integer; color: HPLAYERCOLOR; speakerTitle: String; text: String; sceneDuration: Single; voiceoverDuration: Single);
procedure EndCinematicScene;
procedure ForceCinematicSubtitles(flag: Boolean);
function GetCameraMargin(whichMargin: Integer): Single;
function GetCameraBoundMinX: Single;
function GetCameraBoundMinY: Single;
function GetCameraBoundMaxX: Single;
function GetCameraBoundMaxY: Single;
function GetCameraField(whichField: HCAMERAFIELD): Single;
function GetCameraTargetPositionX: Single;
function GetCameraTargetPositionY: Single;
function GetCameraTargetPositionZ: Single;
function GetCameraTargetPositionLoc: HLOCATION;
function GetCameraEyePositionX: Single;
function GetCameraEyePositionY: Single;
function GetCameraEyePositionZ: Single;
function GetCameraEyePositionLoc: HLOCATION;
procedure NewSoundEnvironment(environmentName: String);
function CreateSound(fileName: String; looping: Boolean; is3D: Boolean; stopwhenoutofrange: Boolean; fadeInRate: Integer; fadeOutRate: Integer; eaxSetting: String): HSOUND;
function CreateSoundFilenameWithLabel(fileName: String; looping: Boolean; is3D: Boolean; stopwhenoutofrange: Boolean; fadeInRate: Integer; fadeOutRate: Integer; SLKEntryName: String): HSOUND;
function CreateSoundFromLabel(soundLabel: String; looping: Boolean; is3D: Boolean; stopwhenoutofrange: Boolean; fadeInRate: Integer; fadeOutRate: Integer): HSOUND;
function CreateMIDISound(soundLabel: String; fadeInRate: Integer; fadeOutRate: Integer): HSOUND;
procedure SetSoundParamsFromLabel(soundHandle: HSOUND; soundLabel: String);
procedure SetSoundDistanceCutoff(soundHandle: HSOUND; cutoff: Single);
procedure SetSoundChannel(soundHandle: HSOUND; channel: Integer);
procedure SetSoundVolume(soundHandle: HSOUND; volume: Integer);
procedure SetSoundPitch(soundHandle: HSOUND; pitch: Single);
procedure SetSoundPlayPosition(soundHandle: HSOUND; millisecs: Integer);
procedure SetSoundDistances(soundHandle: HSOUND; minDist: Single; maxDist: Single);
procedure SetSoundConeAngles(soundHandle: HSOUND; inside: Single; outside: Single; outsideVolume: Integer);
procedure SetSoundConeOrientation(soundHandle: HSOUND; x: Single; y: Single; z: Single);
procedure SetSoundPosition(soundHandle: HSOUND; x: Single; y: Single; z: Single);
procedure SetSoundVelocity(soundHandle: HSOUND; x: Single; y: Single; z: Single);
procedure AttachSoundToUnit(soundHandle: HSOUND; whichUnit: HUNIT);
procedure StartSound(soundHandle: HSOUND);
procedure StopSound(soundHandle: HSOUND; killWhenDone: Boolean; fadeOut: Boolean);
procedure KillSoundWhenDone(soundHandle: HSOUND);
procedure SetMapMusic(musicName: String; random: Boolean; index: Integer);
procedure ClearMapMusic;
procedure PlayMusic(musicName: String);
procedure PlayMusicEx(musicName: String; frommsecs: Integer; fadeinmsecs: Integer);
procedure StopMusic(fadeOut: Boolean);
procedure ResumeMusic;
procedure PlayThematicMusic(musicFileName: String);
procedure PlayThematicMusicEx(musicFileName: String; frommsecs: Integer);
procedure EndThematicMusic;
procedure SetMusicVolume(volume: Integer);
procedure SetMusicPlayPosition(millisecs: Integer);
procedure SetThematicMusicPlayPosition(millisecs: Integer);
procedure SetSoundDuration(soundHandle: HSOUND; duration: Integer);
function GetSoundDuration(soundHandle: HSOUND): Integer;
function GetSoundFileDuration(musicFileName: String): Integer;
procedure VolumeGroupSetVolume(vgroup: HVOLUMEGROUP; scale: Single);
procedure VolumeGroupReset;
function GetSoundIsPlaying(soundHandle: HSOUND): Boolean;
function GetSoundIsLoading(soundHandle: HSOUND): Boolean;
procedure RegisterStackedSound(soundHandle: HSOUND; byPosition: Boolean; rectwidth: Single; rectheight: Single);
procedure UnregisterStackedSound(soundHandle: HSOUND; byPosition: Boolean; rectwidth: Single; rectheight: Single);
function AddWeatherEffect(where: HRECT; effectID: Integer): HWEATHEREFFECT;
procedure RemoveWeatherEffect(whichEffect: HWEATHEREFFECT);
procedure EnableWeatherEffect(whichEffect: HWEATHEREFFECT; enable: Boolean);
function TerrainDeformCrater(x: Single; y: Single; radius: Single; depth: Single; duration: Integer; permanent: Boolean): HTERRAINDEFORMATION;
function TerrainDeformRipple(x: Single; y: Single; radius: Single; depth: Single; duration: Integer; count: Integer; spaceWaves: Single; timeWaves: Single; radiusStartPct: Single; limitNeg: Boolean): HTERRAINDEFORMATION;
function TerrainDeformWave(x: Single; y: Single; dirX: Single; dirY: Single; distance: Single; speed: Single; radius: Single; depth: Single; trailTime: Integer; count: Integer): HTERRAINDEFORMATION;
function TerrainDeformRandom(x: Single; y: Single; radius: Single; minDelta: Single; maxDelta: Single; duration: Integer; updateInterval: Integer): HTERRAINDEFORMATION;
procedure TerrainDeformStop(deformation: HTERRAINDEFORMATION; duration: Integer);
procedure TerrainDeformStopAll;
function AddSpecialEffect(modelName: String; x: Single; y: Single): HEFFECT;
function AddSpecialEffectLoc(modelName: String; where: HLOCATION): HEFFECT;
function AddSpecialEffectTarget(modelName: String; targetWidget: HWIDGET; attachPointName: String): HEFFECT;
procedure DestroyEffect(whichEffect: HEFFECT);
function AddSpellEffect(abilityString: String; t: HEFFECTTYPE; x: Single; y: Single): HEFFECT;
function AddSpellEffectLoc(abilityString: String; t: HEFFECTTYPE; where: HLOCATION): HEFFECT;
function AddSpellEffectById(abilityId: Integer; t: HEFFECTTYPE; x: Single; y: Single): HEFFECT;
function AddSpellEffectByIdLoc(abilityId: Integer; t: HEFFECTTYPE; where: HLOCATION): HEFFECT;
function AddSpellEffectTarget(modelName: String; t: HEFFECTTYPE; targetWidget: HWIDGET; attachPoint: String): HEFFECT;
function AddSpellEffectTargetById(abilityId: Integer; t: HEFFECTTYPE; targetWidget: HWIDGET; attachPoint: String): HEFFECT;
function AddLightning(codeName: String; checkVisibility: Boolean; x1: Single; y1: Single; x2: Single; y2: Single): HLIGHTNING;
function AddLightningEx(codeName: String; checkVisibility: Boolean; x1: Single; y1: Single; z1: Single; x2: Single; y2: Single; z2: Single): HLIGHTNING;
function DestroyLightning(whichBolt: HLIGHTNING): Boolean;
function MoveLightning(whichBolt: HLIGHTNING; checkVisibility: Boolean; x1: Single; y1: Single; x2: Single; y2: Single): Boolean;
function MoveLightningEx(whichBolt: HLIGHTNING; checkVisibility: Boolean; x1: Single; y1: Single; z1: Single; x2: Single; y2: Single; z2: Single): Boolean;
function GetLightningColorA(whichBolt: HLIGHTNING): Single;
function GetLightningColorR(whichBolt: HLIGHTNING): Single;
function GetLightningColorG(whichBolt: HLIGHTNING): Single;
function GetLightningColorB(whichBolt: HLIGHTNING): Single;
function SetLightningColor(whichBolt: HLIGHTNING; r: Single; g: Single; b: Single; a: Single): Boolean;
function GetAbilityEffect(abilityString: String; t: HEFFECTTYPE; index: Integer): String;
function GetAbilityEffectById(abilityId: Integer; t: HEFFECTTYPE; index: Integer): String;
function GetAbilitySound(abilityString: String; t: HSOUNDTYPE): String;
function GetAbilitySoundById(abilityId: Integer; t: HSOUNDTYPE): String;
function GetTerrainCliffLevel(x: Single; y: Single): Integer;
procedure SetWaterBaseColor(red: Integer; green: Integer; blue: Integer; alpha: Integer);
procedure SetWaterDeforms(val: Boolean);
function GetTerrainType(x: Single; y: Single): Integer;
function GetTerrainVariance(x: Single; y: Single): Integer;
procedure SetTerrainType(x: Single; y: Single; terrainType: Integer; variation: Integer; area: Integer; shape: Integer);
function IsTerrainPathable(x: Single; y: Single; t: HPATHINGTYPE): Boolean;
procedure SetTerrainPathable(x: Single; y: Single; t: HPATHINGTYPE; flag: Boolean);
function CreateImage(file_: String; sizeX: Single; sizeY: Single; sizeZ: Single; posX: Single; posY: Single; posZ: Single; originX: Single; originY: Single; originZ: Single; imageType: Integer): HIMAGE;
procedure DestroyImage(whichImage: HIMAGE);
procedure ShowImage(whichImage: HIMAGE; flag: Boolean);
procedure SetImageConstantHeight(whichImage: HIMAGE; flag: Boolean; height: Single);
procedure SetImagePosition(whichImage: HIMAGE; x: Single; y: Single; z: Single);
procedure SetImageColor(whichImage: HIMAGE; red: Integer; green: Integer; blue: Integer; alpha: Integer);
procedure SetImageRender(whichImage: HIMAGE; flag: Boolean);
procedure SetImageRenderAlways(whichImage: HIMAGE; flag: Boolean);
procedure SetImageAboveWater(whichImage: HIMAGE; flag: Boolean; useWaterAlpha: Boolean);
procedure SetImageType(whichImage: HIMAGE; imageType: Integer);
function CreateUbersplat(x: Single; y: Single; name: String; red: Integer; green: Integer; blue: Integer; alpha: Integer; forcePaused: Boolean; noBirthTime: Boolean): HUBERSPLAT;
procedure DestroyUbersplat(whichSplat: HUBERSPLAT);
procedure ResetUbersplat(whichSplat: HUBERSPLAT);
procedure FinishUbersplat(whichSplat: HUBERSPLAT);
procedure ShowUbersplat(whichSplat: HUBERSPLAT; flag: Boolean);
procedure SetUbersplatRender(whichSplat: HUBERSPLAT; flag: Boolean);
procedure SetUbersplatRenderAlways(whichSplat: HUBERSPLAT; flag: Boolean);
procedure SetBlight(whichPlayer: HPLAYER; x: Single; y: Single; radius: Single; addBlight: Boolean);
procedure SetBlightRect(whichPlayer: HPLAYER; r: HRECT; addBlight: Boolean);
procedure SetBlightPoint(whichPlayer: HPLAYER; x: Single; y: Single; addBlight: Boolean);
procedure SetBlightLoc(whichPlayer: HPLAYER; whichLocation: HLOCATION; radius: Single; addBlight: Boolean);
function CreateBlightedGoldmine(id: HPLAYER; x: Single; y: Single; face: Single): HUNIT;
function IsPointBlighted(x: Single; y: Single): Boolean;
procedure SetDoodadAnimation(x: Single; y: Single; radius: Single; doodadID: Integer; nearestOnly: Boolean; animName: String; animRandom: Boolean);
procedure SetDoodadAnimationRect(r: HRECT; doodadID: Integer; animName: String; animRandom: Boolean);
procedure StartMeleeAI(num: HPLAYER; script: String);
procedure StartCampaignAI(num: HPLAYER; script: String);
procedure CommandAI(num: HPLAYER; command: Integer; data: Integer);
procedure PauseCompAI(p: HPLAYER; pause: Boolean);
function GetAIDifficulty(num: HPLAYER): HAIDIFFICULTY;
procedure RemoveGuardPosition(hUnit: HUNIT);
procedure RecycleGuardPosition(hUnit: HUNIT);
procedure RemoveAllGuardPositions(num: HPLAYER);
procedure Cheat(cheatStr: String);
function IsNoVictoryCheat: Boolean;
function IsNoDefeatCheat: Boolean;
procedure Preload(filename: String);
procedure PreloadEnd(timeout: Single);
procedure PreloadStart;
procedure PreloadRefresh;
procedure PreloadEndEx;
procedure PreloadGenClear;
procedure PreloadGenStart;
procedure PreloadGenEnd(filename: String);
procedure Preloader(filename: String);

implementation

type TConvertRaceFunctionPrototype = function (i: Int32): HRACE; cdecl;
var _ConvertRace: TConvertRaceFunctionPrototype;

function ConvertRace(i: Integer): HRACE;
begin
	Result:= _ConvertRace(i);
end;

type TConvertAllianceTypeFunctionPrototype = function (i: Int32): HALLIANCETYPE; cdecl;
var _ConvertAllianceType: TConvertAllianceTypeFunctionPrototype;

function ConvertAllianceType(i: Integer): HALLIANCETYPE;
begin
	Result:= _ConvertAllianceType(i);
end;

type TConvertRacePrefFunctionPrototype = function (i: Int32): HRACEPREFERENCE; cdecl;
var _ConvertRacePref: TConvertRacePrefFunctionPrototype;

function ConvertRacePref(i: Integer): HRACEPREFERENCE;
begin
	Result:= _ConvertRacePref(i);
end;

type TConvertIGameStateFunctionPrototype = function (i: Int32): HIGAMESTATE; cdecl;
var _ConvertIGameState: TConvertIGameStateFunctionPrototype;

function ConvertIGameState(i: Integer): HIGAMESTATE;
begin
	Result:= _ConvertIGameState(i);
end;

type TConvertFGameStateFunctionPrototype = function (i: Int32): HFGAMESTATE; cdecl;
var _ConvertFGameState: TConvertFGameStateFunctionPrototype;

function ConvertFGameState(i: Integer): HFGAMESTATE;
begin
	Result:= _ConvertFGameState(i);
end;

type TConvertPlayerStateFunctionPrototype = function (i: Int32): HPLAYERSTATE; cdecl;
var _ConvertPlayerState: TConvertPlayerStateFunctionPrototype;

function ConvertPlayerState(i: Integer): HPLAYERSTATE;
begin
	Result:= _ConvertPlayerState(i);
end;

type TConvertPlayerScoreFunctionPrototype = function (i: Int32): HPLAYERSCORE; cdecl;
var _ConvertPlayerScore: TConvertPlayerScoreFunctionPrototype;

function ConvertPlayerScore(i: Integer): HPLAYERSCORE;
begin
	Result:= _ConvertPlayerScore(i);
end;

type TConvertPlayerGameResultFunctionPrototype = function (i: Int32): HPLAYERGAMERESULT; cdecl;
var _ConvertPlayerGameResult: TConvertPlayerGameResultFunctionPrototype;

function ConvertPlayerGameResult(i: Integer): HPLAYERGAMERESULT;
begin
	Result:= _ConvertPlayerGameResult(i);
end;

type TConvertUnitStateFunctionPrototype = function (i: Int32): HUNITSTATE; cdecl;
var _ConvertUnitState: TConvertUnitStateFunctionPrototype;

function ConvertUnitState(i: Integer): HUNITSTATE;
begin
	Result:= _ConvertUnitState(i);
end;

type TConvertAIDifficultyFunctionPrototype = function (i: Int32): HAIDIFFICULTY; cdecl;
var _ConvertAIDifficulty: TConvertAIDifficultyFunctionPrototype;

function ConvertAIDifficulty(i: Integer): HAIDIFFICULTY;
begin
	Result:= _ConvertAIDifficulty(i);
end;

type TConvertGameEventFunctionPrototype = function (i: Int32): HGAMEEVENT; cdecl;
var _ConvertGameEvent: TConvertGameEventFunctionPrototype;

function ConvertGameEvent(i: Integer): HGAMEEVENT;
begin
	Result:= _ConvertGameEvent(i);
end;

type TConvertPlayerEventFunctionPrototype = function (i: Int32): HPLAYEREVENT; cdecl;
var _ConvertPlayerEvent: TConvertPlayerEventFunctionPrototype;

function ConvertPlayerEvent(i: Integer): HPLAYEREVENT;
begin
	Result:= _ConvertPlayerEvent(i);
end;

type TConvertPlayerUnitEventFunctionPrototype = function (i: Int32): HPLAYERUNITEVENT; cdecl;
var _ConvertPlayerUnitEvent: TConvertPlayerUnitEventFunctionPrototype;

function ConvertPlayerUnitEvent(i: Integer): HPLAYERUNITEVENT;
begin
	Result:= _ConvertPlayerUnitEvent(i);
end;

type TConvertWidgetEventFunctionPrototype = function (i: Int32): HWIDGETEVENT; cdecl;
var _ConvertWidgetEvent: TConvertWidgetEventFunctionPrototype;

function ConvertWidgetEvent(i: Integer): HWIDGETEVENT;
begin
	Result:= _ConvertWidgetEvent(i);
end;

type TConvertDialogEventFunctionPrototype = function (i: Int32): HDIALOGEVENT; cdecl;
var _ConvertDialogEvent: TConvertDialogEventFunctionPrototype;

function ConvertDialogEvent(i: Integer): HDIALOGEVENT;
begin
	Result:= _ConvertDialogEvent(i);
end;

type TConvertUnitEventFunctionPrototype = function (i: Int32): HUNITEVENT; cdecl;
var _ConvertUnitEvent: TConvertUnitEventFunctionPrototype;

function ConvertUnitEvent(i: Integer): HUNITEVENT;
begin
	Result:= _ConvertUnitEvent(i);
end;

type TConvertLimitOpFunctionPrototype = function (i: Int32): HLIMITOP; cdecl;
var _ConvertLimitOp: TConvertLimitOpFunctionPrototype;

function ConvertLimitOp(i: Integer): HLIMITOP;
begin
	Result:= _ConvertLimitOp(i);
end;

type TConvertUnitTypeFunctionPrototype = function (i: Int32): HUNITTYPE; cdecl;
var _ConvertUnitType: TConvertUnitTypeFunctionPrototype;

function ConvertUnitType(i: Integer): HUNITTYPE;
begin
	Result:= _ConvertUnitType(i);
end;

type TConvertGameSpeedFunctionPrototype = function (i: Int32): HGAMESPEED; cdecl;
var _ConvertGameSpeed: TConvertGameSpeedFunctionPrototype;

function ConvertGameSpeed(i: Integer): HGAMESPEED;
begin
	Result:= _ConvertGameSpeed(i);
end;

type TConvertPlacementFunctionPrototype = function (i: Int32): HPLACEMENT; cdecl;
var _ConvertPlacement: TConvertPlacementFunctionPrototype;

function ConvertPlacement(i: Integer): HPLACEMENT;
begin
	Result:= _ConvertPlacement(i);
end;

type TConvertStartLocPrioFunctionPrototype = function (i: Int32): HSTARTLOCPRIO; cdecl;
var _ConvertStartLocPrio: TConvertStartLocPrioFunctionPrototype;

function ConvertStartLocPrio(i: Integer): HSTARTLOCPRIO;
begin
	Result:= _ConvertStartLocPrio(i);
end;

type TConvertGameDifficultyFunctionPrototype = function (i: Int32): HGAMEDIFFICULTY; cdecl;
var _ConvertGameDifficulty: TConvertGameDifficultyFunctionPrototype;

function ConvertGameDifficulty(i: Integer): HGAMEDIFFICULTY;
begin
	Result:= _ConvertGameDifficulty(i);
end;

type TConvertGameTypeFunctionPrototype = function (i: Int32): HGAMETYPE; cdecl;
var _ConvertGameType: TConvertGameTypeFunctionPrototype;

function ConvertGameType(i: Integer): HGAMETYPE;
begin
	Result:= _ConvertGameType(i);
end;

type TConvertMapFlagFunctionPrototype = function (i: Int32): HMAPFLAG; cdecl;
var _ConvertMapFlag: TConvertMapFlagFunctionPrototype;

function ConvertMapFlag(i: Integer): HMAPFLAG;
begin
	Result:= _ConvertMapFlag(i);
end;

type TConvertMapVisibilityFunctionPrototype = function (i: Int32): HMAPVISIBILITY; cdecl;
var _ConvertMapVisibility: TConvertMapVisibilityFunctionPrototype;

function ConvertMapVisibility(i: Integer): HMAPVISIBILITY;
begin
	Result:= _ConvertMapVisibility(i);
end;

type TConvertMapSettingFunctionPrototype = function (i: Int32): HMAPSETTING; cdecl;
var _ConvertMapSetting: TConvertMapSettingFunctionPrototype;

function ConvertMapSetting(i: Integer): HMAPSETTING;
begin
	Result:= _ConvertMapSetting(i);
end;

type TConvertMapDensityFunctionPrototype = function (i: Int32): HMAPDENSITY; cdecl;
var _ConvertMapDensity: TConvertMapDensityFunctionPrototype;

function ConvertMapDensity(i: Integer): HMAPDENSITY;
begin
	Result:= _ConvertMapDensity(i);
end;

type TConvertMapControlFunctionPrototype = function (i: Int32): HMAPCONTROL; cdecl;
var _ConvertMapControl: TConvertMapControlFunctionPrototype;

function ConvertMapControl(i: Integer): HMAPCONTROL;
begin
	Result:= _ConvertMapControl(i);
end;

type TConvertPlayerColorFunctionPrototype = function (i: Int32): HPLAYERCOLOR; cdecl;
var _ConvertPlayerColor: TConvertPlayerColorFunctionPrototype;

function ConvertPlayerColor(i: Integer): HPLAYERCOLOR;
begin
	Result:= _ConvertPlayerColor(i);
end;

type TConvertPlayerSlotStateFunctionPrototype = function (i: Int32): HPLAYERSLOTSTATE; cdecl;
var _ConvertPlayerSlotState: TConvertPlayerSlotStateFunctionPrototype;

function ConvertPlayerSlotState(i: Integer): HPLAYERSLOTSTATE;
begin
	Result:= _ConvertPlayerSlotState(i);
end;

type TConvertVolumeGroupFunctionPrototype = function (i: Int32): HVOLUMEGROUP; cdecl;
var _ConvertVolumeGroup: TConvertVolumeGroupFunctionPrototype;

function ConvertVolumeGroup(i: Integer): HVOLUMEGROUP;
begin
	Result:= _ConvertVolumeGroup(i);
end;

type TConvertCameraFieldFunctionPrototype = function (i: Int32): HCAMERAFIELD; cdecl;
var _ConvertCameraField: TConvertCameraFieldFunctionPrototype;

function ConvertCameraField(i: Integer): HCAMERAFIELD;
begin
	Result:= _ConvertCameraField(i);
end;

type TConvertBlendModeFunctionPrototype = function (i: Int32): HBLENDMODE; cdecl;
var _ConvertBlendMode: TConvertBlendModeFunctionPrototype;

function ConvertBlendMode(i: Integer): HBLENDMODE;
begin
	Result:= _ConvertBlendMode(i);
end;

type TConvertRarityControlFunctionPrototype = function (i: Int32): HRARITYCONTROL; cdecl;
var _ConvertRarityControl: TConvertRarityControlFunctionPrototype;

function ConvertRarityControl(i: Integer): HRARITYCONTROL;
begin
	Result:= _ConvertRarityControl(i);
end;

type TConvertTexMapFlagsFunctionPrototype = function (i: Int32): HTEXMAPFLAGS; cdecl;
var _ConvertTexMapFlags: TConvertTexMapFlagsFunctionPrototype;

function ConvertTexMapFlags(i: Integer): HTEXMAPFLAGS;
begin
	Result:= _ConvertTexMapFlags(i);
end;

type TConvertFogStateFunctionPrototype = function (i: Int32): HFOGSTATE; cdecl;
var _ConvertFogState: TConvertFogStateFunctionPrototype;

function ConvertFogState(i: Integer): HFOGSTATE;
begin
	Result:= _ConvertFogState(i);
end;

type TConvertEffectTypeFunctionPrototype = function (i: Int32): HEFFECTTYPE; cdecl;
var _ConvertEffectType: TConvertEffectTypeFunctionPrototype;

function ConvertEffectType(i: Integer): HEFFECTTYPE;
begin
	Result:= _ConvertEffectType(i);
end;

type TConvertVersionFunctionPrototype = function (i: Int32): HVERSION; cdecl;
var _ConvertVersion: TConvertVersionFunctionPrototype;

function ConvertVersion(i: Integer): HVERSION;
begin
	Result:= _ConvertVersion(i);
end;

type TConvertItemTypeFunctionPrototype = function (i: Int32): HITEMTYPE; cdecl;
var _ConvertItemType: TConvertItemTypeFunctionPrototype;

function ConvertItemType(i: Integer): HITEMTYPE;
begin
	Result:= _ConvertItemType(i);
end;

type TConvertAttackTypeFunctionPrototype = function (i: Int32): HATTACKTYPE; cdecl;
var _ConvertAttackType: TConvertAttackTypeFunctionPrototype;

function ConvertAttackType(i: Integer): HATTACKTYPE;
begin
	Result:= _ConvertAttackType(i);
end;

type TConvertDamageTypeFunctionPrototype = function (i: Int32): HDAMAGETYPE; cdecl;
var _ConvertDamageType: TConvertDamageTypeFunctionPrototype;

function ConvertDamageType(i: Integer): HDAMAGETYPE;
begin
	Result:= _ConvertDamageType(i);
end;

type TConvertWeaponTypeFunctionPrototype = function (i: Int32): HWEAPONTYPE; cdecl;
var _ConvertWeaponType: TConvertWeaponTypeFunctionPrototype;

function ConvertWeaponType(i: Integer): HWEAPONTYPE;
begin
	Result:= _ConvertWeaponType(i);
end;

type TConvertSoundTypeFunctionPrototype = function (i: Int32): HSOUNDTYPE; cdecl;
var _ConvertSoundType: TConvertSoundTypeFunctionPrototype;

function ConvertSoundType(i: Integer): HSOUNDTYPE;
begin
	Result:= _ConvertSoundType(i);
end;

type TConvertPathingTypeFunctionPrototype = function (i: Int32): HPATHINGTYPE; cdecl;
var _ConvertPathingType: TConvertPathingTypeFunctionPrototype;

function ConvertPathingType(i: Integer): HPATHINGTYPE;
begin
	Result:= _ConvertPathingType(i);
end;

type TOrderIdFunctionPrototype = function (orderIdString: PJassString): Int32; cdecl;
var _OrderId: TOrderIdFunctionPrototype;

function OrderId(orderIdString: String): Integer;
var
	jorderIdString: PJassString;
begin
	jorderIdString:= CreateJassString(PChar(orderIdString));
	Result:= _OrderId(jorderIdString);
	DestroyJassString(jorderIdString);
end;

type TOrderId2StringFunctionPrototype = function (orderId: Int32): TJassStringHandle; cdecl;
var _OrderId2String: TOrderId2StringFunctionPrototype;

function OrderId2String(orderId: Integer): String;
var
	hResult: TJassStringHandle;
begin
	hResult:= _OrderId2String(orderId);
	Result:= GetStringFromHandle(hResult);
	DecrementStringReferences(hResult);
end;

type TUnitIdFunctionPrototype = function (unitIdString: PJassString): Int32; cdecl;
var _UnitId: TUnitIdFunctionPrototype;

function UnitId(unitIdString: String): Integer;
var
	junitIdString: PJassString;
begin
	junitIdString:= CreateJassString(PChar(unitIdString));
	Result:= _UnitId(junitIdString);
	DestroyJassString(junitIdString);
end;

type TUnitId2StringFunctionPrototype = function (unitId: Int32): TJassStringHandle; cdecl;
var _UnitId2String: TUnitId2StringFunctionPrototype;

function UnitId2String(unitId: Integer): String;
var
	hResult: TJassStringHandle;
begin
	hResult:= _UnitId2String(unitId);
	Result:= GetStringFromHandle(hResult);
	DecrementStringReferences(hResult);
end;

type TAbilityIdFunctionPrototype = function (abilityIdString: PJassString): Int32; cdecl;
var _AbilityId: TAbilityIdFunctionPrototype;

function AbilityId(abilityIdString: String): Integer;
var
	jabilityIdString: PJassString;
begin
	jabilityIdString:= CreateJassString(PChar(abilityIdString));
	Result:= _AbilityId(jabilityIdString);
	DestroyJassString(jabilityIdString);
end;

type TAbilityId2StringFunctionPrototype = function (abilityId: Int32): TJassStringHandle; cdecl;
var _AbilityId2String: TAbilityId2StringFunctionPrototype;

function AbilityId2String(abilityId: Integer): String;
var
	hResult: TJassStringHandle;
begin
	hResult:= _AbilityId2String(abilityId);
	Result:= GetStringFromHandle(hResult);
	DecrementStringReferences(hResult);
end;

type TGetObjectNameFunctionPrototype = function (objectId: Int32): TJassStringHandle; cdecl;
var _GetObjectName: TGetObjectNameFunctionPrototype;

function GetObjectName(objectId: Integer): String;
var
	hResult: TJassStringHandle;
begin
	hResult:= _GetObjectName(objectId);
	Result:= GetStringFromHandle(hResult);
	DecrementStringReferences(hResult);
end;

type TDeg2RadFunctionPrototype = function (degrees: PSingle): TSingle; cdecl;
var _Deg2Rad: TDeg2RadFunctionPrototype;

function Deg2Rad(degrees: Single): Single;
begin
	Result:= _Deg2Rad(@degrees).Value;
end;

type TRad2DegFunctionPrototype = function (radians: PSingle): TSingle; cdecl;
var _Rad2Deg: TRad2DegFunctionPrototype;

function Rad2Deg(radians: Single): Single;
begin
	Result:= _Rad2Deg(@radians).Value;
end;

type TSinFunctionPrototype = function (radians: PSingle): TSingle; cdecl;
var _Sin: TSinFunctionPrototype;

function Sin(radians: Single): Single;
begin
	Result:= _Sin(@radians).Value;
end;

type TCosFunctionPrototype = function (radians: PSingle): TSingle; cdecl;
var _Cos: TCosFunctionPrototype;

function Cos(radians: Single): Single;
begin
	Result:= _Cos(@radians).Value;
end;

type TTanFunctionPrototype = function (radians: PSingle): TSingle; cdecl;
var _Tan: TTanFunctionPrototype;

function Tan(radians: Single): Single;
begin
	Result:= _Tan(@radians).Value;
end;

type TAsinFunctionPrototype = function (y: PSingle): TSingle; cdecl;
var _Asin: TAsinFunctionPrototype;

function Asin(y: Single): Single;
begin
	Result:= _Asin(@y).Value;
end;

type TAcosFunctionPrototype = function (x: PSingle): TSingle; cdecl;
var _Acos: TAcosFunctionPrototype;

function Acos(x: Single): Single;
begin
	Result:= _Acos(@x).Value;
end;

type TAtanFunctionPrototype = function (x: PSingle): TSingle; cdecl;
var _Atan: TAtanFunctionPrototype;

function Atan(x: Single): Single;
begin
	Result:= _Atan(@x).Value;
end;

type TAtan2FunctionPrototype = function (y: PSingle; x: PSingle): TSingle; cdecl;
var _Atan2: TAtan2FunctionPrototype;

function Atan2(y: Single; x: Single): Single;
begin
	Result:= _Atan2(@y, @x).Value;
end;

type TSquareRootFunctionPrototype = function (x: PSingle): TSingle; cdecl;
var _SquareRoot: TSquareRootFunctionPrototype;

function SquareRoot(x: Single): Single;
begin
	Result:= _SquareRoot(@x).Value;
end;

type TPowFunctionPrototype = function (x: PSingle; power: PSingle): TSingle; cdecl;
var _Pow: TPowFunctionPrototype;

function Pow(x: Single; power: Single): Single;
begin
	Result:= _Pow(@x, @power).Value;
end;

type TI2RFunctionPrototype = function (i: Int32): TSingle; cdecl;
var _I2R: TI2RFunctionPrototype;

function I2R(i: Integer): Single;
begin
	Result:= _I2R(i).Value;
end;

type TR2IFunctionPrototype = function (r: PSingle): Int32; cdecl;
var _R2I: TR2IFunctionPrototype;

function R2I(r: Single): Integer;
begin
	Result:= _R2I(@r);
end;

type TI2SFunctionPrototype = function (i: Int32): TJassStringHandle; cdecl;
var _I2S: TI2SFunctionPrototype;

function I2S(i: Integer): String;
var
	hResult: TJassStringHandle;
begin
	hResult:= _I2S(i);
	Result:= GetStringFromHandle(hResult);
	DecrementStringReferences(hResult);
end;

type TR2SFunctionPrototype = function (r: PSingle): TJassStringHandle; cdecl;
var _R2S: TR2SFunctionPrototype;

function R2S(r: Single): String;
var
	hResult: TJassStringHandle;
begin
	hResult:= _R2S(@r);
	Result:= GetStringFromHandle(hResult);
	DecrementStringReferences(hResult);
end;

type TR2SWFunctionPrototype = function (r: PSingle; width: Int32; precision: Int32): TJassStringHandle; cdecl;
var _R2SW: TR2SWFunctionPrototype;

function R2SW(r: Single; width: Integer; precision: Integer): String;
var
	hResult: TJassStringHandle;
begin
	hResult:= _R2SW(@r, width, precision);
	Result:= GetStringFromHandle(hResult);
	DecrementStringReferences(hResult);
end;

type TS2IFunctionPrototype = function (s: PJassString): Int32; cdecl;
var _S2I: TS2IFunctionPrototype;

function S2I(s: String): Integer;
var
	js: PJassString;
begin
	js:= CreateJassString(PChar(s));
	Result:= _S2I(js);
	DestroyJassString(js);
end;

type TS2RFunctionPrototype = function (s: PJassString): TSingle; cdecl;
var _S2R: TS2RFunctionPrototype;

function S2R(s: String): Single;
var
	js: PJassString;
begin
	js:= CreateJassString(PChar(s));
	Result:= _S2R(js).Value;
	DestroyJassString(js);
end;

type TGetHandleIdFunctionPrototype = function (h: TJassObjectHandle): Int32; cdecl;
var _GetHandleId: TGetHandleIdFunctionPrototype;

function GetHandleId(h: TJassObjectHandle): Integer;
begin
	Result:= _GetHandleId(h);
end;

type TSubStringFunctionPrototype = function (source: PJassString; start: Int32; end_: Int32): TJassStringHandle; cdecl;
var _SubString: TSubStringFunctionPrototype;

function SubString(source: String; start: Integer; end_: Integer): String;
var
	jsource: PJassString;
	hResult: TJassStringHandle;
begin
	jsource:= CreateJassString(PChar(source));
	hResult:= _SubString(jsource, start, end_);
	Result:= GetStringFromHandle(hResult);
	DecrementStringReferences(hResult);
	DestroyJassString(jsource);
end;

type TStringLengthFunctionPrototype = function (s: PJassString): Int32; cdecl;
var _StringLength: TStringLengthFunctionPrototype;

function StringLength(s: String): Integer;
var
	js: PJassString;
begin
	js:= CreateJassString(PChar(s));
	Result:= _StringLength(js);
	DestroyJassString(js);
end;

type TStringCaseFunctionPrototype = function (source: PJassString; upper: LongBool): TJassStringHandle; cdecl;
var _StringCase: TStringCaseFunctionPrototype;

function StringCase(source: String; upper: Boolean): String;
var
	jsource: PJassString;
	hResult: TJassStringHandle;
begin
	jsource:= CreateJassString(PChar(source));
	hResult:= _StringCase(jsource, upper);
	Result:= GetStringFromHandle(hResult);
	DecrementStringReferences(hResult);
	DestroyJassString(jsource);
end;

type TStringHashFunctionPrototype = function (s: PJassString): Int32; cdecl;
var _StringHash: TStringHashFunctionPrototype;

function StringHash(s: String): Integer;
var
	js: PJassString;
begin
	js:= CreateJassString(PChar(s));
	Result:= _StringHash(js);
	DestroyJassString(js);
end;

type TGetLocalizedStringFunctionPrototype = function (source: PJassString): TJassStringHandle; cdecl;
var _GetLocalizedString: TGetLocalizedStringFunctionPrototype;

function GetLocalizedString(source: String): String;
var
	jsource: PJassString;
	hResult: TJassStringHandle;
begin
	jsource:= CreateJassString(PChar(source));
	hResult:= _GetLocalizedString(jsource);
	Result:= GetStringFromHandle(hResult);
	DecrementStringReferences(hResult);
	DestroyJassString(jsource);
end;

type TGetLocalizedHotkeyFunctionPrototype = function (source: PJassString): Int32; cdecl;
var _GetLocalizedHotkey: TGetLocalizedHotkeyFunctionPrototype;

function GetLocalizedHotkey(source: String): Integer;
var
	jsource: PJassString;
begin
	jsource:= CreateJassString(PChar(source));
	Result:= _GetLocalizedHotkey(jsource);
	DestroyJassString(jsource);
end;

type TSetMapNameFunctionPrototype = procedure (name: PJassString); cdecl;
var _SetMapName: TSetMapNameFunctionPrototype;

procedure SetMapName(name: String);
var
	jname: PJassString;
begin
	jname:= CreateJassString(PChar(name));
	_SetMapName(jname);
	DestroyJassString(jname);
end;

type TSetMapDescriptionFunctionPrototype = procedure (description: PJassString); cdecl;
var _SetMapDescription: TSetMapDescriptionFunctionPrototype;

procedure SetMapDescription(description: String);
var
	jdescription: PJassString;
begin
	jdescription:= CreateJassString(PChar(description));
	_SetMapDescription(jdescription);
	DestroyJassString(jdescription);
end;

type TSetTeamsFunctionPrototype = procedure (teamcount: Int32); cdecl;
var _SetTeams: TSetTeamsFunctionPrototype;

procedure SetTeams(teamcount: Integer);
begin
	_SetTeams(teamcount);
end;

type TSetPlayersFunctionPrototype = procedure (playercount: Int32); cdecl;
var _SetPlayers: TSetPlayersFunctionPrototype;

procedure SetPlayers(playercount: Integer);
begin
	_SetPlayers(playercount);
end;

type TDefineStartLocationFunctionPrototype = procedure (whichStartLoc: Int32; x: PSingle; y: PSingle); cdecl;
var _DefineStartLocation: TDefineStartLocationFunctionPrototype;

procedure DefineStartLocation(whichStartLoc: Integer; x: Single; y: Single);
begin
	_DefineStartLocation(whichStartLoc, @x, @y);
end;

type TDefineStartLocationLocFunctionPrototype = procedure (whichStartLoc: Int32; whichLocation: HLOCATION); cdecl;
var _DefineStartLocationLoc: TDefineStartLocationLocFunctionPrototype;

procedure DefineStartLocationLoc(whichStartLoc: Integer; whichLocation: HLOCATION);
begin
	_DefineStartLocationLoc(whichStartLoc, whichLocation);
end;

type TSetStartLocPrioCountFunctionPrototype = procedure (whichStartLoc: Int32; prioSlotCount: Int32); cdecl;
var _SetStartLocPrioCount: TSetStartLocPrioCountFunctionPrototype;

procedure SetStartLocPrioCount(whichStartLoc: Integer; prioSlotCount: Integer);
begin
	_SetStartLocPrioCount(whichStartLoc, prioSlotCount);
end;

type TSetStartLocPrioFunctionPrototype = procedure (whichStartLoc: Int32; prioSlotIndex: Int32; otherStartLocIndex: Int32; priority: HSTARTLOCPRIO); cdecl;
var _SetStartLocPrio: TSetStartLocPrioFunctionPrototype;

procedure SetStartLocPrio(whichStartLoc: Integer; prioSlotIndex: Integer; otherStartLocIndex: Integer; priority: HSTARTLOCPRIO);
begin
	_SetStartLocPrio(whichStartLoc, prioSlotIndex, otherStartLocIndex, priority);
end;

type TGetStartLocPrioSlotFunctionPrototype = function (whichStartLoc: Int32; prioSlotIndex: Int32): Int32; cdecl;
var _GetStartLocPrioSlot: TGetStartLocPrioSlotFunctionPrototype;

function GetStartLocPrioSlot(whichStartLoc: Integer; prioSlotIndex: Integer): Integer;
begin
	Result:= _GetStartLocPrioSlot(whichStartLoc, prioSlotIndex);
end;

type TGetStartLocPrioFunctionPrototype = function (whichStartLoc: Int32; prioSlotIndex: Int32): HSTARTLOCPRIO; cdecl;
var _GetStartLocPrio: TGetStartLocPrioFunctionPrototype;

function GetStartLocPrio(whichStartLoc: Integer; prioSlotIndex: Integer): HSTARTLOCPRIO;
begin
	Result:= _GetStartLocPrio(whichStartLoc, prioSlotIndex);
end;

type TSetGameTypeSupportedFunctionPrototype = procedure (whichGameType: HGAMETYPE; value: LongBool); cdecl;
var _SetGameTypeSupported: TSetGameTypeSupportedFunctionPrototype;

procedure SetGameTypeSupported(whichGameType: HGAMETYPE; value: Boolean);
begin
	_SetGameTypeSupported(whichGameType, value);
end;

type TSetMapFlagFunctionPrototype = procedure (whichMapFlag: HMAPFLAG; value: LongBool); cdecl;
var _SetMapFlag: TSetMapFlagFunctionPrototype;

procedure SetMapFlag(whichMapFlag: HMAPFLAG; value: Boolean);
begin
	_SetMapFlag(whichMapFlag, value);
end;

type TSetGamePlacementFunctionPrototype = procedure (whichPlacementType: HPLACEMENT); cdecl;
var _SetGamePlacement: TSetGamePlacementFunctionPrototype;

procedure SetGamePlacement(whichPlacementType: HPLACEMENT);
begin
	_SetGamePlacement(whichPlacementType);
end;

type TSetGameSpeedFunctionPrototype = procedure (whichspeed: HGAMESPEED); cdecl;
var _SetGameSpeed: TSetGameSpeedFunctionPrototype;

procedure SetGameSpeed(whichspeed: HGAMESPEED);
begin
	_SetGameSpeed(whichspeed);
end;

type TSetGameDifficultyFunctionPrototype = procedure (whichdifficulty: HGAMEDIFFICULTY); cdecl;
var _SetGameDifficulty: TSetGameDifficultyFunctionPrototype;

procedure SetGameDifficulty(whichdifficulty: HGAMEDIFFICULTY);
begin
	_SetGameDifficulty(whichdifficulty);
end;

type TSetResourceDensityFunctionPrototype = procedure (whichdensity: HMAPDENSITY); cdecl;
var _SetResourceDensity: TSetResourceDensityFunctionPrototype;

procedure SetResourceDensity(whichdensity: HMAPDENSITY);
begin
	_SetResourceDensity(whichdensity);
end;

type TSetCreatureDensityFunctionPrototype = procedure (whichdensity: HMAPDENSITY); cdecl;
var _SetCreatureDensity: TSetCreatureDensityFunctionPrototype;

procedure SetCreatureDensity(whichdensity: HMAPDENSITY);
begin
	_SetCreatureDensity(whichdensity);
end;

type TGetTeamsFunctionPrototype = function: Int32; cdecl;
var _GetTeams: TGetTeamsFunctionPrototype;

function GetTeams: Integer;
begin
	Result:= _GetTeams();
end;

type TGetPlayersFunctionPrototype = function: Int32; cdecl;
var _GetPlayers: TGetPlayersFunctionPrototype;

function GetPlayers: Integer;
begin
	Result:= _GetPlayers();
end;

type TIsGameTypeSupportedFunctionPrototype = function (whichGameType: HGAMETYPE): LongBool; cdecl;
var _IsGameTypeSupported: TIsGameTypeSupportedFunctionPrototype;

function IsGameTypeSupported(whichGameType: HGAMETYPE): Boolean;
begin
	Result:= _IsGameTypeSupported(whichGameType);
end;

type TGetGameTypeSelectedFunctionPrototype = function: HGAMETYPE; cdecl;
var _GetGameTypeSelected: TGetGameTypeSelectedFunctionPrototype;

function GetGameTypeSelected: HGAMETYPE;
begin
	Result:= _GetGameTypeSelected();
end;

type TIsMapFlagSetFunctionPrototype = function (whichMapFlag: HMAPFLAG): LongBool; cdecl;
var _IsMapFlagSet: TIsMapFlagSetFunctionPrototype;

function IsMapFlagSet(whichMapFlag: HMAPFLAG): Boolean;
begin
	Result:= _IsMapFlagSet(whichMapFlag);
end;

type TGetGamePlacementFunctionPrototype = function: HPLACEMENT; cdecl;
var _GetGamePlacement: TGetGamePlacementFunctionPrototype;

function GetGamePlacement: HPLACEMENT;
begin
	Result:= _GetGamePlacement();
end;

type TGetGameSpeedFunctionPrototype = function: HGAMESPEED; cdecl;
var _GetGameSpeed: TGetGameSpeedFunctionPrototype;

function GetGameSpeed: HGAMESPEED;
begin
	Result:= _GetGameSpeed();
end;

type TGetGameDifficultyFunctionPrototype = function: HGAMEDIFFICULTY; cdecl;
var _GetGameDifficulty: TGetGameDifficultyFunctionPrototype;

function GetGameDifficulty: HGAMEDIFFICULTY;
begin
	Result:= _GetGameDifficulty();
end;

type TGetResourceDensityFunctionPrototype = function: HMAPDENSITY; cdecl;
var _GetResourceDensity: TGetResourceDensityFunctionPrototype;

function GetResourceDensity: HMAPDENSITY;
begin
	Result:= _GetResourceDensity();
end;

type TGetCreatureDensityFunctionPrototype = function: HMAPDENSITY; cdecl;
var _GetCreatureDensity: TGetCreatureDensityFunctionPrototype;

function GetCreatureDensity: HMAPDENSITY;
begin
	Result:= _GetCreatureDensity();
end;

type TGetStartLocationXFunctionPrototype = function (whichStartLocation: Int32): TSingle; cdecl;
var _GetStartLocationX: TGetStartLocationXFunctionPrototype;

function GetStartLocationX(whichStartLocation: Integer): Single;
begin
	Result:= _GetStartLocationX(whichStartLocation).Value;
end;

type TGetStartLocationYFunctionPrototype = function (whichStartLocation: Int32): TSingle; cdecl;
var _GetStartLocationY: TGetStartLocationYFunctionPrototype;

function GetStartLocationY(whichStartLocation: Integer): Single;
begin
	Result:= _GetStartLocationY(whichStartLocation).Value;
end;

type TGetStartLocationLocFunctionPrototype = function (whichStartLocation: Int32): HLOCATION; cdecl;
var _GetStartLocationLoc: TGetStartLocationLocFunctionPrototype;

function GetStartLocationLoc(whichStartLocation: Integer): HLOCATION;
begin
	Result:= _GetStartLocationLoc(whichStartLocation);
end;

type TSetPlayerTeamFunctionPrototype = procedure (whichPlayer: HPLAYER; whichTeam: Int32); cdecl;
var _SetPlayerTeam: TSetPlayerTeamFunctionPrototype;

procedure SetPlayerTeam(whichPlayer: HPLAYER; whichTeam: Integer);
begin
	_SetPlayerTeam(whichPlayer, whichTeam);
end;

type TSetPlayerStartLocationFunctionPrototype = procedure (whichPlayer: HPLAYER; startLocIndex: Int32); cdecl;
var _SetPlayerStartLocation: TSetPlayerStartLocationFunctionPrototype;

procedure SetPlayerStartLocation(whichPlayer: HPLAYER; startLocIndex: Integer);
begin
	_SetPlayerStartLocation(whichPlayer, startLocIndex);
end;

type TForcePlayerStartLocationFunctionPrototype = procedure (whichPlayer: HPLAYER; startLocIndex: Int32); cdecl;
var _ForcePlayerStartLocation: TForcePlayerStartLocationFunctionPrototype;

procedure ForcePlayerStartLocation(whichPlayer: HPLAYER; startLocIndex: Integer);
begin
	_ForcePlayerStartLocation(whichPlayer, startLocIndex);
end;

type TSetPlayerColorFunctionPrototype = procedure (whichPlayer: HPLAYER; color: HPLAYERCOLOR); cdecl;
var _SetPlayerColor: TSetPlayerColorFunctionPrototype;

procedure SetPlayerColor(whichPlayer: HPLAYER; color: HPLAYERCOLOR);
begin
	_SetPlayerColor(whichPlayer, color);
end;

type TSetPlayerAllianceFunctionPrototype = procedure (sourcePlayer: HPLAYER; otherPlayer: HPLAYER; whichAllianceSetting: HALLIANCETYPE; value: LongBool); cdecl;
var _SetPlayerAlliance: TSetPlayerAllianceFunctionPrototype;

procedure SetPlayerAlliance(sourcePlayer: HPLAYER; otherPlayer: HPLAYER; whichAllianceSetting: HALLIANCETYPE; value: Boolean);
begin
	_SetPlayerAlliance(sourcePlayer, otherPlayer, whichAllianceSetting, value);
end;

type TSetPlayerTaxRateFunctionPrototype = procedure (sourcePlayer: HPLAYER; otherPlayer: HPLAYER; whichResource: HPLAYERSTATE; rate: Int32); cdecl;
var _SetPlayerTaxRate: TSetPlayerTaxRateFunctionPrototype;

procedure SetPlayerTaxRate(sourcePlayer: HPLAYER; otherPlayer: HPLAYER; whichResource: HPLAYERSTATE; rate: Integer);
begin
	_SetPlayerTaxRate(sourcePlayer, otherPlayer, whichResource, rate);
end;

type TSetPlayerRacePreferenceFunctionPrototype = procedure (whichPlayer: HPLAYER; whichRacePreference: HRACEPREFERENCE); cdecl;
var _SetPlayerRacePreference: TSetPlayerRacePreferenceFunctionPrototype;

procedure SetPlayerRacePreference(whichPlayer: HPLAYER; whichRacePreference: HRACEPREFERENCE);
begin
	_SetPlayerRacePreference(whichPlayer, whichRacePreference);
end;

type TSetPlayerRaceSelectableFunctionPrototype = procedure (whichPlayer: HPLAYER; value: LongBool); cdecl;
var _SetPlayerRaceSelectable: TSetPlayerRaceSelectableFunctionPrototype;

procedure SetPlayerRaceSelectable(whichPlayer: HPLAYER; value: Boolean);
begin
	_SetPlayerRaceSelectable(whichPlayer, value);
end;

type TSetPlayerControllerFunctionPrototype = procedure (whichPlayer: HPLAYER; controlType: HMAPCONTROL); cdecl;
var _SetPlayerController: TSetPlayerControllerFunctionPrototype;

procedure SetPlayerController(whichPlayer: HPLAYER; controlType: HMAPCONTROL);
begin
	_SetPlayerController(whichPlayer, controlType);
end;

type TSetPlayerNameFunctionPrototype = procedure (whichPlayer: HPLAYER; name: PJassString); cdecl;
var _SetPlayerName: TSetPlayerNameFunctionPrototype;

procedure SetPlayerName(whichPlayer: HPLAYER; name: String);
var
	jname: PJassString;
begin
	jname:= CreateJassString(PChar(name));
	_SetPlayerName(whichPlayer, jname);
	DestroyJassString(jname);
end;

type TSetPlayerOnScoreScreenFunctionPrototype = procedure (whichPlayer: HPLAYER; flag: LongBool); cdecl;
var _SetPlayerOnScoreScreen: TSetPlayerOnScoreScreenFunctionPrototype;

procedure SetPlayerOnScoreScreen(whichPlayer: HPLAYER; flag: Boolean);
begin
	_SetPlayerOnScoreScreen(whichPlayer, flag);
end;

type TGetPlayerTeamFunctionPrototype = function (whichPlayer: HPLAYER): Int32; cdecl;
var _GetPlayerTeam: TGetPlayerTeamFunctionPrototype;

function GetPlayerTeam(whichPlayer: HPLAYER): Integer;
begin
	Result:= _GetPlayerTeam(whichPlayer);
end;

type TGetPlayerStartLocationFunctionPrototype = function (whichPlayer: HPLAYER): Int32; cdecl;
var _GetPlayerStartLocation: TGetPlayerStartLocationFunctionPrototype;

function GetPlayerStartLocation(whichPlayer: HPLAYER): Integer;
begin
	Result:= _GetPlayerStartLocation(whichPlayer);
end;

type TGetPlayerColorFunctionPrototype = function (whichPlayer: HPLAYER): HPLAYERCOLOR; cdecl;
var _GetPlayerColor: TGetPlayerColorFunctionPrototype;

function GetPlayerColor(whichPlayer: HPLAYER): HPLAYERCOLOR;
begin
	Result:= _GetPlayerColor(whichPlayer);
end;

type TGetPlayerSelectableFunctionPrototype = function (whichPlayer: HPLAYER): LongBool; cdecl;
var _GetPlayerSelectable: TGetPlayerSelectableFunctionPrototype;

function GetPlayerSelectable(whichPlayer: HPLAYER): Boolean;
begin
	Result:= _GetPlayerSelectable(whichPlayer);
end;

type TGetPlayerControllerFunctionPrototype = function (whichPlayer: HPLAYER): HMAPCONTROL; cdecl;
var _GetPlayerController: TGetPlayerControllerFunctionPrototype;

function GetPlayerController(whichPlayer: HPLAYER): HMAPCONTROL;
begin
	Result:= _GetPlayerController(whichPlayer);
end;

type TGetPlayerSlotStateFunctionPrototype = function (whichPlayer: HPLAYER): HPLAYERSLOTSTATE; cdecl;
var _GetPlayerSlotState: TGetPlayerSlotStateFunctionPrototype;

function GetPlayerSlotState(whichPlayer: HPLAYER): HPLAYERSLOTSTATE;
begin
	Result:= _GetPlayerSlotState(whichPlayer);
end;

type TGetPlayerTaxRateFunctionPrototype = function (sourcePlayer: HPLAYER; otherPlayer: HPLAYER; whichResource: HPLAYERSTATE): Int32; cdecl;
var _GetPlayerTaxRate: TGetPlayerTaxRateFunctionPrototype;

function GetPlayerTaxRate(sourcePlayer: HPLAYER; otherPlayer: HPLAYER; whichResource: HPLAYERSTATE): Integer;
begin
	Result:= _GetPlayerTaxRate(sourcePlayer, otherPlayer, whichResource);
end;

type TIsPlayerRacePrefSetFunctionPrototype = function (whichPlayer: HPLAYER; pref: HRACEPREFERENCE): LongBool; cdecl;
var _IsPlayerRacePrefSet: TIsPlayerRacePrefSetFunctionPrototype;

function IsPlayerRacePrefSet(whichPlayer: HPLAYER; pref: HRACEPREFERENCE): Boolean;
begin
	Result:= _IsPlayerRacePrefSet(whichPlayer, pref);
end;

type TGetPlayerNameFunctionPrototype = function (whichPlayer: HPLAYER): TJassStringHandle; cdecl;
var _GetPlayerName: TGetPlayerNameFunctionPrototype;

function GetPlayerName(whichPlayer: HPLAYER): String;
var
	hResult: TJassStringHandle;
begin
	hResult:= _GetPlayerName(whichPlayer);
	Result:= GetStringFromHandle(hResult);
	DecrementStringReferences(hResult);
end;

type TCreateTimerFunctionPrototype = function: HTIMER; cdecl;
var _CreateTimer: TCreateTimerFunctionPrototype;

function CreateTimer: HTIMER;
begin
	Result:= _CreateTimer();
end;

type TDestroyTimerFunctionPrototype = procedure (whichTimer: HTIMER); cdecl;
var _DestroyTimer: TDestroyTimerFunctionPrototype;

procedure DestroyTimer(whichTimer: HTIMER);
begin
	_DestroyTimer(whichTimer);
end;

type TTimerStartFunctionPrototype = procedure (whichTimer: HTIMER; timeout: PSingle; periodic: LongBool; handlerFunc: TJassCallback); cdecl;
var _TimerStart: TTimerStartFunctionPrototype;

procedure TimerStart(whichTimer: HTIMER; timeout: Single; periodic: Boolean; handlerFunc: TJassCallback);
begin
	_TimerStart(whichTimer, @timeout, periodic, handlerFunc);
end;

type TTimerGetElapsedFunctionPrototype = function (whichTimer: HTIMER): TSingle; cdecl;
var _TimerGetElapsed: TTimerGetElapsedFunctionPrototype;

function TimerGetElapsed(whichTimer: HTIMER): Single;
begin
	Result:= _TimerGetElapsed(whichTimer).Value;
end;

type TTimerGetRemainingFunctionPrototype = function (whichTimer: HTIMER): TSingle; cdecl;
var _TimerGetRemaining: TTimerGetRemainingFunctionPrototype;

function TimerGetRemaining(whichTimer: HTIMER): Single;
begin
	Result:= _TimerGetRemaining(whichTimer).Value;
end;

type TTimerGetTimeoutFunctionPrototype = function (whichTimer: HTIMER): TSingle; cdecl;
var _TimerGetTimeout: TTimerGetTimeoutFunctionPrototype;

function TimerGetTimeout(whichTimer: HTIMER): Single;
begin
	Result:= _TimerGetTimeout(whichTimer).Value;
end;

type TPauseTimerFunctionPrototype = procedure (whichTimer: HTIMER); cdecl;
var _PauseTimer: TPauseTimerFunctionPrototype;

procedure PauseTimer(whichTimer: HTIMER);
begin
	_PauseTimer(whichTimer);
end;

type TResumeTimerFunctionPrototype = procedure (whichTimer: HTIMER); cdecl;
var _ResumeTimer: TResumeTimerFunctionPrototype;

procedure ResumeTimer(whichTimer: HTIMER);
begin
	_ResumeTimer(whichTimer);
end;

type TGetExpiredTimerFunctionPrototype = function: HTIMER; cdecl;
var _GetExpiredTimer: TGetExpiredTimerFunctionPrototype;

function GetExpiredTimer: HTIMER;
begin
	Result:= _GetExpiredTimer();
end;

type TCreateGroupFunctionPrototype = function: HGROUP; cdecl;
var _CreateGroup: TCreateGroupFunctionPrototype;

function CreateGroup: HGROUP;
begin
	Result:= _CreateGroup();
end;

type TDestroyGroupFunctionPrototype = procedure (whichGroup: HGROUP); cdecl;
var _DestroyGroup: TDestroyGroupFunctionPrototype;

procedure DestroyGroup(whichGroup: HGROUP);
begin
	_DestroyGroup(whichGroup);
end;

type TGroupAddUnitFunctionPrototype = procedure (whichGroup: HGROUP; whichUnit: HUNIT); cdecl;
var _GroupAddUnit: TGroupAddUnitFunctionPrototype;

procedure GroupAddUnit(whichGroup: HGROUP; whichUnit: HUNIT);
begin
	_GroupAddUnit(whichGroup, whichUnit);
end;

type TGroupRemoveUnitFunctionPrototype = procedure (whichGroup: HGROUP; whichUnit: HUNIT); cdecl;
var _GroupRemoveUnit: TGroupRemoveUnitFunctionPrototype;

procedure GroupRemoveUnit(whichGroup: HGROUP; whichUnit: HUNIT);
begin
	_GroupRemoveUnit(whichGroup, whichUnit);
end;

type TGroupClearFunctionPrototype = procedure (whichGroup: HGROUP); cdecl;
var _GroupClear: TGroupClearFunctionPrototype;

procedure GroupClear(whichGroup: HGROUP);
begin
	_GroupClear(whichGroup);
end;

type TGroupEnumUnitsOfTypeFunctionPrototype = procedure (whichGroup: HGROUP; unitname: PJassString; filter: HBOOLEXPR); cdecl;
var _GroupEnumUnitsOfType: TGroupEnumUnitsOfTypeFunctionPrototype;

procedure GroupEnumUnitsOfType(whichGroup: HGROUP; unitname: String; filter: HBOOLEXPR);
var
	junitname: PJassString;
begin
	junitname:= CreateJassString(PChar(unitname));
	_GroupEnumUnitsOfType(whichGroup, junitname, filter);
	DestroyJassString(junitname);
end;

type TGroupEnumUnitsOfPlayerFunctionPrototype = procedure (whichGroup: HGROUP; whichPlayer: HPLAYER; filter: HBOOLEXPR); cdecl;
var _GroupEnumUnitsOfPlayer: TGroupEnumUnitsOfPlayerFunctionPrototype;

procedure GroupEnumUnitsOfPlayer(whichGroup: HGROUP; whichPlayer: HPLAYER; filter: HBOOLEXPR);
begin
	_GroupEnumUnitsOfPlayer(whichGroup, whichPlayer, filter);
end;

type TGroupEnumUnitsOfTypeCountedFunctionPrototype = procedure (whichGroup: HGROUP; unitname: PJassString; filter: HBOOLEXPR; countLimit: Int32); cdecl;
var _GroupEnumUnitsOfTypeCounted: TGroupEnumUnitsOfTypeCountedFunctionPrototype;

procedure GroupEnumUnitsOfTypeCounted(whichGroup: HGROUP; unitname: String; filter: HBOOLEXPR; countLimit: Integer);
var
	junitname: PJassString;
begin
	junitname:= CreateJassString(PChar(unitname));
	_GroupEnumUnitsOfTypeCounted(whichGroup, junitname, filter, countLimit);
	DestroyJassString(junitname);
end;

type TGroupEnumUnitsInRectFunctionPrototype = procedure (whichGroup: HGROUP; r: HRECT; filter: HBOOLEXPR); cdecl;
var _GroupEnumUnitsInRect: TGroupEnumUnitsInRectFunctionPrototype;

procedure GroupEnumUnitsInRect(whichGroup: HGROUP; r: HRECT; filter: HBOOLEXPR);
begin
	_GroupEnumUnitsInRect(whichGroup, r, filter);
end;

type TGroupEnumUnitsInRectCountedFunctionPrototype = procedure (whichGroup: HGROUP; r: HRECT; filter: HBOOLEXPR; countLimit: Int32); cdecl;
var _GroupEnumUnitsInRectCounted: TGroupEnumUnitsInRectCountedFunctionPrototype;

procedure GroupEnumUnitsInRectCounted(whichGroup: HGROUP; r: HRECT; filter: HBOOLEXPR; countLimit: Integer);
begin
	_GroupEnumUnitsInRectCounted(whichGroup, r, filter, countLimit);
end;

type TGroupEnumUnitsInRangeFunctionPrototype = procedure (whichGroup: HGROUP; x: PSingle; y: PSingle; radius: PSingle; filter: HBOOLEXPR); cdecl;
var _GroupEnumUnitsInRange: TGroupEnumUnitsInRangeFunctionPrototype;

procedure GroupEnumUnitsInRange(whichGroup: HGROUP; x: Single; y: Single; radius: Single; filter: HBOOLEXPR);
begin
	_GroupEnumUnitsInRange(whichGroup, @x, @y, @radius, filter);
end;

type TGroupEnumUnitsInRangeOfLocFunctionPrototype = procedure (whichGroup: HGROUP; whichLocation: HLOCATION; radius: PSingle; filter: HBOOLEXPR); cdecl;
var _GroupEnumUnitsInRangeOfLoc: TGroupEnumUnitsInRangeOfLocFunctionPrototype;

procedure GroupEnumUnitsInRangeOfLoc(whichGroup: HGROUP; whichLocation: HLOCATION; radius: Single; filter: HBOOLEXPR);
begin
	_GroupEnumUnitsInRangeOfLoc(whichGroup, whichLocation, @radius, filter);
end;

type TGroupEnumUnitsInRangeCountedFunctionPrototype = procedure (whichGroup: HGROUP; x: PSingle; y: PSingle; radius: PSingle; filter: HBOOLEXPR; countLimit: Int32); cdecl;
var _GroupEnumUnitsInRangeCounted: TGroupEnumUnitsInRangeCountedFunctionPrototype;

procedure GroupEnumUnitsInRangeCounted(whichGroup: HGROUP; x: Single; y: Single; radius: Single; filter: HBOOLEXPR; countLimit: Integer);
begin
	_GroupEnumUnitsInRangeCounted(whichGroup, @x, @y, @radius, filter, countLimit);
end;

type TGroupEnumUnitsInRangeOfLocCountedFunctionPrototype = procedure (whichGroup: HGROUP; whichLocation: HLOCATION; radius: PSingle; filter: HBOOLEXPR; countLimit: Int32); cdecl;
var _GroupEnumUnitsInRangeOfLocCounted: TGroupEnumUnitsInRangeOfLocCountedFunctionPrototype;

procedure GroupEnumUnitsInRangeOfLocCounted(whichGroup: HGROUP; whichLocation: HLOCATION; radius: Single; filter: HBOOLEXPR; countLimit: Integer);
begin
	_GroupEnumUnitsInRangeOfLocCounted(whichGroup, whichLocation, @radius, filter, countLimit);
end;

type TGroupEnumUnitsSelectedFunctionPrototype = procedure (whichGroup: HGROUP; whichPlayer: HPLAYER; filter: HBOOLEXPR); cdecl;
var _GroupEnumUnitsSelected: TGroupEnumUnitsSelectedFunctionPrototype;

procedure GroupEnumUnitsSelected(whichGroup: HGROUP; whichPlayer: HPLAYER; filter: HBOOLEXPR);
begin
	_GroupEnumUnitsSelected(whichGroup, whichPlayer, filter);
end;

type TGroupImmediateOrderFunctionPrototype = function (whichGroup: HGROUP; order: PJassString): LongBool; cdecl;
var _GroupImmediateOrder: TGroupImmediateOrderFunctionPrototype;

function GroupImmediateOrder(whichGroup: HGROUP; order: String): Boolean;
var
	jorder: PJassString;
begin
	jorder:= CreateJassString(PChar(order));
	Result:= _GroupImmediateOrder(whichGroup, jorder);
	DestroyJassString(jorder);
end;

type TGroupImmediateOrderByIdFunctionPrototype = function (whichGroup: HGROUP; order: Int32): LongBool; cdecl;
var _GroupImmediateOrderById: TGroupImmediateOrderByIdFunctionPrototype;

function GroupImmediateOrderById(whichGroup: HGROUP; order: Integer): Boolean;
begin
	Result:= _GroupImmediateOrderById(whichGroup, order);
end;

type TGroupPointOrderFunctionPrototype = function (whichGroup: HGROUP; order: PJassString; x: PSingle; y: PSingle): LongBool; cdecl;
var _GroupPointOrder: TGroupPointOrderFunctionPrototype;

function GroupPointOrder(whichGroup: HGROUP; order: String; x: Single; y: Single): Boolean;
var
	jorder: PJassString;
begin
	jorder:= CreateJassString(PChar(order));
	Result:= _GroupPointOrder(whichGroup, jorder, @x, @y);
	DestroyJassString(jorder);
end;

type TGroupPointOrderLocFunctionPrototype = function (whichGroup: HGROUP; order: PJassString; whichLocation: HLOCATION): LongBool; cdecl;
var _GroupPointOrderLoc: TGroupPointOrderLocFunctionPrototype;

function GroupPointOrderLoc(whichGroup: HGROUP; order: String; whichLocation: HLOCATION): Boolean;
var
	jorder: PJassString;
begin
	jorder:= CreateJassString(PChar(order));
	Result:= _GroupPointOrderLoc(whichGroup, jorder, whichLocation);
	DestroyJassString(jorder);
end;

type TGroupPointOrderByIdFunctionPrototype = function (whichGroup: HGROUP; order: Int32; x: PSingle; y: PSingle): LongBool; cdecl;
var _GroupPointOrderById: TGroupPointOrderByIdFunctionPrototype;

function GroupPointOrderById(whichGroup: HGROUP; order: Integer; x: Single; y: Single): Boolean;
begin
	Result:= _GroupPointOrderById(whichGroup, order, @x, @y);
end;

type TGroupPointOrderByIdLocFunctionPrototype = function (whichGroup: HGROUP; order: Int32; whichLocation: HLOCATION): LongBool; cdecl;
var _GroupPointOrderByIdLoc: TGroupPointOrderByIdLocFunctionPrototype;

function GroupPointOrderByIdLoc(whichGroup: HGROUP; order: Integer; whichLocation: HLOCATION): Boolean;
begin
	Result:= _GroupPointOrderByIdLoc(whichGroup, order, whichLocation);
end;

type TGroupTargetOrderFunctionPrototype = function (whichGroup: HGROUP; order: PJassString; targetWidget: HWIDGET): LongBool; cdecl;
var _GroupTargetOrder: TGroupTargetOrderFunctionPrototype;

function GroupTargetOrder(whichGroup: HGROUP; order: String; targetWidget: HWIDGET): Boolean;
var
	jorder: PJassString;
begin
	jorder:= CreateJassString(PChar(order));
	Result:= _GroupTargetOrder(whichGroup, jorder, targetWidget);
	DestroyJassString(jorder);
end;

type TGroupTargetOrderByIdFunctionPrototype = function (whichGroup: HGROUP; order: Int32; targetWidget: HWIDGET): LongBool; cdecl;
var _GroupTargetOrderById: TGroupTargetOrderByIdFunctionPrototype;

function GroupTargetOrderById(whichGroup: HGROUP; order: Integer; targetWidget: HWIDGET): Boolean;
begin
	Result:= _GroupTargetOrderById(whichGroup, order, targetWidget);
end;

type TForGroupFunctionPrototype = procedure (whichGroup: HGROUP; callback: TJassCallback); cdecl;
var _ForGroup: TForGroupFunctionPrototype;

procedure ForGroup(whichGroup: HGROUP; callback: TJassCallback);
begin
	_ForGroup(whichGroup, callback);
end;

type TFirstOfGroupFunctionPrototype = function (whichGroup: HGROUP): HUNIT; cdecl;
var _FirstOfGroup: TFirstOfGroupFunctionPrototype;

function FirstOfGroup(whichGroup: HGROUP): HUNIT;
begin
	Result:= _FirstOfGroup(whichGroup);
end;

type TCreateForceFunctionPrototype = function: HFORCE; cdecl;
var _CreateForce: TCreateForceFunctionPrototype;

function CreateForce: HFORCE;
begin
	Result:= _CreateForce();
end;

type TDestroyForceFunctionPrototype = procedure (whichForce: HFORCE); cdecl;
var _DestroyForce: TDestroyForceFunctionPrototype;

procedure DestroyForce(whichForce: HFORCE);
begin
	_DestroyForce(whichForce);
end;

type TForceAddPlayerFunctionPrototype = procedure (whichForce: HFORCE; whichPlayer: HPLAYER); cdecl;
var _ForceAddPlayer: TForceAddPlayerFunctionPrototype;

procedure ForceAddPlayer(whichForce: HFORCE; whichPlayer: HPLAYER);
begin
	_ForceAddPlayer(whichForce, whichPlayer);
end;

type TForceRemovePlayerFunctionPrototype = procedure (whichForce: HFORCE; whichPlayer: HPLAYER); cdecl;
var _ForceRemovePlayer: TForceRemovePlayerFunctionPrototype;

procedure ForceRemovePlayer(whichForce: HFORCE; whichPlayer: HPLAYER);
begin
	_ForceRemovePlayer(whichForce, whichPlayer);
end;

type TForceClearFunctionPrototype = procedure (whichForce: HFORCE); cdecl;
var _ForceClear: TForceClearFunctionPrototype;

procedure ForceClear(whichForce: HFORCE);
begin
	_ForceClear(whichForce);
end;

type TForceEnumPlayersFunctionPrototype = procedure (whichForce: HFORCE; filter: HBOOLEXPR); cdecl;
var _ForceEnumPlayers: TForceEnumPlayersFunctionPrototype;

procedure ForceEnumPlayers(whichForce: HFORCE; filter: HBOOLEXPR);
begin
	_ForceEnumPlayers(whichForce, filter);
end;

type TForceEnumPlayersCountedFunctionPrototype = procedure (whichForce: HFORCE; filter: HBOOLEXPR; countLimit: Int32); cdecl;
var _ForceEnumPlayersCounted: TForceEnumPlayersCountedFunctionPrototype;

procedure ForceEnumPlayersCounted(whichForce: HFORCE; filter: HBOOLEXPR; countLimit: Integer);
begin
	_ForceEnumPlayersCounted(whichForce, filter, countLimit);
end;

type TForceEnumAlliesFunctionPrototype = procedure (whichForce: HFORCE; whichPlayer: HPLAYER; filter: HBOOLEXPR); cdecl;
var _ForceEnumAllies: TForceEnumAlliesFunctionPrototype;

procedure ForceEnumAllies(whichForce: HFORCE; whichPlayer: HPLAYER; filter: HBOOLEXPR);
begin
	_ForceEnumAllies(whichForce, whichPlayer, filter);
end;

type TForceEnumEnemiesFunctionPrototype = procedure (whichForce: HFORCE; whichPlayer: HPLAYER; filter: HBOOLEXPR); cdecl;
var _ForceEnumEnemies: TForceEnumEnemiesFunctionPrototype;

procedure ForceEnumEnemies(whichForce: HFORCE; whichPlayer: HPLAYER; filter: HBOOLEXPR);
begin
	_ForceEnumEnemies(whichForce, whichPlayer, filter);
end;

type TForForceFunctionPrototype = procedure (whichForce: HFORCE; callback: TJassCallback); cdecl;
var _ForForce: TForForceFunctionPrototype;

procedure ForForce(whichForce: HFORCE; callback: TJassCallback);
begin
	_ForForce(whichForce, callback);
end;

type TRectFunctionPrototype = function (minx: PSingle; miny: PSingle; maxx: PSingle; maxy: PSingle): HRECT; cdecl;
var _Rect: TRectFunctionPrototype;

function Rect(minx: Single; miny: Single; maxx: Single; maxy: Single): HRECT;
begin
	Result:= _Rect(@minx, @miny, @maxx, @maxy);
end;

type TRectFromLocFunctionPrototype = function (min: HLOCATION; max: HLOCATION): HRECT; cdecl;
var _RectFromLoc: TRectFromLocFunctionPrototype;

function RectFromLoc(min: HLOCATION; max: HLOCATION): HRECT;
begin
	Result:= _RectFromLoc(min, max);
end;

type TRemoveRectFunctionPrototype = procedure (whichRect: HRECT); cdecl;
var _RemoveRect: TRemoveRectFunctionPrototype;

procedure RemoveRect(whichRect: HRECT);
begin
	_RemoveRect(whichRect);
end;

type TSetRectFunctionPrototype = procedure (whichRect: HRECT; minx: PSingle; miny: PSingle; maxx: PSingle; maxy: PSingle); cdecl;
var _SetRect: TSetRectFunctionPrototype;

procedure SetRect(whichRect: HRECT; minx: Single; miny: Single; maxx: Single; maxy: Single);
begin
	_SetRect(whichRect, @minx, @miny, @maxx, @maxy);
end;

type TSetRectFromLocFunctionPrototype = procedure (whichRect: HRECT; min: HLOCATION; max: HLOCATION); cdecl;
var _SetRectFromLoc: TSetRectFromLocFunctionPrototype;

procedure SetRectFromLoc(whichRect: HRECT; min: HLOCATION; max: HLOCATION);
begin
	_SetRectFromLoc(whichRect, min, max);
end;

type TMoveRectToFunctionPrototype = procedure (whichRect: HRECT; newCenterX: PSingle; newCenterY: PSingle); cdecl;
var _MoveRectTo: TMoveRectToFunctionPrototype;

procedure MoveRectTo(whichRect: HRECT; newCenterX: Single; newCenterY: Single);
begin
	_MoveRectTo(whichRect, @newCenterX, @newCenterY);
end;

type TMoveRectToLocFunctionPrototype = procedure (whichRect: HRECT; newCenterLoc: HLOCATION); cdecl;
var _MoveRectToLoc: TMoveRectToLocFunctionPrototype;

procedure MoveRectToLoc(whichRect: HRECT; newCenterLoc: HLOCATION);
begin
	_MoveRectToLoc(whichRect, newCenterLoc);
end;

type TGetRectCenterXFunctionPrototype = function (whichRect: HRECT): TSingle; cdecl;
var _GetRectCenterX: TGetRectCenterXFunctionPrototype;

function GetRectCenterX(whichRect: HRECT): Single;
begin
	Result:= _GetRectCenterX(whichRect).Value;
end;

type TGetRectCenterYFunctionPrototype = function (whichRect: HRECT): TSingle; cdecl;
var _GetRectCenterY: TGetRectCenterYFunctionPrototype;

function GetRectCenterY(whichRect: HRECT): Single;
begin
	Result:= _GetRectCenterY(whichRect).Value;
end;

type TGetRectMinXFunctionPrototype = function (whichRect: HRECT): TSingle; cdecl;
var _GetRectMinX: TGetRectMinXFunctionPrototype;

function GetRectMinX(whichRect: HRECT): Single;
begin
	Result:= _GetRectMinX(whichRect).Value;
end;

type TGetRectMinYFunctionPrototype = function (whichRect: HRECT): TSingle; cdecl;
var _GetRectMinY: TGetRectMinYFunctionPrototype;

function GetRectMinY(whichRect: HRECT): Single;
begin
	Result:= _GetRectMinY(whichRect).Value;
end;

type TGetRectMaxXFunctionPrototype = function (whichRect: HRECT): TSingle; cdecl;
var _GetRectMaxX: TGetRectMaxXFunctionPrototype;

function GetRectMaxX(whichRect: HRECT): Single;
begin
	Result:= _GetRectMaxX(whichRect).Value;
end;

type TGetRectMaxYFunctionPrototype = function (whichRect: HRECT): TSingle; cdecl;
var _GetRectMaxY: TGetRectMaxYFunctionPrototype;

function GetRectMaxY(whichRect: HRECT): Single;
begin
	Result:= _GetRectMaxY(whichRect).Value;
end;

type TCreateRegionFunctionPrototype = function: HREGION; cdecl;
var _CreateRegion: TCreateRegionFunctionPrototype;

function CreateRegion: HREGION;
begin
	Result:= _CreateRegion();
end;

type TRemoveRegionFunctionPrototype = procedure (whichRegion: HREGION); cdecl;
var _RemoveRegion: TRemoveRegionFunctionPrototype;

procedure RemoveRegion(whichRegion: HREGION);
begin
	_RemoveRegion(whichRegion);
end;

type TRegionAddRectFunctionPrototype = procedure (whichRegion: HREGION; r: HRECT); cdecl;
var _RegionAddRect: TRegionAddRectFunctionPrototype;

procedure RegionAddRect(whichRegion: HREGION; r: HRECT);
begin
	_RegionAddRect(whichRegion, r);
end;

type TRegionClearRectFunctionPrototype = procedure (whichRegion: HREGION; r: HRECT); cdecl;
var _RegionClearRect: TRegionClearRectFunctionPrototype;

procedure RegionClearRect(whichRegion: HREGION; r: HRECT);
begin
	_RegionClearRect(whichRegion, r);
end;

type TRegionAddCellFunctionPrototype = procedure (whichRegion: HREGION; x: PSingle; y: PSingle); cdecl;
var _RegionAddCell: TRegionAddCellFunctionPrototype;

procedure RegionAddCell(whichRegion: HREGION; x: Single; y: Single);
begin
	_RegionAddCell(whichRegion, @x, @y);
end;

type TRegionAddCellAtLocFunctionPrototype = procedure (whichRegion: HREGION; whichLocation: HLOCATION); cdecl;
var _RegionAddCellAtLoc: TRegionAddCellAtLocFunctionPrototype;

procedure RegionAddCellAtLoc(whichRegion: HREGION; whichLocation: HLOCATION);
begin
	_RegionAddCellAtLoc(whichRegion, whichLocation);
end;

type TRegionClearCellFunctionPrototype = procedure (whichRegion: HREGION; x: PSingle; y: PSingle); cdecl;
var _RegionClearCell: TRegionClearCellFunctionPrototype;

procedure RegionClearCell(whichRegion: HREGION; x: Single; y: Single);
begin
	_RegionClearCell(whichRegion, @x, @y);
end;

type TRegionClearCellAtLocFunctionPrototype = procedure (whichRegion: HREGION; whichLocation: HLOCATION); cdecl;
var _RegionClearCellAtLoc: TRegionClearCellAtLocFunctionPrototype;

procedure RegionClearCellAtLoc(whichRegion: HREGION; whichLocation: HLOCATION);
begin
	_RegionClearCellAtLoc(whichRegion, whichLocation);
end;

type TLocationFunctionPrototype = function (x: PSingle; y: PSingle): HLOCATION; cdecl;
var _Location: TLocationFunctionPrototype;

function Location(x: Single; y: Single): HLOCATION;
begin
	Result:= _Location(@x, @y);
end;

type TRemoveLocationFunctionPrototype = procedure (whichLocation: HLOCATION); cdecl;
var _RemoveLocation: TRemoveLocationFunctionPrototype;

procedure RemoveLocation(whichLocation: HLOCATION);
begin
	_RemoveLocation(whichLocation);
end;

type TMoveLocationFunctionPrototype = procedure (whichLocation: HLOCATION; newX: PSingle; newY: PSingle); cdecl;
var _MoveLocation: TMoveLocationFunctionPrototype;

procedure MoveLocation(whichLocation: HLOCATION; newX: Single; newY: Single);
begin
	_MoveLocation(whichLocation, @newX, @newY);
end;

type TGetLocationXFunctionPrototype = function (whichLocation: HLOCATION): TSingle; cdecl;
var _GetLocationX: TGetLocationXFunctionPrototype;

function GetLocationX(whichLocation: HLOCATION): Single;
begin
	Result:= _GetLocationX(whichLocation).Value;
end;

type TGetLocationYFunctionPrototype = function (whichLocation: HLOCATION): TSingle; cdecl;
var _GetLocationY: TGetLocationYFunctionPrototype;

function GetLocationY(whichLocation: HLOCATION): Single;
begin
	Result:= _GetLocationY(whichLocation).Value;
end;

type TGetLocationZFunctionPrototype = function (whichLocation: HLOCATION): TSingle; cdecl;
var _GetLocationZ: TGetLocationZFunctionPrototype;

function GetLocationZ(whichLocation: HLOCATION): Single;
begin
	Result:= _GetLocationZ(whichLocation).Value;
end;

type TIsUnitInRegionFunctionPrototype = function (whichRegion: HREGION; whichUnit: HUNIT): LongBool; cdecl;
var _IsUnitInRegion: TIsUnitInRegionFunctionPrototype;

function IsUnitInRegion(whichRegion: HREGION; whichUnit: HUNIT): Boolean;
begin
	Result:= _IsUnitInRegion(whichRegion, whichUnit);
end;

type TIsPointInRegionFunctionPrototype = function (whichRegion: HREGION; x: PSingle; y: PSingle): LongBool; cdecl;
var _IsPointInRegion: TIsPointInRegionFunctionPrototype;

function IsPointInRegion(whichRegion: HREGION; x: Single; y: Single): Boolean;
begin
	Result:= _IsPointInRegion(whichRegion, @x, @y);
end;

type TIsLocationInRegionFunctionPrototype = function (whichRegion: HREGION; whichLocation: HLOCATION): LongBool; cdecl;
var _IsLocationInRegion: TIsLocationInRegionFunctionPrototype;

function IsLocationInRegion(whichRegion: HREGION; whichLocation: HLOCATION): Boolean;
begin
	Result:= _IsLocationInRegion(whichRegion, whichLocation);
end;

type TGetWorldBoundsFunctionPrototype = function: HRECT; cdecl;
var _GetWorldBounds: TGetWorldBoundsFunctionPrototype;

function GetWorldBounds: HRECT;
begin
	Result:= _GetWorldBounds();
end;

type TCreateTriggerFunctionPrototype = function: HTRIGGER; cdecl;
var _CreateTrigger: TCreateTriggerFunctionPrototype;

function CreateTrigger: HTRIGGER;
begin
	Result:= _CreateTrigger();
end;

type TDestroyTriggerFunctionPrototype = procedure (whichTrigger: HTRIGGER); cdecl;
var _DestroyTrigger: TDestroyTriggerFunctionPrototype;

procedure DestroyTrigger(whichTrigger: HTRIGGER);
begin
	_DestroyTrigger(whichTrigger);
end;

type TResetTriggerFunctionPrototype = procedure (whichTrigger: HTRIGGER); cdecl;
var _ResetTrigger: TResetTriggerFunctionPrototype;

procedure ResetTrigger(whichTrigger: HTRIGGER);
begin
	_ResetTrigger(whichTrigger);
end;

type TEnableTriggerFunctionPrototype = procedure (whichTrigger: HTRIGGER); cdecl;
var _EnableTrigger: TEnableTriggerFunctionPrototype;

procedure EnableTrigger(whichTrigger: HTRIGGER);
begin
	_EnableTrigger(whichTrigger);
end;

type TDisableTriggerFunctionPrototype = procedure (whichTrigger: HTRIGGER); cdecl;
var _DisableTrigger: TDisableTriggerFunctionPrototype;

procedure DisableTrigger(whichTrigger: HTRIGGER);
begin
	_DisableTrigger(whichTrigger);
end;

type TIsTriggerEnabledFunctionPrototype = function (whichTrigger: HTRIGGER): LongBool; cdecl;
var _IsTriggerEnabled: TIsTriggerEnabledFunctionPrototype;

function IsTriggerEnabled(whichTrigger: HTRIGGER): Boolean;
begin
	Result:= _IsTriggerEnabled(whichTrigger);
end;

type TTriggerWaitOnSleepsFunctionPrototype = procedure (whichTrigger: HTRIGGER; flag: LongBool); cdecl;
var _TriggerWaitOnSleeps: TTriggerWaitOnSleepsFunctionPrototype;

procedure TriggerWaitOnSleeps(whichTrigger: HTRIGGER; flag: Boolean);
begin
	_TriggerWaitOnSleeps(whichTrigger, flag);
end;

type TIsTriggerWaitOnSleepsFunctionPrototype = function (whichTrigger: HTRIGGER): LongBool; cdecl;
var _IsTriggerWaitOnSleeps: TIsTriggerWaitOnSleepsFunctionPrototype;

function IsTriggerWaitOnSleeps(whichTrigger: HTRIGGER): Boolean;
begin
	Result:= _IsTriggerWaitOnSleeps(whichTrigger);
end;

type TGetFilterUnitFunctionPrototype = function: HUNIT; cdecl;
var _GetFilterUnit: TGetFilterUnitFunctionPrototype;

function GetFilterUnit: HUNIT;
begin
	Result:= _GetFilterUnit();
end;

type TGetEnumUnitFunctionPrototype = function: HUNIT; cdecl;
var _GetEnumUnit: TGetEnumUnitFunctionPrototype;

function GetEnumUnit: HUNIT;
begin
	Result:= _GetEnumUnit();
end;

type TGetFilterDestructableFunctionPrototype = function: HDESTRUCTABLE; cdecl;
var _GetFilterDestructable: TGetFilterDestructableFunctionPrototype;

function GetFilterDestructable: HDESTRUCTABLE;
begin
	Result:= _GetFilterDestructable();
end;

type TGetEnumDestructableFunctionPrototype = function: HDESTRUCTABLE; cdecl;
var _GetEnumDestructable: TGetEnumDestructableFunctionPrototype;

function GetEnumDestructable: HDESTRUCTABLE;
begin
	Result:= _GetEnumDestructable();
end;

type TGetFilterItemFunctionPrototype = function: HITEM; cdecl;
var _GetFilterItem: TGetFilterItemFunctionPrototype;

function GetFilterItem: HITEM;
begin
	Result:= _GetFilterItem();
end;

type TGetEnumItemFunctionPrototype = function: HITEM; cdecl;
var _GetEnumItem: TGetEnumItemFunctionPrototype;

function GetEnumItem: HITEM;
begin
	Result:= _GetEnumItem();
end;

type TGetFilterPlayerFunctionPrototype = function: HPLAYER; cdecl;
var _GetFilterPlayer: TGetFilterPlayerFunctionPrototype;

function GetFilterPlayer: HPLAYER;
begin
	Result:= _GetFilterPlayer();
end;

type TGetEnumPlayerFunctionPrototype = function: HPLAYER; cdecl;
var _GetEnumPlayer: TGetEnumPlayerFunctionPrototype;

function GetEnumPlayer: HPLAYER;
begin
	Result:= _GetEnumPlayer();
end;

type TGetTriggeringTriggerFunctionPrototype = function: HTRIGGER; cdecl;
var _GetTriggeringTrigger: TGetTriggeringTriggerFunctionPrototype;

function GetTriggeringTrigger: HTRIGGER;
begin
	Result:= _GetTriggeringTrigger();
end;

type TGetTriggerEventIdFunctionPrototype = function: HEVENTID; cdecl;
var _GetTriggerEventId: TGetTriggerEventIdFunctionPrototype;

function GetTriggerEventId: HEVENTID;
begin
	Result:= _GetTriggerEventId();
end;

type TGetTriggerEvalCountFunctionPrototype = function (whichTrigger: HTRIGGER): Int32; cdecl;
var _GetTriggerEvalCount: TGetTriggerEvalCountFunctionPrototype;

function GetTriggerEvalCount(whichTrigger: HTRIGGER): Integer;
begin
	Result:= _GetTriggerEvalCount(whichTrigger);
end;

type TGetTriggerExecCountFunctionPrototype = function (whichTrigger: HTRIGGER): Int32; cdecl;
var _GetTriggerExecCount: TGetTriggerExecCountFunctionPrototype;

function GetTriggerExecCount(whichTrigger: HTRIGGER): Integer;
begin
	Result:= _GetTriggerExecCount(whichTrigger);
end;

type TExecuteFuncFunctionPrototype = procedure (funcName: PJassString); cdecl;
var _ExecuteFunc: TExecuteFuncFunctionPrototype;

procedure ExecuteFunc(funcName: String);
var
	jfuncName: PJassString;
begin
	jfuncName:= CreateJassString(PChar(funcName));
	_ExecuteFunc(jfuncName);
	DestroyJassString(jfuncName);
end;

type TAndFunctionPrototype = function (operandA: HBOOLEXPR; operandB: HBOOLEXPR): HBOOLEXPR; cdecl;
var _And: TAndFunctionPrototype;

function And_(operandA: HBOOLEXPR; operandB: HBOOLEXPR): HBOOLEXPR;
begin
	Result:= _And(operandA, operandB);
end;

type TOrFunctionPrototype = function (operandA: HBOOLEXPR; operandB: HBOOLEXPR): HBOOLEXPR; cdecl;
var _Or: TOrFunctionPrototype;

function Or_(operandA: HBOOLEXPR; operandB: HBOOLEXPR): HBOOLEXPR;
begin
	Result:= _Or(operandA, operandB);
end;

type TNotFunctionPrototype = function (operand: HBOOLEXPR): HBOOLEXPR; cdecl;
var _Not: TNotFunctionPrototype;

function Not_(operand: HBOOLEXPR): HBOOLEXPR;
begin
	Result:= _Not(operand);
end;

type TConditionFunctionPrototype = function (func: TJassCallback): HCONDITIONFUNC; cdecl;
var _Condition: TConditionFunctionPrototype;

function Condition(func: TJassCallback): HCONDITIONFUNC;
begin
	Result:= _Condition(func);
end;

type TDestroyConditionFunctionPrototype = procedure (c: HCONDITIONFUNC); cdecl;
var _DestroyCondition: TDestroyConditionFunctionPrototype;

procedure DestroyCondition(c: HCONDITIONFUNC);
begin
	_DestroyCondition(c);
end;

type TFilterFunctionPrototype = function (func: TJassCallback): HFILTERFUNC; cdecl;
var _Filter: TFilterFunctionPrototype;

function Filter(func: TJassCallback): HFILTERFUNC;
begin
	Result:= _Filter(func);
end;

type TDestroyFilterFunctionPrototype = procedure (f: HFILTERFUNC); cdecl;
var _DestroyFilter: TDestroyFilterFunctionPrototype;

procedure DestroyFilter(f: HFILTERFUNC);
begin
	_DestroyFilter(f);
end;

type TDestroyBoolExprFunctionPrototype = procedure (e: HBOOLEXPR); cdecl;
var _DestroyBoolExpr: TDestroyBoolExprFunctionPrototype;

procedure DestroyBoolExpr(e: HBOOLEXPR);
begin
	_DestroyBoolExpr(e);
end;

type TTriggerRegisterVariableEventFunctionPrototype = function (whichTrigger: HTRIGGER; varName: PJassString; opcode: HLIMITOP; limitval: PSingle): HEVENT; cdecl;
var _TriggerRegisterVariableEvent: TTriggerRegisterVariableEventFunctionPrototype;

function TriggerRegisterVariableEvent(whichTrigger: HTRIGGER; varName: String; opcode: HLIMITOP; limitval: Single): HEVENT;
var
	jvarName: PJassString;
begin
	jvarName:= CreateJassString(PChar(varName));
	Result:= _TriggerRegisterVariableEvent(whichTrigger, jvarName, opcode, @limitval);
	DestroyJassString(jvarName);
end;

type TTriggerRegisterTimerEventFunctionPrototype = function (whichTrigger: HTRIGGER; timeout: PSingle; periodic: LongBool): HEVENT; cdecl;
var _TriggerRegisterTimerEvent: TTriggerRegisterTimerEventFunctionPrototype;

function TriggerRegisterTimerEvent(whichTrigger: HTRIGGER; timeout: Single; periodic: Boolean): HEVENT;
begin
	Result:= _TriggerRegisterTimerEvent(whichTrigger, @timeout, periodic);
end;

type TTriggerRegisterTimerExpireEventFunctionPrototype = function (whichTrigger: HTRIGGER; t: HTIMER): HEVENT; cdecl;
var _TriggerRegisterTimerExpireEvent: TTriggerRegisterTimerExpireEventFunctionPrototype;

function TriggerRegisterTimerExpireEvent(whichTrigger: HTRIGGER; t: HTIMER): HEVENT;
begin
	Result:= _TriggerRegisterTimerExpireEvent(whichTrigger, t);
end;

type TTriggerRegisterGameStateEventFunctionPrototype = function (whichTrigger: HTRIGGER; whichState: HGAMESTATE; opcode: HLIMITOP; limitval: PSingle): HEVENT; cdecl;
var _TriggerRegisterGameStateEvent: TTriggerRegisterGameStateEventFunctionPrototype;

function TriggerRegisterGameStateEvent(whichTrigger: HTRIGGER; whichState: HGAMESTATE; opcode: HLIMITOP; limitval: Single): HEVENT;
begin
	Result:= _TriggerRegisterGameStateEvent(whichTrigger, whichState, opcode, @limitval);
end;

type TTriggerRegisterDialogEventFunctionPrototype = function (whichTrigger: HTRIGGER; whichDialog: HDIALOG): HEVENT; cdecl;
var _TriggerRegisterDialogEvent: TTriggerRegisterDialogEventFunctionPrototype;

function TriggerRegisterDialogEvent(whichTrigger: HTRIGGER; whichDialog: HDIALOG): HEVENT;
begin
	Result:= _TriggerRegisterDialogEvent(whichTrigger, whichDialog);
end;

type TTriggerRegisterDialogButtonEventFunctionPrototype = function (whichTrigger: HTRIGGER; whichButton: HBUTTON): HEVENT; cdecl;
var _TriggerRegisterDialogButtonEvent: TTriggerRegisterDialogButtonEventFunctionPrototype;

function TriggerRegisterDialogButtonEvent(whichTrigger: HTRIGGER; whichButton: HBUTTON): HEVENT;
begin
	Result:= _TriggerRegisterDialogButtonEvent(whichTrigger, whichButton);
end;

type TGetEventGameStateFunctionPrototype = function: HGAMESTATE; cdecl;
var _GetEventGameState: TGetEventGameStateFunctionPrototype;

function GetEventGameState: HGAMESTATE;
begin
	Result:= _GetEventGameState();
end;

type TTriggerRegisterGameEventFunctionPrototype = function (whichTrigger: HTRIGGER; whichGameEvent: HGAMEEVENT): HEVENT; cdecl;
var _TriggerRegisterGameEvent: TTriggerRegisterGameEventFunctionPrototype;

function TriggerRegisterGameEvent(whichTrigger: HTRIGGER; whichGameEvent: HGAMEEVENT): HEVENT;
begin
	Result:= _TriggerRegisterGameEvent(whichTrigger, whichGameEvent);
end;

type TGetWinningPlayerFunctionPrototype = function: HPLAYER; cdecl;
var _GetWinningPlayer: TGetWinningPlayerFunctionPrototype;

function GetWinningPlayer: HPLAYER;
begin
	Result:= _GetWinningPlayer();
end;

type TTriggerRegisterEnterRegionFunctionPrototype = function (whichTrigger: HTRIGGER; whichRegion: HREGION; filter: HBOOLEXPR): HEVENT; cdecl;
var _TriggerRegisterEnterRegion: TTriggerRegisterEnterRegionFunctionPrototype;

function TriggerRegisterEnterRegion(whichTrigger: HTRIGGER; whichRegion: HREGION; filter: HBOOLEXPR): HEVENT;
begin
	Result:= _TriggerRegisterEnterRegion(whichTrigger, whichRegion, filter);
end;

type TGetTriggeringRegionFunctionPrototype = function: HREGION; cdecl;
var _GetTriggeringRegion: TGetTriggeringRegionFunctionPrototype;

function GetTriggeringRegion: HREGION;
begin
	Result:= _GetTriggeringRegion();
end;

type TGetEnteringUnitFunctionPrototype = function: HUNIT; cdecl;
var _GetEnteringUnit: TGetEnteringUnitFunctionPrototype;

function GetEnteringUnit: HUNIT;
begin
	Result:= _GetEnteringUnit();
end;

type TTriggerRegisterLeaveRegionFunctionPrototype = function (whichTrigger: HTRIGGER; whichRegion: HREGION; filter: HBOOLEXPR): HEVENT; cdecl;
var _TriggerRegisterLeaveRegion: TTriggerRegisterLeaveRegionFunctionPrototype;

function TriggerRegisterLeaveRegion(whichTrigger: HTRIGGER; whichRegion: HREGION; filter: HBOOLEXPR): HEVENT;
begin
	Result:= _TriggerRegisterLeaveRegion(whichTrigger, whichRegion, filter);
end;

type TGetLeavingUnitFunctionPrototype = function: HUNIT; cdecl;
var _GetLeavingUnit: TGetLeavingUnitFunctionPrototype;

function GetLeavingUnit: HUNIT;
begin
	Result:= _GetLeavingUnit();
end;

type TTriggerRegisterTrackableHitEventFunctionPrototype = function (whichTrigger: HTRIGGER; t: HTRACKABLE): HEVENT; cdecl;
var _TriggerRegisterTrackableHitEvent: TTriggerRegisterTrackableHitEventFunctionPrototype;

function TriggerRegisterTrackableHitEvent(whichTrigger: HTRIGGER; t: HTRACKABLE): HEVENT;
begin
	Result:= _TriggerRegisterTrackableHitEvent(whichTrigger, t);
end;

type TTriggerRegisterTrackableTrackEventFunctionPrototype = function (whichTrigger: HTRIGGER; t: HTRACKABLE): HEVENT; cdecl;
var _TriggerRegisterTrackableTrackEvent: TTriggerRegisterTrackableTrackEventFunctionPrototype;

function TriggerRegisterTrackableTrackEvent(whichTrigger: HTRIGGER; t: HTRACKABLE): HEVENT;
begin
	Result:= _TriggerRegisterTrackableTrackEvent(whichTrigger, t);
end;

type TGetTriggeringTrackableFunctionPrototype = function: HTRACKABLE; cdecl;
var _GetTriggeringTrackable: TGetTriggeringTrackableFunctionPrototype;

function GetTriggeringTrackable: HTRACKABLE;
begin
	Result:= _GetTriggeringTrackable();
end;

type TGetClickedButtonFunctionPrototype = function: HBUTTON; cdecl;
var _GetClickedButton: TGetClickedButtonFunctionPrototype;

function GetClickedButton: HBUTTON;
begin
	Result:= _GetClickedButton();
end;

type TGetClickedDialogFunctionPrototype = function: HDIALOG; cdecl;
var _GetClickedDialog: TGetClickedDialogFunctionPrototype;

function GetClickedDialog: HDIALOG;
begin
	Result:= _GetClickedDialog();
end;

type TGetTournamentFinishSoonTimeRemainingFunctionPrototype = function: TSingle; cdecl;
var _GetTournamentFinishSoonTimeRemaining: TGetTournamentFinishSoonTimeRemainingFunctionPrototype;

function GetTournamentFinishSoonTimeRemaining: Single;
begin
	Result:= _GetTournamentFinishSoonTimeRemaining().Value;
end;

type TGetTournamentFinishNowRuleFunctionPrototype = function: Int32; cdecl;
var _GetTournamentFinishNowRule: TGetTournamentFinishNowRuleFunctionPrototype;

function GetTournamentFinishNowRule: Integer;
begin
	Result:= _GetTournamentFinishNowRule();
end;

type TGetTournamentFinishNowPlayerFunctionPrototype = function: HPLAYER; cdecl;
var _GetTournamentFinishNowPlayer: TGetTournamentFinishNowPlayerFunctionPrototype;

function GetTournamentFinishNowPlayer: HPLAYER;
begin
	Result:= _GetTournamentFinishNowPlayer();
end;

type TGetTournamentScoreFunctionPrototype = function (whichPlayer: HPLAYER): Int32; cdecl;
var _GetTournamentScore: TGetTournamentScoreFunctionPrototype;

function GetTournamentScore(whichPlayer: HPLAYER): Integer;
begin
	Result:= _GetTournamentScore(whichPlayer);
end;

type TGetSaveBasicFilenameFunctionPrototype = function: TJassStringHandle; cdecl;
var _GetSaveBasicFilename: TGetSaveBasicFilenameFunctionPrototype;

function GetSaveBasicFilename: String;
var
	hResult: TJassStringHandle;
begin
	hResult:= _GetSaveBasicFilename();
	Result:= GetStringFromHandle(hResult);
	DecrementStringReferences(hResult);
end;

type TTriggerRegisterPlayerEventFunctionPrototype = function (whichTrigger: HTRIGGER; whichPlayer: HPLAYER; whichPlayerEvent: HPLAYEREVENT): HEVENT; cdecl;
var _TriggerRegisterPlayerEvent: TTriggerRegisterPlayerEventFunctionPrototype;

function TriggerRegisterPlayerEvent(whichTrigger: HTRIGGER; whichPlayer: HPLAYER; whichPlayerEvent: HPLAYEREVENT): HEVENT;
begin
	Result:= _TriggerRegisterPlayerEvent(whichTrigger, whichPlayer, whichPlayerEvent);
end;

type TGetTriggerPlayerFunctionPrototype = function: HPLAYER; cdecl;
var _GetTriggerPlayer: TGetTriggerPlayerFunctionPrototype;

function GetTriggerPlayer: HPLAYER;
begin
	Result:= _GetTriggerPlayer();
end;

type TTriggerRegisterPlayerUnitEventFunctionPrototype = function (whichTrigger: HTRIGGER; whichPlayer: HPLAYER; whichPlayerUnitEvent: HPLAYERUNITEVENT; filter: HBOOLEXPR): HEVENT; cdecl;
var _TriggerRegisterPlayerUnitEvent: TTriggerRegisterPlayerUnitEventFunctionPrototype;

function TriggerRegisterPlayerUnitEvent(whichTrigger: HTRIGGER; whichPlayer: HPLAYER; whichPlayerUnitEvent: HPLAYERUNITEVENT; filter: HBOOLEXPR): HEVENT;
begin
	Result:= _TriggerRegisterPlayerUnitEvent(whichTrigger, whichPlayer, whichPlayerUnitEvent, filter);
end;

type TGetLevelingUnitFunctionPrototype = function: HUNIT; cdecl;
var _GetLevelingUnit: TGetLevelingUnitFunctionPrototype;

function GetLevelingUnit: HUNIT;
begin
	Result:= _GetLevelingUnit();
end;

type TGetLearningUnitFunctionPrototype = function: HUNIT; cdecl;
var _GetLearningUnit: TGetLearningUnitFunctionPrototype;

function GetLearningUnit: HUNIT;
begin
	Result:= _GetLearningUnit();
end;

type TGetLearnedSkillFunctionPrototype = function: Int32; cdecl;
var _GetLearnedSkill: TGetLearnedSkillFunctionPrototype;

function GetLearnedSkill: Integer;
begin
	Result:= _GetLearnedSkill();
end;

type TGetLearnedSkillLevelFunctionPrototype = function: Int32; cdecl;
var _GetLearnedSkillLevel: TGetLearnedSkillLevelFunctionPrototype;

function GetLearnedSkillLevel: Integer;
begin
	Result:= _GetLearnedSkillLevel();
end;

type TGetRevivableUnitFunctionPrototype = function: HUNIT; cdecl;
var _GetRevivableUnit: TGetRevivableUnitFunctionPrototype;

function GetRevivableUnit: HUNIT;
begin
	Result:= _GetRevivableUnit();
end;

type TGetRevivingUnitFunctionPrototype = function: HUNIT; cdecl;
var _GetRevivingUnit: TGetRevivingUnitFunctionPrototype;

function GetRevivingUnit: HUNIT;
begin
	Result:= _GetRevivingUnit();
end;

type TGetAttackerFunctionPrototype = function: HUNIT; cdecl;
var _GetAttacker: TGetAttackerFunctionPrototype;

function GetAttacker: HUNIT;
begin
	Result:= _GetAttacker();
end;

type TGetRescuerFunctionPrototype = function: HUNIT; cdecl;
var _GetRescuer: TGetRescuerFunctionPrototype;

function GetRescuer: HUNIT;
begin
	Result:= _GetRescuer();
end;

type TGetDyingUnitFunctionPrototype = function: HUNIT; cdecl;
var _GetDyingUnit: TGetDyingUnitFunctionPrototype;

function GetDyingUnit: HUNIT;
begin
	Result:= _GetDyingUnit();
end;

type TGetKillingUnitFunctionPrototype = function: HUNIT; cdecl;
var _GetKillingUnit: TGetKillingUnitFunctionPrototype;

function GetKillingUnit: HUNIT;
begin
	Result:= _GetKillingUnit();
end;

type TGetDecayingUnitFunctionPrototype = function: HUNIT; cdecl;
var _GetDecayingUnit: TGetDecayingUnitFunctionPrototype;

function GetDecayingUnit: HUNIT;
begin
	Result:= _GetDecayingUnit();
end;

type TGetConstructingStructureFunctionPrototype = function: HUNIT; cdecl;
var _GetConstructingStructure: TGetConstructingStructureFunctionPrototype;

function GetConstructingStructure: HUNIT;
begin
	Result:= _GetConstructingStructure();
end;

type TGetCancelledStructureFunctionPrototype = function: HUNIT; cdecl;
var _GetCancelledStructure: TGetCancelledStructureFunctionPrototype;

function GetCancelledStructure: HUNIT;
begin
	Result:= _GetCancelledStructure();
end;

type TGetConstructedStructureFunctionPrototype = function: HUNIT; cdecl;
var _GetConstructedStructure: TGetConstructedStructureFunctionPrototype;

function GetConstructedStructure: HUNIT;
begin
	Result:= _GetConstructedStructure();
end;

type TGetResearchingUnitFunctionPrototype = function: HUNIT; cdecl;
var _GetResearchingUnit: TGetResearchingUnitFunctionPrototype;

function GetResearchingUnit: HUNIT;
begin
	Result:= _GetResearchingUnit();
end;

type TGetResearchedFunctionPrototype = function: Int32; cdecl;
var _GetResearched: TGetResearchedFunctionPrototype;

function GetResearched: Integer;
begin
	Result:= _GetResearched();
end;

type TGetTrainedUnitTypeFunctionPrototype = function: Int32; cdecl;
var _GetTrainedUnitType: TGetTrainedUnitTypeFunctionPrototype;

function GetTrainedUnitType: Integer;
begin
	Result:= _GetTrainedUnitType();
end;

type TGetTrainedUnitFunctionPrototype = function: HUNIT; cdecl;
var _GetTrainedUnit: TGetTrainedUnitFunctionPrototype;

function GetTrainedUnit: HUNIT;
begin
	Result:= _GetTrainedUnit();
end;

type TGetDetectedUnitFunctionPrototype = function: HUNIT; cdecl;
var _GetDetectedUnit: TGetDetectedUnitFunctionPrototype;

function GetDetectedUnit: HUNIT;
begin
	Result:= _GetDetectedUnit();
end;

type TGetSummoningUnitFunctionPrototype = function: HUNIT; cdecl;
var _GetSummoningUnit: TGetSummoningUnitFunctionPrototype;

function GetSummoningUnit: HUNIT;
begin
	Result:= _GetSummoningUnit();
end;

type TGetSummonedUnitFunctionPrototype = function: HUNIT; cdecl;
var _GetSummonedUnit: TGetSummonedUnitFunctionPrototype;

function GetSummonedUnit: HUNIT;
begin
	Result:= _GetSummonedUnit();
end;

type TGetTransportUnitFunctionPrototype = function: HUNIT; cdecl;
var _GetTransportUnit: TGetTransportUnitFunctionPrototype;

function GetTransportUnit: HUNIT;
begin
	Result:= _GetTransportUnit();
end;

type TGetLoadedUnitFunctionPrototype = function: HUNIT; cdecl;
var _GetLoadedUnit: TGetLoadedUnitFunctionPrototype;

function GetLoadedUnit: HUNIT;
begin
	Result:= _GetLoadedUnit();
end;

type TGetSellingUnitFunctionPrototype = function: HUNIT; cdecl;
var _GetSellingUnit: TGetSellingUnitFunctionPrototype;

function GetSellingUnit: HUNIT;
begin
	Result:= _GetSellingUnit();
end;

type TGetSoldUnitFunctionPrototype = function: HUNIT; cdecl;
var _GetSoldUnit: TGetSoldUnitFunctionPrototype;

function GetSoldUnit: HUNIT;
begin
	Result:= _GetSoldUnit();
end;

type TGetBuyingUnitFunctionPrototype = function: HUNIT; cdecl;
var _GetBuyingUnit: TGetBuyingUnitFunctionPrototype;

function GetBuyingUnit: HUNIT;
begin
	Result:= _GetBuyingUnit();
end;

type TGetSoldItemFunctionPrototype = function: HITEM; cdecl;
var _GetSoldItem: TGetSoldItemFunctionPrototype;

function GetSoldItem: HITEM;
begin
	Result:= _GetSoldItem();
end;

type TGetChangingUnitFunctionPrototype = function: HUNIT; cdecl;
var _GetChangingUnit: TGetChangingUnitFunctionPrototype;

function GetChangingUnit: HUNIT;
begin
	Result:= _GetChangingUnit();
end;

type TGetChangingUnitPrevOwnerFunctionPrototype = function: HPLAYER; cdecl;
var _GetChangingUnitPrevOwner: TGetChangingUnitPrevOwnerFunctionPrototype;

function GetChangingUnitPrevOwner: HPLAYER;
begin
	Result:= _GetChangingUnitPrevOwner();
end;

type TGetManipulatingUnitFunctionPrototype = function: HUNIT; cdecl;
var _GetManipulatingUnit: TGetManipulatingUnitFunctionPrototype;

function GetManipulatingUnit: HUNIT;
begin
	Result:= _GetManipulatingUnit();
end;

type TGetManipulatedItemFunctionPrototype = function: HITEM; cdecl;
var _GetManipulatedItem: TGetManipulatedItemFunctionPrototype;

function GetManipulatedItem: HITEM;
begin
	Result:= _GetManipulatedItem();
end;

type TGetOrderedUnitFunctionPrototype = function: HUNIT; cdecl;
var _GetOrderedUnit: TGetOrderedUnitFunctionPrototype;

function GetOrderedUnit: HUNIT;
begin
	Result:= _GetOrderedUnit();
end;

type TGetIssuedOrderIdFunctionPrototype = function: Int32; cdecl;
var _GetIssuedOrderId: TGetIssuedOrderIdFunctionPrototype;

function GetIssuedOrderId: Integer;
begin
	Result:= _GetIssuedOrderId();
end;

type TGetOrderPointXFunctionPrototype = function: TSingle; cdecl;
var _GetOrderPointX: TGetOrderPointXFunctionPrototype;

function GetOrderPointX: Single;
begin
	Result:= _GetOrderPointX().Value;
end;

type TGetOrderPointYFunctionPrototype = function: TSingle; cdecl;
var _GetOrderPointY: TGetOrderPointYFunctionPrototype;

function GetOrderPointY: Single;
begin
	Result:= _GetOrderPointY().Value;
end;

type TGetOrderPointLocFunctionPrototype = function: HLOCATION; cdecl;
var _GetOrderPointLoc: TGetOrderPointLocFunctionPrototype;

function GetOrderPointLoc: HLOCATION;
begin
	Result:= _GetOrderPointLoc();
end;

type TGetOrderTargetFunctionPrototype = function: HWIDGET; cdecl;
var _GetOrderTarget: TGetOrderTargetFunctionPrototype;

function GetOrderTarget: HWIDGET;
begin
	Result:= _GetOrderTarget();
end;

type TGetOrderTargetDestructableFunctionPrototype = function: HDESTRUCTABLE; cdecl;
var _GetOrderTargetDestructable: TGetOrderTargetDestructableFunctionPrototype;

function GetOrderTargetDestructable: HDESTRUCTABLE;
begin
	Result:= _GetOrderTargetDestructable();
end;

type TGetOrderTargetItemFunctionPrototype = function: HITEM; cdecl;
var _GetOrderTargetItem: TGetOrderTargetItemFunctionPrototype;

function GetOrderTargetItem: HITEM;
begin
	Result:= _GetOrderTargetItem();
end;

type TGetOrderTargetUnitFunctionPrototype = function: HUNIT; cdecl;
var _GetOrderTargetUnit: TGetOrderTargetUnitFunctionPrototype;

function GetOrderTargetUnit: HUNIT;
begin
	Result:= _GetOrderTargetUnit();
end;

type TGetSpellAbilityUnitFunctionPrototype = function: HUNIT; cdecl;
var _GetSpellAbilityUnit: TGetSpellAbilityUnitFunctionPrototype;

function GetSpellAbilityUnit: HUNIT;
begin
	Result:= _GetSpellAbilityUnit();
end;

type TGetSpellAbilityIdFunctionPrototype = function: Int32; cdecl;
var _GetSpellAbilityId: TGetSpellAbilityIdFunctionPrototype;

function GetSpellAbilityId: Integer;
begin
	Result:= _GetSpellAbilityId();
end;

type TGetSpellAbilityFunctionPrototype = function: HABILITY; cdecl;
var _GetSpellAbility: TGetSpellAbilityFunctionPrototype;

function GetSpellAbility: HABILITY;
begin
	Result:= _GetSpellAbility();
end;

type TGetSpellTargetLocFunctionPrototype = function: HLOCATION; cdecl;
var _GetSpellTargetLoc: TGetSpellTargetLocFunctionPrototype;

function GetSpellTargetLoc: HLOCATION;
begin
	Result:= _GetSpellTargetLoc();
end;

type TGetSpellTargetXFunctionPrototype = function: TSingle; cdecl;
var _GetSpellTargetX: TGetSpellTargetXFunctionPrototype;

function GetSpellTargetX: Single;
begin
	Result:= _GetSpellTargetX().Value;
end;

type TGetSpellTargetYFunctionPrototype = function: TSingle; cdecl;
var _GetSpellTargetY: TGetSpellTargetYFunctionPrototype;

function GetSpellTargetY: Single;
begin
	Result:= _GetSpellTargetY().Value;
end;

type TGetSpellTargetDestructableFunctionPrototype = function: HDESTRUCTABLE; cdecl;
var _GetSpellTargetDestructable: TGetSpellTargetDestructableFunctionPrototype;

function GetSpellTargetDestructable: HDESTRUCTABLE;
begin
	Result:= _GetSpellTargetDestructable();
end;

type TGetSpellTargetItemFunctionPrototype = function: HITEM; cdecl;
var _GetSpellTargetItem: TGetSpellTargetItemFunctionPrototype;

function GetSpellTargetItem: HITEM;
begin
	Result:= _GetSpellTargetItem();
end;

type TGetSpellTargetUnitFunctionPrototype = function: HUNIT; cdecl;
var _GetSpellTargetUnit: TGetSpellTargetUnitFunctionPrototype;

function GetSpellTargetUnit: HUNIT;
begin
	Result:= _GetSpellTargetUnit();
end;

type TTriggerRegisterPlayerAllianceChangeFunctionPrototype = function (whichTrigger: HTRIGGER; whichPlayer: HPLAYER; whichAlliance: HALLIANCETYPE): HEVENT; cdecl;
var _TriggerRegisterPlayerAllianceChange: TTriggerRegisterPlayerAllianceChangeFunctionPrototype;

function TriggerRegisterPlayerAllianceChange(whichTrigger: HTRIGGER; whichPlayer: HPLAYER; whichAlliance: HALLIANCETYPE): HEVENT;
begin
	Result:= _TriggerRegisterPlayerAllianceChange(whichTrigger, whichPlayer, whichAlliance);
end;

type TTriggerRegisterPlayerStateEventFunctionPrototype = function (whichTrigger: HTRIGGER; whichPlayer: HPLAYER; whichState: HPLAYERSTATE; opcode: HLIMITOP; limitval: PSingle): HEVENT; cdecl;
var _TriggerRegisterPlayerStateEvent: TTriggerRegisterPlayerStateEventFunctionPrototype;

function TriggerRegisterPlayerStateEvent(whichTrigger: HTRIGGER; whichPlayer: HPLAYER; whichState: HPLAYERSTATE; opcode: HLIMITOP; limitval: Single): HEVENT;
begin
	Result:= _TriggerRegisterPlayerStateEvent(whichTrigger, whichPlayer, whichState, opcode, @limitval);
end;

type TGetEventPlayerStateFunctionPrototype = function: HPLAYERSTATE; cdecl;
var _GetEventPlayerState: TGetEventPlayerStateFunctionPrototype;

function GetEventPlayerState: HPLAYERSTATE;
begin
	Result:= _GetEventPlayerState();
end;

type TTriggerRegisterPlayerChatEventFunctionPrototype = function (whichTrigger: HTRIGGER; whichPlayer: HPLAYER; chatMessageToDetect: PJassString; exactMatchOnly: LongBool): HEVENT; cdecl;
var _TriggerRegisterPlayerChatEvent: TTriggerRegisterPlayerChatEventFunctionPrototype;

function TriggerRegisterPlayerChatEvent(whichTrigger: HTRIGGER; whichPlayer: HPLAYER; chatMessageToDetect: String; exactMatchOnly: Boolean): HEVENT;
var
	jchatMessageToDetect: PJassString;
begin
	jchatMessageToDetect:= CreateJassString(PChar(chatMessageToDetect));
	Result:= _TriggerRegisterPlayerChatEvent(whichTrigger, whichPlayer, jchatMessageToDetect, exactMatchOnly);
	DestroyJassString(jchatMessageToDetect);
end;

type TGetEventPlayerChatStringFunctionPrototype = function: TJassStringHandle; cdecl;
var _GetEventPlayerChatString: TGetEventPlayerChatStringFunctionPrototype;

function GetEventPlayerChatString: String;
var
	hResult: TJassStringHandle;
begin
	hResult:= _GetEventPlayerChatString();
	Result:= GetStringFromHandle(hResult);
	DecrementStringReferences(hResult);
end;

type TGetEventPlayerChatStringMatchedFunctionPrototype = function: TJassStringHandle; cdecl;
var _GetEventPlayerChatStringMatched: TGetEventPlayerChatStringMatchedFunctionPrototype;

function GetEventPlayerChatStringMatched: String;
var
	hResult: TJassStringHandle;
begin
	hResult:= _GetEventPlayerChatStringMatched();
	Result:= GetStringFromHandle(hResult);
	DecrementStringReferences(hResult);
end;

type TTriggerRegisterDeathEventFunctionPrototype = function (whichTrigger: HTRIGGER; whichWidget: HWIDGET): HEVENT; cdecl;
var _TriggerRegisterDeathEvent: TTriggerRegisterDeathEventFunctionPrototype;

function TriggerRegisterDeathEvent(whichTrigger: HTRIGGER; whichWidget: HWIDGET): HEVENT;
begin
	Result:= _TriggerRegisterDeathEvent(whichTrigger, whichWidget);
end;

type TGetTriggerUnitFunctionPrototype = function: HUNIT; cdecl;
var _GetTriggerUnit: TGetTriggerUnitFunctionPrototype;

function GetTriggerUnit: HUNIT;
begin
	Result:= _GetTriggerUnit();
end;

type TTriggerRegisterUnitStateEventFunctionPrototype = function (whichTrigger: HTRIGGER; whichUnit: HUNIT; whichState: HUNITSTATE; opcode: HLIMITOP; limitval: PSingle): HEVENT; cdecl;
var _TriggerRegisterUnitStateEvent: TTriggerRegisterUnitStateEventFunctionPrototype;

function TriggerRegisterUnitStateEvent(whichTrigger: HTRIGGER; whichUnit: HUNIT; whichState: HUNITSTATE; opcode: HLIMITOP; limitval: Single): HEVENT;
begin
	Result:= _TriggerRegisterUnitStateEvent(whichTrigger, whichUnit, whichState, opcode, @limitval);
end;

type TGetEventUnitStateFunctionPrototype = function: HUNITSTATE; cdecl;
var _GetEventUnitState: TGetEventUnitStateFunctionPrototype;

function GetEventUnitState: HUNITSTATE;
begin
	Result:= _GetEventUnitState();
end;

type TTriggerRegisterUnitEventFunctionPrototype = function (whichTrigger: HTRIGGER; whichUnit: HUNIT; whichEvent: HUNITEVENT): HEVENT; cdecl;
var _TriggerRegisterUnitEvent: TTriggerRegisterUnitEventFunctionPrototype;

function TriggerRegisterUnitEvent(whichTrigger: HTRIGGER; whichUnit: HUNIT; whichEvent: HUNITEVENT): HEVENT;
begin
	Result:= _TriggerRegisterUnitEvent(whichTrigger, whichUnit, whichEvent);
end;

type TGetEventDamageFunctionPrototype = function: TSingle; cdecl;
var _GetEventDamage: TGetEventDamageFunctionPrototype;

function GetEventDamage: Single;
begin
	Result:= _GetEventDamage().Value;
end;

type TGetEventDamageSourceFunctionPrototype = function: HUNIT; cdecl;
var _GetEventDamageSource: TGetEventDamageSourceFunctionPrototype;

function GetEventDamageSource: HUNIT;
begin
	Result:= _GetEventDamageSource();
end;

type TGetEventDetectingPlayerFunctionPrototype = function: HPLAYER; cdecl;
var _GetEventDetectingPlayer: TGetEventDetectingPlayerFunctionPrototype;

function GetEventDetectingPlayer: HPLAYER;
begin
	Result:= _GetEventDetectingPlayer();
end;

type TTriggerRegisterFilterUnitEventFunctionPrototype = function (whichTrigger: HTRIGGER; whichUnit: HUNIT; whichEvent: HUNITEVENT; filter: HBOOLEXPR): HEVENT; cdecl;
var _TriggerRegisterFilterUnitEvent: TTriggerRegisterFilterUnitEventFunctionPrototype;

function TriggerRegisterFilterUnitEvent(whichTrigger: HTRIGGER; whichUnit: HUNIT; whichEvent: HUNITEVENT; filter: HBOOLEXPR): HEVENT;
begin
	Result:= _TriggerRegisterFilterUnitEvent(whichTrigger, whichUnit, whichEvent, filter);
end;

type TGetEventTargetUnitFunctionPrototype = function: HUNIT; cdecl;
var _GetEventTargetUnit: TGetEventTargetUnitFunctionPrototype;

function GetEventTargetUnit: HUNIT;
begin
	Result:= _GetEventTargetUnit();
end;

type TTriggerRegisterUnitInRangeFunctionPrototype = function (whichTrigger: HTRIGGER; whichUnit: HUNIT; range: PSingle; filter: HBOOLEXPR): HEVENT; cdecl;
var _TriggerRegisterUnitInRange: TTriggerRegisterUnitInRangeFunctionPrototype;

function TriggerRegisterUnitInRange(whichTrigger: HTRIGGER; whichUnit: HUNIT; range: Single; filter: HBOOLEXPR): HEVENT;
begin
	Result:= _TriggerRegisterUnitInRange(whichTrigger, whichUnit, @range, filter);
end;

type TTriggerAddConditionFunctionPrototype = function (whichTrigger: HTRIGGER; condition: HBOOLEXPR): HTRIGGERCONDITION; cdecl;
var _TriggerAddCondition: TTriggerAddConditionFunctionPrototype;

function TriggerAddCondition(whichTrigger: HTRIGGER; condition: HBOOLEXPR): HTRIGGERCONDITION;
begin
	Result:= _TriggerAddCondition(whichTrigger, condition);
end;

type TTriggerRemoveConditionFunctionPrototype = procedure (whichTrigger: HTRIGGER; whichCondition: HTRIGGERCONDITION); cdecl;
var _TriggerRemoveCondition: TTriggerRemoveConditionFunctionPrototype;

procedure TriggerRemoveCondition(whichTrigger: HTRIGGER; whichCondition: HTRIGGERCONDITION);
begin
	_TriggerRemoveCondition(whichTrigger, whichCondition);
end;

type TTriggerClearConditionsFunctionPrototype = procedure (whichTrigger: HTRIGGER); cdecl;
var _TriggerClearConditions: TTriggerClearConditionsFunctionPrototype;

procedure TriggerClearConditions(whichTrigger: HTRIGGER);
begin
	_TriggerClearConditions(whichTrigger);
end;

type TTriggerAddActionFunctionPrototype = function (whichTrigger: HTRIGGER; actionFunc: TJassCallback): HTRIGGERACTION; cdecl;
var _TriggerAddAction: TTriggerAddActionFunctionPrototype;

function TriggerAddAction(whichTrigger: HTRIGGER; actionFunc: TJassCallback): HTRIGGERACTION;
begin
	Result:= _TriggerAddAction(whichTrigger, actionFunc);
end;

type TTriggerRemoveActionFunctionPrototype = procedure (whichTrigger: HTRIGGER; whichAction: HTRIGGERACTION); cdecl;
var _TriggerRemoveAction: TTriggerRemoveActionFunctionPrototype;

procedure TriggerRemoveAction(whichTrigger: HTRIGGER; whichAction: HTRIGGERACTION);
begin
	_TriggerRemoveAction(whichTrigger, whichAction);
end;

type TTriggerClearActionsFunctionPrototype = procedure (whichTrigger: HTRIGGER); cdecl;
var _TriggerClearActions: TTriggerClearActionsFunctionPrototype;

procedure TriggerClearActions(whichTrigger: HTRIGGER);
begin
	_TriggerClearActions(whichTrigger);
end;

type TTriggerSleepActionFunctionPrototype = procedure (timeout: PSingle); cdecl;
var _TriggerSleepAction: TTriggerSleepActionFunctionPrototype;

procedure TriggerSleepAction(timeout: Single);
begin
	_TriggerSleepAction(@timeout);
end;

type TTriggerWaitForSoundFunctionPrototype = procedure (s: HSOUND; offset: PSingle); cdecl;
var _TriggerWaitForSound: TTriggerWaitForSoundFunctionPrototype;

procedure TriggerWaitForSound(s: HSOUND; offset: Single);
begin
	_TriggerWaitForSound(s, @offset);
end;

type TTriggerEvaluateFunctionPrototype = function (whichTrigger: HTRIGGER): LongBool; cdecl;
var _TriggerEvaluate: TTriggerEvaluateFunctionPrototype;

function TriggerEvaluate(whichTrigger: HTRIGGER): Boolean;
begin
	Result:= _TriggerEvaluate(whichTrigger);
end;

type TTriggerExecuteFunctionPrototype = procedure (whichTrigger: HTRIGGER); cdecl;
var _TriggerExecute: TTriggerExecuteFunctionPrototype;

procedure TriggerExecute(whichTrigger: HTRIGGER);
begin
	_TriggerExecute(whichTrigger);
end;

type TTriggerExecuteWaitFunctionPrototype = procedure (whichTrigger: HTRIGGER); cdecl;
var _TriggerExecuteWait: TTriggerExecuteWaitFunctionPrototype;

procedure TriggerExecuteWait(whichTrigger: HTRIGGER);
begin
	_TriggerExecuteWait(whichTrigger);
end;

type TTriggerSyncStartFunctionPrototype = procedure; cdecl;
var _TriggerSyncStart: TTriggerSyncStartFunctionPrototype;

procedure TriggerSyncStart;
begin
	_TriggerSyncStart();
end;

type TTriggerSyncReadyFunctionPrototype = procedure; cdecl;
var _TriggerSyncReady: TTriggerSyncReadyFunctionPrototype;

procedure TriggerSyncReady;
begin
	_TriggerSyncReady();
end;

type TGetWidgetLifeFunctionPrototype = function (whichWidget: HWIDGET): TSingle; cdecl;
var _GetWidgetLife: TGetWidgetLifeFunctionPrototype;

function GetWidgetLife(whichWidget: HWIDGET): Single;
begin
	Result:= _GetWidgetLife(whichWidget).Value;
end;

type TSetWidgetLifeFunctionPrototype = procedure (whichWidget: HWIDGET; newLife: PSingle); cdecl;
var _SetWidgetLife: TSetWidgetLifeFunctionPrototype;

procedure SetWidgetLife(whichWidget: HWIDGET; newLife: Single);
begin
	_SetWidgetLife(whichWidget, @newLife);
end;

type TGetWidgetXFunctionPrototype = function (whichWidget: HWIDGET): TSingle; cdecl;
var _GetWidgetX: TGetWidgetXFunctionPrototype;

function GetWidgetX(whichWidget: HWIDGET): Single;
begin
	Result:= _GetWidgetX(whichWidget).Value;
end;

type TGetWidgetYFunctionPrototype = function (whichWidget: HWIDGET): TSingle; cdecl;
var _GetWidgetY: TGetWidgetYFunctionPrototype;

function GetWidgetY(whichWidget: HWIDGET): Single;
begin
	Result:= _GetWidgetY(whichWidget).Value;
end;

type TGetTriggerWidgetFunctionPrototype = function: HWIDGET; cdecl;
var _GetTriggerWidget: TGetTriggerWidgetFunctionPrototype;

function GetTriggerWidget: HWIDGET;
begin
	Result:= _GetTriggerWidget();
end;

type TCreateDestructableFunctionPrototype = function (objectid: Int32; x: PSingle; y: PSingle; face: PSingle; scale: PSingle; variation: Int32): HDESTRUCTABLE; cdecl;
var _CreateDestructable: TCreateDestructableFunctionPrototype;

function CreateDestructable(objectid: Integer; x: Single; y: Single; face: Single; scale: Single; variation: Integer): HDESTRUCTABLE;
begin
	Result:= _CreateDestructable(objectid, @x, @y, @face, @scale, variation);
end;

type TCreateDestructableZFunctionPrototype = function (objectid: Int32; x: PSingle; y: PSingle; z: PSingle; face: PSingle; scale: PSingle; variation: Int32): HDESTRUCTABLE; cdecl;
var _CreateDestructableZ: TCreateDestructableZFunctionPrototype;

function CreateDestructableZ(objectid: Integer; x: Single; y: Single; z: Single; face: Single; scale: Single; variation: Integer): HDESTRUCTABLE;
begin
	Result:= _CreateDestructableZ(objectid, @x, @y, @z, @face, @scale, variation);
end;

type TCreateDeadDestructableFunctionPrototype = function (objectid: Int32; x: PSingle; y: PSingle; face: PSingle; scale: PSingle; variation: Int32): HDESTRUCTABLE; cdecl;
var _CreateDeadDestructable: TCreateDeadDestructableFunctionPrototype;

function CreateDeadDestructable(objectid: Integer; x: Single; y: Single; face: Single; scale: Single; variation: Integer): HDESTRUCTABLE;
begin
	Result:= _CreateDeadDestructable(objectid, @x, @y, @face, @scale, variation);
end;

type TCreateDeadDestructableZFunctionPrototype = function (objectid: Int32; x: PSingle; y: PSingle; z: PSingle; face: PSingle; scale: PSingle; variation: Int32): HDESTRUCTABLE; cdecl;
var _CreateDeadDestructableZ: TCreateDeadDestructableZFunctionPrototype;

function CreateDeadDestructableZ(objectid: Integer; x: Single; y: Single; z: Single; face: Single; scale: Single; variation: Integer): HDESTRUCTABLE;
begin
	Result:= _CreateDeadDestructableZ(objectid, @x, @y, @z, @face, @scale, variation);
end;

type TRemoveDestructableFunctionPrototype = procedure (d: HDESTRUCTABLE); cdecl;
var _RemoveDestructable: TRemoveDestructableFunctionPrototype;

procedure RemoveDestructable(d: HDESTRUCTABLE);
begin
	_RemoveDestructable(d);
end;

type TKillDestructableFunctionPrototype = procedure (d: HDESTRUCTABLE); cdecl;
var _KillDestructable: TKillDestructableFunctionPrototype;

procedure KillDestructable(d: HDESTRUCTABLE);
begin
	_KillDestructable(d);
end;

type TSetDestructableInvulnerableFunctionPrototype = procedure (d: HDESTRUCTABLE; flag: LongBool); cdecl;
var _SetDestructableInvulnerable: TSetDestructableInvulnerableFunctionPrototype;

procedure SetDestructableInvulnerable(d: HDESTRUCTABLE; flag: Boolean);
begin
	_SetDestructableInvulnerable(d, flag);
end;

type TIsDestructableInvulnerableFunctionPrototype = function (d: HDESTRUCTABLE): LongBool; cdecl;
var _IsDestructableInvulnerable: TIsDestructableInvulnerableFunctionPrototype;

function IsDestructableInvulnerable(d: HDESTRUCTABLE): Boolean;
begin
	Result:= _IsDestructableInvulnerable(d);
end;

type TEnumDestructablesInRectFunctionPrototype = procedure (r: HRECT; filter: HBOOLEXPR; actionFunc: TJassCallback); cdecl;
var _EnumDestructablesInRect: TEnumDestructablesInRectFunctionPrototype;

procedure EnumDestructablesInRect(r: HRECT; filter: HBOOLEXPR; actionFunc: TJassCallback);
begin
	_EnumDestructablesInRect(r, filter, actionFunc);
end;

type TGetDestructableTypeIdFunctionPrototype = function (d: HDESTRUCTABLE): Int32; cdecl;
var _GetDestructableTypeId: TGetDestructableTypeIdFunctionPrototype;

function GetDestructableTypeId(d: HDESTRUCTABLE): Integer;
begin
	Result:= _GetDestructableTypeId(d);
end;

type TGetDestructableXFunctionPrototype = function (d: HDESTRUCTABLE): TSingle; cdecl;
var _GetDestructableX: TGetDestructableXFunctionPrototype;

function GetDestructableX(d: HDESTRUCTABLE): Single;
begin
	Result:= _GetDestructableX(d).Value;
end;

type TGetDestructableYFunctionPrototype = function (d: HDESTRUCTABLE): TSingle; cdecl;
var _GetDestructableY: TGetDestructableYFunctionPrototype;

function GetDestructableY(d: HDESTRUCTABLE): Single;
begin
	Result:= _GetDestructableY(d).Value;
end;

type TSetDestructableLifeFunctionPrototype = procedure (d: HDESTRUCTABLE; life: PSingle); cdecl;
var _SetDestructableLife: TSetDestructableLifeFunctionPrototype;

procedure SetDestructableLife(d: HDESTRUCTABLE; life: Single);
begin
	_SetDestructableLife(d, @life);
end;

type TGetDestructableLifeFunctionPrototype = function (d: HDESTRUCTABLE): TSingle; cdecl;
var _GetDestructableLife: TGetDestructableLifeFunctionPrototype;

function GetDestructableLife(d: HDESTRUCTABLE): Single;
begin
	Result:= _GetDestructableLife(d).Value;
end;

type TSetDestructableMaxLifeFunctionPrototype = procedure (d: HDESTRUCTABLE; max: PSingle); cdecl;
var _SetDestructableMaxLife: TSetDestructableMaxLifeFunctionPrototype;

procedure SetDestructableMaxLife(d: HDESTRUCTABLE; max: Single);
begin
	_SetDestructableMaxLife(d, @max);
end;

type TGetDestructableMaxLifeFunctionPrototype = function (d: HDESTRUCTABLE): TSingle; cdecl;
var _GetDestructableMaxLife: TGetDestructableMaxLifeFunctionPrototype;

function GetDestructableMaxLife(d: HDESTRUCTABLE): Single;
begin
	Result:= _GetDestructableMaxLife(d).Value;
end;

type TDestructableRestoreLifeFunctionPrototype = procedure (d: HDESTRUCTABLE; life: PSingle; birth: LongBool); cdecl;
var _DestructableRestoreLife: TDestructableRestoreLifeFunctionPrototype;

procedure DestructableRestoreLife(d: HDESTRUCTABLE; life: Single; birth: Boolean);
begin
	_DestructableRestoreLife(d, @life, birth);
end;

type TQueueDestructableAnimationFunctionPrototype = procedure (d: HDESTRUCTABLE; whichAnimation: PJassString); cdecl;
var _QueueDestructableAnimation: TQueueDestructableAnimationFunctionPrototype;

procedure QueueDestructableAnimation(d: HDESTRUCTABLE; whichAnimation: String);
var
	jwhichAnimation: PJassString;
begin
	jwhichAnimation:= CreateJassString(PChar(whichAnimation));
	_QueueDestructableAnimation(d, jwhichAnimation);
	DestroyJassString(jwhichAnimation);
end;

type TSetDestructableAnimationFunctionPrototype = procedure (d: HDESTRUCTABLE; whichAnimation: PJassString); cdecl;
var _SetDestructableAnimation: TSetDestructableAnimationFunctionPrototype;

procedure SetDestructableAnimation(d: HDESTRUCTABLE; whichAnimation: String);
var
	jwhichAnimation: PJassString;
begin
	jwhichAnimation:= CreateJassString(PChar(whichAnimation));
	_SetDestructableAnimation(d, jwhichAnimation);
	DestroyJassString(jwhichAnimation);
end;

type TSetDestructableAnimationSpeedFunctionPrototype = procedure (d: HDESTRUCTABLE; speedFactor: PSingle); cdecl;
var _SetDestructableAnimationSpeed: TSetDestructableAnimationSpeedFunctionPrototype;

procedure SetDestructableAnimationSpeed(d: HDESTRUCTABLE; speedFactor: Single);
begin
	_SetDestructableAnimationSpeed(d, @speedFactor);
end;

type TShowDestructableFunctionPrototype = procedure (d: HDESTRUCTABLE; flag: LongBool); cdecl;
var _ShowDestructable: TShowDestructableFunctionPrototype;

procedure ShowDestructable(d: HDESTRUCTABLE; flag: Boolean);
begin
	_ShowDestructable(d, flag);
end;

type TGetDestructableOccluderHeightFunctionPrototype = function (d: HDESTRUCTABLE): TSingle; cdecl;
var _GetDestructableOccluderHeight: TGetDestructableOccluderHeightFunctionPrototype;

function GetDestructableOccluderHeight(d: HDESTRUCTABLE): Single;
begin
	Result:= _GetDestructableOccluderHeight(d).Value;
end;

type TSetDestructableOccluderHeightFunctionPrototype = procedure (d: HDESTRUCTABLE; height: PSingle); cdecl;
var _SetDestructableOccluderHeight: TSetDestructableOccluderHeightFunctionPrototype;

procedure SetDestructableOccluderHeight(d: HDESTRUCTABLE; height: Single);
begin
	_SetDestructableOccluderHeight(d, @height);
end;

type TGetDestructableNameFunctionPrototype = function (d: HDESTRUCTABLE): TJassStringHandle; cdecl;
var _GetDestructableName: TGetDestructableNameFunctionPrototype;

function GetDestructableName(d: HDESTRUCTABLE): String;
var
	hResult: TJassStringHandle;
begin
	hResult:= _GetDestructableName(d);
	Result:= GetStringFromHandle(hResult);
	DecrementStringReferences(hResult);
end;

type TGetTriggerDestructableFunctionPrototype = function: HDESTRUCTABLE; cdecl;
var _GetTriggerDestructable: TGetTriggerDestructableFunctionPrototype;

function GetTriggerDestructable: HDESTRUCTABLE;
begin
	Result:= _GetTriggerDestructable();
end;

type TCreateItemFunctionPrototype = function (itemid: Int32; x: PSingle; y: PSingle): HITEM; cdecl;
var _CreateItem: TCreateItemFunctionPrototype;

function CreateItem(itemid: Integer; x: Single; y: Single): HITEM;
begin
	Result:= _CreateItem(itemid, @x, @y);
end;

type TRemoveItemFunctionPrototype = procedure (whichItem: HITEM); cdecl;
var _RemoveItem: TRemoveItemFunctionPrototype;

procedure RemoveItem(whichItem: HITEM);
begin
	_RemoveItem(whichItem);
end;

type TGetItemPlayerFunctionPrototype = function (whichItem: HITEM): HPLAYER; cdecl;
var _GetItemPlayer: TGetItemPlayerFunctionPrototype;

function GetItemPlayer(whichItem: HITEM): HPLAYER;
begin
	Result:= _GetItemPlayer(whichItem);
end;

type TGetItemTypeIdFunctionPrototype = function (i: HITEM): Int32; cdecl;
var _GetItemTypeId: TGetItemTypeIdFunctionPrototype;

function GetItemTypeId(i: HITEM): Integer;
begin
	Result:= _GetItemTypeId(i);
end;

type TGetItemXFunctionPrototype = function (i: HITEM): TSingle; cdecl;
var _GetItemX: TGetItemXFunctionPrototype;

function GetItemX(i: HITEM): Single;
begin
	Result:= _GetItemX(i).Value;
end;

type TGetItemYFunctionPrototype = function (i: HITEM): TSingle; cdecl;
var _GetItemY: TGetItemYFunctionPrototype;

function GetItemY(i: HITEM): Single;
begin
	Result:= _GetItemY(i).Value;
end;

type TSetItemPositionFunctionPrototype = procedure (i: HITEM; x: PSingle; y: PSingle); cdecl;
var _SetItemPosition: TSetItemPositionFunctionPrototype;

procedure SetItemPosition(i: HITEM; x: Single; y: Single);
begin
	_SetItemPosition(i, @x, @y);
end;

type TSetItemDropOnDeathFunctionPrototype = procedure (whichItem: HITEM; flag: LongBool); cdecl;
var _SetItemDropOnDeath: TSetItemDropOnDeathFunctionPrototype;

procedure SetItemDropOnDeath(whichItem: HITEM; flag: Boolean);
begin
	_SetItemDropOnDeath(whichItem, flag);
end;

type TSetItemDroppableFunctionPrototype = procedure (i: HITEM; flag: LongBool); cdecl;
var _SetItemDroppable: TSetItemDroppableFunctionPrototype;

procedure SetItemDroppable(i: HITEM; flag: Boolean);
begin
	_SetItemDroppable(i, flag);
end;

type TSetItemPawnableFunctionPrototype = procedure (i: HITEM; flag: LongBool); cdecl;
var _SetItemPawnable: TSetItemPawnableFunctionPrototype;

procedure SetItemPawnable(i: HITEM; flag: Boolean);
begin
	_SetItemPawnable(i, flag);
end;

type TSetItemPlayerFunctionPrototype = procedure (whichItem: HITEM; whichPlayer: HPLAYER; changeColor: LongBool); cdecl;
var _SetItemPlayer: TSetItemPlayerFunctionPrototype;

procedure SetItemPlayer(whichItem: HITEM; whichPlayer: HPLAYER; changeColor: Boolean);
begin
	_SetItemPlayer(whichItem, whichPlayer, changeColor);
end;

type TSetItemInvulnerableFunctionPrototype = procedure (whichItem: HITEM; flag: LongBool); cdecl;
var _SetItemInvulnerable: TSetItemInvulnerableFunctionPrototype;

procedure SetItemInvulnerable(whichItem: HITEM; flag: Boolean);
begin
	_SetItemInvulnerable(whichItem, flag);
end;

type TIsItemInvulnerableFunctionPrototype = function (whichItem: HITEM): LongBool; cdecl;
var _IsItemInvulnerable: TIsItemInvulnerableFunctionPrototype;

function IsItemInvulnerable(whichItem: HITEM): Boolean;
begin
	Result:= _IsItemInvulnerable(whichItem);
end;

type TSetItemVisibleFunctionPrototype = procedure (whichItem: HITEM; show: LongBool); cdecl;
var _SetItemVisible: TSetItemVisibleFunctionPrototype;

procedure SetItemVisible(whichItem: HITEM; show: Boolean);
begin
	_SetItemVisible(whichItem, show);
end;

type TIsItemVisibleFunctionPrototype = function (whichItem: HITEM): LongBool; cdecl;
var _IsItemVisible: TIsItemVisibleFunctionPrototype;

function IsItemVisible(whichItem: HITEM): Boolean;
begin
	Result:= _IsItemVisible(whichItem);
end;

type TIsItemOwnedFunctionPrototype = function (whichItem: HITEM): LongBool; cdecl;
var _IsItemOwned: TIsItemOwnedFunctionPrototype;

function IsItemOwned(whichItem: HITEM): Boolean;
begin
	Result:= _IsItemOwned(whichItem);
end;

type TIsItemPowerupFunctionPrototype = function (whichItem: HITEM): LongBool; cdecl;
var _IsItemPowerup: TIsItemPowerupFunctionPrototype;

function IsItemPowerup(whichItem: HITEM): Boolean;
begin
	Result:= _IsItemPowerup(whichItem);
end;

type TIsItemSellableFunctionPrototype = function (whichItem: HITEM): LongBool; cdecl;
var _IsItemSellable: TIsItemSellableFunctionPrototype;

function IsItemSellable(whichItem: HITEM): Boolean;
begin
	Result:= _IsItemSellable(whichItem);
end;

type TIsItemPawnableFunctionPrototype = function (whichItem: HITEM): LongBool; cdecl;
var _IsItemPawnable: TIsItemPawnableFunctionPrototype;

function IsItemPawnable(whichItem: HITEM): Boolean;
begin
	Result:= _IsItemPawnable(whichItem);
end;

type TIsItemIdPowerupFunctionPrototype = function (itemId: Int32): LongBool; cdecl;
var _IsItemIdPowerup: TIsItemIdPowerupFunctionPrototype;

function IsItemIdPowerup(itemId: Integer): Boolean;
begin
	Result:= _IsItemIdPowerup(itemId);
end;

type TIsItemIdSellableFunctionPrototype = function (itemId: Int32): LongBool; cdecl;
var _IsItemIdSellable: TIsItemIdSellableFunctionPrototype;

function IsItemIdSellable(itemId: Integer): Boolean;
begin
	Result:= _IsItemIdSellable(itemId);
end;

type TIsItemIdPawnableFunctionPrototype = function (itemId: Int32): LongBool; cdecl;
var _IsItemIdPawnable: TIsItemIdPawnableFunctionPrototype;

function IsItemIdPawnable(itemId: Integer): Boolean;
begin
	Result:= _IsItemIdPawnable(itemId);
end;

type TEnumItemsInRectFunctionPrototype = procedure (r: HRECT; filter: HBOOLEXPR; actionFunc: TJassCallback); cdecl;
var _EnumItemsInRect: TEnumItemsInRectFunctionPrototype;

procedure EnumItemsInRect(r: HRECT; filter: HBOOLEXPR; actionFunc: TJassCallback);
begin
	_EnumItemsInRect(r, filter, actionFunc);
end;

type TGetItemLevelFunctionPrototype = function (whichItem: HITEM): Int32; cdecl;
var _GetItemLevel: TGetItemLevelFunctionPrototype;

function GetItemLevel(whichItem: HITEM): Integer;
begin
	Result:= _GetItemLevel(whichItem);
end;

type TGetItemTypeFunctionPrototype = function (whichItem: HITEM): HITEMTYPE; cdecl;
var _GetItemType: TGetItemTypeFunctionPrototype;

function GetItemType(whichItem: HITEM): HITEMTYPE;
begin
	Result:= _GetItemType(whichItem);
end;

type TSetItemDropIDFunctionPrototype = procedure (whichItem: HITEM; unitId: Int32); cdecl;
var _SetItemDropID: TSetItemDropIDFunctionPrototype;

procedure SetItemDropID(whichItem: HITEM; unitId: Integer);
begin
	_SetItemDropID(whichItem, unitId);
end;

type TGetItemNameFunctionPrototype = function (whichItem: HITEM): TJassStringHandle; cdecl;
var _GetItemName: TGetItemNameFunctionPrototype;

function GetItemName(whichItem: HITEM): String;
var
	hResult: TJassStringHandle;
begin
	hResult:= _GetItemName(whichItem);
	Result:= GetStringFromHandle(hResult);
	DecrementStringReferences(hResult);
end;

type TGetItemChargesFunctionPrototype = function (whichItem: HITEM): Int32; cdecl;
var _GetItemCharges: TGetItemChargesFunctionPrototype;

function GetItemCharges(whichItem: HITEM): Integer;
begin
	Result:= _GetItemCharges(whichItem);
end;

type TSetItemChargesFunctionPrototype = procedure (whichItem: HITEM; charges: Int32); cdecl;
var _SetItemCharges: TSetItemChargesFunctionPrototype;

procedure SetItemCharges(whichItem: HITEM; charges: Integer);
begin
	_SetItemCharges(whichItem, charges);
end;

type TGetItemUserDataFunctionPrototype = function (whichItem: HITEM): Int32; cdecl;
var _GetItemUserData: TGetItemUserDataFunctionPrototype;

function GetItemUserData(whichItem: HITEM): Integer;
begin
	Result:= _GetItemUserData(whichItem);
end;

type TSetItemUserDataFunctionPrototype = procedure (whichItem: HITEM; data: Int32); cdecl;
var _SetItemUserData: TSetItemUserDataFunctionPrototype;

procedure SetItemUserData(whichItem: HITEM; data: Integer);
begin
	_SetItemUserData(whichItem, data);
end;

type TCreateUnitFunctionPrototype = function (id: HPLAYER; unitid: Int32; x: PSingle; y: PSingle; face: PSingle): HUNIT; cdecl;
var _CreateUnit: TCreateUnitFunctionPrototype;

function CreateUnit(id: HPLAYER; unitid: Integer; x: Single; y: Single; face: Single): HUNIT;
begin
	Result:= _CreateUnit(id, unitid, @x, @y, @face);
end;

type TCreateUnitByNameFunctionPrototype = function (whichPlayer: HPLAYER; unitname: PJassString; x: PSingle; y: PSingle; face: PSingle): HUNIT; cdecl;
var _CreateUnitByName: TCreateUnitByNameFunctionPrototype;

function CreateUnitByName(whichPlayer: HPLAYER; unitname: String; x: Single; y: Single; face: Single): HUNIT;
var
	junitname: PJassString;
begin
	junitname:= CreateJassString(PChar(unitname));
	Result:= _CreateUnitByName(whichPlayer, junitname, @x, @y, @face);
	DestroyJassString(junitname);
end;

type TCreateUnitAtLocFunctionPrototype = function (id: HPLAYER; unitid: Int32; whichLocation: HLOCATION; face: PSingle): HUNIT; cdecl;
var _CreateUnitAtLoc: TCreateUnitAtLocFunctionPrototype;

function CreateUnitAtLoc(id: HPLAYER; unitid: Integer; whichLocation: HLOCATION; face: Single): HUNIT;
begin
	Result:= _CreateUnitAtLoc(id, unitid, whichLocation, @face);
end;

type TCreateUnitAtLocByNameFunctionPrototype = function (id: HPLAYER; unitname: PJassString; whichLocation: HLOCATION; face: PSingle): HUNIT; cdecl;
var _CreateUnitAtLocByName: TCreateUnitAtLocByNameFunctionPrototype;

function CreateUnitAtLocByName(id: HPLAYER; unitname: String; whichLocation: HLOCATION; face: Single): HUNIT;
var
	junitname: PJassString;
begin
	junitname:= CreateJassString(PChar(unitname));
	Result:= _CreateUnitAtLocByName(id, junitname, whichLocation, @face);
	DestroyJassString(junitname);
end;

type TCreateCorpseFunctionPrototype = function (whichPlayer: HPLAYER; unitid: Int32; x: PSingle; y: PSingle; face: PSingle): HUNIT; cdecl;
var _CreateCorpse: TCreateCorpseFunctionPrototype;

function CreateCorpse(whichPlayer: HPLAYER; unitid: Integer; x: Single; y: Single; face: Single): HUNIT;
begin
	Result:= _CreateCorpse(whichPlayer, unitid, @x, @y, @face);
end;

type TKillUnitFunctionPrototype = procedure (whichUnit: HUNIT); cdecl;
var _KillUnit: TKillUnitFunctionPrototype;

procedure KillUnit(whichUnit: HUNIT);
begin
	_KillUnit(whichUnit);
end;

type TRemoveUnitFunctionPrototype = procedure (whichUnit: HUNIT); cdecl;
var _RemoveUnit: TRemoveUnitFunctionPrototype;

procedure RemoveUnit(whichUnit: HUNIT);
begin
	_RemoveUnit(whichUnit);
end;

type TShowUnitFunctionPrototype = procedure (whichUnit: HUNIT; show: LongBool); cdecl;
var _ShowUnit: TShowUnitFunctionPrototype;

procedure ShowUnit(whichUnit: HUNIT; show: Boolean);
begin
	_ShowUnit(whichUnit, show);
end;

type TSetUnitStateFunctionPrototype = procedure (whichUnit: HUNIT; whichUnitState: HUNITSTATE; newVal: PSingle); cdecl;
var _SetUnitState: TSetUnitStateFunctionPrototype;

procedure SetUnitState(whichUnit: HUNIT; whichUnitState: HUNITSTATE; newVal: Single);
begin
	_SetUnitState(whichUnit, whichUnitState, @newVal);
end;

type TSetUnitXFunctionPrototype = procedure (whichUnit: HUNIT; newX: PSingle); cdecl;
var _SetUnitX: TSetUnitXFunctionPrototype;

procedure SetUnitX(whichUnit: HUNIT; newX: Single);
begin
	_SetUnitX(whichUnit, @newX);
end;

type TSetUnitYFunctionPrototype = procedure (whichUnit: HUNIT; newY: PSingle); cdecl;
var _SetUnitY: TSetUnitYFunctionPrototype;

procedure SetUnitY(whichUnit: HUNIT; newY: Single);
begin
	_SetUnitY(whichUnit, @newY);
end;

type TSetUnitPositionFunctionPrototype = procedure (whichUnit: HUNIT; newX: PSingle; newY: PSingle); cdecl;
var _SetUnitPosition: TSetUnitPositionFunctionPrototype;

procedure SetUnitPosition(whichUnit: HUNIT; newX: Single; newY: Single);
begin
	_SetUnitPosition(whichUnit, @newX, @newY);
end;

type TSetUnitPositionLocFunctionPrototype = procedure (whichUnit: HUNIT; whichLocation: HLOCATION); cdecl;
var _SetUnitPositionLoc: TSetUnitPositionLocFunctionPrototype;

procedure SetUnitPositionLoc(whichUnit: HUNIT; whichLocation: HLOCATION);
begin
	_SetUnitPositionLoc(whichUnit, whichLocation);
end;

type TSetUnitFacingFunctionPrototype = procedure (whichUnit: HUNIT; facingAngle: PSingle); cdecl;
var _SetUnitFacing: TSetUnitFacingFunctionPrototype;

procedure SetUnitFacing(whichUnit: HUNIT; facingAngle: Single);
begin
	_SetUnitFacing(whichUnit, @facingAngle);
end;

type TSetUnitFacingTimedFunctionPrototype = procedure (whichUnit: HUNIT; facingAngle: PSingle; duration: PSingle); cdecl;
var _SetUnitFacingTimed: TSetUnitFacingTimedFunctionPrototype;

procedure SetUnitFacingTimed(whichUnit: HUNIT; facingAngle: Single; duration: Single);
begin
	_SetUnitFacingTimed(whichUnit, @facingAngle, @duration);
end;

type TSetUnitMoveSpeedFunctionPrototype = procedure (whichUnit: HUNIT; newSpeed: PSingle); cdecl;
var _SetUnitMoveSpeed: TSetUnitMoveSpeedFunctionPrototype;

procedure SetUnitMoveSpeed(whichUnit: HUNIT; newSpeed: Single);
begin
	_SetUnitMoveSpeed(whichUnit, @newSpeed);
end;

type TSetUnitFlyHeightFunctionPrototype = procedure (whichUnit: HUNIT; newHeight: PSingle; rate: PSingle); cdecl;
var _SetUnitFlyHeight: TSetUnitFlyHeightFunctionPrototype;

procedure SetUnitFlyHeight(whichUnit: HUNIT; newHeight: Single; rate: Single);
begin
	_SetUnitFlyHeight(whichUnit, @newHeight, @rate);
end;

type TSetUnitTurnSpeedFunctionPrototype = procedure (whichUnit: HUNIT; newTurnSpeed: PSingle); cdecl;
var _SetUnitTurnSpeed: TSetUnitTurnSpeedFunctionPrototype;

procedure SetUnitTurnSpeed(whichUnit: HUNIT; newTurnSpeed: Single);
begin
	_SetUnitTurnSpeed(whichUnit, @newTurnSpeed);
end;

type TSetUnitPropWindowFunctionPrototype = procedure (whichUnit: HUNIT; newPropWindowAngle: PSingle); cdecl;
var _SetUnitPropWindow: TSetUnitPropWindowFunctionPrototype;

procedure SetUnitPropWindow(whichUnit: HUNIT; newPropWindowAngle: Single);
begin
	_SetUnitPropWindow(whichUnit, @newPropWindowAngle);
end;

type TSetUnitAcquireRangeFunctionPrototype = procedure (whichUnit: HUNIT; newAcquireRange: PSingle); cdecl;
var _SetUnitAcquireRange: TSetUnitAcquireRangeFunctionPrototype;

procedure SetUnitAcquireRange(whichUnit: HUNIT; newAcquireRange: Single);
begin
	_SetUnitAcquireRange(whichUnit, @newAcquireRange);
end;

type TSetUnitCreepGuardFunctionPrototype = procedure (whichUnit: HUNIT; creepGuard: LongBool); cdecl;
var _SetUnitCreepGuard: TSetUnitCreepGuardFunctionPrototype;

procedure SetUnitCreepGuard(whichUnit: HUNIT; creepGuard: Boolean);
begin
	_SetUnitCreepGuard(whichUnit, creepGuard);
end;

type TGetUnitAcquireRangeFunctionPrototype = function (whichUnit: HUNIT): TSingle; cdecl;
var _GetUnitAcquireRange: TGetUnitAcquireRangeFunctionPrototype;

function GetUnitAcquireRange(whichUnit: HUNIT): Single;
begin
	Result:= _GetUnitAcquireRange(whichUnit).Value;
end;

type TGetUnitTurnSpeedFunctionPrototype = function (whichUnit: HUNIT): TSingle; cdecl;
var _GetUnitTurnSpeed: TGetUnitTurnSpeedFunctionPrototype;

function GetUnitTurnSpeed(whichUnit: HUNIT): Single;
begin
	Result:= _GetUnitTurnSpeed(whichUnit).Value;
end;

type TGetUnitPropWindowFunctionPrototype = function (whichUnit: HUNIT): TSingle; cdecl;
var _GetUnitPropWindow: TGetUnitPropWindowFunctionPrototype;

function GetUnitPropWindow(whichUnit: HUNIT): Single;
begin
	Result:= _GetUnitPropWindow(whichUnit).Value;
end;

type TGetUnitFlyHeightFunctionPrototype = function (whichUnit: HUNIT): TSingle; cdecl;
var _GetUnitFlyHeight: TGetUnitFlyHeightFunctionPrototype;

function GetUnitFlyHeight(whichUnit: HUNIT): Single;
begin
	Result:= _GetUnitFlyHeight(whichUnit).Value;
end;

type TGetUnitDefaultAcquireRangeFunctionPrototype = function (whichUnit: HUNIT): TSingle; cdecl;
var _GetUnitDefaultAcquireRange: TGetUnitDefaultAcquireRangeFunctionPrototype;

function GetUnitDefaultAcquireRange(whichUnit: HUNIT): Single;
begin
	Result:= _GetUnitDefaultAcquireRange(whichUnit).Value;
end;

type TGetUnitDefaultTurnSpeedFunctionPrototype = function (whichUnit: HUNIT): TSingle; cdecl;
var _GetUnitDefaultTurnSpeed: TGetUnitDefaultTurnSpeedFunctionPrototype;

function GetUnitDefaultTurnSpeed(whichUnit: HUNIT): Single;
begin
	Result:= _GetUnitDefaultTurnSpeed(whichUnit).Value;
end;

type TGetUnitDefaultPropWindowFunctionPrototype = function (whichUnit: HUNIT): TSingle; cdecl;
var _GetUnitDefaultPropWindow: TGetUnitDefaultPropWindowFunctionPrototype;

function GetUnitDefaultPropWindow(whichUnit: HUNIT): Single;
begin
	Result:= _GetUnitDefaultPropWindow(whichUnit).Value;
end;

type TGetUnitDefaultFlyHeightFunctionPrototype = function (whichUnit: HUNIT): TSingle; cdecl;
var _GetUnitDefaultFlyHeight: TGetUnitDefaultFlyHeightFunctionPrototype;

function GetUnitDefaultFlyHeight(whichUnit: HUNIT): Single;
begin
	Result:= _GetUnitDefaultFlyHeight(whichUnit).Value;
end;

type TSetUnitOwnerFunctionPrototype = procedure (whichUnit: HUNIT; whichPlayer: HPLAYER; changeColor: LongBool); cdecl;
var _SetUnitOwner: TSetUnitOwnerFunctionPrototype;

procedure SetUnitOwner(whichUnit: HUNIT; whichPlayer: HPLAYER; changeColor: Boolean);
begin
	_SetUnitOwner(whichUnit, whichPlayer, changeColor);
end;

type TSetUnitColorFunctionPrototype = procedure (whichUnit: HUNIT; whichColor: HPLAYERCOLOR); cdecl;
var _SetUnitColor: TSetUnitColorFunctionPrototype;

procedure SetUnitColor(whichUnit: HUNIT; whichColor: HPLAYERCOLOR);
begin
	_SetUnitColor(whichUnit, whichColor);
end;

type TSetUnitScaleFunctionPrototype = procedure (whichUnit: HUNIT; scaleX: PSingle; scaleY: PSingle; scaleZ: PSingle); cdecl;
var _SetUnitScale: TSetUnitScaleFunctionPrototype;

procedure SetUnitScale(whichUnit: HUNIT; scaleX: Single; scaleY: Single; scaleZ: Single);
begin
	_SetUnitScale(whichUnit, @scaleX, @scaleY, @scaleZ);
end;

type TSetUnitTimeScaleFunctionPrototype = procedure (whichUnit: HUNIT; timeScale: PSingle); cdecl;
var _SetUnitTimeScale: TSetUnitTimeScaleFunctionPrototype;

procedure SetUnitTimeScale(whichUnit: HUNIT; timeScale: Single);
begin
	_SetUnitTimeScale(whichUnit, @timeScale);
end;

type TSetUnitBlendTimeFunctionPrototype = procedure (whichUnit: HUNIT; blendTime: PSingle); cdecl;
var _SetUnitBlendTime: TSetUnitBlendTimeFunctionPrototype;

procedure SetUnitBlendTime(whichUnit: HUNIT; blendTime: Single);
begin
	_SetUnitBlendTime(whichUnit, @blendTime);
end;

type TSetUnitVertexColorFunctionPrototype = procedure (whichUnit: HUNIT; red: Int32; green: Int32; blue: Int32; alpha: Int32); cdecl;
var _SetUnitVertexColor: TSetUnitVertexColorFunctionPrototype;

procedure SetUnitVertexColor(whichUnit: HUNIT; red: Integer; green: Integer; blue: Integer; alpha: Integer);
begin
	_SetUnitVertexColor(whichUnit, red, green, blue, alpha);
end;

type TQueueUnitAnimationFunctionPrototype = procedure (whichUnit: HUNIT; whichAnimation: PJassString); cdecl;
var _QueueUnitAnimation: TQueueUnitAnimationFunctionPrototype;

procedure QueueUnitAnimation(whichUnit: HUNIT; whichAnimation: String);
var
	jwhichAnimation: PJassString;
begin
	jwhichAnimation:= CreateJassString(PChar(whichAnimation));
	_QueueUnitAnimation(whichUnit, jwhichAnimation);
	DestroyJassString(jwhichAnimation);
end;

type TSetUnitAnimationFunctionPrototype = procedure (whichUnit: HUNIT; whichAnimation: PJassString); cdecl;
var _SetUnitAnimation: TSetUnitAnimationFunctionPrototype;

procedure SetUnitAnimation(whichUnit: HUNIT; whichAnimation: String);
var
	jwhichAnimation: PJassString;
begin
	jwhichAnimation:= CreateJassString(PChar(whichAnimation));
	_SetUnitAnimation(whichUnit, jwhichAnimation);
	DestroyJassString(jwhichAnimation);
end;

type TSetUnitAnimationByIndexFunctionPrototype = procedure (whichUnit: HUNIT; whichAnimation: Int32); cdecl;
var _SetUnitAnimationByIndex: TSetUnitAnimationByIndexFunctionPrototype;

procedure SetUnitAnimationByIndex(whichUnit: HUNIT; whichAnimation: Integer);
begin
	_SetUnitAnimationByIndex(whichUnit, whichAnimation);
end;

type TSetUnitAnimationWithRarityFunctionPrototype = procedure (whichUnit: HUNIT; whichAnimation: PJassString; rarity: HRARITYCONTROL); cdecl;
var _SetUnitAnimationWithRarity: TSetUnitAnimationWithRarityFunctionPrototype;

procedure SetUnitAnimationWithRarity(whichUnit: HUNIT; whichAnimation: String; rarity: HRARITYCONTROL);
var
	jwhichAnimation: PJassString;
begin
	jwhichAnimation:= CreateJassString(PChar(whichAnimation));
	_SetUnitAnimationWithRarity(whichUnit, jwhichAnimation, rarity);
	DestroyJassString(jwhichAnimation);
end;

type TAddUnitAnimationPropertiesFunctionPrototype = procedure (whichUnit: HUNIT; animProperties: PJassString; add: LongBool); cdecl;
var _AddUnitAnimationProperties: TAddUnitAnimationPropertiesFunctionPrototype;

procedure AddUnitAnimationProperties(whichUnit: HUNIT; animProperties: String; add: Boolean);
var
	janimProperties: PJassString;
begin
	janimProperties:= CreateJassString(PChar(animProperties));
	_AddUnitAnimationProperties(whichUnit, janimProperties, add);
	DestroyJassString(janimProperties);
end;

type TSetUnitLookAtFunctionPrototype = procedure (whichUnit: HUNIT; whichBone: PJassString; lookAtTarget: HUNIT; offsetX: PSingle; offsetY: PSingle; offsetZ: PSingle); cdecl;
var _SetUnitLookAt: TSetUnitLookAtFunctionPrototype;

procedure SetUnitLookAt(whichUnit: HUNIT; whichBone: String; lookAtTarget: HUNIT; offsetX: Single; offsetY: Single; offsetZ: Single);
var
	jwhichBone: PJassString;
begin
	jwhichBone:= CreateJassString(PChar(whichBone));
	_SetUnitLookAt(whichUnit, jwhichBone, lookAtTarget, @offsetX, @offsetY, @offsetZ);
	DestroyJassString(jwhichBone);
end;

type TResetUnitLookAtFunctionPrototype = procedure (whichUnit: HUNIT); cdecl;
var _ResetUnitLookAt: TResetUnitLookAtFunctionPrototype;

procedure ResetUnitLookAt(whichUnit: HUNIT);
begin
	_ResetUnitLookAt(whichUnit);
end;

type TSetUnitRescuableFunctionPrototype = procedure (whichUnit: HUNIT; byWhichPlayer: HPLAYER; flag: LongBool); cdecl;
var _SetUnitRescuable: TSetUnitRescuableFunctionPrototype;

procedure SetUnitRescuable(whichUnit: HUNIT; byWhichPlayer: HPLAYER; flag: Boolean);
begin
	_SetUnitRescuable(whichUnit, byWhichPlayer, flag);
end;

type TSetUnitRescueRangeFunctionPrototype = procedure (whichUnit: HUNIT; range: PSingle); cdecl;
var _SetUnitRescueRange: TSetUnitRescueRangeFunctionPrototype;

procedure SetUnitRescueRange(whichUnit: HUNIT; range: Single);
begin
	_SetUnitRescueRange(whichUnit, @range);
end;

type TSetHeroStrFunctionPrototype = procedure (whichHero: HUNIT; newStr: Int32; permanent: LongBool); cdecl;
var _SetHeroStr: TSetHeroStrFunctionPrototype;

procedure SetHeroStr(whichHero: HUNIT; newStr: Integer; permanent: Boolean);
begin
	_SetHeroStr(whichHero, newStr, permanent);
end;

type TSetHeroAgiFunctionPrototype = procedure (whichHero: HUNIT; newAgi: Int32; permanent: LongBool); cdecl;
var _SetHeroAgi: TSetHeroAgiFunctionPrototype;

procedure SetHeroAgi(whichHero: HUNIT; newAgi: Integer; permanent: Boolean);
begin
	_SetHeroAgi(whichHero, newAgi, permanent);
end;

type TSetHeroIntFunctionPrototype = procedure (whichHero: HUNIT; newInt: Int32; permanent: LongBool); cdecl;
var _SetHeroInt: TSetHeroIntFunctionPrototype;

procedure SetHeroInt(whichHero: HUNIT; newInt: Integer; permanent: Boolean);
begin
	_SetHeroInt(whichHero, newInt, permanent);
end;

type TGetHeroStrFunctionPrototype = function (whichHero: HUNIT; includeBonuses: LongBool): Int32; cdecl;
var _GetHeroStr: TGetHeroStrFunctionPrototype;

function GetHeroStr(whichHero: HUNIT; includeBonuses: Boolean): Integer;
begin
	Result:= _GetHeroStr(whichHero, includeBonuses);
end;

type TGetHeroAgiFunctionPrototype = function (whichHero: HUNIT; includeBonuses: LongBool): Int32; cdecl;
var _GetHeroAgi: TGetHeroAgiFunctionPrototype;

function GetHeroAgi(whichHero: HUNIT; includeBonuses: Boolean): Integer;
begin
	Result:= _GetHeroAgi(whichHero, includeBonuses);
end;

type TGetHeroIntFunctionPrototype = function (whichHero: HUNIT; includeBonuses: LongBool): Int32; cdecl;
var _GetHeroInt: TGetHeroIntFunctionPrototype;

function GetHeroInt(whichHero: HUNIT; includeBonuses: Boolean): Integer;
begin
	Result:= _GetHeroInt(whichHero, includeBonuses);
end;

type TUnitStripHeroLevelFunctionPrototype = function (whichHero: HUNIT; howManyLevels: Int32): LongBool; cdecl;
var _UnitStripHeroLevel: TUnitStripHeroLevelFunctionPrototype;

function UnitStripHeroLevel(whichHero: HUNIT; howManyLevels: Integer): Boolean;
begin
	Result:= _UnitStripHeroLevel(whichHero, howManyLevels);
end;

type TGetHeroXPFunctionPrototype = function (whichHero: HUNIT): Int32; cdecl;
var _GetHeroXP: TGetHeroXPFunctionPrototype;

function GetHeroXP(whichHero: HUNIT): Integer;
begin
	Result:= _GetHeroXP(whichHero);
end;

type TSetHeroXPFunctionPrototype = procedure (whichHero: HUNIT; newXpVal: Int32; showEyeCandy: LongBool); cdecl;
var _SetHeroXP: TSetHeroXPFunctionPrototype;

procedure SetHeroXP(whichHero: HUNIT; newXpVal: Integer; showEyeCandy: Boolean);
begin
	_SetHeroXP(whichHero, newXpVal, showEyeCandy);
end;

type TGetHeroSkillPointsFunctionPrototype = function (whichHero: HUNIT): Int32; cdecl;
var _GetHeroSkillPoints: TGetHeroSkillPointsFunctionPrototype;

function GetHeroSkillPoints(whichHero: HUNIT): Integer;
begin
	Result:= _GetHeroSkillPoints(whichHero);
end;

type TUnitModifySkillPointsFunctionPrototype = function (whichHero: HUNIT; skillPointDelta: Int32): LongBool; cdecl;
var _UnitModifySkillPoints: TUnitModifySkillPointsFunctionPrototype;

function UnitModifySkillPoints(whichHero: HUNIT; skillPointDelta: Integer): Boolean;
begin
	Result:= _UnitModifySkillPoints(whichHero, skillPointDelta);
end;

type TAddHeroXPFunctionPrototype = procedure (whichHero: HUNIT; xpToAdd: Int32; showEyeCandy: LongBool); cdecl;
var _AddHeroXP: TAddHeroXPFunctionPrototype;

procedure AddHeroXP(whichHero: HUNIT; xpToAdd: Integer; showEyeCandy: Boolean);
begin
	_AddHeroXP(whichHero, xpToAdd, showEyeCandy);
end;

type TSetHeroLevelFunctionPrototype = procedure (whichHero: HUNIT; level: Int32; showEyeCandy: LongBool); cdecl;
var _SetHeroLevel: TSetHeroLevelFunctionPrototype;

procedure SetHeroLevel(whichHero: HUNIT; level: Integer; showEyeCandy: Boolean);
begin
	_SetHeroLevel(whichHero, level, showEyeCandy);
end;

type TGetHeroLevelFunctionPrototype = function (whichHero: HUNIT): Int32; cdecl;
var _GetHeroLevel: TGetHeroLevelFunctionPrototype;

function GetHeroLevel(whichHero: HUNIT): Integer;
begin
	Result:= _GetHeroLevel(whichHero);
end;

type TGetUnitLevelFunctionPrototype = function (whichUnit: HUNIT): Int32; cdecl;
var _GetUnitLevel: TGetUnitLevelFunctionPrototype;

function GetUnitLevel(whichUnit: HUNIT): Integer;
begin
	Result:= _GetUnitLevel(whichUnit);
end;

type TGetHeroProperNameFunctionPrototype = function (whichHero: HUNIT): TJassStringHandle; cdecl;
var _GetHeroProperName: TGetHeroProperNameFunctionPrototype;

function GetHeroProperName(whichHero: HUNIT): String;
var
	hResult: TJassStringHandle;
begin
	hResult:= _GetHeroProperName(whichHero);
	Result:= GetStringFromHandle(hResult);
	DecrementStringReferences(hResult);
end;

type TSuspendHeroXPFunctionPrototype = procedure (whichHero: HUNIT; flag: LongBool); cdecl;
var _SuspendHeroXP: TSuspendHeroXPFunctionPrototype;

procedure SuspendHeroXP(whichHero: HUNIT; flag: Boolean);
begin
	_SuspendHeroXP(whichHero, flag);
end;

type TIsSuspendedXPFunctionPrototype = function (whichHero: HUNIT): LongBool; cdecl;
var _IsSuspendedXP: TIsSuspendedXPFunctionPrototype;

function IsSuspendedXP(whichHero: HUNIT): Boolean;
begin
	Result:= _IsSuspendedXP(whichHero);
end;

type TSelectHeroSkillFunctionPrototype = procedure (whichHero: HUNIT; abilcode: Int32); cdecl;
var _SelectHeroSkill: TSelectHeroSkillFunctionPrototype;

procedure SelectHeroSkill(whichHero: HUNIT; abilcode: Integer);
begin
	_SelectHeroSkill(whichHero, abilcode);
end;

type TGetUnitAbilityLevelFunctionPrototype = function (whichUnit: HUNIT; abilcode: Int32): Int32; cdecl;
var _GetUnitAbilityLevel: TGetUnitAbilityLevelFunctionPrototype;

function GetUnitAbilityLevel(whichUnit: HUNIT; abilcode: Integer): Integer;
begin
	Result:= _GetUnitAbilityLevel(whichUnit, abilcode);
end;

type TDecUnitAbilityLevelFunctionPrototype = function (whichUnit: HUNIT; abilcode: Int32): Int32; cdecl;
var _DecUnitAbilityLevel: TDecUnitAbilityLevelFunctionPrototype;

function DecUnitAbilityLevel(whichUnit: HUNIT; abilcode: Integer): Integer;
begin
	Result:= _DecUnitAbilityLevel(whichUnit, abilcode);
end;

type TIncUnitAbilityLevelFunctionPrototype = function (whichUnit: HUNIT; abilcode: Int32): Int32; cdecl;
var _IncUnitAbilityLevel: TIncUnitAbilityLevelFunctionPrototype;

function IncUnitAbilityLevel(whichUnit: HUNIT; abilcode: Integer): Integer;
begin
	Result:= _IncUnitAbilityLevel(whichUnit, abilcode);
end;

type TSetUnitAbilityLevelFunctionPrototype = function (whichUnit: HUNIT; abilcode: Int32; level: Int32): Int32; cdecl;
var _SetUnitAbilityLevel: TSetUnitAbilityLevelFunctionPrototype;

function SetUnitAbilityLevel(whichUnit: HUNIT; abilcode: Integer; level: Integer): Integer;
begin
	Result:= _SetUnitAbilityLevel(whichUnit, abilcode, level);
end;

type TReviveHeroFunctionPrototype = function (whichHero: HUNIT; x: PSingle; y: PSingle; doEyecandy: LongBool): LongBool; cdecl;
var _ReviveHero: TReviveHeroFunctionPrototype;

function ReviveHero(whichHero: HUNIT; x: Single; y: Single; doEyecandy: Boolean): Boolean;
begin
	Result:= _ReviveHero(whichHero, @x, @y, doEyecandy);
end;

type TReviveHeroLocFunctionPrototype = function (whichHero: HUNIT; loc: HLOCATION; doEyecandy: LongBool): LongBool; cdecl;
var _ReviveHeroLoc: TReviveHeroLocFunctionPrototype;

function ReviveHeroLoc(whichHero: HUNIT; loc: HLOCATION; doEyecandy: Boolean): Boolean;
begin
	Result:= _ReviveHeroLoc(whichHero, loc, doEyecandy);
end;

type TSetUnitExplodedFunctionPrototype = procedure (whichUnit: HUNIT; exploded: LongBool); cdecl;
var _SetUnitExploded: TSetUnitExplodedFunctionPrototype;

procedure SetUnitExploded(whichUnit: HUNIT; exploded: Boolean);
begin
	_SetUnitExploded(whichUnit, exploded);
end;

type TSetUnitInvulnerableFunctionPrototype = procedure (whichUnit: HUNIT; flag: LongBool); cdecl;
var _SetUnitInvulnerable: TSetUnitInvulnerableFunctionPrototype;

procedure SetUnitInvulnerable(whichUnit: HUNIT; flag: Boolean);
begin
	_SetUnitInvulnerable(whichUnit, flag);
end;

type TPauseUnitFunctionPrototype = procedure (whichUnit: HUNIT; flag: LongBool); cdecl;
var _PauseUnit: TPauseUnitFunctionPrototype;

procedure PauseUnit(whichUnit: HUNIT; flag: Boolean);
begin
	_PauseUnit(whichUnit, flag);
end;

type TIsUnitPausedFunctionPrototype = function (whichHero: HUNIT): LongBool; cdecl;
var _IsUnitPaused: TIsUnitPausedFunctionPrototype;

function IsUnitPaused(whichHero: HUNIT): Boolean;
begin
	Result:= _IsUnitPaused(whichHero);
end;

type TSetUnitPathingFunctionPrototype = procedure (whichUnit: HUNIT; flag: LongBool); cdecl;
var _SetUnitPathing: TSetUnitPathingFunctionPrototype;

procedure SetUnitPathing(whichUnit: HUNIT; flag: Boolean);
begin
	_SetUnitPathing(whichUnit, flag);
end;

type TClearSelectionFunctionPrototype = procedure; cdecl;
var _ClearSelection: TClearSelectionFunctionPrototype;

procedure ClearSelection;
begin
	_ClearSelection();
end;

type TSelectUnitFunctionPrototype = procedure (whichUnit: HUNIT; flag: LongBool); cdecl;
var _SelectUnit: TSelectUnitFunctionPrototype;

procedure SelectUnit(whichUnit: HUNIT; flag: Boolean);
begin
	_SelectUnit(whichUnit, flag);
end;

type TGetUnitPointValueFunctionPrototype = function (whichUnit: HUNIT): Int32; cdecl;
var _GetUnitPointValue: TGetUnitPointValueFunctionPrototype;

function GetUnitPointValue(whichUnit: HUNIT): Integer;
begin
	Result:= _GetUnitPointValue(whichUnit);
end;

type TGetUnitPointValueByTypeFunctionPrototype = function (unitType: Int32): Int32; cdecl;
var _GetUnitPointValueByType: TGetUnitPointValueByTypeFunctionPrototype;

function GetUnitPointValueByType(unitType: Integer): Integer;
begin
	Result:= _GetUnitPointValueByType(unitType);
end;

type TUnitAddItemFunctionPrototype = function (whichUnit: HUNIT; whichItem: HITEM): LongBool; cdecl;
var _UnitAddItem: TUnitAddItemFunctionPrototype;

function UnitAddItem(whichUnit: HUNIT; whichItem: HITEM): Boolean;
begin
	Result:= _UnitAddItem(whichUnit, whichItem);
end;

type TUnitAddItemByIdFunctionPrototype = function (whichUnit: HUNIT; itemId: Int32): HITEM; cdecl;
var _UnitAddItemById: TUnitAddItemByIdFunctionPrototype;

function UnitAddItemById(whichUnit: HUNIT; itemId: Integer): HITEM;
begin
	Result:= _UnitAddItemById(whichUnit, itemId);
end;

type TUnitAddItemToSlotByIdFunctionPrototype = function (whichUnit: HUNIT; itemId: Int32; itemSlot: Int32): LongBool; cdecl;
var _UnitAddItemToSlotById: TUnitAddItemToSlotByIdFunctionPrototype;

function UnitAddItemToSlotById(whichUnit: HUNIT; itemId: Integer; itemSlot: Integer): Boolean;
begin
	Result:= _UnitAddItemToSlotById(whichUnit, itemId, itemSlot);
end;

type TUnitRemoveItemFunctionPrototype = procedure (whichUnit: HUNIT; whichItem: HITEM); cdecl;
var _UnitRemoveItem: TUnitRemoveItemFunctionPrototype;

procedure UnitRemoveItem(whichUnit: HUNIT; whichItem: HITEM);
begin
	_UnitRemoveItem(whichUnit, whichItem);
end;

type TUnitRemoveItemFromSlotFunctionPrototype = function (whichUnit: HUNIT; itemSlot: Int32): HITEM; cdecl;
var _UnitRemoveItemFromSlot: TUnitRemoveItemFromSlotFunctionPrototype;

function UnitRemoveItemFromSlot(whichUnit: HUNIT; itemSlot: Integer): HITEM;
begin
	Result:= _UnitRemoveItemFromSlot(whichUnit, itemSlot);
end;

type TUnitHasItemFunctionPrototype = function (whichUnit: HUNIT; whichItem: HITEM): LongBool; cdecl;
var _UnitHasItem: TUnitHasItemFunctionPrototype;

function UnitHasItem(whichUnit: HUNIT; whichItem: HITEM): Boolean;
begin
	Result:= _UnitHasItem(whichUnit, whichItem);
end;

type TUnitItemInSlotFunctionPrototype = function (whichUnit: HUNIT; itemSlot: Int32): HITEM; cdecl;
var _UnitItemInSlot: TUnitItemInSlotFunctionPrototype;

function UnitItemInSlot(whichUnit: HUNIT; itemSlot: Integer): HITEM;
begin
	Result:= _UnitItemInSlot(whichUnit, itemSlot);
end;

type TUnitInventorySizeFunctionPrototype = function (whichUnit: HUNIT): Int32; cdecl;
var _UnitInventorySize: TUnitInventorySizeFunctionPrototype;

function UnitInventorySize(whichUnit: HUNIT): Integer;
begin
	Result:= _UnitInventorySize(whichUnit);
end;

type TUnitDropItemPointFunctionPrototype = function (whichUnit: HUNIT; whichItem: HITEM; x: PSingle; y: PSingle): LongBool; cdecl;
var _UnitDropItemPoint: TUnitDropItemPointFunctionPrototype;

function UnitDropItemPoint(whichUnit: HUNIT; whichItem: HITEM; x: Single; y: Single): Boolean;
begin
	Result:= _UnitDropItemPoint(whichUnit, whichItem, @x, @y);
end;

type TUnitDropItemSlotFunctionPrototype = function (whichUnit: HUNIT; whichItem: HITEM; slot: Int32): LongBool; cdecl;
var _UnitDropItemSlot: TUnitDropItemSlotFunctionPrototype;

function UnitDropItemSlot(whichUnit: HUNIT; whichItem: HITEM; slot: Integer): Boolean;
begin
	Result:= _UnitDropItemSlot(whichUnit, whichItem, slot);
end;

type TUnitDropItemTargetFunctionPrototype = function (whichUnit: HUNIT; whichItem: HITEM; target: HWIDGET): LongBool; cdecl;
var _UnitDropItemTarget: TUnitDropItemTargetFunctionPrototype;

function UnitDropItemTarget(whichUnit: HUNIT; whichItem: HITEM; target: HWIDGET): Boolean;
begin
	Result:= _UnitDropItemTarget(whichUnit, whichItem, target);
end;

type TUnitUseItemFunctionPrototype = function (whichUnit: HUNIT; whichItem: HITEM): LongBool; cdecl;
var _UnitUseItem: TUnitUseItemFunctionPrototype;

function UnitUseItem(whichUnit: HUNIT; whichItem: HITEM): Boolean;
begin
	Result:= _UnitUseItem(whichUnit, whichItem);
end;

type TUnitUseItemPointFunctionPrototype = function (whichUnit: HUNIT; whichItem: HITEM; x: PSingle; y: PSingle): LongBool; cdecl;
var _UnitUseItemPoint: TUnitUseItemPointFunctionPrototype;

function UnitUseItemPoint(whichUnit: HUNIT; whichItem: HITEM; x: Single; y: Single): Boolean;
begin
	Result:= _UnitUseItemPoint(whichUnit, whichItem, @x, @y);
end;

type TUnitUseItemTargetFunctionPrototype = function (whichUnit: HUNIT; whichItem: HITEM; target: HWIDGET): LongBool; cdecl;
var _UnitUseItemTarget: TUnitUseItemTargetFunctionPrototype;

function UnitUseItemTarget(whichUnit: HUNIT; whichItem: HITEM; target: HWIDGET): Boolean;
begin
	Result:= _UnitUseItemTarget(whichUnit, whichItem, target);
end;

type TGetUnitXFunctionPrototype = function (whichUnit: HUNIT): TSingle; cdecl;
var _GetUnitX: TGetUnitXFunctionPrototype;

function GetUnitX(whichUnit: HUNIT): Single;
begin
	Result:= _GetUnitX(whichUnit).Value;
end;

type TGetUnitYFunctionPrototype = function (whichUnit: HUNIT): TSingle; cdecl;
var _GetUnitY: TGetUnitYFunctionPrototype;

function GetUnitY(whichUnit: HUNIT): Single;
begin
	Result:= _GetUnitY(whichUnit).Value;
end;

type TGetUnitLocFunctionPrototype = function (whichUnit: HUNIT): HLOCATION; cdecl;
var _GetUnitLoc: TGetUnitLocFunctionPrototype;

function GetUnitLoc(whichUnit: HUNIT): HLOCATION;
begin
	Result:= _GetUnitLoc(whichUnit);
end;

type TGetUnitFacingFunctionPrototype = function (whichUnit: HUNIT): TSingle; cdecl;
var _GetUnitFacing: TGetUnitFacingFunctionPrototype;

function GetUnitFacing(whichUnit: HUNIT): Single;
begin
	Result:= _GetUnitFacing(whichUnit).Value;
end;

type TGetUnitMoveSpeedFunctionPrototype = function (whichUnit: HUNIT): TSingle; cdecl;
var _GetUnitMoveSpeed: TGetUnitMoveSpeedFunctionPrototype;

function GetUnitMoveSpeed(whichUnit: HUNIT): Single;
begin
	Result:= _GetUnitMoveSpeed(whichUnit).Value;
end;

type TGetUnitDefaultMoveSpeedFunctionPrototype = function (whichUnit: HUNIT): TSingle; cdecl;
var _GetUnitDefaultMoveSpeed: TGetUnitDefaultMoveSpeedFunctionPrototype;

function GetUnitDefaultMoveSpeed(whichUnit: HUNIT): Single;
begin
	Result:= _GetUnitDefaultMoveSpeed(whichUnit).Value;
end;

type TGetUnitStateFunctionPrototype = function (whichUnit: HUNIT; whichUnitState: HUNITSTATE): TSingle; cdecl;
var _GetUnitState: TGetUnitStateFunctionPrototype;

function GetUnitState(whichUnit: HUNIT; whichUnitState: HUNITSTATE): Single;
begin
	Result:= _GetUnitState(whichUnit, whichUnitState).Value;
end;

type TGetOwningPlayerFunctionPrototype = function (whichUnit: HUNIT): HPLAYER; cdecl;
var _GetOwningPlayer: TGetOwningPlayerFunctionPrototype;

function GetOwningPlayer(whichUnit: HUNIT): HPLAYER;
begin
	Result:= _GetOwningPlayer(whichUnit);
end;

type TGetUnitTypeIdFunctionPrototype = function (whichUnit: HUNIT): Int32; cdecl;
var _GetUnitTypeId: TGetUnitTypeIdFunctionPrototype;

function GetUnitTypeId(whichUnit: HUNIT): Integer;
begin
	Result:= _GetUnitTypeId(whichUnit);
end;

type TGetUnitRaceFunctionPrototype = function (whichUnit: HUNIT): HRACE; cdecl;
var _GetUnitRace: TGetUnitRaceFunctionPrototype;

function GetUnitRace(whichUnit: HUNIT): HRACE;
begin
	Result:= _GetUnitRace(whichUnit);
end;

type TGetUnitNameFunctionPrototype = function (whichUnit: HUNIT): TJassStringHandle; cdecl;
var _GetUnitName: TGetUnitNameFunctionPrototype;

function GetUnitName(whichUnit: HUNIT): String;
var
	hResult: TJassStringHandle;
begin
	hResult:= _GetUnitName(whichUnit);
	Result:= GetStringFromHandle(hResult);
	DecrementStringReferences(hResult);
end;

type TGetUnitFoodUsedFunctionPrototype = function (whichUnit: HUNIT): Int32; cdecl;
var _GetUnitFoodUsed: TGetUnitFoodUsedFunctionPrototype;

function GetUnitFoodUsed(whichUnit: HUNIT): Integer;
begin
	Result:= _GetUnitFoodUsed(whichUnit);
end;

type TGetUnitFoodMadeFunctionPrototype = function (whichUnit: HUNIT): Int32; cdecl;
var _GetUnitFoodMade: TGetUnitFoodMadeFunctionPrototype;

function GetUnitFoodMade(whichUnit: HUNIT): Integer;
begin
	Result:= _GetUnitFoodMade(whichUnit);
end;

type TGetFoodMadeFunctionPrototype = function (unitId: Int32): Int32; cdecl;
var _GetFoodMade: TGetFoodMadeFunctionPrototype;

function GetFoodMade(unitId: Integer): Integer;
begin
	Result:= _GetFoodMade(unitId);
end;

type TGetFoodUsedFunctionPrototype = function (unitId: Int32): Int32; cdecl;
var _GetFoodUsed: TGetFoodUsedFunctionPrototype;

function GetFoodUsed(unitId: Integer): Integer;
begin
	Result:= _GetFoodUsed(unitId);
end;

type TSetUnitUseFoodFunctionPrototype = procedure (whichUnit: HUNIT; useFood: LongBool); cdecl;
var _SetUnitUseFood: TSetUnitUseFoodFunctionPrototype;

procedure SetUnitUseFood(whichUnit: HUNIT; useFood: Boolean);
begin
	_SetUnitUseFood(whichUnit, useFood);
end;

type TGetUnitRallyPointFunctionPrototype = function (whichUnit: HUNIT): HLOCATION; cdecl;
var _GetUnitRallyPoint: TGetUnitRallyPointFunctionPrototype;

function GetUnitRallyPoint(whichUnit: HUNIT): HLOCATION;
begin
	Result:= _GetUnitRallyPoint(whichUnit);
end;

type TGetUnitRallyUnitFunctionPrototype = function (whichUnit: HUNIT): HUNIT; cdecl;
var _GetUnitRallyUnit: TGetUnitRallyUnitFunctionPrototype;

function GetUnitRallyUnit(whichUnit: HUNIT): HUNIT;
begin
	Result:= _GetUnitRallyUnit(whichUnit);
end;

type TGetUnitRallyDestructableFunctionPrototype = function (whichUnit: HUNIT): HDESTRUCTABLE; cdecl;
var _GetUnitRallyDestructable: TGetUnitRallyDestructableFunctionPrototype;

function GetUnitRallyDestructable(whichUnit: HUNIT): HDESTRUCTABLE;
begin
	Result:= _GetUnitRallyDestructable(whichUnit);
end;

type TIsUnitInGroupFunctionPrototype = function (whichUnit: HUNIT; whichGroup: HGROUP): LongBool; cdecl;
var _IsUnitInGroup: TIsUnitInGroupFunctionPrototype;

function IsUnitInGroup(whichUnit: HUNIT; whichGroup: HGROUP): Boolean;
begin
	Result:= _IsUnitInGroup(whichUnit, whichGroup);
end;

type TIsUnitInForceFunctionPrototype = function (whichUnit: HUNIT; whichForce: HFORCE): LongBool; cdecl;
var _IsUnitInForce: TIsUnitInForceFunctionPrototype;

function IsUnitInForce(whichUnit: HUNIT; whichForce: HFORCE): Boolean;
begin
	Result:= _IsUnitInForce(whichUnit, whichForce);
end;

type TIsUnitOwnedByPlayerFunctionPrototype = function (whichUnit: HUNIT; whichPlayer: HPLAYER): LongBool; cdecl;
var _IsUnitOwnedByPlayer: TIsUnitOwnedByPlayerFunctionPrototype;

function IsUnitOwnedByPlayer(whichUnit: HUNIT; whichPlayer: HPLAYER): Boolean;
begin
	Result:= _IsUnitOwnedByPlayer(whichUnit, whichPlayer);
end;

type TIsUnitAllyFunctionPrototype = function (whichUnit: HUNIT; whichPlayer: HPLAYER): LongBool; cdecl;
var _IsUnitAlly: TIsUnitAllyFunctionPrototype;

function IsUnitAlly(whichUnit: HUNIT; whichPlayer: HPLAYER): Boolean;
begin
	Result:= _IsUnitAlly(whichUnit, whichPlayer);
end;

type TIsUnitEnemyFunctionPrototype = function (whichUnit: HUNIT; whichPlayer: HPLAYER): LongBool; cdecl;
var _IsUnitEnemy: TIsUnitEnemyFunctionPrototype;

function IsUnitEnemy(whichUnit: HUNIT; whichPlayer: HPLAYER): Boolean;
begin
	Result:= _IsUnitEnemy(whichUnit, whichPlayer);
end;

type TIsUnitVisibleFunctionPrototype = function (whichUnit: HUNIT; whichPlayer: HPLAYER): LongBool; cdecl;
var _IsUnitVisible: TIsUnitVisibleFunctionPrototype;

function IsUnitVisible(whichUnit: HUNIT; whichPlayer: HPLAYER): Boolean;
begin
	Result:= _IsUnitVisible(whichUnit, whichPlayer);
end;

type TIsUnitDetectedFunctionPrototype = function (whichUnit: HUNIT; whichPlayer: HPLAYER): LongBool; cdecl;
var _IsUnitDetected: TIsUnitDetectedFunctionPrototype;

function IsUnitDetected(whichUnit: HUNIT; whichPlayer: HPLAYER): Boolean;
begin
	Result:= _IsUnitDetected(whichUnit, whichPlayer);
end;

type TIsUnitInvisibleFunctionPrototype = function (whichUnit: HUNIT; whichPlayer: HPLAYER): LongBool; cdecl;
var _IsUnitInvisible: TIsUnitInvisibleFunctionPrototype;

function IsUnitInvisible(whichUnit: HUNIT; whichPlayer: HPLAYER): Boolean;
begin
	Result:= _IsUnitInvisible(whichUnit, whichPlayer);
end;

type TIsUnitFoggedFunctionPrototype = function (whichUnit: HUNIT; whichPlayer: HPLAYER): LongBool; cdecl;
var _IsUnitFogged: TIsUnitFoggedFunctionPrototype;

function IsUnitFogged(whichUnit: HUNIT; whichPlayer: HPLAYER): Boolean;
begin
	Result:= _IsUnitFogged(whichUnit, whichPlayer);
end;

type TIsUnitMaskedFunctionPrototype = function (whichUnit: HUNIT; whichPlayer: HPLAYER): LongBool; cdecl;
var _IsUnitMasked: TIsUnitMaskedFunctionPrototype;

function IsUnitMasked(whichUnit: HUNIT; whichPlayer: HPLAYER): Boolean;
begin
	Result:= _IsUnitMasked(whichUnit, whichPlayer);
end;

type TIsUnitSelectedFunctionPrototype = function (whichUnit: HUNIT; whichPlayer: HPLAYER): LongBool; cdecl;
var _IsUnitSelected: TIsUnitSelectedFunctionPrototype;

function IsUnitSelected(whichUnit: HUNIT; whichPlayer: HPLAYER): Boolean;
begin
	Result:= _IsUnitSelected(whichUnit, whichPlayer);
end;

type TIsUnitRaceFunctionPrototype = function (whichUnit: HUNIT; whichRace: HRACE): LongBool; cdecl;
var _IsUnitRace: TIsUnitRaceFunctionPrototype;

function IsUnitRace(whichUnit: HUNIT; whichRace: HRACE): Boolean;
begin
	Result:= _IsUnitRace(whichUnit, whichRace);
end;

type TIsUnitTypeFunctionPrototype = function (whichUnit: HUNIT; whichUnitType: HUNITTYPE): LongBool; cdecl;
var _IsUnitType: TIsUnitTypeFunctionPrototype;

function IsUnitType(whichUnit: HUNIT; whichUnitType: HUNITTYPE): Boolean;
begin
	Result:= _IsUnitType(whichUnit, whichUnitType);
end;

type TIsUnitFunctionPrototype = function (whichUnit: HUNIT; whichSpecifiedUnit: HUNIT): LongBool; cdecl;
var _IsUnit: TIsUnitFunctionPrototype;

function IsUnit(whichUnit: HUNIT; whichSpecifiedUnit: HUNIT): Boolean;
begin
	Result:= _IsUnit(whichUnit, whichSpecifiedUnit);
end;

type TIsUnitInRangeFunctionPrototype = function (whichUnit: HUNIT; otherUnit: HUNIT; distance: PSingle): LongBool; cdecl;
var _IsUnitInRange: TIsUnitInRangeFunctionPrototype;

function IsUnitInRange(whichUnit: HUNIT; otherUnit: HUNIT; distance: Single): Boolean;
begin
	Result:= _IsUnitInRange(whichUnit, otherUnit, @distance);
end;

type TIsUnitInRangeXYFunctionPrototype = function (whichUnit: HUNIT; x: PSingle; y: PSingle; distance: PSingle): LongBool; cdecl;
var _IsUnitInRangeXY: TIsUnitInRangeXYFunctionPrototype;

function IsUnitInRangeXY(whichUnit: HUNIT; x: Single; y: Single; distance: Single): Boolean;
begin
	Result:= _IsUnitInRangeXY(whichUnit, @x, @y, @distance);
end;

type TIsUnitInRangeLocFunctionPrototype = function (whichUnit: HUNIT; whichLocation: HLOCATION; distance: PSingle): LongBool; cdecl;
var _IsUnitInRangeLoc: TIsUnitInRangeLocFunctionPrototype;

function IsUnitInRangeLoc(whichUnit: HUNIT; whichLocation: HLOCATION; distance: Single): Boolean;
begin
	Result:= _IsUnitInRangeLoc(whichUnit, whichLocation, @distance);
end;

type TIsUnitHiddenFunctionPrototype = function (whichUnit: HUNIT): LongBool; cdecl;
var _IsUnitHidden: TIsUnitHiddenFunctionPrototype;

function IsUnitHidden(whichUnit: HUNIT): Boolean;
begin
	Result:= _IsUnitHidden(whichUnit);
end;

type TIsUnitIllusionFunctionPrototype = function (whichUnit: HUNIT): LongBool; cdecl;
var _IsUnitIllusion: TIsUnitIllusionFunctionPrototype;

function IsUnitIllusion(whichUnit: HUNIT): Boolean;
begin
	Result:= _IsUnitIllusion(whichUnit);
end;

type TIsUnitInTransportFunctionPrototype = function (whichUnit: HUNIT; whichTransport: HUNIT): LongBool; cdecl;
var _IsUnitInTransport: TIsUnitInTransportFunctionPrototype;

function IsUnitInTransport(whichUnit: HUNIT; whichTransport: HUNIT): Boolean;
begin
	Result:= _IsUnitInTransport(whichUnit, whichTransport);
end;

type TIsUnitLoadedFunctionPrototype = function (whichUnit: HUNIT): LongBool; cdecl;
var _IsUnitLoaded: TIsUnitLoadedFunctionPrototype;

function IsUnitLoaded(whichUnit: HUNIT): Boolean;
begin
	Result:= _IsUnitLoaded(whichUnit);
end;

type TIsHeroUnitIdFunctionPrototype = function (unitId: Int32): LongBool; cdecl;
var _IsHeroUnitId: TIsHeroUnitIdFunctionPrototype;

function IsHeroUnitId(unitId: Integer): Boolean;
begin
	Result:= _IsHeroUnitId(unitId);
end;

type TIsUnitIdTypeFunctionPrototype = function (unitId: Int32; whichUnitType: HUNITTYPE): LongBool; cdecl;
var _IsUnitIdType: TIsUnitIdTypeFunctionPrototype;

function IsUnitIdType(unitId: Integer; whichUnitType: HUNITTYPE): Boolean;
begin
	Result:= _IsUnitIdType(unitId, whichUnitType);
end;

type TUnitShareVisionFunctionPrototype = procedure (whichUnit: HUNIT; whichPlayer: HPLAYER; share: LongBool); cdecl;
var _UnitShareVision: TUnitShareVisionFunctionPrototype;

procedure UnitShareVision(whichUnit: HUNIT; whichPlayer: HPLAYER; share: Boolean);
begin
	_UnitShareVision(whichUnit, whichPlayer, share);
end;

type TUnitSuspendDecayFunctionPrototype = procedure (whichUnit: HUNIT; suspend: LongBool); cdecl;
var _UnitSuspendDecay: TUnitSuspendDecayFunctionPrototype;

procedure UnitSuspendDecay(whichUnit: HUNIT; suspend: Boolean);
begin
	_UnitSuspendDecay(whichUnit, suspend);
end;

type TUnitAddTypeFunctionPrototype = function (whichUnit: HUNIT; whichUnitType: HUNITTYPE): LongBool; cdecl;
var _UnitAddType: TUnitAddTypeFunctionPrototype;

function UnitAddType(whichUnit: HUNIT; whichUnitType: HUNITTYPE): Boolean;
begin
	Result:= _UnitAddType(whichUnit, whichUnitType);
end;

type TUnitRemoveTypeFunctionPrototype = function (whichUnit: HUNIT; whichUnitType: HUNITTYPE): LongBool; cdecl;
var _UnitRemoveType: TUnitRemoveTypeFunctionPrototype;

function UnitRemoveType(whichUnit: HUNIT; whichUnitType: HUNITTYPE): Boolean;
begin
	Result:= _UnitRemoveType(whichUnit, whichUnitType);
end;

type TUnitAddAbilityFunctionPrototype = function (whichUnit: HUNIT; abilityId: Int32): LongBool; cdecl;
var _UnitAddAbility: TUnitAddAbilityFunctionPrototype;

function UnitAddAbility(whichUnit: HUNIT; abilityId: Integer): Boolean;
begin
	Result:= _UnitAddAbility(whichUnit, abilityId);
end;

type TUnitRemoveAbilityFunctionPrototype = function (whichUnit: HUNIT; abilityId: Int32): LongBool; cdecl;
var _UnitRemoveAbility: TUnitRemoveAbilityFunctionPrototype;

function UnitRemoveAbility(whichUnit: HUNIT; abilityId: Integer): Boolean;
begin
	Result:= _UnitRemoveAbility(whichUnit, abilityId);
end;

type TUnitMakeAbilityPermanentFunctionPrototype = function (whichUnit: HUNIT; permanent: LongBool; abilityId: Int32): LongBool; cdecl;
var _UnitMakeAbilityPermanent: TUnitMakeAbilityPermanentFunctionPrototype;

function UnitMakeAbilityPermanent(whichUnit: HUNIT; permanent: Boolean; abilityId: Integer): Boolean;
begin
	Result:= _UnitMakeAbilityPermanent(whichUnit, permanent, abilityId);
end;

type TUnitRemoveBuffsFunctionPrototype = procedure (whichUnit: HUNIT; removePositive: LongBool; removeNegative: LongBool); cdecl;
var _UnitRemoveBuffs: TUnitRemoveBuffsFunctionPrototype;

procedure UnitRemoveBuffs(whichUnit: HUNIT; removePositive: Boolean; removeNegative: Boolean);
begin
	_UnitRemoveBuffs(whichUnit, removePositive, removeNegative);
end;

type TUnitRemoveBuffsExFunctionPrototype = procedure (whichUnit: HUNIT; removePositive: LongBool; removeNegative: LongBool; magic: LongBool; physical: LongBool; timedLife: LongBool; aura: LongBool; autoDispel: LongBool); cdecl;
var _UnitRemoveBuffsEx: TUnitRemoveBuffsExFunctionPrototype;

procedure UnitRemoveBuffsEx(whichUnit: HUNIT; removePositive: Boolean; removeNegative: Boolean; magic: Boolean; physical: Boolean; timedLife: Boolean; aura: Boolean; autoDispel: Boolean);
begin
	_UnitRemoveBuffsEx(whichUnit, removePositive, removeNegative, magic, physical, timedLife, aura, autoDispel);
end;

type TUnitHasBuffsExFunctionPrototype = function (whichUnit: HUNIT; removePositive: LongBool; removeNegative: LongBool; magic: LongBool; physical: LongBool; timedLife: LongBool; aura: LongBool; autoDispel: LongBool): LongBool; cdecl;
var _UnitHasBuffsEx: TUnitHasBuffsExFunctionPrototype;

function UnitHasBuffsEx(whichUnit: HUNIT; removePositive: Boolean; removeNegative: Boolean; magic: Boolean; physical: Boolean; timedLife: Boolean; aura: Boolean; autoDispel: Boolean): Boolean;
begin
	Result:= _UnitHasBuffsEx(whichUnit, removePositive, removeNegative, magic, physical, timedLife, aura, autoDispel);
end;

type TUnitCountBuffsExFunctionPrototype = function (whichUnit: HUNIT; removePositive: LongBool; removeNegative: LongBool; magic: LongBool; physical: LongBool; timedLife: LongBool; aura: LongBool; autoDispel: LongBool): Int32; cdecl;
var _UnitCountBuffsEx: TUnitCountBuffsExFunctionPrototype;

function UnitCountBuffsEx(whichUnit: HUNIT; removePositive: Boolean; removeNegative: Boolean; magic: Boolean; physical: Boolean; timedLife: Boolean; aura: Boolean; autoDispel: Boolean): Integer;
begin
	Result:= _UnitCountBuffsEx(whichUnit, removePositive, removeNegative, magic, physical, timedLife, aura, autoDispel);
end;

type TUnitAddSleepFunctionPrototype = procedure (whichUnit: HUNIT; add: LongBool); cdecl;
var _UnitAddSleep: TUnitAddSleepFunctionPrototype;

procedure UnitAddSleep(whichUnit: HUNIT; add: Boolean);
begin
	_UnitAddSleep(whichUnit, add);
end;

type TUnitCanSleepFunctionPrototype = function (whichUnit: HUNIT): LongBool; cdecl;
var _UnitCanSleep: TUnitCanSleepFunctionPrototype;

function UnitCanSleep(whichUnit: HUNIT): Boolean;
begin
	Result:= _UnitCanSleep(whichUnit);
end;

type TUnitAddSleepPermFunctionPrototype = procedure (whichUnit: HUNIT; add: LongBool); cdecl;
var _UnitAddSleepPerm: TUnitAddSleepPermFunctionPrototype;

procedure UnitAddSleepPerm(whichUnit: HUNIT; add: Boolean);
begin
	_UnitAddSleepPerm(whichUnit, add);
end;

type TUnitCanSleepPermFunctionPrototype = function (whichUnit: HUNIT): LongBool; cdecl;
var _UnitCanSleepPerm: TUnitCanSleepPermFunctionPrototype;

function UnitCanSleepPerm(whichUnit: HUNIT): Boolean;
begin
	Result:= _UnitCanSleepPerm(whichUnit);
end;

type TUnitIsSleepingFunctionPrototype = function (whichUnit: HUNIT): LongBool; cdecl;
var _UnitIsSleeping: TUnitIsSleepingFunctionPrototype;

function UnitIsSleeping(whichUnit: HUNIT): Boolean;
begin
	Result:= _UnitIsSleeping(whichUnit);
end;

type TUnitWakeUpFunctionPrototype = procedure (whichUnit: HUNIT); cdecl;
var _UnitWakeUp: TUnitWakeUpFunctionPrototype;

procedure UnitWakeUp(whichUnit: HUNIT);
begin
	_UnitWakeUp(whichUnit);
end;

type TUnitApplyTimedLifeFunctionPrototype = procedure (whichUnit: HUNIT; buffId: Int32; duration: PSingle); cdecl;
var _UnitApplyTimedLife: TUnitApplyTimedLifeFunctionPrototype;

procedure UnitApplyTimedLife(whichUnit: HUNIT; buffId: Integer; duration: Single);
begin
	_UnitApplyTimedLife(whichUnit, buffId, @duration);
end;

type TUnitIgnoreAlarmFunctionPrototype = function (whichUnit: HUNIT; flag: LongBool): LongBool; cdecl;
var _UnitIgnoreAlarm: TUnitIgnoreAlarmFunctionPrototype;

function UnitIgnoreAlarm(whichUnit: HUNIT; flag: Boolean): Boolean;
begin
	Result:= _UnitIgnoreAlarm(whichUnit, flag);
end;

type TUnitIgnoreAlarmToggledFunctionPrototype = function (whichUnit: HUNIT): LongBool; cdecl;
var _UnitIgnoreAlarmToggled: TUnitIgnoreAlarmToggledFunctionPrototype;

function UnitIgnoreAlarmToggled(whichUnit: HUNIT): Boolean;
begin
	Result:= _UnitIgnoreAlarmToggled(whichUnit);
end;

type TUnitResetCooldownFunctionPrototype = procedure (whichUnit: HUNIT); cdecl;
var _UnitResetCooldown: TUnitResetCooldownFunctionPrototype;

procedure UnitResetCooldown(whichUnit: HUNIT);
begin
	_UnitResetCooldown(whichUnit);
end;

type TUnitSetConstructionProgressFunctionPrototype = procedure (whichUnit: HUNIT; constructionPercentage: Int32); cdecl;
var _UnitSetConstructionProgress: TUnitSetConstructionProgressFunctionPrototype;

procedure UnitSetConstructionProgress(whichUnit: HUNIT; constructionPercentage: Integer);
begin
	_UnitSetConstructionProgress(whichUnit, constructionPercentage);
end;

type TUnitSetUpgradeProgressFunctionPrototype = procedure (whichUnit: HUNIT; upgradePercentage: Int32); cdecl;
var _UnitSetUpgradeProgress: TUnitSetUpgradeProgressFunctionPrototype;

procedure UnitSetUpgradeProgress(whichUnit: HUNIT; upgradePercentage: Integer);
begin
	_UnitSetUpgradeProgress(whichUnit, upgradePercentage);
end;

type TUnitPauseTimedLifeFunctionPrototype = procedure (whichUnit: HUNIT; flag: LongBool); cdecl;
var _UnitPauseTimedLife: TUnitPauseTimedLifeFunctionPrototype;

procedure UnitPauseTimedLife(whichUnit: HUNIT; flag: Boolean);
begin
	_UnitPauseTimedLife(whichUnit, flag);
end;

type TUnitSetUsesAltIconFunctionPrototype = procedure (whichUnit: HUNIT; flag: LongBool); cdecl;
var _UnitSetUsesAltIcon: TUnitSetUsesAltIconFunctionPrototype;

procedure UnitSetUsesAltIcon(whichUnit: HUNIT; flag: Boolean);
begin
	_UnitSetUsesAltIcon(whichUnit, flag);
end;

type TUnitDamagePointFunctionPrototype = function (whichUnit: HUNIT; delay: PSingle; radius: PSingle; x: PSingle; y: PSingle; amount: PSingle; attack: LongBool; ranged: LongBool; attackType: HATTACKTYPE; damageType: HDAMAGETYPE; weaponType: HWEAPONTYPE): LongBool; cdecl;
var _UnitDamagePoint: TUnitDamagePointFunctionPrototype;

function UnitDamagePoint(whichUnit: HUNIT; delay: Single; radius: Single; x: Single; y: Single; amount: Single; attack: Boolean; ranged: Boolean; attackType: HATTACKTYPE; damageType: HDAMAGETYPE; weaponType: HWEAPONTYPE): Boolean;
begin
	Result:= _UnitDamagePoint(whichUnit, @delay, @radius, @x, @y, @amount, attack, ranged, attackType, damageType, weaponType);
end;

type TUnitDamageTargetFunctionPrototype = function (whichUnit: HUNIT; target: HWIDGET; amount: PSingle; attack: LongBool; ranged: LongBool; attackType: HATTACKTYPE; damageType: HDAMAGETYPE; weaponType: HWEAPONTYPE): LongBool; cdecl;
var _UnitDamageTarget: TUnitDamageTargetFunctionPrototype;

function UnitDamageTarget(whichUnit: HUNIT; target: HWIDGET; amount: Single; attack: Boolean; ranged: Boolean; attackType: HATTACKTYPE; damageType: HDAMAGETYPE; weaponType: HWEAPONTYPE): Boolean;
begin
	Result:= _UnitDamageTarget(whichUnit, target, @amount, attack, ranged, attackType, damageType, weaponType);
end;

type TIssueImmediateOrderFunctionPrototype = function (whichUnit: HUNIT; order: PJassString): LongBool; cdecl;
var _IssueImmediateOrder: TIssueImmediateOrderFunctionPrototype;

function IssueImmediateOrder(whichUnit: HUNIT; order: String): Boolean;
var
	jorder: PJassString;
begin
	jorder:= CreateJassString(PChar(order));
	Result:= _IssueImmediateOrder(whichUnit, jorder);
	DestroyJassString(jorder);
end;

type TIssueImmediateOrderByIdFunctionPrototype = function (whichUnit: HUNIT; order: Int32): LongBool; cdecl;
var _IssueImmediateOrderById: TIssueImmediateOrderByIdFunctionPrototype;

function IssueImmediateOrderById(whichUnit: HUNIT; order: Integer): Boolean;
begin
	Result:= _IssueImmediateOrderById(whichUnit, order);
end;

type TIssuePointOrderFunctionPrototype = function (whichUnit: HUNIT; order: PJassString; x: PSingle; y: PSingle): LongBool; cdecl;
var _IssuePointOrder: TIssuePointOrderFunctionPrototype;

function IssuePointOrder(whichUnit: HUNIT; order: String; x: Single; y: Single): Boolean;
var
	jorder: PJassString;
begin
	jorder:= CreateJassString(PChar(order));
	Result:= _IssuePointOrder(whichUnit, jorder, @x, @y);
	DestroyJassString(jorder);
end;

type TIssuePointOrderLocFunctionPrototype = function (whichUnit: HUNIT; order: PJassString; whichLocation: HLOCATION): LongBool; cdecl;
var _IssuePointOrderLoc: TIssuePointOrderLocFunctionPrototype;

function IssuePointOrderLoc(whichUnit: HUNIT; order: String; whichLocation: HLOCATION): Boolean;
var
	jorder: PJassString;
begin
	jorder:= CreateJassString(PChar(order));
	Result:= _IssuePointOrderLoc(whichUnit, jorder, whichLocation);
	DestroyJassString(jorder);
end;

type TIssuePointOrderByIdFunctionPrototype = function (whichUnit: HUNIT; order: Int32; x: PSingle; y: PSingle): LongBool; cdecl;
var _IssuePointOrderById: TIssuePointOrderByIdFunctionPrototype;

function IssuePointOrderById(whichUnit: HUNIT; order: Integer; x: Single; y: Single): Boolean;
begin
	Result:= _IssuePointOrderById(whichUnit, order, @x, @y);
end;

type TIssuePointOrderByIdLocFunctionPrototype = function (whichUnit: HUNIT; order: Int32; whichLocation: HLOCATION): LongBool; cdecl;
var _IssuePointOrderByIdLoc: TIssuePointOrderByIdLocFunctionPrototype;

function IssuePointOrderByIdLoc(whichUnit: HUNIT; order: Integer; whichLocation: HLOCATION): Boolean;
begin
	Result:= _IssuePointOrderByIdLoc(whichUnit, order, whichLocation);
end;

type TIssueTargetOrderFunctionPrototype = function (whichUnit: HUNIT; order: PJassString; targetWidget: HWIDGET): LongBool; cdecl;
var _IssueTargetOrder: TIssueTargetOrderFunctionPrototype;

function IssueTargetOrder(whichUnit: HUNIT; order: String; targetWidget: HWIDGET): Boolean;
var
	jorder: PJassString;
begin
	jorder:= CreateJassString(PChar(order));
	Result:= _IssueTargetOrder(whichUnit, jorder, targetWidget);
	DestroyJassString(jorder);
end;

type TIssueTargetOrderByIdFunctionPrototype = function (whichUnit: HUNIT; order: Int32; targetWidget: HWIDGET): LongBool; cdecl;
var _IssueTargetOrderById: TIssueTargetOrderByIdFunctionPrototype;

function IssueTargetOrderById(whichUnit: HUNIT; order: Integer; targetWidget: HWIDGET): Boolean;
begin
	Result:= _IssueTargetOrderById(whichUnit, order, targetWidget);
end;

type TIssueInstantPointOrderFunctionPrototype = function (whichUnit: HUNIT; order: PJassString; x: PSingle; y: PSingle; instantTargetWidget: HWIDGET): LongBool; cdecl;
var _IssueInstantPointOrder: TIssueInstantPointOrderFunctionPrototype;

function IssueInstantPointOrder(whichUnit: HUNIT; order: String; x: Single; y: Single; instantTargetWidget: HWIDGET): Boolean;
var
	jorder: PJassString;
begin
	jorder:= CreateJassString(PChar(order));
	Result:= _IssueInstantPointOrder(whichUnit, jorder, @x, @y, instantTargetWidget);
	DestroyJassString(jorder);
end;

type TIssueInstantPointOrderByIdFunctionPrototype = function (whichUnit: HUNIT; order: Int32; x: PSingle; y: PSingle; instantTargetWidget: HWIDGET): LongBool; cdecl;
var _IssueInstantPointOrderById: TIssueInstantPointOrderByIdFunctionPrototype;

function IssueInstantPointOrderById(whichUnit: HUNIT; order: Integer; x: Single; y: Single; instantTargetWidget: HWIDGET): Boolean;
begin
	Result:= _IssueInstantPointOrderById(whichUnit, order, @x, @y, instantTargetWidget);
end;

type TIssueInstantTargetOrderFunctionPrototype = function (whichUnit: HUNIT; order: PJassString; targetWidget: HWIDGET; instantTargetWidget: HWIDGET): LongBool; cdecl;
var _IssueInstantTargetOrder: TIssueInstantTargetOrderFunctionPrototype;

function IssueInstantTargetOrder(whichUnit: HUNIT; order: String; targetWidget: HWIDGET; instantTargetWidget: HWIDGET): Boolean;
var
	jorder: PJassString;
begin
	jorder:= CreateJassString(PChar(order));
	Result:= _IssueInstantTargetOrder(whichUnit, jorder, targetWidget, instantTargetWidget);
	DestroyJassString(jorder);
end;

type TIssueInstantTargetOrderByIdFunctionPrototype = function (whichUnit: HUNIT; order: Int32; targetWidget: HWIDGET; instantTargetWidget: HWIDGET): LongBool; cdecl;
var _IssueInstantTargetOrderById: TIssueInstantTargetOrderByIdFunctionPrototype;

function IssueInstantTargetOrderById(whichUnit: HUNIT; order: Integer; targetWidget: HWIDGET; instantTargetWidget: HWIDGET): Boolean;
begin
	Result:= _IssueInstantTargetOrderById(whichUnit, order, targetWidget, instantTargetWidget);
end;

type TIssueBuildOrderFunctionPrototype = function (whichPeon: HUNIT; unitToBuild: PJassString; x: PSingle; y: PSingle): LongBool; cdecl;
var _IssueBuildOrder: TIssueBuildOrderFunctionPrototype;

function IssueBuildOrder(whichPeon: HUNIT; unitToBuild: String; x: Single; y: Single): Boolean;
var
	junitToBuild: PJassString;
begin
	junitToBuild:= CreateJassString(PChar(unitToBuild));
	Result:= _IssueBuildOrder(whichPeon, junitToBuild, @x, @y);
	DestroyJassString(junitToBuild);
end;

type TIssueBuildOrderByIdFunctionPrototype = function (whichPeon: HUNIT; unitId: Int32; x: PSingle; y: PSingle): LongBool; cdecl;
var _IssueBuildOrderById: TIssueBuildOrderByIdFunctionPrototype;

function IssueBuildOrderById(whichPeon: HUNIT; unitId: Integer; x: Single; y: Single): Boolean;
begin
	Result:= _IssueBuildOrderById(whichPeon, unitId, @x, @y);
end;

type TIssueNeutralImmediateOrderFunctionPrototype = function (forWhichPlayer: HPLAYER; neutralStructure: HUNIT; unitToBuild: PJassString): LongBool; cdecl;
var _IssueNeutralImmediateOrder: TIssueNeutralImmediateOrderFunctionPrototype;

function IssueNeutralImmediateOrder(forWhichPlayer: HPLAYER; neutralStructure: HUNIT; unitToBuild: String): Boolean;
var
	junitToBuild: PJassString;
begin
	junitToBuild:= CreateJassString(PChar(unitToBuild));
	Result:= _IssueNeutralImmediateOrder(forWhichPlayer, neutralStructure, junitToBuild);
	DestroyJassString(junitToBuild);
end;

type TIssueNeutralImmediateOrderByIdFunctionPrototype = function (forWhichPlayer: HPLAYER; neutralStructure: HUNIT; unitId: Int32): LongBool; cdecl;
var _IssueNeutralImmediateOrderById: TIssueNeutralImmediateOrderByIdFunctionPrototype;

function IssueNeutralImmediateOrderById(forWhichPlayer: HPLAYER; neutralStructure: HUNIT; unitId: Integer): Boolean;
begin
	Result:= _IssueNeutralImmediateOrderById(forWhichPlayer, neutralStructure, unitId);
end;

type TIssueNeutralPointOrderFunctionPrototype = function (forWhichPlayer: HPLAYER; neutralStructure: HUNIT; unitToBuild: PJassString; x: PSingle; y: PSingle): LongBool; cdecl;
var _IssueNeutralPointOrder: TIssueNeutralPointOrderFunctionPrototype;

function IssueNeutralPointOrder(forWhichPlayer: HPLAYER; neutralStructure: HUNIT; unitToBuild: String; x: Single; y: Single): Boolean;
var
	junitToBuild: PJassString;
begin
	junitToBuild:= CreateJassString(PChar(unitToBuild));
	Result:= _IssueNeutralPointOrder(forWhichPlayer, neutralStructure, junitToBuild, @x, @y);
	DestroyJassString(junitToBuild);
end;

type TIssueNeutralPointOrderByIdFunctionPrototype = function (forWhichPlayer: HPLAYER; neutralStructure: HUNIT; unitId: Int32; x: PSingle; y: PSingle): LongBool; cdecl;
var _IssueNeutralPointOrderById: TIssueNeutralPointOrderByIdFunctionPrototype;

function IssueNeutralPointOrderById(forWhichPlayer: HPLAYER; neutralStructure: HUNIT; unitId: Integer; x: Single; y: Single): Boolean;
begin
	Result:= _IssueNeutralPointOrderById(forWhichPlayer, neutralStructure, unitId, @x, @y);
end;

type TIssueNeutralTargetOrderFunctionPrototype = function (forWhichPlayer: HPLAYER; neutralStructure: HUNIT; unitToBuild: PJassString; target: HWIDGET): LongBool; cdecl;
var _IssueNeutralTargetOrder: TIssueNeutralTargetOrderFunctionPrototype;

function IssueNeutralTargetOrder(forWhichPlayer: HPLAYER; neutralStructure: HUNIT; unitToBuild: String; target: HWIDGET): Boolean;
var
	junitToBuild: PJassString;
begin
	junitToBuild:= CreateJassString(PChar(unitToBuild));
	Result:= _IssueNeutralTargetOrder(forWhichPlayer, neutralStructure, junitToBuild, target);
	DestroyJassString(junitToBuild);
end;

type TIssueNeutralTargetOrderByIdFunctionPrototype = function (forWhichPlayer: HPLAYER; neutralStructure: HUNIT; unitId: Int32; target: HWIDGET): LongBool; cdecl;
var _IssueNeutralTargetOrderById: TIssueNeutralTargetOrderByIdFunctionPrototype;

function IssueNeutralTargetOrderById(forWhichPlayer: HPLAYER; neutralStructure: HUNIT; unitId: Integer; target: HWIDGET): Boolean;
begin
	Result:= _IssueNeutralTargetOrderById(forWhichPlayer, neutralStructure, unitId, target);
end;

type TGetUnitCurrentOrderFunctionPrototype = function (whichUnit: HUNIT): Int32; cdecl;
var _GetUnitCurrentOrder: TGetUnitCurrentOrderFunctionPrototype;

function GetUnitCurrentOrder(whichUnit: HUNIT): Integer;
begin
	Result:= _GetUnitCurrentOrder(whichUnit);
end;

type TSetResourceAmountFunctionPrototype = procedure (whichUnit: HUNIT; amount: Int32); cdecl;
var _SetResourceAmount: TSetResourceAmountFunctionPrototype;

procedure SetResourceAmount(whichUnit: HUNIT; amount: Integer);
begin
	_SetResourceAmount(whichUnit, amount);
end;

type TAddResourceAmountFunctionPrototype = procedure (whichUnit: HUNIT; amount: Int32); cdecl;
var _AddResourceAmount: TAddResourceAmountFunctionPrototype;

procedure AddResourceAmount(whichUnit: HUNIT; amount: Integer);
begin
	_AddResourceAmount(whichUnit, amount);
end;

type TGetResourceAmountFunctionPrototype = function (whichUnit: HUNIT): Int32; cdecl;
var _GetResourceAmount: TGetResourceAmountFunctionPrototype;

function GetResourceAmount(whichUnit: HUNIT): Integer;
begin
	Result:= _GetResourceAmount(whichUnit);
end;

type TWaygateGetDestinationXFunctionPrototype = function (waygate: HUNIT): TSingle; cdecl;
var _WaygateGetDestinationX: TWaygateGetDestinationXFunctionPrototype;

function WaygateGetDestinationX(waygate: HUNIT): Single;
begin
	Result:= _WaygateGetDestinationX(waygate).Value;
end;

type TWaygateGetDestinationYFunctionPrototype = function (waygate: HUNIT): TSingle; cdecl;
var _WaygateGetDestinationY: TWaygateGetDestinationYFunctionPrototype;

function WaygateGetDestinationY(waygate: HUNIT): Single;
begin
	Result:= _WaygateGetDestinationY(waygate).Value;
end;

type TWaygateSetDestinationFunctionPrototype = procedure (waygate: HUNIT; x: PSingle; y: PSingle); cdecl;
var _WaygateSetDestination: TWaygateSetDestinationFunctionPrototype;

procedure WaygateSetDestination(waygate: HUNIT; x: Single; y: Single);
begin
	_WaygateSetDestination(waygate, @x, @y);
end;

type TWaygateActivateFunctionPrototype = procedure (waygate: HUNIT; activate: LongBool); cdecl;
var _WaygateActivate: TWaygateActivateFunctionPrototype;

procedure WaygateActivate(waygate: HUNIT; activate: Boolean);
begin
	_WaygateActivate(waygate, activate);
end;

type TWaygateIsActiveFunctionPrototype = function (waygate: HUNIT): LongBool; cdecl;
var _WaygateIsActive: TWaygateIsActiveFunctionPrototype;

function WaygateIsActive(waygate: HUNIT): Boolean;
begin
	Result:= _WaygateIsActive(waygate);
end;

type TAddItemToAllStockFunctionPrototype = procedure (itemId: Int32; currentStock: Int32; stockMax: Int32); cdecl;
var _AddItemToAllStock: TAddItemToAllStockFunctionPrototype;

procedure AddItemToAllStock(itemId: Integer; currentStock: Integer; stockMax: Integer);
begin
	_AddItemToAllStock(itemId, currentStock, stockMax);
end;

type TAddItemToStockFunctionPrototype = procedure (whichUnit: HUNIT; itemId: Int32; currentStock: Int32; stockMax: Int32); cdecl;
var _AddItemToStock: TAddItemToStockFunctionPrototype;

procedure AddItemToStock(whichUnit: HUNIT; itemId: Integer; currentStock: Integer; stockMax: Integer);
begin
	_AddItemToStock(whichUnit, itemId, currentStock, stockMax);
end;

type TAddUnitToAllStockFunctionPrototype = procedure (unitId: Int32; currentStock: Int32; stockMax: Int32); cdecl;
var _AddUnitToAllStock: TAddUnitToAllStockFunctionPrototype;

procedure AddUnitToAllStock(unitId: Integer; currentStock: Integer; stockMax: Integer);
begin
	_AddUnitToAllStock(unitId, currentStock, stockMax);
end;

type TAddUnitToStockFunctionPrototype = procedure (whichUnit: HUNIT; unitId: Int32; currentStock: Int32; stockMax: Int32); cdecl;
var _AddUnitToStock: TAddUnitToStockFunctionPrototype;

procedure AddUnitToStock(whichUnit: HUNIT; unitId: Integer; currentStock: Integer; stockMax: Integer);
begin
	_AddUnitToStock(whichUnit, unitId, currentStock, stockMax);
end;

type TRemoveItemFromAllStockFunctionPrototype = procedure (itemId: Int32); cdecl;
var _RemoveItemFromAllStock: TRemoveItemFromAllStockFunctionPrototype;

procedure RemoveItemFromAllStock(itemId: Integer);
begin
	_RemoveItemFromAllStock(itemId);
end;

type TRemoveItemFromStockFunctionPrototype = procedure (whichUnit: HUNIT; itemId: Int32); cdecl;
var _RemoveItemFromStock: TRemoveItemFromStockFunctionPrototype;

procedure RemoveItemFromStock(whichUnit: HUNIT; itemId: Integer);
begin
	_RemoveItemFromStock(whichUnit, itemId);
end;

type TRemoveUnitFromAllStockFunctionPrototype = procedure (unitId: Int32); cdecl;
var _RemoveUnitFromAllStock: TRemoveUnitFromAllStockFunctionPrototype;

procedure RemoveUnitFromAllStock(unitId: Integer);
begin
	_RemoveUnitFromAllStock(unitId);
end;

type TRemoveUnitFromStockFunctionPrototype = procedure (whichUnit: HUNIT; unitId: Int32); cdecl;
var _RemoveUnitFromStock: TRemoveUnitFromStockFunctionPrototype;

procedure RemoveUnitFromStock(whichUnit: HUNIT; unitId: Integer);
begin
	_RemoveUnitFromStock(whichUnit, unitId);
end;

type TSetAllItemTypeSlotsFunctionPrototype = procedure (slots: Int32); cdecl;
var _SetAllItemTypeSlots: TSetAllItemTypeSlotsFunctionPrototype;

procedure SetAllItemTypeSlots(slots: Integer);
begin
	_SetAllItemTypeSlots(slots);
end;

type TSetAllUnitTypeSlotsFunctionPrototype = procedure (slots: Int32); cdecl;
var _SetAllUnitTypeSlots: TSetAllUnitTypeSlotsFunctionPrototype;

procedure SetAllUnitTypeSlots(slots: Integer);
begin
	_SetAllUnitTypeSlots(slots);
end;

type TSetItemTypeSlotsFunctionPrototype = procedure (whichUnit: HUNIT; slots: Int32); cdecl;
var _SetItemTypeSlots: TSetItemTypeSlotsFunctionPrototype;

procedure SetItemTypeSlots(whichUnit: HUNIT; slots: Integer);
begin
	_SetItemTypeSlots(whichUnit, slots);
end;

type TSetUnitTypeSlotsFunctionPrototype = procedure (whichUnit: HUNIT; slots: Int32); cdecl;
var _SetUnitTypeSlots: TSetUnitTypeSlotsFunctionPrototype;

procedure SetUnitTypeSlots(whichUnit: HUNIT; slots: Integer);
begin
	_SetUnitTypeSlots(whichUnit, slots);
end;

type TGetUnitUserDataFunctionPrototype = function (whichUnit: HUNIT): Int32; cdecl;
var _GetUnitUserData: TGetUnitUserDataFunctionPrototype;

function GetUnitUserData(whichUnit: HUNIT): Integer;
begin
	Result:= _GetUnitUserData(whichUnit);
end;

type TSetUnitUserDataFunctionPrototype = procedure (whichUnit: HUNIT; data: Int32); cdecl;
var _SetUnitUserData: TSetUnitUserDataFunctionPrototype;

procedure SetUnitUserData(whichUnit: HUNIT; data: Integer);
begin
	_SetUnitUserData(whichUnit, data);
end;

type TPlayerFunctionPrototype = function (number: Int32): HPLAYER; cdecl;
var _Player: TPlayerFunctionPrototype;

function Player(number: Integer): HPLAYER;
begin
	Result:= _Player(number);
end;

type TGetLocalPlayerFunctionPrototype = function: HPLAYER; cdecl;
var _GetLocalPlayer: TGetLocalPlayerFunctionPrototype;

function GetLocalPlayer: HPLAYER;
begin
	Result:= _GetLocalPlayer();
end;

type TIsPlayerAllyFunctionPrototype = function (whichPlayer: HPLAYER; otherPlayer: HPLAYER): LongBool; cdecl;
var _IsPlayerAlly: TIsPlayerAllyFunctionPrototype;

function IsPlayerAlly(whichPlayer: HPLAYER; otherPlayer: HPLAYER): Boolean;
begin
	Result:= _IsPlayerAlly(whichPlayer, otherPlayer);
end;

type TIsPlayerEnemyFunctionPrototype = function (whichPlayer: HPLAYER; otherPlayer: HPLAYER): LongBool; cdecl;
var _IsPlayerEnemy: TIsPlayerEnemyFunctionPrototype;

function IsPlayerEnemy(whichPlayer: HPLAYER; otherPlayer: HPLAYER): Boolean;
begin
	Result:= _IsPlayerEnemy(whichPlayer, otherPlayer);
end;

type TIsPlayerInForceFunctionPrototype = function (whichPlayer: HPLAYER; whichForce: HFORCE): LongBool; cdecl;
var _IsPlayerInForce: TIsPlayerInForceFunctionPrototype;

function IsPlayerInForce(whichPlayer: HPLAYER; whichForce: HFORCE): Boolean;
begin
	Result:= _IsPlayerInForce(whichPlayer, whichForce);
end;

type TIsPlayerObserverFunctionPrototype = function (whichPlayer: HPLAYER): LongBool; cdecl;
var _IsPlayerObserver: TIsPlayerObserverFunctionPrototype;

function IsPlayerObserver(whichPlayer: HPLAYER): Boolean;
begin
	Result:= _IsPlayerObserver(whichPlayer);
end;

type TIsVisibleToPlayerFunctionPrototype = function (x: PSingle; y: PSingle; whichPlayer: HPLAYER): LongBool; cdecl;
var _IsVisibleToPlayer: TIsVisibleToPlayerFunctionPrototype;

function IsVisibleToPlayer(x: Single; y: Single; whichPlayer: HPLAYER): Boolean;
begin
	Result:= _IsVisibleToPlayer(@x, @y, whichPlayer);
end;

type TIsLocationVisibleToPlayerFunctionPrototype = function (whichLocation: HLOCATION; whichPlayer: HPLAYER): LongBool; cdecl;
var _IsLocationVisibleToPlayer: TIsLocationVisibleToPlayerFunctionPrototype;

function IsLocationVisibleToPlayer(whichLocation: HLOCATION; whichPlayer: HPLAYER): Boolean;
begin
	Result:= _IsLocationVisibleToPlayer(whichLocation, whichPlayer);
end;

type TIsFoggedToPlayerFunctionPrototype = function (x: PSingle; y: PSingle; whichPlayer: HPLAYER): LongBool; cdecl;
var _IsFoggedToPlayer: TIsFoggedToPlayerFunctionPrototype;

function IsFoggedToPlayer(x: Single; y: Single; whichPlayer: HPLAYER): Boolean;
begin
	Result:= _IsFoggedToPlayer(@x, @y, whichPlayer);
end;

type TIsLocationFoggedToPlayerFunctionPrototype = function (whichLocation: HLOCATION; whichPlayer: HPLAYER): LongBool; cdecl;
var _IsLocationFoggedToPlayer: TIsLocationFoggedToPlayerFunctionPrototype;

function IsLocationFoggedToPlayer(whichLocation: HLOCATION; whichPlayer: HPLAYER): Boolean;
begin
	Result:= _IsLocationFoggedToPlayer(whichLocation, whichPlayer);
end;

type TIsMaskedToPlayerFunctionPrototype = function (x: PSingle; y: PSingle; whichPlayer: HPLAYER): LongBool; cdecl;
var _IsMaskedToPlayer: TIsMaskedToPlayerFunctionPrototype;

function IsMaskedToPlayer(x: Single; y: Single; whichPlayer: HPLAYER): Boolean;
begin
	Result:= _IsMaskedToPlayer(@x, @y, whichPlayer);
end;

type TIsLocationMaskedToPlayerFunctionPrototype = function (whichLocation: HLOCATION; whichPlayer: HPLAYER): LongBool; cdecl;
var _IsLocationMaskedToPlayer: TIsLocationMaskedToPlayerFunctionPrototype;

function IsLocationMaskedToPlayer(whichLocation: HLOCATION; whichPlayer: HPLAYER): Boolean;
begin
	Result:= _IsLocationMaskedToPlayer(whichLocation, whichPlayer);
end;

type TGetPlayerRaceFunctionPrototype = function (whichPlayer: HPLAYER): HRACE; cdecl;
var _GetPlayerRace: TGetPlayerRaceFunctionPrototype;

function GetPlayerRace(whichPlayer: HPLAYER): HRACE;
begin
	Result:= _GetPlayerRace(whichPlayer);
end;

type TGetPlayerIdFunctionPrototype = function (whichPlayer: HPLAYER): Int32; cdecl;
var _GetPlayerId: TGetPlayerIdFunctionPrototype;

function GetPlayerId(whichPlayer: HPLAYER): Integer;
begin
	Result:= _GetPlayerId(whichPlayer);
end;

type TGetPlayerUnitCountFunctionPrototype = function (whichPlayer: HPLAYER; includeIncomplete: LongBool): Int32; cdecl;
var _GetPlayerUnitCount: TGetPlayerUnitCountFunctionPrototype;

function GetPlayerUnitCount(whichPlayer: HPLAYER; includeIncomplete: Boolean): Integer;
begin
	Result:= _GetPlayerUnitCount(whichPlayer, includeIncomplete);
end;

type TGetPlayerTypedUnitCountFunctionPrototype = function (whichPlayer: HPLAYER; unitName: PJassString; includeIncomplete: LongBool; includeUpgrades: LongBool): Int32; cdecl;
var _GetPlayerTypedUnitCount: TGetPlayerTypedUnitCountFunctionPrototype;

function GetPlayerTypedUnitCount(whichPlayer: HPLAYER; unitName: String; includeIncomplete: Boolean; includeUpgrades: Boolean): Integer;
var
	junitName: PJassString;
begin
	junitName:= CreateJassString(PChar(unitName));
	Result:= _GetPlayerTypedUnitCount(whichPlayer, junitName, includeIncomplete, includeUpgrades);
	DestroyJassString(junitName);
end;

type TGetPlayerStructureCountFunctionPrototype = function (whichPlayer: HPLAYER; includeIncomplete: LongBool): Int32; cdecl;
var _GetPlayerStructureCount: TGetPlayerStructureCountFunctionPrototype;

function GetPlayerStructureCount(whichPlayer: HPLAYER; includeIncomplete: Boolean): Integer;
begin
	Result:= _GetPlayerStructureCount(whichPlayer, includeIncomplete);
end;

type TGetPlayerStateFunctionPrototype = function (whichPlayer: HPLAYER; whichPlayerState: HPLAYERSTATE): Int32; cdecl;
var _GetPlayerState: TGetPlayerStateFunctionPrototype;

function GetPlayerState(whichPlayer: HPLAYER; whichPlayerState: HPLAYERSTATE): Integer;
begin
	Result:= _GetPlayerState(whichPlayer, whichPlayerState);
end;

type TGetPlayerScoreFunctionPrototype = function (whichPlayer: HPLAYER; whichPlayerScore: HPLAYERSCORE): Int32; cdecl;
var _GetPlayerScore: TGetPlayerScoreFunctionPrototype;

function GetPlayerScore(whichPlayer: HPLAYER; whichPlayerScore: HPLAYERSCORE): Integer;
begin
	Result:= _GetPlayerScore(whichPlayer, whichPlayerScore);
end;

type TGetPlayerAllianceFunctionPrototype = function (sourcePlayer: HPLAYER; otherPlayer: HPLAYER; whichAllianceSetting: HALLIANCETYPE): LongBool; cdecl;
var _GetPlayerAlliance: TGetPlayerAllianceFunctionPrototype;

function GetPlayerAlliance(sourcePlayer: HPLAYER; otherPlayer: HPLAYER; whichAllianceSetting: HALLIANCETYPE): Boolean;
begin
	Result:= _GetPlayerAlliance(sourcePlayer, otherPlayer, whichAllianceSetting);
end;

type TGetPlayerHandicapFunctionPrototype = function (whichPlayer: HPLAYER): TSingle; cdecl;
var _GetPlayerHandicap: TGetPlayerHandicapFunctionPrototype;

function GetPlayerHandicap(whichPlayer: HPLAYER): Single;
begin
	Result:= _GetPlayerHandicap(whichPlayer).Value;
end;

type TGetPlayerHandicapXPFunctionPrototype = function (whichPlayer: HPLAYER): TSingle; cdecl;
var _GetPlayerHandicapXP: TGetPlayerHandicapXPFunctionPrototype;

function GetPlayerHandicapXP(whichPlayer: HPLAYER): Single;
begin
	Result:= _GetPlayerHandicapXP(whichPlayer).Value;
end;

type TSetPlayerHandicapFunctionPrototype = procedure (whichPlayer: HPLAYER; handicap: PSingle); cdecl;
var _SetPlayerHandicap: TSetPlayerHandicapFunctionPrototype;

procedure SetPlayerHandicap(whichPlayer: HPLAYER; handicap: Single);
begin
	_SetPlayerHandicap(whichPlayer, @handicap);
end;

type TSetPlayerHandicapXPFunctionPrototype = procedure (whichPlayer: HPLAYER; handicap: PSingle); cdecl;
var _SetPlayerHandicapXP: TSetPlayerHandicapXPFunctionPrototype;

procedure SetPlayerHandicapXP(whichPlayer: HPLAYER; handicap: Single);
begin
	_SetPlayerHandicapXP(whichPlayer, @handicap);
end;

type TSetPlayerTechMaxAllowedFunctionPrototype = procedure (whichPlayer: HPLAYER; techid: Int32; maximum: Int32); cdecl;
var _SetPlayerTechMaxAllowed: TSetPlayerTechMaxAllowedFunctionPrototype;

procedure SetPlayerTechMaxAllowed(whichPlayer: HPLAYER; techid: Integer; maximum: Integer);
begin
	_SetPlayerTechMaxAllowed(whichPlayer, techid, maximum);
end;

type TGetPlayerTechMaxAllowedFunctionPrototype = function (whichPlayer: HPLAYER; techid: Int32): Int32; cdecl;
var _GetPlayerTechMaxAllowed: TGetPlayerTechMaxAllowedFunctionPrototype;

function GetPlayerTechMaxAllowed(whichPlayer: HPLAYER; techid: Integer): Integer;
begin
	Result:= _GetPlayerTechMaxAllowed(whichPlayer, techid);
end;

type TAddPlayerTechResearchedFunctionPrototype = procedure (whichPlayer: HPLAYER; techid: Int32; levels: Int32); cdecl;
var _AddPlayerTechResearched: TAddPlayerTechResearchedFunctionPrototype;

procedure AddPlayerTechResearched(whichPlayer: HPLAYER; techid: Integer; levels: Integer);
begin
	_AddPlayerTechResearched(whichPlayer, techid, levels);
end;

type TSetPlayerTechResearchedFunctionPrototype = procedure (whichPlayer: HPLAYER; techid: Int32; setToLevel: Int32); cdecl;
var _SetPlayerTechResearched: TSetPlayerTechResearchedFunctionPrototype;

procedure SetPlayerTechResearched(whichPlayer: HPLAYER; techid: Integer; setToLevel: Integer);
begin
	_SetPlayerTechResearched(whichPlayer, techid, setToLevel);
end;

type TGetPlayerTechResearchedFunctionPrototype = function (whichPlayer: HPLAYER; techid: Int32; specificonly: LongBool): LongBool; cdecl;
var _GetPlayerTechResearched: TGetPlayerTechResearchedFunctionPrototype;

function GetPlayerTechResearched(whichPlayer: HPLAYER; techid: Integer; specificonly: Boolean): Boolean;
begin
	Result:= _GetPlayerTechResearched(whichPlayer, techid, specificonly);
end;

type TGetPlayerTechCountFunctionPrototype = function (whichPlayer: HPLAYER; techid: Int32; specificonly: LongBool): Int32; cdecl;
var _GetPlayerTechCount: TGetPlayerTechCountFunctionPrototype;

function GetPlayerTechCount(whichPlayer: HPLAYER; techid: Integer; specificonly: Boolean): Integer;
begin
	Result:= _GetPlayerTechCount(whichPlayer, techid, specificonly);
end;

type TSetPlayerUnitsOwnerFunctionPrototype = procedure (whichPlayer: HPLAYER; newOwner: Int32); cdecl;
var _SetPlayerUnitsOwner: TSetPlayerUnitsOwnerFunctionPrototype;

procedure SetPlayerUnitsOwner(whichPlayer: HPLAYER; newOwner: Integer);
begin
	_SetPlayerUnitsOwner(whichPlayer, newOwner);
end;

type TCripplePlayerFunctionPrototype = procedure (whichPlayer: HPLAYER; toWhichPlayers: HFORCE; flag: LongBool); cdecl;
var _CripplePlayer: TCripplePlayerFunctionPrototype;

procedure CripplePlayer(whichPlayer: HPLAYER; toWhichPlayers: HFORCE; flag: Boolean);
begin
	_CripplePlayer(whichPlayer, toWhichPlayers, flag);
end;

type TSetPlayerAbilityAvailableFunctionPrototype = procedure (whichPlayer: HPLAYER; abilid: Int32; avail: LongBool); cdecl;
var _SetPlayerAbilityAvailable: TSetPlayerAbilityAvailableFunctionPrototype;

procedure SetPlayerAbilityAvailable(whichPlayer: HPLAYER; abilid: Integer; avail: Boolean);
begin
	_SetPlayerAbilityAvailable(whichPlayer, abilid, avail);
end;

type TSetPlayerStateFunctionPrototype = procedure (whichPlayer: HPLAYER; whichPlayerState: HPLAYERSTATE; value: Int32); cdecl;
var _SetPlayerState: TSetPlayerStateFunctionPrototype;

procedure SetPlayerState(whichPlayer: HPLAYER; whichPlayerState: HPLAYERSTATE; value: Integer);
begin
	_SetPlayerState(whichPlayer, whichPlayerState, value);
end;

type TRemovePlayerFunctionPrototype = procedure (whichPlayer: HPLAYER; gameResult: HPLAYERGAMERESULT); cdecl;
var _RemovePlayer: TRemovePlayerFunctionPrototype;

procedure RemovePlayer(whichPlayer: HPLAYER; gameResult: HPLAYERGAMERESULT);
begin
	_RemovePlayer(whichPlayer, gameResult);
end;

type TCachePlayerHeroDataFunctionPrototype = procedure (whichPlayer: HPLAYER); cdecl;
var _CachePlayerHeroData: TCachePlayerHeroDataFunctionPrototype;

procedure CachePlayerHeroData(whichPlayer: HPLAYER);
begin
	_CachePlayerHeroData(whichPlayer);
end;

type TSetFogStateRectFunctionPrototype = procedure (forWhichPlayer: HPLAYER; whichState: HFOGSTATE; where: HRECT; useSharedVision: LongBool); cdecl;
var _SetFogStateRect: TSetFogStateRectFunctionPrototype;

procedure SetFogStateRect(forWhichPlayer: HPLAYER; whichState: HFOGSTATE; where: HRECT; useSharedVision: Boolean);
begin
	_SetFogStateRect(forWhichPlayer, whichState, where, useSharedVision);
end;

type TSetFogStateRadiusFunctionPrototype = procedure (forWhichPlayer: HPLAYER; whichState: HFOGSTATE; centerx: PSingle; centerY: PSingle; radius: PSingle; useSharedVision: LongBool); cdecl;
var _SetFogStateRadius: TSetFogStateRadiusFunctionPrototype;

procedure SetFogStateRadius(forWhichPlayer: HPLAYER; whichState: HFOGSTATE; centerx: Single; centerY: Single; radius: Single; useSharedVision: Boolean);
begin
	_SetFogStateRadius(forWhichPlayer, whichState, @centerx, @centerY, @radius, useSharedVision);
end;

type TSetFogStateRadiusLocFunctionPrototype = procedure (forWhichPlayer: HPLAYER; whichState: HFOGSTATE; center: HLOCATION; radius: PSingle; useSharedVision: LongBool); cdecl;
var _SetFogStateRadiusLoc: TSetFogStateRadiusLocFunctionPrototype;

procedure SetFogStateRadiusLoc(forWhichPlayer: HPLAYER; whichState: HFOGSTATE; center: HLOCATION; radius: Single; useSharedVision: Boolean);
begin
	_SetFogStateRadiusLoc(forWhichPlayer, whichState, center, @radius, useSharedVision);
end;

type TFogMaskEnableFunctionPrototype = procedure (enable: LongBool); cdecl;
var _FogMaskEnable: TFogMaskEnableFunctionPrototype;

procedure FogMaskEnable(enable: Boolean);
begin
	_FogMaskEnable(enable);
end;

type TIsFogMaskEnabledFunctionPrototype = function: LongBool; cdecl;
var _IsFogMaskEnabled: TIsFogMaskEnabledFunctionPrototype;

function IsFogMaskEnabled: Boolean;
begin
	Result:= _IsFogMaskEnabled();
end;

type TFogEnableFunctionPrototype = procedure (enable: LongBool); cdecl;
var _FogEnable: TFogEnableFunctionPrototype;

procedure FogEnable(enable: Boolean);
begin
	_FogEnable(enable);
end;

type TIsFogEnabledFunctionPrototype = function: LongBool; cdecl;
var _IsFogEnabled: TIsFogEnabledFunctionPrototype;

function IsFogEnabled: Boolean;
begin
	Result:= _IsFogEnabled();
end;

type TCreateFogModifierRectFunctionPrototype = function (forWhichPlayer: HPLAYER; whichState: HFOGSTATE; where: HRECT; useSharedVision: LongBool; afterUnits: LongBool): HFOGMODIFIER; cdecl;
var _CreateFogModifierRect: TCreateFogModifierRectFunctionPrototype;

function CreateFogModifierRect(forWhichPlayer: HPLAYER; whichState: HFOGSTATE; where: HRECT; useSharedVision: Boolean; afterUnits: Boolean): HFOGMODIFIER;
begin
	Result:= _CreateFogModifierRect(forWhichPlayer, whichState, where, useSharedVision, afterUnits);
end;

type TCreateFogModifierRadiusFunctionPrototype = function (forWhichPlayer: HPLAYER; whichState: HFOGSTATE; centerx: PSingle; centerY: PSingle; radius: PSingle; useSharedVision: LongBool; afterUnits: LongBool): HFOGMODIFIER; cdecl;
var _CreateFogModifierRadius: TCreateFogModifierRadiusFunctionPrototype;

function CreateFogModifierRadius(forWhichPlayer: HPLAYER; whichState: HFOGSTATE; centerx: Single; centerY: Single; radius: Single; useSharedVision: Boolean; afterUnits: Boolean): HFOGMODIFIER;
begin
	Result:= _CreateFogModifierRadius(forWhichPlayer, whichState, @centerx, @centerY, @radius, useSharedVision, afterUnits);
end;

type TCreateFogModifierRadiusLocFunctionPrototype = function (forWhichPlayer: HPLAYER; whichState: HFOGSTATE; center: HLOCATION; radius: PSingle; useSharedVision: LongBool; afterUnits: LongBool): HFOGMODIFIER; cdecl;
var _CreateFogModifierRadiusLoc: TCreateFogModifierRadiusLocFunctionPrototype;

function CreateFogModifierRadiusLoc(forWhichPlayer: HPLAYER; whichState: HFOGSTATE; center: HLOCATION; radius: Single; useSharedVision: Boolean; afterUnits: Boolean): HFOGMODIFIER;
begin
	Result:= _CreateFogModifierRadiusLoc(forWhichPlayer, whichState, center, @radius, useSharedVision, afterUnits);
end;

type TDestroyFogModifierFunctionPrototype = procedure (whichFogModifier: HFOGMODIFIER); cdecl;
var _DestroyFogModifier: TDestroyFogModifierFunctionPrototype;

procedure DestroyFogModifier(whichFogModifier: HFOGMODIFIER);
begin
	_DestroyFogModifier(whichFogModifier);
end;

type TFogModifierStartFunctionPrototype = procedure (whichFogModifier: HFOGMODIFIER); cdecl;
var _FogModifierStart: TFogModifierStartFunctionPrototype;

procedure FogModifierStart(whichFogModifier: HFOGMODIFIER);
begin
	_FogModifierStart(whichFogModifier);
end;

type TFogModifierStopFunctionPrototype = procedure (whichFogModifier: HFOGMODIFIER); cdecl;
var _FogModifierStop: TFogModifierStopFunctionPrototype;

procedure FogModifierStop(whichFogModifier: HFOGMODIFIER);
begin
	_FogModifierStop(whichFogModifier);
end;

type TVersionGetFunctionPrototype = function: HVERSION; cdecl;
var _VersionGet: TVersionGetFunctionPrototype;

function VersionGet: HVERSION;
begin
	Result:= _VersionGet();
end;

type TVersionCompatibleFunctionPrototype = function (whichVersion: HVERSION): LongBool; cdecl;
var _VersionCompatible: TVersionCompatibleFunctionPrototype;

function VersionCompatible(whichVersion: HVERSION): Boolean;
begin
	Result:= _VersionCompatible(whichVersion);
end;

type TVersionSupportedFunctionPrototype = function (whichVersion: HVERSION): LongBool; cdecl;
var _VersionSupported: TVersionSupportedFunctionPrototype;

function VersionSupported(whichVersion: HVERSION): Boolean;
begin
	Result:= _VersionSupported(whichVersion);
end;

type TEndGameFunctionPrototype = procedure (doScoreScreen: LongBool); cdecl;
var _EndGame: TEndGameFunctionPrototype;

procedure EndGame(doScoreScreen: Boolean);
begin
	_EndGame(doScoreScreen);
end;

type TChangeLevelFunctionPrototype = procedure (newLevel: PJassString; doScoreScreen: LongBool); cdecl;
var _ChangeLevel: TChangeLevelFunctionPrototype;

procedure ChangeLevel(newLevel: String; doScoreScreen: Boolean);
var
	jnewLevel: PJassString;
begin
	jnewLevel:= CreateJassString(PChar(newLevel));
	_ChangeLevel(jnewLevel, doScoreScreen);
	DestroyJassString(jnewLevel);
end;

type TRestartGameFunctionPrototype = procedure (doScoreScreen: LongBool); cdecl;
var _RestartGame: TRestartGameFunctionPrototype;

procedure RestartGame(doScoreScreen: Boolean);
begin
	_RestartGame(doScoreScreen);
end;

type TReloadGameFunctionPrototype = procedure; cdecl;
var _ReloadGame: TReloadGameFunctionPrototype;

procedure ReloadGame;
begin
	_ReloadGame();
end;

type TSetCampaignMenuRaceFunctionPrototype = procedure (r: HRACE); cdecl;
var _SetCampaignMenuRace: TSetCampaignMenuRaceFunctionPrototype;

procedure SetCampaignMenuRace(r: HRACE);
begin
	_SetCampaignMenuRace(r);
end;

type TSetCampaignMenuRaceExFunctionPrototype = procedure (campaignIndex: Int32); cdecl;
var _SetCampaignMenuRaceEx: TSetCampaignMenuRaceExFunctionPrototype;

procedure SetCampaignMenuRaceEx(campaignIndex: Integer);
begin
	_SetCampaignMenuRaceEx(campaignIndex);
end;

type TForceCampaignSelectScreenFunctionPrototype = procedure; cdecl;
var _ForceCampaignSelectScreen: TForceCampaignSelectScreenFunctionPrototype;

procedure ForceCampaignSelectScreen;
begin
	_ForceCampaignSelectScreen();
end;

type TLoadGameFunctionPrototype = procedure (saveFileName: PJassString; doScoreScreen: LongBool); cdecl;
var _LoadGame: TLoadGameFunctionPrototype;

procedure LoadGame(saveFileName: String; doScoreScreen: Boolean);
var
	jsaveFileName: PJassString;
begin
	jsaveFileName:= CreateJassString(PChar(saveFileName));
	_LoadGame(jsaveFileName, doScoreScreen);
	DestroyJassString(jsaveFileName);
end;

type TSaveGameFunctionPrototype = procedure (saveFileName: PJassString); cdecl;
var _SaveGame: TSaveGameFunctionPrototype;

procedure SaveGame(saveFileName: String);
var
	jsaveFileName: PJassString;
begin
	jsaveFileName:= CreateJassString(PChar(saveFileName));
	_SaveGame(jsaveFileName);
	DestroyJassString(jsaveFileName);
end;

type TRenameSaveDirectoryFunctionPrototype = function (sourceDirName: PJassString; destDirName: PJassString): LongBool; cdecl;
var _RenameSaveDirectory: TRenameSaveDirectoryFunctionPrototype;

function RenameSaveDirectory(sourceDirName: String; destDirName: String): Boolean;
var
	jsourceDirName: PJassString;
	jdestDirName: PJassString;
begin
	jsourceDirName:= CreateJassString(PChar(sourceDirName));
	jdestDirName:= CreateJassString(PChar(destDirName));
	Result:= _RenameSaveDirectory(jsourceDirName, jdestDirName);
	DestroyJassString(jsourceDirName);
	DestroyJassString(jdestDirName);
end;

type TRemoveSaveDirectoryFunctionPrototype = function (sourceDirName: PJassString): LongBool; cdecl;
var _RemoveSaveDirectory: TRemoveSaveDirectoryFunctionPrototype;

function RemoveSaveDirectory(sourceDirName: String): Boolean;
var
	jsourceDirName: PJassString;
begin
	jsourceDirName:= CreateJassString(PChar(sourceDirName));
	Result:= _RemoveSaveDirectory(jsourceDirName);
	DestroyJassString(jsourceDirName);
end;

type TCopySaveGameFunctionPrototype = function (sourceSaveName: PJassString; destSaveName: PJassString): LongBool; cdecl;
var _CopySaveGame: TCopySaveGameFunctionPrototype;

function CopySaveGame(sourceSaveName: String; destSaveName: String): Boolean;
var
	jsourceSaveName: PJassString;
	jdestSaveName: PJassString;
begin
	jsourceSaveName:= CreateJassString(PChar(sourceSaveName));
	jdestSaveName:= CreateJassString(PChar(destSaveName));
	Result:= _CopySaveGame(jsourceSaveName, jdestSaveName);
	DestroyJassString(jsourceSaveName);
	DestroyJassString(jdestSaveName);
end;

type TSaveGameExistsFunctionPrototype = function (saveName: PJassString): LongBool; cdecl;
var _SaveGameExists: TSaveGameExistsFunctionPrototype;

function SaveGameExists(saveName: String): Boolean;
var
	jsaveName: PJassString;
begin
	jsaveName:= CreateJassString(PChar(saveName));
	Result:= _SaveGameExists(jsaveName);
	DestroyJassString(jsaveName);
end;

type TSyncSelectionsFunctionPrototype = procedure; cdecl;
var _SyncSelections: TSyncSelectionsFunctionPrototype;

procedure SyncSelections;
begin
	_SyncSelections();
end;

type TSetFloatGameStateFunctionPrototype = procedure (whichFloatGameState: HFGAMESTATE; value: PSingle); cdecl;
var _SetFloatGameState: TSetFloatGameStateFunctionPrototype;

procedure SetFloatGameState(whichFloatGameState: HFGAMESTATE; value: Single);
begin
	_SetFloatGameState(whichFloatGameState, @value);
end;

type TGetFloatGameStateFunctionPrototype = function (whichFloatGameState: HFGAMESTATE): TSingle; cdecl;
var _GetFloatGameState: TGetFloatGameStateFunctionPrototype;

function GetFloatGameState(whichFloatGameState: HFGAMESTATE): Single;
begin
	Result:= _GetFloatGameState(whichFloatGameState).Value;
end;

type TSetIntegerGameStateFunctionPrototype = procedure (whichIntegerGameState: HIGAMESTATE; value: Int32); cdecl;
var _SetIntegerGameState: TSetIntegerGameStateFunctionPrototype;

procedure SetIntegerGameState(whichIntegerGameState: HIGAMESTATE; value: Integer);
begin
	_SetIntegerGameState(whichIntegerGameState, value);
end;

type TGetIntegerGameStateFunctionPrototype = function (whichIntegerGameState: HIGAMESTATE): Int32; cdecl;
var _GetIntegerGameState: TGetIntegerGameStateFunctionPrototype;

function GetIntegerGameState(whichIntegerGameState: HIGAMESTATE): Integer;
begin
	Result:= _GetIntegerGameState(whichIntegerGameState);
end;

type TSetTutorialClearedFunctionPrototype = procedure (cleared: LongBool); cdecl;
var _SetTutorialCleared: TSetTutorialClearedFunctionPrototype;

procedure SetTutorialCleared(cleared: Boolean);
begin
	_SetTutorialCleared(cleared);
end;

type TSetMissionAvailableFunctionPrototype = procedure (campaignNumber: Int32; missionNumber: Int32; available: LongBool); cdecl;
var _SetMissionAvailable: TSetMissionAvailableFunctionPrototype;

procedure SetMissionAvailable(campaignNumber: Integer; missionNumber: Integer; available: Boolean);
begin
	_SetMissionAvailable(campaignNumber, missionNumber, available);
end;

type TSetCampaignAvailableFunctionPrototype = procedure (campaignNumber: Int32; available: LongBool); cdecl;
var _SetCampaignAvailable: TSetCampaignAvailableFunctionPrototype;

procedure SetCampaignAvailable(campaignNumber: Integer; available: Boolean);
begin
	_SetCampaignAvailable(campaignNumber, available);
end;

type TSetOpCinematicAvailableFunctionPrototype = procedure (campaignNumber: Int32; available: LongBool); cdecl;
var _SetOpCinematicAvailable: TSetOpCinematicAvailableFunctionPrototype;

procedure SetOpCinematicAvailable(campaignNumber: Integer; available: Boolean);
begin
	_SetOpCinematicAvailable(campaignNumber, available);
end;

type TSetEdCinematicAvailableFunctionPrototype = procedure (campaignNumber: Int32; available: LongBool); cdecl;
var _SetEdCinematicAvailable: TSetEdCinematicAvailableFunctionPrototype;

procedure SetEdCinematicAvailable(campaignNumber: Integer; available: Boolean);
begin
	_SetEdCinematicAvailable(campaignNumber, available);
end;

type TGetDefaultDifficultyFunctionPrototype = function: HGAMEDIFFICULTY; cdecl;
var _GetDefaultDifficulty: TGetDefaultDifficultyFunctionPrototype;

function GetDefaultDifficulty: HGAMEDIFFICULTY;
begin
	Result:= _GetDefaultDifficulty();
end;

type TSetDefaultDifficultyFunctionPrototype = procedure (g: HGAMEDIFFICULTY); cdecl;
var _SetDefaultDifficulty: TSetDefaultDifficultyFunctionPrototype;

procedure SetDefaultDifficulty(g: HGAMEDIFFICULTY);
begin
	_SetDefaultDifficulty(g);
end;

type TSetCustomCampaignButtonVisibleFunctionPrototype = procedure (whichButton: Int32; visible: LongBool); cdecl;
var _SetCustomCampaignButtonVisible: TSetCustomCampaignButtonVisibleFunctionPrototype;

procedure SetCustomCampaignButtonVisible(whichButton: Integer; visible: Boolean);
begin
	_SetCustomCampaignButtonVisible(whichButton, visible);
end;

type TGetCustomCampaignButtonVisibleFunctionPrototype = function (whichButton: Int32): LongBool; cdecl;
var _GetCustomCampaignButtonVisible: TGetCustomCampaignButtonVisibleFunctionPrototype;

function GetCustomCampaignButtonVisible(whichButton: Integer): Boolean;
begin
	Result:= _GetCustomCampaignButtonVisible(whichButton);
end;

type TDoNotSaveReplayFunctionPrototype = procedure; cdecl;
var _DoNotSaveReplay: TDoNotSaveReplayFunctionPrototype;

procedure DoNotSaveReplay;
begin
	_DoNotSaveReplay();
end;

type TDialogCreateFunctionPrototype = function: HDIALOG; cdecl;
var _DialogCreate: TDialogCreateFunctionPrototype;

function DialogCreate: HDIALOG;
begin
	Result:= _DialogCreate();
end;

type TDialogDestroyFunctionPrototype = procedure (whichDialog: HDIALOG); cdecl;
var _DialogDestroy: TDialogDestroyFunctionPrototype;

procedure DialogDestroy(whichDialog: HDIALOG);
begin
	_DialogDestroy(whichDialog);
end;

type TDialogClearFunctionPrototype = procedure (whichDialog: HDIALOG); cdecl;
var _DialogClear: TDialogClearFunctionPrototype;

procedure DialogClear(whichDialog: HDIALOG);
begin
	_DialogClear(whichDialog);
end;

type TDialogSetMessageFunctionPrototype = procedure (whichDialog: HDIALOG; messageText: PJassString); cdecl;
var _DialogSetMessage: TDialogSetMessageFunctionPrototype;

procedure DialogSetMessage(whichDialog: HDIALOG; messageText: String);
var
	jmessageText: PJassString;
begin
	jmessageText:= CreateJassString(PChar(messageText));
	_DialogSetMessage(whichDialog, jmessageText);
	DestroyJassString(jmessageText);
end;

type TDialogAddButtonFunctionPrototype = function (whichDialog: HDIALOG; buttonText: PJassString; hotkey: Int32): HBUTTON; cdecl;
var _DialogAddButton: TDialogAddButtonFunctionPrototype;

function DialogAddButton(whichDialog: HDIALOG; buttonText: String; hotkey: Integer): HBUTTON;
var
	jbuttonText: PJassString;
begin
	jbuttonText:= CreateJassString(PChar(buttonText));
	Result:= _DialogAddButton(whichDialog, jbuttonText, hotkey);
	DestroyJassString(jbuttonText);
end;

type TDialogAddQuitButtonFunctionPrototype = function (whichDialog: HDIALOG; doScoreScreen: LongBool; buttonText: PJassString; hotkey: Int32): HBUTTON; cdecl;
var _DialogAddQuitButton: TDialogAddQuitButtonFunctionPrototype;

function DialogAddQuitButton(whichDialog: HDIALOG; doScoreScreen: Boolean; buttonText: String; hotkey: Integer): HBUTTON;
var
	jbuttonText: PJassString;
begin
	jbuttonText:= CreateJassString(PChar(buttonText));
	Result:= _DialogAddQuitButton(whichDialog, doScoreScreen, jbuttonText, hotkey);
	DestroyJassString(jbuttonText);
end;

type TDialogDisplayFunctionPrototype = procedure (whichPlayer: HPLAYER; whichDialog: HDIALOG; flag: LongBool); cdecl;
var _DialogDisplay: TDialogDisplayFunctionPrototype;

procedure DialogDisplay(whichPlayer: HPLAYER; whichDialog: HDIALOG; flag: Boolean);
begin
	_DialogDisplay(whichPlayer, whichDialog, flag);
end;

type TReloadGameCachesFromDiskFunctionPrototype = function: LongBool; cdecl;
var _ReloadGameCachesFromDisk: TReloadGameCachesFromDiskFunctionPrototype;

function ReloadGameCachesFromDisk: Boolean;
begin
	Result:= _ReloadGameCachesFromDisk();
end;

type TInitGameCacheFunctionPrototype = function (campaignFile: PJassString): HGAMECACHE; cdecl;
var _InitGameCache: TInitGameCacheFunctionPrototype;

function InitGameCache(campaignFile: String): HGAMECACHE;
var
	jcampaignFile: PJassString;
begin
	jcampaignFile:= CreateJassString(PChar(campaignFile));
	Result:= _InitGameCache(jcampaignFile);
	DestroyJassString(jcampaignFile);
end;

type TSaveGameCacheFunctionPrototype = function (whichCache: HGAMECACHE): LongBool; cdecl;
var _SaveGameCache: TSaveGameCacheFunctionPrototype;

function SaveGameCache(whichCache: HGAMECACHE): Boolean;
begin
	Result:= _SaveGameCache(whichCache);
end;

type TStoreIntegerFunctionPrototype = procedure (cache: HGAMECACHE; missionKey: PJassString; key: PJassString; value: Int32); cdecl;
var _StoreInteger: TStoreIntegerFunctionPrototype;

procedure StoreInteger(cache: HGAMECACHE; missionKey: String; key: String; value: Integer);
var
	jmissionKey: PJassString;
	jkey: PJassString;
begin
	jmissionKey:= CreateJassString(PChar(missionKey));
	jkey:= CreateJassString(PChar(key));
	_StoreInteger(cache, jmissionKey, jkey, value);
	DestroyJassString(jmissionKey);
	DestroyJassString(jkey);
end;

type TStoreRealFunctionPrototype = procedure (cache: HGAMECACHE; missionKey: PJassString; key: PJassString; value: PSingle); cdecl;
var _StoreReal: TStoreRealFunctionPrototype;

procedure StoreReal(cache: HGAMECACHE; missionKey: String; key: String; value: Single);
var
	jmissionKey: PJassString;
	jkey: PJassString;
begin
	jmissionKey:= CreateJassString(PChar(missionKey));
	jkey:= CreateJassString(PChar(key));
	_StoreReal(cache, jmissionKey, jkey, @value);
	DestroyJassString(jmissionKey);
	DestroyJassString(jkey);
end;

type TStoreBooleanFunctionPrototype = procedure (cache: HGAMECACHE; missionKey: PJassString; key: PJassString; value: LongBool); cdecl;
var _StoreBoolean: TStoreBooleanFunctionPrototype;

procedure StoreBoolean(cache: HGAMECACHE; missionKey: String; key: String; value: Boolean);
var
	jmissionKey: PJassString;
	jkey: PJassString;
begin
	jmissionKey:= CreateJassString(PChar(missionKey));
	jkey:= CreateJassString(PChar(key));
	_StoreBoolean(cache, jmissionKey, jkey, value);
	DestroyJassString(jmissionKey);
	DestroyJassString(jkey);
end;

type TStoreUnitFunctionPrototype = function (cache: HGAMECACHE; missionKey: PJassString; key: PJassString; whichUnit: HUNIT): LongBool; cdecl;
var _StoreUnit: TStoreUnitFunctionPrototype;

function StoreUnit(cache: HGAMECACHE; missionKey: String; key: String; whichUnit: HUNIT): Boolean;
var
	jmissionKey: PJassString;
	jkey: PJassString;
begin
	jmissionKey:= CreateJassString(PChar(missionKey));
	jkey:= CreateJassString(PChar(key));
	Result:= _StoreUnit(cache, jmissionKey, jkey, whichUnit);
	DestroyJassString(jmissionKey);
	DestroyJassString(jkey);
end;

type TStoreStringFunctionPrototype = function (cache: HGAMECACHE; missionKey: PJassString; key: PJassString; value: PJassString): LongBool; cdecl;
var _StoreString: TStoreStringFunctionPrototype;

function StoreString(cache: HGAMECACHE; missionKey: String; key: String; value: String): Boolean;
var
	jmissionKey: PJassString;
	jkey: PJassString;
	jvalue: PJassString;
begin
	jmissionKey:= CreateJassString(PChar(missionKey));
	jkey:= CreateJassString(PChar(key));
	jvalue:= CreateJassString(PChar(value));
	Result:= _StoreString(cache, jmissionKey, jkey, jvalue);
	DestroyJassString(jmissionKey);
	DestroyJassString(jkey);
	DestroyJassString(jvalue);
end;

type TSyncStoredIntegerFunctionPrototype = procedure (cache: HGAMECACHE; missionKey: PJassString; key: PJassString); cdecl;
var _SyncStoredInteger: TSyncStoredIntegerFunctionPrototype;

procedure SyncStoredInteger(cache: HGAMECACHE; missionKey: String; key: String);
var
	jmissionKey: PJassString;
	jkey: PJassString;
begin
	jmissionKey:= CreateJassString(PChar(missionKey));
	jkey:= CreateJassString(PChar(key));
	_SyncStoredInteger(cache, jmissionKey, jkey);
	DestroyJassString(jmissionKey);
	DestroyJassString(jkey);
end;

type TSyncStoredRealFunctionPrototype = procedure (cache: HGAMECACHE; missionKey: PJassString; key: PJassString); cdecl;
var _SyncStoredReal: TSyncStoredRealFunctionPrototype;

procedure SyncStoredReal(cache: HGAMECACHE; missionKey: String; key: String);
var
	jmissionKey: PJassString;
	jkey: PJassString;
begin
	jmissionKey:= CreateJassString(PChar(missionKey));
	jkey:= CreateJassString(PChar(key));
	_SyncStoredReal(cache, jmissionKey, jkey);
	DestroyJassString(jmissionKey);
	DestroyJassString(jkey);
end;

type TSyncStoredBooleanFunctionPrototype = procedure (cache: HGAMECACHE; missionKey: PJassString; key: PJassString); cdecl;
var _SyncStoredBoolean: TSyncStoredBooleanFunctionPrototype;

procedure SyncStoredBoolean(cache: HGAMECACHE; missionKey: String; key: String);
var
	jmissionKey: PJassString;
	jkey: PJassString;
begin
	jmissionKey:= CreateJassString(PChar(missionKey));
	jkey:= CreateJassString(PChar(key));
	_SyncStoredBoolean(cache, jmissionKey, jkey);
	DestroyJassString(jmissionKey);
	DestroyJassString(jkey);
end;

type TSyncStoredUnitFunctionPrototype = procedure (cache: HGAMECACHE; missionKey: PJassString; key: PJassString); cdecl;
var _SyncStoredUnit: TSyncStoredUnitFunctionPrototype;

procedure SyncStoredUnit(cache: HGAMECACHE; missionKey: String; key: String);
var
	jmissionKey: PJassString;
	jkey: PJassString;
begin
	jmissionKey:= CreateJassString(PChar(missionKey));
	jkey:= CreateJassString(PChar(key));
	_SyncStoredUnit(cache, jmissionKey, jkey);
	DestroyJassString(jmissionKey);
	DestroyJassString(jkey);
end;

type TSyncStoredStringFunctionPrototype = procedure (cache: HGAMECACHE; missionKey: PJassString; key: PJassString); cdecl;
var _SyncStoredString: TSyncStoredStringFunctionPrototype;

procedure SyncStoredString(cache: HGAMECACHE; missionKey: String; key: String);
var
	jmissionKey: PJassString;
	jkey: PJassString;
begin
	jmissionKey:= CreateJassString(PChar(missionKey));
	jkey:= CreateJassString(PChar(key));
	_SyncStoredString(cache, jmissionKey, jkey);
	DestroyJassString(jmissionKey);
	DestroyJassString(jkey);
end;

type THaveStoredIntegerFunctionPrototype = function (cache: HGAMECACHE; missionKey: PJassString; key: PJassString): LongBool; cdecl;
var _HaveStoredInteger: THaveStoredIntegerFunctionPrototype;

function HaveStoredInteger(cache: HGAMECACHE; missionKey: String; key: String): Boolean;
var
	jmissionKey: PJassString;
	jkey: PJassString;
begin
	jmissionKey:= CreateJassString(PChar(missionKey));
	jkey:= CreateJassString(PChar(key));
	Result:= _HaveStoredInteger(cache, jmissionKey, jkey);
	DestroyJassString(jmissionKey);
	DestroyJassString(jkey);
end;

type THaveStoredRealFunctionPrototype = function (cache: HGAMECACHE; missionKey: PJassString; key: PJassString): LongBool; cdecl;
var _HaveStoredReal: THaveStoredRealFunctionPrototype;

function HaveStoredReal(cache: HGAMECACHE; missionKey: String; key: String): Boolean;
var
	jmissionKey: PJassString;
	jkey: PJassString;
begin
	jmissionKey:= CreateJassString(PChar(missionKey));
	jkey:= CreateJassString(PChar(key));
	Result:= _HaveStoredReal(cache, jmissionKey, jkey);
	DestroyJassString(jmissionKey);
	DestroyJassString(jkey);
end;

type THaveStoredBooleanFunctionPrototype = function (cache: HGAMECACHE; missionKey: PJassString; key: PJassString): LongBool; cdecl;
var _HaveStoredBoolean: THaveStoredBooleanFunctionPrototype;

function HaveStoredBoolean(cache: HGAMECACHE; missionKey: String; key: String): Boolean;
var
	jmissionKey: PJassString;
	jkey: PJassString;
begin
	jmissionKey:= CreateJassString(PChar(missionKey));
	jkey:= CreateJassString(PChar(key));
	Result:= _HaveStoredBoolean(cache, jmissionKey, jkey);
	DestroyJassString(jmissionKey);
	DestroyJassString(jkey);
end;

type THaveStoredUnitFunctionPrototype = function (cache: HGAMECACHE; missionKey: PJassString; key: PJassString): LongBool; cdecl;
var _HaveStoredUnit: THaveStoredUnitFunctionPrototype;

function HaveStoredUnit(cache: HGAMECACHE; missionKey: String; key: String): Boolean;
var
	jmissionKey: PJassString;
	jkey: PJassString;
begin
	jmissionKey:= CreateJassString(PChar(missionKey));
	jkey:= CreateJassString(PChar(key));
	Result:= _HaveStoredUnit(cache, jmissionKey, jkey);
	DestroyJassString(jmissionKey);
	DestroyJassString(jkey);
end;

type THaveStoredStringFunctionPrototype = function (cache: HGAMECACHE; missionKey: PJassString; key: PJassString): LongBool; cdecl;
var _HaveStoredString: THaveStoredStringFunctionPrototype;

function HaveStoredString(cache: HGAMECACHE; missionKey: String; key: String): Boolean;
var
	jmissionKey: PJassString;
	jkey: PJassString;
begin
	jmissionKey:= CreateJassString(PChar(missionKey));
	jkey:= CreateJassString(PChar(key));
	Result:= _HaveStoredString(cache, jmissionKey, jkey);
	DestroyJassString(jmissionKey);
	DestroyJassString(jkey);
end;

type TFlushGameCacheFunctionPrototype = procedure (cache: HGAMECACHE); cdecl;
var _FlushGameCache: TFlushGameCacheFunctionPrototype;

procedure FlushGameCache(cache: HGAMECACHE);
begin
	_FlushGameCache(cache);
end;

type TFlushStoredMissionFunctionPrototype = procedure (cache: HGAMECACHE; missionKey: PJassString); cdecl;
var _FlushStoredMission: TFlushStoredMissionFunctionPrototype;

procedure FlushStoredMission(cache: HGAMECACHE; missionKey: String);
var
	jmissionKey: PJassString;
begin
	jmissionKey:= CreateJassString(PChar(missionKey));
	_FlushStoredMission(cache, jmissionKey);
	DestroyJassString(jmissionKey);
end;

type TFlushStoredIntegerFunctionPrototype = procedure (cache: HGAMECACHE; missionKey: PJassString; key: PJassString); cdecl;
var _FlushStoredInteger: TFlushStoredIntegerFunctionPrototype;

procedure FlushStoredInteger(cache: HGAMECACHE; missionKey: String; key: String);
var
	jmissionKey: PJassString;
	jkey: PJassString;
begin
	jmissionKey:= CreateJassString(PChar(missionKey));
	jkey:= CreateJassString(PChar(key));
	_FlushStoredInteger(cache, jmissionKey, jkey);
	DestroyJassString(jmissionKey);
	DestroyJassString(jkey);
end;

type TFlushStoredRealFunctionPrototype = procedure (cache: HGAMECACHE; missionKey: PJassString; key: PJassString); cdecl;
var _FlushStoredReal: TFlushStoredRealFunctionPrototype;

procedure FlushStoredReal(cache: HGAMECACHE; missionKey: String; key: String);
var
	jmissionKey: PJassString;
	jkey: PJassString;
begin
	jmissionKey:= CreateJassString(PChar(missionKey));
	jkey:= CreateJassString(PChar(key));
	_FlushStoredReal(cache, jmissionKey, jkey);
	DestroyJassString(jmissionKey);
	DestroyJassString(jkey);
end;

type TFlushStoredBooleanFunctionPrototype = procedure (cache: HGAMECACHE; missionKey: PJassString; key: PJassString); cdecl;
var _FlushStoredBoolean: TFlushStoredBooleanFunctionPrototype;

procedure FlushStoredBoolean(cache: HGAMECACHE; missionKey: String; key: String);
var
	jmissionKey: PJassString;
	jkey: PJassString;
begin
	jmissionKey:= CreateJassString(PChar(missionKey));
	jkey:= CreateJassString(PChar(key));
	_FlushStoredBoolean(cache, jmissionKey, jkey);
	DestroyJassString(jmissionKey);
	DestroyJassString(jkey);
end;

type TFlushStoredUnitFunctionPrototype = procedure (cache: HGAMECACHE; missionKey: PJassString; key: PJassString); cdecl;
var _FlushStoredUnit: TFlushStoredUnitFunctionPrototype;

procedure FlushStoredUnit(cache: HGAMECACHE; missionKey: String; key: String);
var
	jmissionKey: PJassString;
	jkey: PJassString;
begin
	jmissionKey:= CreateJassString(PChar(missionKey));
	jkey:= CreateJassString(PChar(key));
	_FlushStoredUnit(cache, jmissionKey, jkey);
	DestroyJassString(jmissionKey);
	DestroyJassString(jkey);
end;

type TFlushStoredStringFunctionPrototype = procedure (cache: HGAMECACHE; missionKey: PJassString; key: PJassString); cdecl;
var _FlushStoredString: TFlushStoredStringFunctionPrototype;

procedure FlushStoredString(cache: HGAMECACHE; missionKey: String; key: String);
var
	jmissionKey: PJassString;
	jkey: PJassString;
begin
	jmissionKey:= CreateJassString(PChar(missionKey));
	jkey:= CreateJassString(PChar(key));
	_FlushStoredString(cache, jmissionKey, jkey);
	DestroyJassString(jmissionKey);
	DestroyJassString(jkey);
end;

type TGetStoredIntegerFunctionPrototype = function (cache: HGAMECACHE; missionKey: PJassString; key: PJassString): Int32; cdecl;
var _GetStoredInteger: TGetStoredIntegerFunctionPrototype;

function GetStoredInteger(cache: HGAMECACHE; missionKey: String; key: String): Integer;
var
	jmissionKey: PJassString;
	jkey: PJassString;
begin
	jmissionKey:= CreateJassString(PChar(missionKey));
	jkey:= CreateJassString(PChar(key));
	Result:= _GetStoredInteger(cache, jmissionKey, jkey);
	DestroyJassString(jmissionKey);
	DestroyJassString(jkey);
end;

type TGetStoredRealFunctionPrototype = function (cache: HGAMECACHE; missionKey: PJassString; key: PJassString): TSingle; cdecl;
var _GetStoredReal: TGetStoredRealFunctionPrototype;

function GetStoredReal(cache: HGAMECACHE; missionKey: String; key: String): Single;
var
	jmissionKey: PJassString;
	jkey: PJassString;
begin
	jmissionKey:= CreateJassString(PChar(missionKey));
	jkey:= CreateJassString(PChar(key));
	Result:= _GetStoredReal(cache, jmissionKey, jkey).Value;
	DestroyJassString(jmissionKey);
	DestroyJassString(jkey);
end;

type TGetStoredBooleanFunctionPrototype = function (cache: HGAMECACHE; missionKey: PJassString; key: PJassString): LongBool; cdecl;
var _GetStoredBoolean: TGetStoredBooleanFunctionPrototype;

function GetStoredBoolean(cache: HGAMECACHE; missionKey: String; key: String): Boolean;
var
	jmissionKey: PJassString;
	jkey: PJassString;
begin
	jmissionKey:= CreateJassString(PChar(missionKey));
	jkey:= CreateJassString(PChar(key));
	Result:= _GetStoredBoolean(cache, jmissionKey, jkey);
	DestroyJassString(jmissionKey);
	DestroyJassString(jkey);
end;

type TGetStoredStringFunctionPrototype = function (cache: HGAMECACHE; missionKey: PJassString; key: PJassString): TJassStringHandle; cdecl;
var _GetStoredString: TGetStoredStringFunctionPrototype;

function GetStoredString(cache: HGAMECACHE; missionKey: String; key: String): String;
var
	jmissionKey: PJassString;
	jkey: PJassString;
	hResult: TJassStringHandle;
begin
	jmissionKey:= CreateJassString(PChar(missionKey));
	jkey:= CreateJassString(PChar(key));
	hResult:= _GetStoredString(cache, jmissionKey, jkey);
	Result:= GetStringFromHandle(hResult);
	DecrementStringReferences(hResult);
	DestroyJassString(jmissionKey);
	DestroyJassString(jkey);
end;

type TRestoreUnitFunctionPrototype = function (cache: HGAMECACHE; missionKey: PJassString; key: PJassString; forWhichPlayer: HPLAYER; x: PSingle; y: PSingle; facing: PSingle): HUNIT; cdecl;
var _RestoreUnit: TRestoreUnitFunctionPrototype;

function RestoreUnit(cache: HGAMECACHE; missionKey: String; key: String; forWhichPlayer: HPLAYER; x: Single; y: Single; facing: Single): HUNIT;
var
	jmissionKey: PJassString;
	jkey: PJassString;
begin
	jmissionKey:= CreateJassString(PChar(missionKey));
	jkey:= CreateJassString(PChar(key));
	Result:= _RestoreUnit(cache, jmissionKey, jkey, forWhichPlayer, @x, @y, @facing);
	DestroyJassString(jmissionKey);
	DestroyJassString(jkey);
end;

type TInitHashtableFunctionPrototype = function: HHASHTABLE; cdecl;
var _InitHashtable: TInitHashtableFunctionPrototype;

function InitHashtable: HHASHTABLE;
begin
	Result:= _InitHashtable();
end;

type TSaveIntegerFunctionPrototype = procedure (table: HHASHTABLE; parentKey: Int32; childKey: Int32; value: Int32); cdecl;
var _SaveInteger: TSaveIntegerFunctionPrototype;

procedure SaveInteger(table: HHASHTABLE; parentKey: Integer; childKey: Integer; value: Integer);
begin
	_SaveInteger(table, parentKey, childKey, value);
end;

type TSaveRealFunctionPrototype = procedure (table: HHASHTABLE; parentKey: Int32; childKey: Int32; value: PSingle); cdecl;
var _SaveReal: TSaveRealFunctionPrototype;

procedure SaveReal(table: HHASHTABLE; parentKey: Integer; childKey: Integer; value: Single);
begin
	_SaveReal(table, parentKey, childKey, @value);
end;

type TSaveBooleanFunctionPrototype = procedure (table: HHASHTABLE; parentKey: Int32; childKey: Int32; value: LongBool); cdecl;
var _SaveBoolean: TSaveBooleanFunctionPrototype;

procedure SaveBoolean(table: HHASHTABLE; parentKey: Integer; childKey: Integer; value: Boolean);
begin
	_SaveBoolean(table, parentKey, childKey, value);
end;

type TSaveStrFunctionPrototype = function (table: HHASHTABLE; parentKey: Int32; childKey: Int32; value: PJassString): LongBool; cdecl;
var _SaveStr: TSaveStrFunctionPrototype;

function SaveStr(table: HHASHTABLE; parentKey: Integer; childKey: Integer; value: String): Boolean;
var
	jvalue: PJassString;
begin
	jvalue:= CreateJassString(PChar(value));
	Result:= _SaveStr(table, parentKey, childKey, jvalue);
	DestroyJassString(jvalue);
end;

type TSavePlayerHandleFunctionPrototype = function (table: HHASHTABLE; parentKey: Int32; childKey: Int32; whichPlayer: HPLAYER): LongBool; cdecl;
var _SavePlayerHandle: TSavePlayerHandleFunctionPrototype;

function SavePlayerHandle(table: HHASHTABLE; parentKey: Integer; childKey: Integer; whichPlayer: HPLAYER): Boolean;
begin
	Result:= _SavePlayerHandle(table, parentKey, childKey, whichPlayer);
end;

type TSaveWidgetHandleFunctionPrototype = function (table: HHASHTABLE; parentKey: Int32; childKey: Int32; whichWidget: HWIDGET): LongBool; cdecl;
var _SaveWidgetHandle: TSaveWidgetHandleFunctionPrototype;

function SaveWidgetHandle(table: HHASHTABLE; parentKey: Integer; childKey: Integer; whichWidget: HWIDGET): Boolean;
begin
	Result:= _SaveWidgetHandle(table, parentKey, childKey, whichWidget);
end;

type TSaveDestructableHandleFunctionPrototype = function (table: HHASHTABLE; parentKey: Int32; childKey: Int32; whichDestructable: HDESTRUCTABLE): LongBool; cdecl;
var _SaveDestructableHandle: TSaveDestructableHandleFunctionPrototype;

function SaveDestructableHandle(table: HHASHTABLE; parentKey: Integer; childKey: Integer; whichDestructable: HDESTRUCTABLE): Boolean;
begin
	Result:= _SaveDestructableHandle(table, parentKey, childKey, whichDestructable);
end;

type TSaveItemHandleFunctionPrototype = function (table: HHASHTABLE; parentKey: Int32; childKey: Int32; whichItem: HITEM): LongBool; cdecl;
var _SaveItemHandle: TSaveItemHandleFunctionPrototype;

function SaveItemHandle(table: HHASHTABLE; parentKey: Integer; childKey: Integer; whichItem: HITEM): Boolean;
begin
	Result:= _SaveItemHandle(table, parentKey, childKey, whichItem);
end;

type TSaveUnitHandleFunctionPrototype = function (table: HHASHTABLE; parentKey: Int32; childKey: Int32; whichUnit: HUNIT): LongBool; cdecl;
var _SaveUnitHandle: TSaveUnitHandleFunctionPrototype;

function SaveUnitHandle(table: HHASHTABLE; parentKey: Integer; childKey: Integer; whichUnit: HUNIT): Boolean;
begin
	Result:= _SaveUnitHandle(table, parentKey, childKey, whichUnit);
end;

type TSaveAbilityHandleFunctionPrototype = function (table: HHASHTABLE; parentKey: Int32; childKey: Int32; whichAbility: HABILITY): LongBool; cdecl;
var _SaveAbilityHandle: TSaveAbilityHandleFunctionPrototype;

function SaveAbilityHandle(table: HHASHTABLE; parentKey: Integer; childKey: Integer; whichAbility: HABILITY): Boolean;
begin
	Result:= _SaveAbilityHandle(table, parentKey, childKey, whichAbility);
end;

type TSaveTimerHandleFunctionPrototype = function (table: HHASHTABLE; parentKey: Int32; childKey: Int32; whichTimer: HTIMER): LongBool; cdecl;
var _SaveTimerHandle: TSaveTimerHandleFunctionPrototype;

function SaveTimerHandle(table: HHASHTABLE; parentKey: Integer; childKey: Integer; whichTimer: HTIMER): Boolean;
begin
	Result:= _SaveTimerHandle(table, parentKey, childKey, whichTimer);
end;

type TSaveTriggerHandleFunctionPrototype = function (table: HHASHTABLE; parentKey: Int32; childKey: Int32; whichTrigger: HTRIGGER): LongBool; cdecl;
var _SaveTriggerHandle: TSaveTriggerHandleFunctionPrototype;

function SaveTriggerHandle(table: HHASHTABLE; parentKey: Integer; childKey: Integer; whichTrigger: HTRIGGER): Boolean;
begin
	Result:= _SaveTriggerHandle(table, parentKey, childKey, whichTrigger);
end;

type TSaveTriggerConditionHandleFunctionPrototype = function (table: HHASHTABLE; parentKey: Int32; childKey: Int32; whichTriggercondition: HTRIGGERCONDITION): LongBool; cdecl;
var _SaveTriggerConditionHandle: TSaveTriggerConditionHandleFunctionPrototype;

function SaveTriggerConditionHandle(table: HHASHTABLE; parentKey: Integer; childKey: Integer; whichTriggercondition: HTRIGGERCONDITION): Boolean;
begin
	Result:= _SaveTriggerConditionHandle(table, parentKey, childKey, whichTriggercondition);
end;

type TSaveTriggerActionHandleFunctionPrototype = function (table: HHASHTABLE; parentKey: Int32; childKey: Int32; whichTriggeraction: HTRIGGERACTION): LongBool; cdecl;
var _SaveTriggerActionHandle: TSaveTriggerActionHandleFunctionPrototype;

function SaveTriggerActionHandle(table: HHASHTABLE; parentKey: Integer; childKey: Integer; whichTriggeraction: HTRIGGERACTION): Boolean;
begin
	Result:= _SaveTriggerActionHandle(table, parentKey, childKey, whichTriggeraction);
end;

type TSaveTriggerEventHandleFunctionPrototype = function (table: HHASHTABLE; parentKey: Int32; childKey: Int32; whichEvent: HEVENT): LongBool; cdecl;
var _SaveTriggerEventHandle: TSaveTriggerEventHandleFunctionPrototype;

function SaveTriggerEventHandle(table: HHASHTABLE; parentKey: Integer; childKey: Integer; whichEvent: HEVENT): Boolean;
begin
	Result:= _SaveTriggerEventHandle(table, parentKey, childKey, whichEvent);
end;

type TSaveForceHandleFunctionPrototype = function (table: HHASHTABLE; parentKey: Int32; childKey: Int32; whichForce: HFORCE): LongBool; cdecl;
var _SaveForceHandle: TSaveForceHandleFunctionPrototype;

function SaveForceHandle(table: HHASHTABLE; parentKey: Integer; childKey: Integer; whichForce: HFORCE): Boolean;
begin
	Result:= _SaveForceHandle(table, parentKey, childKey, whichForce);
end;

type TSaveGroupHandleFunctionPrototype = function (table: HHASHTABLE; parentKey: Int32; childKey: Int32; whichGroup: HGROUP): LongBool; cdecl;
var _SaveGroupHandle: TSaveGroupHandleFunctionPrototype;

function SaveGroupHandle(table: HHASHTABLE; parentKey: Integer; childKey: Integer; whichGroup: HGROUP): Boolean;
begin
	Result:= _SaveGroupHandle(table, parentKey, childKey, whichGroup);
end;

type TSaveLocationHandleFunctionPrototype = function (table: HHASHTABLE; parentKey: Int32; childKey: Int32; whichLocation: HLOCATION): LongBool; cdecl;
var _SaveLocationHandle: TSaveLocationHandleFunctionPrototype;

function SaveLocationHandle(table: HHASHTABLE; parentKey: Integer; childKey: Integer; whichLocation: HLOCATION): Boolean;
begin
	Result:= _SaveLocationHandle(table, parentKey, childKey, whichLocation);
end;

type TSaveRectHandleFunctionPrototype = function (table: HHASHTABLE; parentKey: Int32; childKey: Int32; whichRect: HRECT): LongBool; cdecl;
var _SaveRectHandle: TSaveRectHandleFunctionPrototype;

function SaveRectHandle(table: HHASHTABLE; parentKey: Integer; childKey: Integer; whichRect: HRECT): Boolean;
begin
	Result:= _SaveRectHandle(table, parentKey, childKey, whichRect);
end;

type TSaveBooleanExprHandleFunctionPrototype = function (table: HHASHTABLE; parentKey: Int32; childKey: Int32; whichBoolexpr: HBOOLEXPR): LongBool; cdecl;
var _SaveBooleanExprHandle: TSaveBooleanExprHandleFunctionPrototype;

function SaveBooleanExprHandle(table: HHASHTABLE; parentKey: Integer; childKey: Integer; whichBoolexpr: HBOOLEXPR): Boolean;
begin
	Result:= _SaveBooleanExprHandle(table, parentKey, childKey, whichBoolexpr);
end;

type TSaveSoundHandleFunctionPrototype = function (table: HHASHTABLE; parentKey: Int32; childKey: Int32; whichSound: HSOUND): LongBool; cdecl;
var _SaveSoundHandle: TSaveSoundHandleFunctionPrototype;

function SaveSoundHandle(table: HHASHTABLE; parentKey: Integer; childKey: Integer; whichSound: HSOUND): Boolean;
begin
	Result:= _SaveSoundHandle(table, parentKey, childKey, whichSound);
end;

type TSaveEffectHandleFunctionPrototype = function (table: HHASHTABLE; parentKey: Int32; childKey: Int32; whichEffect: HEFFECT): LongBool; cdecl;
var _SaveEffectHandle: TSaveEffectHandleFunctionPrototype;

function SaveEffectHandle(table: HHASHTABLE; parentKey: Integer; childKey: Integer; whichEffect: HEFFECT): Boolean;
begin
	Result:= _SaveEffectHandle(table, parentKey, childKey, whichEffect);
end;

type TSaveUnitPoolHandleFunctionPrototype = function (table: HHASHTABLE; parentKey: Int32; childKey: Int32; whichUnitpool: HUNITPOOL): LongBool; cdecl;
var _SaveUnitPoolHandle: TSaveUnitPoolHandleFunctionPrototype;

function SaveUnitPoolHandle(table: HHASHTABLE; parentKey: Integer; childKey: Integer; whichUnitpool: HUNITPOOL): Boolean;
begin
	Result:= _SaveUnitPoolHandle(table, parentKey, childKey, whichUnitpool);
end;

type TSaveItemPoolHandleFunctionPrototype = function (table: HHASHTABLE; parentKey: Int32; childKey: Int32; whichItempool: HITEMPOOL): LongBool; cdecl;
var _SaveItemPoolHandle: TSaveItemPoolHandleFunctionPrototype;

function SaveItemPoolHandle(table: HHASHTABLE; parentKey: Integer; childKey: Integer; whichItempool: HITEMPOOL): Boolean;
begin
	Result:= _SaveItemPoolHandle(table, parentKey, childKey, whichItempool);
end;

type TSaveQuestHandleFunctionPrototype = function (table: HHASHTABLE; parentKey: Int32; childKey: Int32; whichQuest: HQUEST): LongBool; cdecl;
var _SaveQuestHandle: TSaveQuestHandleFunctionPrototype;

function SaveQuestHandle(table: HHASHTABLE; parentKey: Integer; childKey: Integer; whichQuest: HQUEST): Boolean;
begin
	Result:= _SaveQuestHandle(table, parentKey, childKey, whichQuest);
end;

type TSaveQuestItemHandleFunctionPrototype = function (table: HHASHTABLE; parentKey: Int32; childKey: Int32; whichQuestitem: HQUESTITEM): LongBool; cdecl;
var _SaveQuestItemHandle: TSaveQuestItemHandleFunctionPrototype;

function SaveQuestItemHandle(table: HHASHTABLE; parentKey: Integer; childKey: Integer; whichQuestitem: HQUESTITEM): Boolean;
begin
	Result:= _SaveQuestItemHandle(table, parentKey, childKey, whichQuestitem);
end;

type TSaveDefeatConditionHandleFunctionPrototype = function (table: HHASHTABLE; parentKey: Int32; childKey: Int32; whichDefeatcondition: HDEFEATCONDITION): LongBool; cdecl;
var _SaveDefeatConditionHandle: TSaveDefeatConditionHandleFunctionPrototype;

function SaveDefeatConditionHandle(table: HHASHTABLE; parentKey: Integer; childKey: Integer; whichDefeatcondition: HDEFEATCONDITION): Boolean;
begin
	Result:= _SaveDefeatConditionHandle(table, parentKey, childKey, whichDefeatcondition);
end;

type TSaveTimerDialogHandleFunctionPrototype = function (table: HHASHTABLE; parentKey: Int32; childKey: Int32; whichTimerdialog: HTIMERDIALOG): LongBool; cdecl;
var _SaveTimerDialogHandle: TSaveTimerDialogHandleFunctionPrototype;

function SaveTimerDialogHandle(table: HHASHTABLE; parentKey: Integer; childKey: Integer; whichTimerdialog: HTIMERDIALOG): Boolean;
begin
	Result:= _SaveTimerDialogHandle(table, parentKey, childKey, whichTimerdialog);
end;

type TSaveLeaderboardHandleFunctionPrototype = function (table: HHASHTABLE; parentKey: Int32; childKey: Int32; whichLeaderboard: HLEADERBOARD): LongBool; cdecl;
var _SaveLeaderboardHandle: TSaveLeaderboardHandleFunctionPrototype;

function SaveLeaderboardHandle(table: HHASHTABLE; parentKey: Integer; childKey: Integer; whichLeaderboard: HLEADERBOARD): Boolean;
begin
	Result:= _SaveLeaderboardHandle(table, parentKey, childKey, whichLeaderboard);
end;

type TSaveMultiboardHandleFunctionPrototype = function (table: HHASHTABLE; parentKey: Int32; childKey: Int32; whichMultiboard: HMULTIBOARD): LongBool; cdecl;
var _SaveMultiboardHandle: TSaveMultiboardHandleFunctionPrototype;

function SaveMultiboardHandle(table: HHASHTABLE; parentKey: Integer; childKey: Integer; whichMultiboard: HMULTIBOARD): Boolean;
begin
	Result:= _SaveMultiboardHandle(table, parentKey, childKey, whichMultiboard);
end;

type TSaveMultiboardItemHandleFunctionPrototype = function (table: HHASHTABLE; parentKey: Int32; childKey: Int32; whichMultiboarditem: HMULTIBOARDITEM): LongBool; cdecl;
var _SaveMultiboardItemHandle: TSaveMultiboardItemHandleFunctionPrototype;

function SaveMultiboardItemHandle(table: HHASHTABLE; parentKey: Integer; childKey: Integer; whichMultiboarditem: HMULTIBOARDITEM): Boolean;
begin
	Result:= _SaveMultiboardItemHandle(table, parentKey, childKey, whichMultiboarditem);
end;

type TSaveTrackableHandleFunctionPrototype = function (table: HHASHTABLE; parentKey: Int32; childKey: Int32; whichTrackable: HTRACKABLE): LongBool; cdecl;
var _SaveTrackableHandle: TSaveTrackableHandleFunctionPrototype;

function SaveTrackableHandle(table: HHASHTABLE; parentKey: Integer; childKey: Integer; whichTrackable: HTRACKABLE): Boolean;
begin
	Result:= _SaveTrackableHandle(table, parentKey, childKey, whichTrackable);
end;

type TSaveDialogHandleFunctionPrototype = function (table: HHASHTABLE; parentKey: Int32; childKey: Int32; whichDialog: HDIALOG): LongBool; cdecl;
var _SaveDialogHandle: TSaveDialogHandleFunctionPrototype;

function SaveDialogHandle(table: HHASHTABLE; parentKey: Integer; childKey: Integer; whichDialog: HDIALOG): Boolean;
begin
	Result:= _SaveDialogHandle(table, parentKey, childKey, whichDialog);
end;

type TSaveButtonHandleFunctionPrototype = function (table: HHASHTABLE; parentKey: Int32; childKey: Int32; whichButton: HBUTTON): LongBool; cdecl;
var _SaveButtonHandle: TSaveButtonHandleFunctionPrototype;

function SaveButtonHandle(table: HHASHTABLE; parentKey: Integer; childKey: Integer; whichButton: HBUTTON): Boolean;
begin
	Result:= _SaveButtonHandle(table, parentKey, childKey, whichButton);
end;

type TSaveTextTagHandleFunctionPrototype = function (table: HHASHTABLE; parentKey: Int32; childKey: Int32; whichTexttag: HTEXTTAG): LongBool; cdecl;
var _SaveTextTagHandle: TSaveTextTagHandleFunctionPrototype;

function SaveTextTagHandle(table: HHASHTABLE; parentKey: Integer; childKey: Integer; whichTexttag: HTEXTTAG): Boolean;
begin
	Result:= _SaveTextTagHandle(table, parentKey, childKey, whichTexttag);
end;

type TSaveLightningHandleFunctionPrototype = function (table: HHASHTABLE; parentKey: Int32; childKey: Int32; whichLightning: HLIGHTNING): LongBool; cdecl;
var _SaveLightningHandle: TSaveLightningHandleFunctionPrototype;

function SaveLightningHandle(table: HHASHTABLE; parentKey: Integer; childKey: Integer; whichLightning: HLIGHTNING): Boolean;
begin
	Result:= _SaveLightningHandle(table, parentKey, childKey, whichLightning);
end;

type TSaveImageHandleFunctionPrototype = function (table: HHASHTABLE; parentKey: Int32; childKey: Int32; whichImage: HIMAGE): LongBool; cdecl;
var _SaveImageHandle: TSaveImageHandleFunctionPrototype;

function SaveImageHandle(table: HHASHTABLE; parentKey: Integer; childKey: Integer; whichImage: HIMAGE): Boolean;
begin
	Result:= _SaveImageHandle(table, parentKey, childKey, whichImage);
end;

type TSaveUbersplatHandleFunctionPrototype = function (table: HHASHTABLE; parentKey: Int32; childKey: Int32; whichUbersplat: HUBERSPLAT): LongBool; cdecl;
var _SaveUbersplatHandle: TSaveUbersplatHandleFunctionPrototype;

function SaveUbersplatHandle(table: HHASHTABLE; parentKey: Integer; childKey: Integer; whichUbersplat: HUBERSPLAT): Boolean;
begin
	Result:= _SaveUbersplatHandle(table, parentKey, childKey, whichUbersplat);
end;

type TSaveRegionHandleFunctionPrototype = function (table: HHASHTABLE; parentKey: Int32; childKey: Int32; whichRegion: HREGION): LongBool; cdecl;
var _SaveRegionHandle: TSaveRegionHandleFunctionPrototype;

function SaveRegionHandle(table: HHASHTABLE; parentKey: Integer; childKey: Integer; whichRegion: HREGION): Boolean;
begin
	Result:= _SaveRegionHandle(table, parentKey, childKey, whichRegion);
end;

type TSaveFogStateHandleFunctionPrototype = function (table: HHASHTABLE; parentKey: Int32; childKey: Int32; whichFogState: HFOGSTATE): LongBool; cdecl;
var _SaveFogStateHandle: TSaveFogStateHandleFunctionPrototype;

function SaveFogStateHandle(table: HHASHTABLE; parentKey: Integer; childKey: Integer; whichFogState: HFOGSTATE): Boolean;
begin
	Result:= _SaveFogStateHandle(table, parentKey, childKey, whichFogState);
end;

type TSaveFogModifierHandleFunctionPrototype = function (table: HHASHTABLE; parentKey: Int32; childKey: Int32; whichFogModifier: HFOGMODIFIER): LongBool; cdecl;
var _SaveFogModifierHandle: TSaveFogModifierHandleFunctionPrototype;

function SaveFogModifierHandle(table: HHASHTABLE; parentKey: Integer; childKey: Integer; whichFogModifier: HFOGMODIFIER): Boolean;
begin
	Result:= _SaveFogModifierHandle(table, parentKey, childKey, whichFogModifier);
end;

type TSaveAgentHandleFunctionPrototype = function (table: HHASHTABLE; parentKey: Int32; childKey: Int32; whichAgent: HAGENT): LongBool; cdecl;
var _SaveAgentHandle: TSaveAgentHandleFunctionPrototype;

function SaveAgentHandle(table: HHASHTABLE; parentKey: Integer; childKey: Integer; whichAgent: HAGENT): Boolean;
begin
	Result:= _SaveAgentHandle(table, parentKey, childKey, whichAgent);
end;

type TSaveHashtableHandleFunctionPrototype = function (table: HHASHTABLE; parentKey: Int32; childKey: Int32; whichHashtable: HHASHTABLE): LongBool; cdecl;
var _SaveHashtableHandle: TSaveHashtableHandleFunctionPrototype;

function SaveHashtableHandle(table: HHASHTABLE; parentKey: Integer; childKey: Integer; whichHashtable: HHASHTABLE): Boolean;
begin
	Result:= _SaveHashtableHandle(table, parentKey, childKey, whichHashtable);
end;

type TLoadIntegerFunctionPrototype = function (table: HHASHTABLE; parentKey: Int32; childKey: Int32): Int32; cdecl;
var _LoadInteger: TLoadIntegerFunctionPrototype;

function LoadInteger(table: HHASHTABLE; parentKey: Integer; childKey: Integer): Integer;
begin
	Result:= _LoadInteger(table, parentKey, childKey);
end;

type TLoadRealFunctionPrototype = function (table: HHASHTABLE; parentKey: Int32; childKey: Int32): TSingle; cdecl;
var _LoadReal: TLoadRealFunctionPrototype;

function LoadReal(table: HHASHTABLE; parentKey: Integer; childKey: Integer): Single;
begin
	Result:= _LoadReal(table, parentKey, childKey).Value;
end;

type TLoadBooleanFunctionPrototype = function (table: HHASHTABLE; parentKey: Int32; childKey: Int32): LongBool; cdecl;
var _LoadBoolean: TLoadBooleanFunctionPrototype;

function LoadBoolean(table: HHASHTABLE; parentKey: Integer; childKey: Integer): Boolean;
begin
	Result:= _LoadBoolean(table, parentKey, childKey);
end;

type TLoadStrFunctionPrototype = function (table: HHASHTABLE; parentKey: Int32; childKey: Int32): TJassStringHandle; cdecl;
var _LoadStr: TLoadStrFunctionPrototype;

function LoadStr(table: HHASHTABLE; parentKey: Integer; childKey: Integer): String;
var
	hResult: TJassStringHandle;
begin
	hResult:= _LoadStr(table, parentKey, childKey);
	Result:= GetStringFromHandle(hResult);
	DecrementStringReferences(hResult);
end;

type TLoadPlayerHandleFunctionPrototype = function (table: HHASHTABLE; parentKey: Int32; childKey: Int32): HPLAYER; cdecl;
var _LoadPlayerHandle: TLoadPlayerHandleFunctionPrototype;

function LoadPlayerHandle(table: HHASHTABLE; parentKey: Integer; childKey: Integer): HPLAYER;
begin
	Result:= _LoadPlayerHandle(table, parentKey, childKey);
end;

type TLoadWidgetHandleFunctionPrototype = function (table: HHASHTABLE; parentKey: Int32; childKey: Int32): HWIDGET; cdecl;
var _LoadWidgetHandle: TLoadWidgetHandleFunctionPrototype;

function LoadWidgetHandle(table: HHASHTABLE; parentKey: Integer; childKey: Integer): HWIDGET;
begin
	Result:= _LoadWidgetHandle(table, parentKey, childKey);
end;

type TLoadDestructableHandleFunctionPrototype = function (table: HHASHTABLE; parentKey: Int32; childKey: Int32): HDESTRUCTABLE; cdecl;
var _LoadDestructableHandle: TLoadDestructableHandleFunctionPrototype;

function LoadDestructableHandle(table: HHASHTABLE; parentKey: Integer; childKey: Integer): HDESTRUCTABLE;
begin
	Result:= _LoadDestructableHandle(table, parentKey, childKey);
end;

type TLoadItemHandleFunctionPrototype = function (table: HHASHTABLE; parentKey: Int32; childKey: Int32): HITEM; cdecl;
var _LoadItemHandle: TLoadItemHandleFunctionPrototype;

function LoadItemHandle(table: HHASHTABLE; parentKey: Integer; childKey: Integer): HITEM;
begin
	Result:= _LoadItemHandle(table, parentKey, childKey);
end;

type TLoadUnitHandleFunctionPrototype = function (table: HHASHTABLE; parentKey: Int32; childKey: Int32): HUNIT; cdecl;
var _LoadUnitHandle: TLoadUnitHandleFunctionPrototype;

function LoadUnitHandle(table: HHASHTABLE; parentKey: Integer; childKey: Integer): HUNIT;
begin
	Result:= _LoadUnitHandle(table, parentKey, childKey);
end;

type TLoadAbilityHandleFunctionPrototype = function (table: HHASHTABLE; parentKey: Int32; childKey: Int32): HABILITY; cdecl;
var _LoadAbilityHandle: TLoadAbilityHandleFunctionPrototype;

function LoadAbilityHandle(table: HHASHTABLE; parentKey: Integer; childKey: Integer): HABILITY;
begin
	Result:= _LoadAbilityHandle(table, parentKey, childKey);
end;

type TLoadTimerHandleFunctionPrototype = function (table: HHASHTABLE; parentKey: Int32; childKey: Int32): HTIMER; cdecl;
var _LoadTimerHandle: TLoadTimerHandleFunctionPrototype;

function LoadTimerHandle(table: HHASHTABLE; parentKey: Integer; childKey: Integer): HTIMER;
begin
	Result:= _LoadTimerHandle(table, parentKey, childKey);
end;

type TLoadTriggerHandleFunctionPrototype = function (table: HHASHTABLE; parentKey: Int32; childKey: Int32): HTRIGGER; cdecl;
var _LoadTriggerHandle: TLoadTriggerHandleFunctionPrototype;

function LoadTriggerHandle(table: HHASHTABLE; parentKey: Integer; childKey: Integer): HTRIGGER;
begin
	Result:= _LoadTriggerHandle(table, parentKey, childKey);
end;

type TLoadTriggerConditionHandleFunctionPrototype = function (table: HHASHTABLE; parentKey: Int32; childKey: Int32): HTRIGGERCONDITION; cdecl;
var _LoadTriggerConditionHandle: TLoadTriggerConditionHandleFunctionPrototype;

function LoadTriggerConditionHandle(table: HHASHTABLE; parentKey: Integer; childKey: Integer): HTRIGGERCONDITION;
begin
	Result:= _LoadTriggerConditionHandle(table, parentKey, childKey);
end;

type TLoadTriggerActionHandleFunctionPrototype = function (table: HHASHTABLE; parentKey: Int32; childKey: Int32): HTRIGGERACTION; cdecl;
var _LoadTriggerActionHandle: TLoadTriggerActionHandleFunctionPrototype;

function LoadTriggerActionHandle(table: HHASHTABLE; parentKey: Integer; childKey: Integer): HTRIGGERACTION;
begin
	Result:= _LoadTriggerActionHandle(table, parentKey, childKey);
end;

type TLoadTriggerEventHandleFunctionPrototype = function (table: HHASHTABLE; parentKey: Int32; childKey: Int32): HEVENT; cdecl;
var _LoadTriggerEventHandle: TLoadTriggerEventHandleFunctionPrototype;

function LoadTriggerEventHandle(table: HHASHTABLE; parentKey: Integer; childKey: Integer): HEVENT;
begin
	Result:= _LoadTriggerEventHandle(table, parentKey, childKey);
end;

type TLoadForceHandleFunctionPrototype = function (table: HHASHTABLE; parentKey: Int32; childKey: Int32): HFORCE; cdecl;
var _LoadForceHandle: TLoadForceHandleFunctionPrototype;

function LoadForceHandle(table: HHASHTABLE; parentKey: Integer; childKey: Integer): HFORCE;
begin
	Result:= _LoadForceHandle(table, parentKey, childKey);
end;

type TLoadGroupHandleFunctionPrototype = function (table: HHASHTABLE; parentKey: Int32; childKey: Int32): HGROUP; cdecl;
var _LoadGroupHandle: TLoadGroupHandleFunctionPrototype;

function LoadGroupHandle(table: HHASHTABLE; parentKey: Integer; childKey: Integer): HGROUP;
begin
	Result:= _LoadGroupHandle(table, parentKey, childKey);
end;

type TLoadLocationHandleFunctionPrototype = function (table: HHASHTABLE; parentKey: Int32; childKey: Int32): HLOCATION; cdecl;
var _LoadLocationHandle: TLoadLocationHandleFunctionPrototype;

function LoadLocationHandle(table: HHASHTABLE; parentKey: Integer; childKey: Integer): HLOCATION;
begin
	Result:= _LoadLocationHandle(table, parentKey, childKey);
end;

type TLoadRectHandleFunctionPrototype = function (table: HHASHTABLE; parentKey: Int32; childKey: Int32): HRECT; cdecl;
var _LoadRectHandle: TLoadRectHandleFunctionPrototype;

function LoadRectHandle(table: HHASHTABLE; parentKey: Integer; childKey: Integer): HRECT;
begin
	Result:= _LoadRectHandle(table, parentKey, childKey);
end;

type TLoadBooleanExprHandleFunctionPrototype = function (table: HHASHTABLE; parentKey: Int32; childKey: Int32): HBOOLEXPR; cdecl;
var _LoadBooleanExprHandle: TLoadBooleanExprHandleFunctionPrototype;

function LoadBooleanExprHandle(table: HHASHTABLE; parentKey: Integer; childKey: Integer): HBOOLEXPR;
begin
	Result:= _LoadBooleanExprHandle(table, parentKey, childKey);
end;

type TLoadSoundHandleFunctionPrototype = function (table: HHASHTABLE; parentKey: Int32; childKey: Int32): HSOUND; cdecl;
var _LoadSoundHandle: TLoadSoundHandleFunctionPrototype;

function LoadSoundHandle(table: HHASHTABLE; parentKey: Integer; childKey: Integer): HSOUND;
begin
	Result:= _LoadSoundHandle(table, parentKey, childKey);
end;

type TLoadEffectHandleFunctionPrototype = function (table: HHASHTABLE; parentKey: Int32; childKey: Int32): HEFFECT; cdecl;
var _LoadEffectHandle: TLoadEffectHandleFunctionPrototype;

function LoadEffectHandle(table: HHASHTABLE; parentKey: Integer; childKey: Integer): HEFFECT;
begin
	Result:= _LoadEffectHandle(table, parentKey, childKey);
end;

type TLoadUnitPoolHandleFunctionPrototype = function (table: HHASHTABLE; parentKey: Int32; childKey: Int32): HUNITPOOL; cdecl;
var _LoadUnitPoolHandle: TLoadUnitPoolHandleFunctionPrototype;

function LoadUnitPoolHandle(table: HHASHTABLE; parentKey: Integer; childKey: Integer): HUNITPOOL;
begin
	Result:= _LoadUnitPoolHandle(table, parentKey, childKey);
end;

type TLoadItemPoolHandleFunctionPrototype = function (table: HHASHTABLE; parentKey: Int32; childKey: Int32): HITEMPOOL; cdecl;
var _LoadItemPoolHandle: TLoadItemPoolHandleFunctionPrototype;

function LoadItemPoolHandle(table: HHASHTABLE; parentKey: Integer; childKey: Integer): HITEMPOOL;
begin
	Result:= _LoadItemPoolHandle(table, parentKey, childKey);
end;

type TLoadQuestHandleFunctionPrototype = function (table: HHASHTABLE; parentKey: Int32; childKey: Int32): HQUEST; cdecl;
var _LoadQuestHandle: TLoadQuestHandleFunctionPrototype;

function LoadQuestHandle(table: HHASHTABLE; parentKey: Integer; childKey: Integer): HQUEST;
begin
	Result:= _LoadQuestHandle(table, parentKey, childKey);
end;

type TLoadQuestItemHandleFunctionPrototype = function (table: HHASHTABLE; parentKey: Int32; childKey: Int32): HQUESTITEM; cdecl;
var _LoadQuestItemHandle: TLoadQuestItemHandleFunctionPrototype;

function LoadQuestItemHandle(table: HHASHTABLE; parentKey: Integer; childKey: Integer): HQUESTITEM;
begin
	Result:= _LoadQuestItemHandle(table, parentKey, childKey);
end;

type TLoadDefeatConditionHandleFunctionPrototype = function (table: HHASHTABLE; parentKey: Int32; childKey: Int32): HDEFEATCONDITION; cdecl;
var _LoadDefeatConditionHandle: TLoadDefeatConditionHandleFunctionPrototype;

function LoadDefeatConditionHandle(table: HHASHTABLE; parentKey: Integer; childKey: Integer): HDEFEATCONDITION;
begin
	Result:= _LoadDefeatConditionHandle(table, parentKey, childKey);
end;

type TLoadTimerDialogHandleFunctionPrototype = function (table: HHASHTABLE; parentKey: Int32; childKey: Int32): HTIMERDIALOG; cdecl;
var _LoadTimerDialogHandle: TLoadTimerDialogHandleFunctionPrototype;

function LoadTimerDialogHandle(table: HHASHTABLE; parentKey: Integer; childKey: Integer): HTIMERDIALOG;
begin
	Result:= _LoadTimerDialogHandle(table, parentKey, childKey);
end;

type TLoadLeaderboardHandleFunctionPrototype = function (table: HHASHTABLE; parentKey: Int32; childKey: Int32): HLEADERBOARD; cdecl;
var _LoadLeaderboardHandle: TLoadLeaderboardHandleFunctionPrototype;

function LoadLeaderboardHandle(table: HHASHTABLE; parentKey: Integer; childKey: Integer): HLEADERBOARD;
begin
	Result:= _LoadLeaderboardHandle(table, parentKey, childKey);
end;

type TLoadMultiboardHandleFunctionPrototype = function (table: HHASHTABLE; parentKey: Int32; childKey: Int32): HMULTIBOARD; cdecl;
var _LoadMultiboardHandle: TLoadMultiboardHandleFunctionPrototype;

function LoadMultiboardHandle(table: HHASHTABLE; parentKey: Integer; childKey: Integer): HMULTIBOARD;
begin
	Result:= _LoadMultiboardHandle(table, parentKey, childKey);
end;

type TLoadMultiboardItemHandleFunctionPrototype = function (table: HHASHTABLE; parentKey: Int32; childKey: Int32): HMULTIBOARDITEM; cdecl;
var _LoadMultiboardItemHandle: TLoadMultiboardItemHandleFunctionPrototype;

function LoadMultiboardItemHandle(table: HHASHTABLE; parentKey: Integer; childKey: Integer): HMULTIBOARDITEM;
begin
	Result:= _LoadMultiboardItemHandle(table, parentKey, childKey);
end;

type TLoadTrackableHandleFunctionPrototype = function (table: HHASHTABLE; parentKey: Int32; childKey: Int32): HTRACKABLE; cdecl;
var _LoadTrackableHandle: TLoadTrackableHandleFunctionPrototype;

function LoadTrackableHandle(table: HHASHTABLE; parentKey: Integer; childKey: Integer): HTRACKABLE;
begin
	Result:= _LoadTrackableHandle(table, parentKey, childKey);
end;

type TLoadDialogHandleFunctionPrototype = function (table: HHASHTABLE; parentKey: Int32; childKey: Int32): HDIALOG; cdecl;
var _LoadDialogHandle: TLoadDialogHandleFunctionPrototype;

function LoadDialogHandle(table: HHASHTABLE; parentKey: Integer; childKey: Integer): HDIALOG;
begin
	Result:= _LoadDialogHandle(table, parentKey, childKey);
end;

type TLoadButtonHandleFunctionPrototype = function (table: HHASHTABLE; parentKey: Int32; childKey: Int32): HBUTTON; cdecl;
var _LoadButtonHandle: TLoadButtonHandleFunctionPrototype;

function LoadButtonHandle(table: HHASHTABLE; parentKey: Integer; childKey: Integer): HBUTTON;
begin
	Result:= _LoadButtonHandle(table, parentKey, childKey);
end;

type TLoadTextTagHandleFunctionPrototype = function (table: HHASHTABLE; parentKey: Int32; childKey: Int32): HTEXTTAG; cdecl;
var _LoadTextTagHandle: TLoadTextTagHandleFunctionPrototype;

function LoadTextTagHandle(table: HHASHTABLE; parentKey: Integer; childKey: Integer): HTEXTTAG;
begin
	Result:= _LoadTextTagHandle(table, parentKey, childKey);
end;

type TLoadLightningHandleFunctionPrototype = function (table: HHASHTABLE; parentKey: Int32; childKey: Int32): HLIGHTNING; cdecl;
var _LoadLightningHandle: TLoadLightningHandleFunctionPrototype;

function LoadLightningHandle(table: HHASHTABLE; parentKey: Integer; childKey: Integer): HLIGHTNING;
begin
	Result:= _LoadLightningHandle(table, parentKey, childKey);
end;

type TLoadImageHandleFunctionPrototype = function (table: HHASHTABLE; parentKey: Int32; childKey: Int32): HIMAGE; cdecl;
var _LoadImageHandle: TLoadImageHandleFunctionPrototype;

function LoadImageHandle(table: HHASHTABLE; parentKey: Integer; childKey: Integer): HIMAGE;
begin
	Result:= _LoadImageHandle(table, parentKey, childKey);
end;

type TLoadUbersplatHandleFunctionPrototype = function (table: HHASHTABLE; parentKey: Int32; childKey: Int32): HUBERSPLAT; cdecl;
var _LoadUbersplatHandle: TLoadUbersplatHandleFunctionPrototype;

function LoadUbersplatHandle(table: HHASHTABLE; parentKey: Integer; childKey: Integer): HUBERSPLAT;
begin
	Result:= _LoadUbersplatHandle(table, parentKey, childKey);
end;

type TLoadRegionHandleFunctionPrototype = function (table: HHASHTABLE; parentKey: Int32; childKey: Int32): HREGION; cdecl;
var _LoadRegionHandle: TLoadRegionHandleFunctionPrototype;

function LoadRegionHandle(table: HHASHTABLE; parentKey: Integer; childKey: Integer): HREGION;
begin
	Result:= _LoadRegionHandle(table, parentKey, childKey);
end;

type TLoadFogStateHandleFunctionPrototype = function (table: HHASHTABLE; parentKey: Int32; childKey: Int32): HFOGSTATE; cdecl;
var _LoadFogStateHandle: TLoadFogStateHandleFunctionPrototype;

function LoadFogStateHandle(table: HHASHTABLE; parentKey: Integer; childKey: Integer): HFOGSTATE;
begin
	Result:= _LoadFogStateHandle(table, parentKey, childKey);
end;

type TLoadFogModifierHandleFunctionPrototype = function (table: HHASHTABLE; parentKey: Int32; childKey: Int32): HFOGMODIFIER; cdecl;
var _LoadFogModifierHandle: TLoadFogModifierHandleFunctionPrototype;

function LoadFogModifierHandle(table: HHASHTABLE; parentKey: Integer; childKey: Integer): HFOGMODIFIER;
begin
	Result:= _LoadFogModifierHandle(table, parentKey, childKey);
end;

type TLoadHashtableHandleFunctionPrototype = function (table: HHASHTABLE; parentKey: Int32; childKey: Int32): HHASHTABLE; cdecl;
var _LoadHashtableHandle: TLoadHashtableHandleFunctionPrototype;

function LoadHashtableHandle(table: HHASHTABLE; parentKey: Integer; childKey: Integer): HHASHTABLE;
begin
	Result:= _LoadHashtableHandle(table, parentKey, childKey);
end;

type THaveSavedIntegerFunctionPrototype = function (table: HHASHTABLE; parentKey: Int32; childKey: Int32): LongBool; cdecl;
var _HaveSavedInteger: THaveSavedIntegerFunctionPrototype;

function HaveSavedInteger(table: HHASHTABLE; parentKey: Integer; childKey: Integer): Boolean;
begin
	Result:= _HaveSavedInteger(table, parentKey, childKey);
end;

type THaveSavedRealFunctionPrototype = function (table: HHASHTABLE; parentKey: Int32; childKey: Int32): LongBool; cdecl;
var _HaveSavedReal: THaveSavedRealFunctionPrototype;

function HaveSavedReal(table: HHASHTABLE; parentKey: Integer; childKey: Integer): Boolean;
begin
	Result:= _HaveSavedReal(table, parentKey, childKey);
end;

type THaveSavedBooleanFunctionPrototype = function (table: HHASHTABLE; parentKey: Int32; childKey: Int32): LongBool; cdecl;
var _HaveSavedBoolean: THaveSavedBooleanFunctionPrototype;

function HaveSavedBoolean(table: HHASHTABLE; parentKey: Integer; childKey: Integer): Boolean;
begin
	Result:= _HaveSavedBoolean(table, parentKey, childKey);
end;

type THaveSavedStringFunctionPrototype = function (table: HHASHTABLE; parentKey: Int32; childKey: Int32): LongBool; cdecl;
var _HaveSavedString: THaveSavedStringFunctionPrototype;

function HaveSavedString(table: HHASHTABLE; parentKey: Integer; childKey: Integer): Boolean;
begin
	Result:= _HaveSavedString(table, parentKey, childKey);
end;

type THaveSavedHandleFunctionPrototype = function (table: HHASHTABLE; parentKey: Int32; childKey: Int32): LongBool; cdecl;
var _HaveSavedHandle: THaveSavedHandleFunctionPrototype;

function HaveSavedHandle(table: HHASHTABLE; parentKey: Integer; childKey: Integer): Boolean;
begin
	Result:= _HaveSavedHandle(table, parentKey, childKey);
end;

type TRemoveSavedIntegerFunctionPrototype = procedure (table: HHASHTABLE; parentKey: Int32; childKey: Int32); cdecl;
var _RemoveSavedInteger: TRemoveSavedIntegerFunctionPrototype;

procedure RemoveSavedInteger(table: HHASHTABLE; parentKey: Integer; childKey: Integer);
begin
	_RemoveSavedInteger(table, parentKey, childKey);
end;

type TRemoveSavedRealFunctionPrototype = procedure (table: HHASHTABLE; parentKey: Int32; childKey: Int32); cdecl;
var _RemoveSavedReal: TRemoveSavedRealFunctionPrototype;

procedure RemoveSavedReal(table: HHASHTABLE; parentKey: Integer; childKey: Integer);
begin
	_RemoveSavedReal(table, parentKey, childKey);
end;

type TRemoveSavedBooleanFunctionPrototype = procedure (table: HHASHTABLE; parentKey: Int32; childKey: Int32); cdecl;
var _RemoveSavedBoolean: TRemoveSavedBooleanFunctionPrototype;

procedure RemoveSavedBoolean(table: HHASHTABLE; parentKey: Integer; childKey: Integer);
begin
	_RemoveSavedBoolean(table, parentKey, childKey);
end;

type TRemoveSavedStringFunctionPrototype = procedure (table: HHASHTABLE; parentKey: Int32; childKey: Int32); cdecl;
var _RemoveSavedString: TRemoveSavedStringFunctionPrototype;

procedure RemoveSavedString(table: HHASHTABLE; parentKey: Integer; childKey: Integer);
begin
	_RemoveSavedString(table, parentKey, childKey);
end;

type TRemoveSavedHandleFunctionPrototype = procedure (table: HHASHTABLE; parentKey: Int32; childKey: Int32); cdecl;
var _RemoveSavedHandle: TRemoveSavedHandleFunctionPrototype;

procedure RemoveSavedHandle(table: HHASHTABLE; parentKey: Integer; childKey: Integer);
begin
	_RemoveSavedHandle(table, parentKey, childKey);
end;

type TFlushParentHashtableFunctionPrototype = procedure (table: HHASHTABLE); cdecl;
var _FlushParentHashtable: TFlushParentHashtableFunctionPrototype;

procedure FlushParentHashtable(table: HHASHTABLE);
begin
	_FlushParentHashtable(table);
end;

type TFlushChildHashtableFunctionPrototype = procedure (table: HHASHTABLE; parentKey: Int32); cdecl;
var _FlushChildHashtable: TFlushChildHashtableFunctionPrototype;

procedure FlushChildHashtable(table: HHASHTABLE; parentKey: Integer);
begin
	_FlushChildHashtable(table, parentKey);
end;

type TGetRandomIntFunctionPrototype = function (lowBound: Int32; highBound: Int32): Int32; cdecl;
var _GetRandomInt: TGetRandomIntFunctionPrototype;

function GetRandomInt(lowBound: Integer; highBound: Integer): Integer;
begin
	Result:= _GetRandomInt(lowBound, highBound);
end;

type TGetRandomRealFunctionPrototype = function (lowBound: PSingle; highBound: PSingle): TSingle; cdecl;
var _GetRandomReal: TGetRandomRealFunctionPrototype;

function GetRandomReal(lowBound: Single; highBound: Single): Single;
begin
	Result:= _GetRandomReal(@lowBound, @highBound).Value;
end;

type TCreateUnitPoolFunctionPrototype = function: HUNITPOOL; cdecl;
var _CreateUnitPool: TCreateUnitPoolFunctionPrototype;

function CreateUnitPool: HUNITPOOL;
begin
	Result:= _CreateUnitPool();
end;

type TDestroyUnitPoolFunctionPrototype = procedure (whichPool: HUNITPOOL); cdecl;
var _DestroyUnitPool: TDestroyUnitPoolFunctionPrototype;

procedure DestroyUnitPool(whichPool: HUNITPOOL);
begin
	_DestroyUnitPool(whichPool);
end;

type TUnitPoolAddUnitTypeFunctionPrototype = procedure (whichPool: HUNITPOOL; unitId: Int32; weight: PSingle); cdecl;
var _UnitPoolAddUnitType: TUnitPoolAddUnitTypeFunctionPrototype;

procedure UnitPoolAddUnitType(whichPool: HUNITPOOL; unitId: Integer; weight: Single);
begin
	_UnitPoolAddUnitType(whichPool, unitId, @weight);
end;

type TUnitPoolRemoveUnitTypeFunctionPrototype = procedure (whichPool: HUNITPOOL; unitId: Int32); cdecl;
var _UnitPoolRemoveUnitType: TUnitPoolRemoveUnitTypeFunctionPrototype;

procedure UnitPoolRemoveUnitType(whichPool: HUNITPOOL; unitId: Integer);
begin
	_UnitPoolRemoveUnitType(whichPool, unitId);
end;

type TPlaceRandomUnitFunctionPrototype = function (whichPool: HUNITPOOL; forWhichPlayer: HPLAYER; x: PSingle; y: PSingle; facing: PSingle): HUNIT; cdecl;
var _PlaceRandomUnit: TPlaceRandomUnitFunctionPrototype;

function PlaceRandomUnit(whichPool: HUNITPOOL; forWhichPlayer: HPLAYER; x: Single; y: Single; facing: Single): HUNIT;
begin
	Result:= _PlaceRandomUnit(whichPool, forWhichPlayer, @x, @y, @facing);
end;

type TCreateItemPoolFunctionPrototype = function: HITEMPOOL; cdecl;
var _CreateItemPool: TCreateItemPoolFunctionPrototype;

function CreateItemPool: HITEMPOOL;
begin
	Result:= _CreateItemPool();
end;

type TDestroyItemPoolFunctionPrototype = procedure (whichItemPool: HITEMPOOL); cdecl;
var _DestroyItemPool: TDestroyItemPoolFunctionPrototype;

procedure DestroyItemPool(whichItemPool: HITEMPOOL);
begin
	_DestroyItemPool(whichItemPool);
end;

type TItemPoolAddItemTypeFunctionPrototype = procedure (whichItemPool: HITEMPOOL; itemId: Int32; weight: PSingle); cdecl;
var _ItemPoolAddItemType: TItemPoolAddItemTypeFunctionPrototype;

procedure ItemPoolAddItemType(whichItemPool: HITEMPOOL; itemId: Integer; weight: Single);
begin
	_ItemPoolAddItemType(whichItemPool, itemId, @weight);
end;

type TItemPoolRemoveItemTypeFunctionPrototype = procedure (whichItemPool: HITEMPOOL; itemId: Int32); cdecl;
var _ItemPoolRemoveItemType: TItemPoolRemoveItemTypeFunctionPrototype;

procedure ItemPoolRemoveItemType(whichItemPool: HITEMPOOL; itemId: Integer);
begin
	_ItemPoolRemoveItemType(whichItemPool, itemId);
end;

type TPlaceRandomItemFunctionPrototype = function (whichItemPool: HITEMPOOL; x: PSingle; y: PSingle): HITEM; cdecl;
var _PlaceRandomItem: TPlaceRandomItemFunctionPrototype;

function PlaceRandomItem(whichItemPool: HITEMPOOL; x: Single; y: Single): HITEM;
begin
	Result:= _PlaceRandomItem(whichItemPool, @x, @y);
end;

type TChooseRandomCreepFunctionPrototype = function (level: Int32): Int32; cdecl;
var _ChooseRandomCreep: TChooseRandomCreepFunctionPrototype;

function ChooseRandomCreep(level: Integer): Integer;
begin
	Result:= _ChooseRandomCreep(level);
end;

type TChooseRandomNPBuildingFunctionPrototype = function: Int32; cdecl;
var _ChooseRandomNPBuilding: TChooseRandomNPBuildingFunctionPrototype;

function ChooseRandomNPBuilding: Integer;
begin
	Result:= _ChooseRandomNPBuilding();
end;

type TChooseRandomItemFunctionPrototype = function (level: Int32): Int32; cdecl;
var _ChooseRandomItem: TChooseRandomItemFunctionPrototype;

function ChooseRandomItem(level: Integer): Integer;
begin
	Result:= _ChooseRandomItem(level);
end;

type TChooseRandomItemExFunctionPrototype = function (whichType: HITEMTYPE; level: Int32): Int32; cdecl;
var _ChooseRandomItemEx: TChooseRandomItemExFunctionPrototype;

function ChooseRandomItemEx(whichType: HITEMTYPE; level: Integer): Integer;
begin
	Result:= _ChooseRandomItemEx(whichType, level);
end;

type TSetRandomSeedFunctionPrototype = procedure (seed: Int32); cdecl;
var _SetRandomSeed: TSetRandomSeedFunctionPrototype;

procedure SetRandomSeed(seed: Integer);
begin
	_SetRandomSeed(seed);
end;

type TSetTerrainFogFunctionPrototype = procedure (a: PSingle; b: PSingle; c: PSingle; d: PSingle; e: PSingle); cdecl;
var _SetTerrainFog: TSetTerrainFogFunctionPrototype;

procedure SetTerrainFog(a: Single; b: Single; c: Single; d: Single; e: Single);
begin
	_SetTerrainFog(@a, @b, @c, @d, @e);
end;

type TResetTerrainFogFunctionPrototype = procedure; cdecl;
var _ResetTerrainFog: TResetTerrainFogFunctionPrototype;

procedure ResetTerrainFog;
begin
	_ResetTerrainFog();
end;

type TSetUnitFogFunctionPrototype = procedure (a: PSingle; b: PSingle; c: PSingle; d: PSingle; e: PSingle); cdecl;
var _SetUnitFog: TSetUnitFogFunctionPrototype;

procedure SetUnitFog(a: Single; b: Single; c: Single; d: Single; e: Single);
begin
	_SetUnitFog(@a, @b, @c, @d, @e);
end;

type TSetTerrainFogExFunctionPrototype = procedure (style: Int32; zstart: PSingle; zend: PSingle; density: PSingle; red: PSingle; green: PSingle; blue: PSingle); cdecl;
var _SetTerrainFogEx: TSetTerrainFogExFunctionPrototype;

procedure SetTerrainFogEx(style: Integer; zstart: Single; zend: Single; density: Single; red: Single; green: Single; blue: Single);
begin
	_SetTerrainFogEx(style, @zstart, @zend, @density, @red, @green, @blue);
end;

type TDisplayTextToPlayerFunctionPrototype = procedure (toPlayer: HPLAYER; x: PSingle; y: PSingle; message: PJassString); cdecl;
var _DisplayTextToPlayer: TDisplayTextToPlayerFunctionPrototype;

procedure DisplayTextToPlayer(toPlayer: HPLAYER; x: Single; y: Single; message: String);
var
	jmessage: PJassString;
begin
	jmessage:= CreateJassString(PChar(message));
	_DisplayTextToPlayer(toPlayer, @x, @y, jmessage);
	DestroyJassString(jmessage);
end;

type TDisplayTimedTextToPlayerFunctionPrototype = procedure (toPlayer: HPLAYER; x: PSingle; y: PSingle; duration: PSingle; message: PJassString); cdecl;
var _DisplayTimedTextToPlayer: TDisplayTimedTextToPlayerFunctionPrototype;

procedure DisplayTimedTextToPlayer(toPlayer: HPLAYER; x: Single; y: Single; duration: Single; message: String);
var
	jmessage: PJassString;
begin
	jmessage:= CreateJassString(PChar(message));
	_DisplayTimedTextToPlayer(toPlayer, @x, @y, @duration, jmessage);
	DestroyJassString(jmessage);
end;

type TDisplayTimedTextFromPlayerFunctionPrototype = procedure (toPlayer: HPLAYER; x: PSingle; y: PSingle; duration: PSingle; message: PJassString); cdecl;
var _DisplayTimedTextFromPlayer: TDisplayTimedTextFromPlayerFunctionPrototype;

procedure DisplayTimedTextFromPlayer(toPlayer: HPLAYER; x: Single; y: Single; duration: Single; message: String);
var
	jmessage: PJassString;
begin
	jmessage:= CreateJassString(PChar(message));
	_DisplayTimedTextFromPlayer(toPlayer, @x, @y, @duration, jmessage);
	DestroyJassString(jmessage);
end;

type TClearTextMessagesFunctionPrototype = procedure; cdecl;
var _ClearTextMessages: TClearTextMessagesFunctionPrototype;

procedure ClearTextMessages;
begin
	_ClearTextMessages();
end;

type TSetDayNightModelsFunctionPrototype = procedure (terrainDNCFile: PJassString; unitDNCFile: PJassString); cdecl;
var _SetDayNightModels: TSetDayNightModelsFunctionPrototype;

procedure SetDayNightModels(terrainDNCFile: String; unitDNCFile: String);
var
	jterrainDNCFile: PJassString;
	junitDNCFile: PJassString;
begin
	jterrainDNCFile:= CreateJassString(PChar(terrainDNCFile));
	junitDNCFile:= CreateJassString(PChar(unitDNCFile));
	_SetDayNightModels(jterrainDNCFile, junitDNCFile);
	DestroyJassString(jterrainDNCFile);
	DestroyJassString(junitDNCFile);
end;

type TSetSkyModelFunctionPrototype = procedure (skyModelFile: PJassString); cdecl;
var _SetSkyModel: TSetSkyModelFunctionPrototype;

procedure SetSkyModel(skyModelFile: String);
var
	jskyModelFile: PJassString;
begin
	jskyModelFile:= CreateJassString(PChar(skyModelFile));
	_SetSkyModel(jskyModelFile);
	DestroyJassString(jskyModelFile);
end;

type TEnableUserControlFunctionPrototype = procedure (b: LongBool); cdecl;
var _EnableUserControl: TEnableUserControlFunctionPrototype;

procedure EnableUserControl(b: Boolean);
begin
	_EnableUserControl(b);
end;

type TEnableUserUIFunctionPrototype = procedure (b: LongBool); cdecl;
var _EnableUserUI: TEnableUserUIFunctionPrototype;

procedure EnableUserUI(b: Boolean);
begin
	_EnableUserUI(b);
end;

type TSuspendTimeOfDayFunctionPrototype = procedure (b: LongBool); cdecl;
var _SuspendTimeOfDay: TSuspendTimeOfDayFunctionPrototype;

procedure SuspendTimeOfDay(b: Boolean);
begin
	_SuspendTimeOfDay(b);
end;

type TSetTimeOfDayScaleFunctionPrototype = procedure (r: PSingle); cdecl;
var _SetTimeOfDayScale: TSetTimeOfDayScaleFunctionPrototype;

procedure SetTimeOfDayScale(r: Single);
begin
	_SetTimeOfDayScale(@r);
end;

type TGetTimeOfDayScaleFunctionPrototype = function: TSingle; cdecl;
var _GetTimeOfDayScale: TGetTimeOfDayScaleFunctionPrototype;

function GetTimeOfDayScale: Single;
begin
	Result:= _GetTimeOfDayScale().Value;
end;

type TShowInterfaceFunctionPrototype = procedure (flag: LongBool; fadeDuration: PSingle); cdecl;
var _ShowInterface: TShowInterfaceFunctionPrototype;

procedure ShowInterface(flag: Boolean; fadeDuration: Single);
begin
	_ShowInterface(flag, @fadeDuration);
end;

type TPauseGameFunctionPrototype = procedure (flag: LongBool); cdecl;
var _PauseGame: TPauseGameFunctionPrototype;

procedure PauseGame(flag: Boolean);
begin
	_PauseGame(flag);
end;

type TUnitAddIndicatorFunctionPrototype = procedure (whichUnit: HUNIT; red: Int32; green: Int32; blue: Int32; alpha: Int32); cdecl;
var _UnitAddIndicator: TUnitAddIndicatorFunctionPrototype;

procedure UnitAddIndicator(whichUnit: HUNIT; red: Integer; green: Integer; blue: Integer; alpha: Integer);
begin
	_UnitAddIndicator(whichUnit, red, green, blue, alpha);
end;

type TAddIndicatorFunctionPrototype = procedure (whichWidget: HWIDGET; red: Int32; green: Int32; blue: Int32; alpha: Int32); cdecl;
var _AddIndicator: TAddIndicatorFunctionPrototype;

procedure AddIndicator(whichWidget: HWIDGET; red: Integer; green: Integer; blue: Integer; alpha: Integer);
begin
	_AddIndicator(whichWidget, red, green, blue, alpha);
end;

type TPingMinimapFunctionPrototype = procedure (x: PSingle; y: PSingle; duration: PSingle); cdecl;
var _PingMinimap: TPingMinimapFunctionPrototype;

procedure PingMinimap(x: Single; y: Single; duration: Single);
begin
	_PingMinimap(@x, @y, @duration);
end;

type TPingMinimapExFunctionPrototype = procedure (x: PSingle; y: PSingle; duration: PSingle; red: Int32; green: Int32; blue: Int32; extraEffects: LongBool); cdecl;
var _PingMinimapEx: TPingMinimapExFunctionPrototype;

procedure PingMinimapEx(x: Single; y: Single; duration: Single; red: Integer; green: Integer; blue: Integer; extraEffects: Boolean);
begin
	_PingMinimapEx(@x, @y, @duration, red, green, blue, extraEffects);
end;

type TEnableOcclusionFunctionPrototype = procedure (flag: LongBool); cdecl;
var _EnableOcclusion: TEnableOcclusionFunctionPrototype;

procedure EnableOcclusion(flag: Boolean);
begin
	_EnableOcclusion(flag);
end;

type TSetIntroShotTextFunctionPrototype = procedure (introText: PJassString); cdecl;
var _SetIntroShotText: TSetIntroShotTextFunctionPrototype;

procedure SetIntroShotText(introText: String);
var
	jintroText: PJassString;
begin
	jintroText:= CreateJassString(PChar(introText));
	_SetIntroShotText(jintroText);
	DestroyJassString(jintroText);
end;

type TSetIntroShotModelFunctionPrototype = procedure (introModelPath: PJassString); cdecl;
var _SetIntroShotModel: TSetIntroShotModelFunctionPrototype;

procedure SetIntroShotModel(introModelPath: String);
var
	jintroModelPath: PJassString;
begin
	jintroModelPath:= CreateJassString(PChar(introModelPath));
	_SetIntroShotModel(jintroModelPath);
	DestroyJassString(jintroModelPath);
end;

type TEnableWorldFogBoundaryFunctionPrototype = procedure (b: LongBool); cdecl;
var _EnableWorldFogBoundary: TEnableWorldFogBoundaryFunctionPrototype;

procedure EnableWorldFogBoundary(b: Boolean);
begin
	_EnableWorldFogBoundary(b);
end;

type TPlayModelCinematicFunctionPrototype = procedure (modelName: PJassString); cdecl;
var _PlayModelCinematic: TPlayModelCinematicFunctionPrototype;

procedure PlayModelCinematic(modelName: String);
var
	jmodelName: PJassString;
begin
	jmodelName:= CreateJassString(PChar(modelName));
	_PlayModelCinematic(jmodelName);
	DestroyJassString(jmodelName);
end;

type TPlayCinematicFunctionPrototype = procedure (movieName: PJassString); cdecl;
var _PlayCinematic: TPlayCinematicFunctionPrototype;

procedure PlayCinematic(movieName: String);
var
	jmovieName: PJassString;
begin
	jmovieName:= CreateJassString(PChar(movieName));
	_PlayCinematic(jmovieName);
	DestroyJassString(jmovieName);
end;

type TForceUIKeyFunctionPrototype = procedure (key: PJassString); cdecl;
var _ForceUIKey: TForceUIKeyFunctionPrototype;

procedure ForceUIKey(key: String);
var
	jkey: PJassString;
begin
	jkey:= CreateJassString(PChar(key));
	_ForceUIKey(jkey);
	DestroyJassString(jkey);
end;

type TForceUICancelFunctionPrototype = procedure; cdecl;
var _ForceUICancel: TForceUICancelFunctionPrototype;

procedure ForceUICancel;
begin
	_ForceUICancel();
end;

type TDisplayLoadDialogFunctionPrototype = procedure; cdecl;
var _DisplayLoadDialog: TDisplayLoadDialogFunctionPrototype;

procedure DisplayLoadDialog;
begin
	_DisplayLoadDialog();
end;

type TSetAltMinimapIconFunctionPrototype = procedure (iconPath: PJassString); cdecl;
var _SetAltMinimapIcon: TSetAltMinimapIconFunctionPrototype;

procedure SetAltMinimapIcon(iconPath: String);
var
	jiconPath: PJassString;
begin
	jiconPath:= CreateJassString(PChar(iconPath));
	_SetAltMinimapIcon(jiconPath);
	DestroyJassString(jiconPath);
end;

type TDisableRestartMissionFunctionPrototype = procedure (flag: LongBool); cdecl;
var _DisableRestartMission: TDisableRestartMissionFunctionPrototype;

procedure DisableRestartMission(flag: Boolean);
begin
	_DisableRestartMission(flag);
end;

type TCreateTextTagFunctionPrototype = function: HTEXTTAG; cdecl;
var _CreateTextTag: TCreateTextTagFunctionPrototype;

function CreateTextTag: HTEXTTAG;
begin
	Result:= _CreateTextTag();
end;

type TDestroyTextTagFunctionPrototype = procedure (t: HTEXTTAG); cdecl;
var _DestroyTextTag: TDestroyTextTagFunctionPrototype;

procedure DestroyTextTag(t: HTEXTTAG);
begin
	_DestroyTextTag(t);
end;

type TSetTextTagTextFunctionPrototype = procedure (t: HTEXTTAG; s: PJassString; height: PSingle); cdecl;
var _SetTextTagText: TSetTextTagTextFunctionPrototype;

procedure SetTextTagText(t: HTEXTTAG; s: String; height: Single);
var
	js: PJassString;
begin
	js:= CreateJassString(PChar(s));
	_SetTextTagText(t, js, @height);
	DestroyJassString(js);
end;

type TSetTextTagPosFunctionPrototype = procedure (t: HTEXTTAG; x: PSingle; y: PSingle; heightOffset: PSingle); cdecl;
var _SetTextTagPos: TSetTextTagPosFunctionPrototype;

procedure SetTextTagPos(t: HTEXTTAG; x: Single; y: Single; heightOffset: Single);
begin
	_SetTextTagPos(t, @x, @y, @heightOffset);
end;

type TSetTextTagPosUnitFunctionPrototype = procedure (t: HTEXTTAG; whichUnit: HUNIT; heightOffset: PSingle); cdecl;
var _SetTextTagPosUnit: TSetTextTagPosUnitFunctionPrototype;

procedure SetTextTagPosUnit(t: HTEXTTAG; whichUnit: HUNIT; heightOffset: Single);
begin
	_SetTextTagPosUnit(t, whichUnit, @heightOffset);
end;

type TSetTextTagColorFunctionPrototype = procedure (t: HTEXTTAG; red: Int32; green: Int32; blue: Int32; alpha: Int32); cdecl;
var _SetTextTagColor: TSetTextTagColorFunctionPrototype;

procedure SetTextTagColor(t: HTEXTTAG; red: Integer; green: Integer; blue: Integer; alpha: Integer);
begin
	_SetTextTagColor(t, red, green, blue, alpha);
end;

type TSetTextTagVelocityFunctionPrototype = procedure (t: HTEXTTAG; xvel: PSingle; yvel: PSingle); cdecl;
var _SetTextTagVelocity: TSetTextTagVelocityFunctionPrototype;

procedure SetTextTagVelocity(t: HTEXTTAG; xvel: Single; yvel: Single);
begin
	_SetTextTagVelocity(t, @xvel, @yvel);
end;

type TSetTextTagVisibilityFunctionPrototype = procedure (t: HTEXTTAG; flag: LongBool); cdecl;
var _SetTextTagVisibility: TSetTextTagVisibilityFunctionPrototype;

procedure SetTextTagVisibility(t: HTEXTTAG; flag: Boolean);
begin
	_SetTextTagVisibility(t, flag);
end;

type TSetTextTagSuspendedFunctionPrototype = procedure (t: HTEXTTAG; flag: LongBool); cdecl;
var _SetTextTagSuspended: TSetTextTagSuspendedFunctionPrototype;

procedure SetTextTagSuspended(t: HTEXTTAG; flag: Boolean);
begin
	_SetTextTagSuspended(t, flag);
end;

type TSetTextTagPermanentFunctionPrototype = procedure (t: HTEXTTAG; flag: LongBool); cdecl;
var _SetTextTagPermanent: TSetTextTagPermanentFunctionPrototype;

procedure SetTextTagPermanent(t: HTEXTTAG; flag: Boolean);
begin
	_SetTextTagPermanent(t, flag);
end;

type TSetTextTagAgeFunctionPrototype = procedure (t: HTEXTTAG; age: PSingle); cdecl;
var _SetTextTagAge: TSetTextTagAgeFunctionPrototype;

procedure SetTextTagAge(t: HTEXTTAG; age: Single);
begin
	_SetTextTagAge(t, @age);
end;

type TSetTextTagLifespanFunctionPrototype = procedure (t: HTEXTTAG; lifespan: PSingle); cdecl;
var _SetTextTagLifespan: TSetTextTagLifespanFunctionPrototype;

procedure SetTextTagLifespan(t: HTEXTTAG; lifespan: Single);
begin
	_SetTextTagLifespan(t, @lifespan);
end;

type TSetTextTagFadepointFunctionPrototype = procedure (t: HTEXTTAG; fadepoint: PSingle); cdecl;
var _SetTextTagFadepoint: TSetTextTagFadepointFunctionPrototype;

procedure SetTextTagFadepoint(t: HTEXTTAG; fadepoint: Single);
begin
	_SetTextTagFadepoint(t, @fadepoint);
end;

type TSetReservedLocalHeroButtonsFunctionPrototype = procedure (reserved: Int32); cdecl;
var _SetReservedLocalHeroButtons: TSetReservedLocalHeroButtonsFunctionPrototype;

procedure SetReservedLocalHeroButtons(reserved: Integer);
begin
	_SetReservedLocalHeroButtons(reserved);
end;

type TGetAllyColorFilterStateFunctionPrototype = function: Int32; cdecl;
var _GetAllyColorFilterState: TGetAllyColorFilterStateFunctionPrototype;

function GetAllyColorFilterState: Integer;
begin
	Result:= _GetAllyColorFilterState();
end;

type TSetAllyColorFilterStateFunctionPrototype = procedure (state: Int32); cdecl;
var _SetAllyColorFilterState: TSetAllyColorFilterStateFunctionPrototype;

procedure SetAllyColorFilterState(state: Integer);
begin
	_SetAllyColorFilterState(state);
end;

type TGetCreepCampFilterStateFunctionPrototype = function: LongBool; cdecl;
var _GetCreepCampFilterState: TGetCreepCampFilterStateFunctionPrototype;

function GetCreepCampFilterState: Boolean;
begin
	Result:= _GetCreepCampFilterState();
end;

type TSetCreepCampFilterStateFunctionPrototype = procedure (state: LongBool); cdecl;
var _SetCreepCampFilterState: TSetCreepCampFilterStateFunctionPrototype;

procedure SetCreepCampFilterState(state: Boolean);
begin
	_SetCreepCampFilterState(state);
end;

type TEnableMinimapFilterButtonsFunctionPrototype = procedure (enableAlly: LongBool; enableCreep: LongBool); cdecl;
var _EnableMinimapFilterButtons: TEnableMinimapFilterButtonsFunctionPrototype;

procedure EnableMinimapFilterButtons(enableAlly: Boolean; enableCreep: Boolean);
begin
	_EnableMinimapFilterButtons(enableAlly, enableCreep);
end;

type TEnableDragSelectFunctionPrototype = procedure (state: LongBool; ui: LongBool); cdecl;
var _EnableDragSelect: TEnableDragSelectFunctionPrototype;

procedure EnableDragSelect(state: Boolean; ui: Boolean);
begin
	_EnableDragSelect(state, ui);
end;

type TEnablePreSelectFunctionPrototype = procedure (state: LongBool; ui: LongBool); cdecl;
var _EnablePreSelect: TEnablePreSelectFunctionPrototype;

procedure EnablePreSelect(state: Boolean; ui: Boolean);
begin
	_EnablePreSelect(state, ui);
end;

type TEnableSelectFunctionPrototype = procedure (state: LongBool; ui: LongBool); cdecl;
var _EnableSelect: TEnableSelectFunctionPrototype;

procedure EnableSelect(state: Boolean; ui: Boolean);
begin
	_EnableSelect(state, ui);
end;

type TCreateTrackableFunctionPrototype = function (trackableModelPath: PJassString; x: PSingle; y: PSingle; facing: PSingle): HTRACKABLE; cdecl;
var _CreateTrackable: TCreateTrackableFunctionPrototype;

function CreateTrackable(trackableModelPath: String; x: Single; y: Single; facing: Single): HTRACKABLE;
var
	jtrackableModelPath: PJassString;
begin
	jtrackableModelPath:= CreateJassString(PChar(trackableModelPath));
	Result:= _CreateTrackable(jtrackableModelPath, @x, @y, @facing);
	DestroyJassString(jtrackableModelPath);
end;

type TCreateQuestFunctionPrototype = function: HQUEST; cdecl;
var _CreateQuest: TCreateQuestFunctionPrototype;

function CreateQuest: HQUEST;
begin
	Result:= _CreateQuest();
end;

type TDestroyQuestFunctionPrototype = procedure (whichQuest: HQUEST); cdecl;
var _DestroyQuest: TDestroyQuestFunctionPrototype;

procedure DestroyQuest(whichQuest: HQUEST);
begin
	_DestroyQuest(whichQuest);
end;

type TQuestSetTitleFunctionPrototype = procedure (whichQuest: HQUEST; title: PJassString); cdecl;
var _QuestSetTitle: TQuestSetTitleFunctionPrototype;

procedure QuestSetTitle(whichQuest: HQUEST; title: String);
var
	jtitle: PJassString;
begin
	jtitle:= CreateJassString(PChar(title));
	_QuestSetTitle(whichQuest, jtitle);
	DestroyJassString(jtitle);
end;

type TQuestSetDescriptionFunctionPrototype = procedure (whichQuest: HQUEST; description: PJassString); cdecl;
var _QuestSetDescription: TQuestSetDescriptionFunctionPrototype;

procedure QuestSetDescription(whichQuest: HQUEST; description: String);
var
	jdescription: PJassString;
begin
	jdescription:= CreateJassString(PChar(description));
	_QuestSetDescription(whichQuest, jdescription);
	DestroyJassString(jdescription);
end;

type TQuestSetIconPathFunctionPrototype = procedure (whichQuest: HQUEST; iconPath: PJassString); cdecl;
var _QuestSetIconPath: TQuestSetIconPathFunctionPrototype;

procedure QuestSetIconPath(whichQuest: HQUEST; iconPath: String);
var
	jiconPath: PJassString;
begin
	jiconPath:= CreateJassString(PChar(iconPath));
	_QuestSetIconPath(whichQuest, jiconPath);
	DestroyJassString(jiconPath);
end;

type TQuestSetRequiredFunctionPrototype = procedure (whichQuest: HQUEST; required: LongBool); cdecl;
var _QuestSetRequired: TQuestSetRequiredFunctionPrototype;

procedure QuestSetRequired(whichQuest: HQUEST; required: Boolean);
begin
	_QuestSetRequired(whichQuest, required);
end;

type TQuestSetCompletedFunctionPrototype = procedure (whichQuest: HQUEST; completed: LongBool); cdecl;
var _QuestSetCompleted: TQuestSetCompletedFunctionPrototype;

procedure QuestSetCompleted(whichQuest: HQUEST; completed: Boolean);
begin
	_QuestSetCompleted(whichQuest, completed);
end;

type TQuestSetDiscoveredFunctionPrototype = procedure (whichQuest: HQUEST; discovered: LongBool); cdecl;
var _QuestSetDiscovered: TQuestSetDiscoveredFunctionPrototype;

procedure QuestSetDiscovered(whichQuest: HQUEST; discovered: Boolean);
begin
	_QuestSetDiscovered(whichQuest, discovered);
end;

type TQuestSetFailedFunctionPrototype = procedure (whichQuest: HQUEST; failed: LongBool); cdecl;
var _QuestSetFailed: TQuestSetFailedFunctionPrototype;

procedure QuestSetFailed(whichQuest: HQUEST; failed: Boolean);
begin
	_QuestSetFailed(whichQuest, failed);
end;

type TQuestSetEnabledFunctionPrototype = procedure (whichQuest: HQUEST; enabled: LongBool); cdecl;
var _QuestSetEnabled: TQuestSetEnabledFunctionPrototype;

procedure QuestSetEnabled(whichQuest: HQUEST; enabled: Boolean);
begin
	_QuestSetEnabled(whichQuest, enabled);
end;

type TIsQuestRequiredFunctionPrototype = function (whichQuest: HQUEST): LongBool; cdecl;
var _IsQuestRequired: TIsQuestRequiredFunctionPrototype;

function IsQuestRequired(whichQuest: HQUEST): Boolean;
begin
	Result:= _IsQuestRequired(whichQuest);
end;

type TIsQuestCompletedFunctionPrototype = function (whichQuest: HQUEST): LongBool; cdecl;
var _IsQuestCompleted: TIsQuestCompletedFunctionPrototype;

function IsQuestCompleted(whichQuest: HQUEST): Boolean;
begin
	Result:= _IsQuestCompleted(whichQuest);
end;

type TIsQuestDiscoveredFunctionPrototype = function (whichQuest: HQUEST): LongBool; cdecl;
var _IsQuestDiscovered: TIsQuestDiscoveredFunctionPrototype;

function IsQuestDiscovered(whichQuest: HQUEST): Boolean;
begin
	Result:= _IsQuestDiscovered(whichQuest);
end;

type TIsQuestFailedFunctionPrototype = function (whichQuest: HQUEST): LongBool; cdecl;
var _IsQuestFailed: TIsQuestFailedFunctionPrototype;

function IsQuestFailed(whichQuest: HQUEST): Boolean;
begin
	Result:= _IsQuestFailed(whichQuest);
end;

type TIsQuestEnabledFunctionPrototype = function (whichQuest: HQUEST): LongBool; cdecl;
var _IsQuestEnabled: TIsQuestEnabledFunctionPrototype;

function IsQuestEnabled(whichQuest: HQUEST): Boolean;
begin
	Result:= _IsQuestEnabled(whichQuest);
end;

type TQuestCreateItemFunctionPrototype = function (whichQuest: HQUEST): HQUESTITEM; cdecl;
var _QuestCreateItem: TQuestCreateItemFunctionPrototype;

function QuestCreateItem(whichQuest: HQUEST): HQUESTITEM;
begin
	Result:= _QuestCreateItem(whichQuest);
end;

type TQuestItemSetDescriptionFunctionPrototype = procedure (whichQuestItem: HQUESTITEM; description: PJassString); cdecl;
var _QuestItemSetDescription: TQuestItemSetDescriptionFunctionPrototype;

procedure QuestItemSetDescription(whichQuestItem: HQUESTITEM; description: String);
var
	jdescription: PJassString;
begin
	jdescription:= CreateJassString(PChar(description));
	_QuestItemSetDescription(whichQuestItem, jdescription);
	DestroyJassString(jdescription);
end;

type TQuestItemSetCompletedFunctionPrototype = procedure (whichQuestItem: HQUESTITEM; completed: LongBool); cdecl;
var _QuestItemSetCompleted: TQuestItemSetCompletedFunctionPrototype;

procedure QuestItemSetCompleted(whichQuestItem: HQUESTITEM; completed: Boolean);
begin
	_QuestItemSetCompleted(whichQuestItem, completed);
end;

type TIsQuestItemCompletedFunctionPrototype = function (whichQuestItem: HQUESTITEM): LongBool; cdecl;
var _IsQuestItemCompleted: TIsQuestItemCompletedFunctionPrototype;

function IsQuestItemCompleted(whichQuestItem: HQUESTITEM): Boolean;
begin
	Result:= _IsQuestItemCompleted(whichQuestItem);
end;

type TCreateDefeatConditionFunctionPrototype = function: HDEFEATCONDITION; cdecl;
var _CreateDefeatCondition: TCreateDefeatConditionFunctionPrototype;

function CreateDefeatCondition: HDEFEATCONDITION;
begin
	Result:= _CreateDefeatCondition();
end;

type TDestroyDefeatConditionFunctionPrototype = procedure (whichCondition: HDEFEATCONDITION); cdecl;
var _DestroyDefeatCondition: TDestroyDefeatConditionFunctionPrototype;

procedure DestroyDefeatCondition(whichCondition: HDEFEATCONDITION);
begin
	_DestroyDefeatCondition(whichCondition);
end;

type TDefeatConditionSetDescriptionFunctionPrototype = procedure (whichCondition: HDEFEATCONDITION; description: PJassString); cdecl;
var _DefeatConditionSetDescription: TDefeatConditionSetDescriptionFunctionPrototype;

procedure DefeatConditionSetDescription(whichCondition: HDEFEATCONDITION; description: String);
var
	jdescription: PJassString;
begin
	jdescription:= CreateJassString(PChar(description));
	_DefeatConditionSetDescription(whichCondition, jdescription);
	DestroyJassString(jdescription);
end;

type TFlashQuestDialogButtonFunctionPrototype = procedure; cdecl;
var _FlashQuestDialogButton: TFlashQuestDialogButtonFunctionPrototype;

procedure FlashQuestDialogButton;
begin
	_FlashQuestDialogButton();
end;

type TForceQuestDialogUpdateFunctionPrototype = procedure; cdecl;
var _ForceQuestDialogUpdate: TForceQuestDialogUpdateFunctionPrototype;

procedure ForceQuestDialogUpdate;
begin
	_ForceQuestDialogUpdate();
end;

type TCreateTimerDialogFunctionPrototype = function (t: HTIMER): HTIMERDIALOG; cdecl;
var _CreateTimerDialog: TCreateTimerDialogFunctionPrototype;

function CreateTimerDialog(t: HTIMER): HTIMERDIALOG;
begin
	Result:= _CreateTimerDialog(t);
end;

type TDestroyTimerDialogFunctionPrototype = procedure (whichDialog: HTIMERDIALOG); cdecl;
var _DestroyTimerDialog: TDestroyTimerDialogFunctionPrototype;

procedure DestroyTimerDialog(whichDialog: HTIMERDIALOG);
begin
	_DestroyTimerDialog(whichDialog);
end;

type TTimerDialogSetTitleFunctionPrototype = procedure (whichDialog: HTIMERDIALOG; title: PJassString); cdecl;
var _TimerDialogSetTitle: TTimerDialogSetTitleFunctionPrototype;

procedure TimerDialogSetTitle(whichDialog: HTIMERDIALOG; title: String);
var
	jtitle: PJassString;
begin
	jtitle:= CreateJassString(PChar(title));
	_TimerDialogSetTitle(whichDialog, jtitle);
	DestroyJassString(jtitle);
end;

type TTimerDialogSetTitleColorFunctionPrototype = procedure (whichDialog: HTIMERDIALOG; red: Int32; green: Int32; blue: Int32; alpha: Int32); cdecl;
var _TimerDialogSetTitleColor: TTimerDialogSetTitleColorFunctionPrototype;

procedure TimerDialogSetTitleColor(whichDialog: HTIMERDIALOG; red: Integer; green: Integer; blue: Integer; alpha: Integer);
begin
	_TimerDialogSetTitleColor(whichDialog, red, green, blue, alpha);
end;

type TTimerDialogSetTimeColorFunctionPrototype = procedure (whichDialog: HTIMERDIALOG; red: Int32; green: Int32; blue: Int32; alpha: Int32); cdecl;
var _TimerDialogSetTimeColor: TTimerDialogSetTimeColorFunctionPrototype;

procedure TimerDialogSetTimeColor(whichDialog: HTIMERDIALOG; red: Integer; green: Integer; blue: Integer; alpha: Integer);
begin
	_TimerDialogSetTimeColor(whichDialog, red, green, blue, alpha);
end;

type TTimerDialogSetSpeedFunctionPrototype = procedure (whichDialog: HTIMERDIALOG; speedMultFactor: PSingle); cdecl;
var _TimerDialogSetSpeed: TTimerDialogSetSpeedFunctionPrototype;

procedure TimerDialogSetSpeed(whichDialog: HTIMERDIALOG; speedMultFactor: Single);
begin
	_TimerDialogSetSpeed(whichDialog, @speedMultFactor);
end;

type TTimerDialogDisplayFunctionPrototype = procedure (whichDialog: HTIMERDIALOG; display: LongBool); cdecl;
var _TimerDialogDisplay: TTimerDialogDisplayFunctionPrototype;

procedure TimerDialogDisplay(whichDialog: HTIMERDIALOG; display: Boolean);
begin
	_TimerDialogDisplay(whichDialog, display);
end;

type TIsTimerDialogDisplayedFunctionPrototype = function (whichDialog: HTIMERDIALOG): LongBool; cdecl;
var _IsTimerDialogDisplayed: TIsTimerDialogDisplayedFunctionPrototype;

function IsTimerDialogDisplayed(whichDialog: HTIMERDIALOG): Boolean;
begin
	Result:= _IsTimerDialogDisplayed(whichDialog);
end;

type TTimerDialogSetRealTimeRemainingFunctionPrototype = procedure (whichDialog: HTIMERDIALOG; timeRemaining: PSingle); cdecl;
var _TimerDialogSetRealTimeRemaining: TTimerDialogSetRealTimeRemainingFunctionPrototype;

procedure TimerDialogSetRealTimeRemaining(whichDialog: HTIMERDIALOG; timeRemaining: Single);
begin
	_TimerDialogSetRealTimeRemaining(whichDialog, @timeRemaining);
end;

type TCreateLeaderboardFunctionPrototype = function: HLEADERBOARD; cdecl;
var _CreateLeaderboard: TCreateLeaderboardFunctionPrototype;

function CreateLeaderboard: HLEADERBOARD;
begin
	Result:= _CreateLeaderboard();
end;

type TDestroyLeaderboardFunctionPrototype = procedure (lb: HLEADERBOARD); cdecl;
var _DestroyLeaderboard: TDestroyLeaderboardFunctionPrototype;

procedure DestroyLeaderboard(lb: HLEADERBOARD);
begin
	_DestroyLeaderboard(lb);
end;

type TLeaderboardDisplayFunctionPrototype = procedure (lb: HLEADERBOARD; show: LongBool); cdecl;
var _LeaderboardDisplay: TLeaderboardDisplayFunctionPrototype;

procedure LeaderboardDisplay(lb: HLEADERBOARD; show: Boolean);
begin
	_LeaderboardDisplay(lb, show);
end;

type TIsLeaderboardDisplayedFunctionPrototype = function (lb: HLEADERBOARD): LongBool; cdecl;
var _IsLeaderboardDisplayed: TIsLeaderboardDisplayedFunctionPrototype;

function IsLeaderboardDisplayed(lb: HLEADERBOARD): Boolean;
begin
	Result:= _IsLeaderboardDisplayed(lb);
end;

type TLeaderboardGetItemCountFunctionPrototype = function (lb: HLEADERBOARD): Int32; cdecl;
var _LeaderboardGetItemCount: TLeaderboardGetItemCountFunctionPrototype;

function LeaderboardGetItemCount(lb: HLEADERBOARD): Integer;
begin
	Result:= _LeaderboardGetItemCount(lb);
end;

type TLeaderboardSetSizeByItemCountFunctionPrototype = procedure (lb: HLEADERBOARD; count: Int32); cdecl;
var _LeaderboardSetSizeByItemCount: TLeaderboardSetSizeByItemCountFunctionPrototype;

procedure LeaderboardSetSizeByItemCount(lb: HLEADERBOARD; count: Integer);
begin
	_LeaderboardSetSizeByItemCount(lb, count);
end;

type TLeaderboardAddItemFunctionPrototype = procedure (lb: HLEADERBOARD; label_: PJassString; value: Int32; p: HPLAYER); cdecl;
var _LeaderboardAddItem: TLeaderboardAddItemFunctionPrototype;

procedure LeaderboardAddItem(lb: HLEADERBOARD; label_: String; value: Integer; p: HPLAYER);
var
	jlabel: PJassString;
begin
	jlabel:= CreateJassString(PChar(label_));
	_LeaderboardAddItem(lb, jlabel, value, p);
	DestroyJassString(jlabel);
end;

type TLeaderboardRemoveItemFunctionPrototype = procedure (lb: HLEADERBOARD; index: Int32); cdecl;
var _LeaderboardRemoveItem: TLeaderboardRemoveItemFunctionPrototype;

procedure LeaderboardRemoveItem(lb: HLEADERBOARD; index: Integer);
begin
	_LeaderboardRemoveItem(lb, index);
end;

type TLeaderboardRemovePlayerItemFunctionPrototype = procedure (lb: HLEADERBOARD; p: HPLAYER); cdecl;
var _LeaderboardRemovePlayerItem: TLeaderboardRemovePlayerItemFunctionPrototype;

procedure LeaderboardRemovePlayerItem(lb: HLEADERBOARD; p: HPLAYER);
begin
	_LeaderboardRemovePlayerItem(lb, p);
end;

type TLeaderboardClearFunctionPrototype = procedure (lb: HLEADERBOARD); cdecl;
var _LeaderboardClear: TLeaderboardClearFunctionPrototype;

procedure LeaderboardClear(lb: HLEADERBOARD);
begin
	_LeaderboardClear(lb);
end;

type TLeaderboardSortItemsByValueFunctionPrototype = procedure (lb: HLEADERBOARD; ascending: LongBool); cdecl;
var _LeaderboardSortItemsByValue: TLeaderboardSortItemsByValueFunctionPrototype;

procedure LeaderboardSortItemsByValue(lb: HLEADERBOARD; ascending: Boolean);
begin
	_LeaderboardSortItemsByValue(lb, ascending);
end;

type TLeaderboardSortItemsByPlayerFunctionPrototype = procedure (lb: HLEADERBOARD; ascending: LongBool); cdecl;
var _LeaderboardSortItemsByPlayer: TLeaderboardSortItemsByPlayerFunctionPrototype;

procedure LeaderboardSortItemsByPlayer(lb: HLEADERBOARD; ascending: Boolean);
begin
	_LeaderboardSortItemsByPlayer(lb, ascending);
end;

type TLeaderboardSortItemsByLabelFunctionPrototype = procedure (lb: HLEADERBOARD; ascending: LongBool); cdecl;
var _LeaderboardSortItemsByLabel: TLeaderboardSortItemsByLabelFunctionPrototype;

procedure LeaderboardSortItemsByLabel(lb: HLEADERBOARD; ascending: Boolean);
begin
	_LeaderboardSortItemsByLabel(lb, ascending);
end;

type TLeaderboardHasPlayerItemFunctionPrototype = function (lb: HLEADERBOARD; p: HPLAYER): LongBool; cdecl;
var _LeaderboardHasPlayerItem: TLeaderboardHasPlayerItemFunctionPrototype;

function LeaderboardHasPlayerItem(lb: HLEADERBOARD; p: HPLAYER): Boolean;
begin
	Result:= _LeaderboardHasPlayerItem(lb, p);
end;

type TLeaderboardGetPlayerIndexFunctionPrototype = function (lb: HLEADERBOARD; p: HPLAYER): Int32; cdecl;
var _LeaderboardGetPlayerIndex: TLeaderboardGetPlayerIndexFunctionPrototype;

function LeaderboardGetPlayerIndex(lb: HLEADERBOARD; p: HPLAYER): Integer;
begin
	Result:= _LeaderboardGetPlayerIndex(lb, p);
end;

type TLeaderboardSetLabelFunctionPrototype = procedure (lb: HLEADERBOARD; label_: PJassString); cdecl;
var _LeaderboardSetLabel: TLeaderboardSetLabelFunctionPrototype;

procedure LeaderboardSetLabel(lb: HLEADERBOARD; label_: String);
var
	jlabel: PJassString;
begin
	jlabel:= CreateJassString(PChar(label_));
	_LeaderboardSetLabel(lb, jlabel);
	DestroyJassString(jlabel);
end;

type TLeaderboardGetLabelTextFunctionPrototype = function (lb: HLEADERBOARD): TJassStringHandle; cdecl;
var _LeaderboardGetLabelText: TLeaderboardGetLabelTextFunctionPrototype;

function LeaderboardGetLabelText(lb: HLEADERBOARD): String;
var
	hResult: TJassStringHandle;
begin
	hResult:= _LeaderboardGetLabelText(lb);
	Result:= GetStringFromHandle(hResult);
	DecrementStringReferences(hResult);
end;

type TPlayerSetLeaderboardFunctionPrototype = procedure (toPlayer: HPLAYER; lb: HLEADERBOARD); cdecl;
var _PlayerSetLeaderboard: TPlayerSetLeaderboardFunctionPrototype;

procedure PlayerSetLeaderboard(toPlayer: HPLAYER; lb: HLEADERBOARD);
begin
	_PlayerSetLeaderboard(toPlayer, lb);
end;

type TPlayerGetLeaderboardFunctionPrototype = function (toPlayer: HPLAYER): HLEADERBOARD; cdecl;
var _PlayerGetLeaderboard: TPlayerGetLeaderboardFunctionPrototype;

function PlayerGetLeaderboard(toPlayer: HPLAYER): HLEADERBOARD;
begin
	Result:= _PlayerGetLeaderboard(toPlayer);
end;

type TLeaderboardSetLabelColorFunctionPrototype = procedure (lb: HLEADERBOARD; red: Int32; green: Int32; blue: Int32; alpha: Int32); cdecl;
var _LeaderboardSetLabelColor: TLeaderboardSetLabelColorFunctionPrototype;

procedure LeaderboardSetLabelColor(lb: HLEADERBOARD; red: Integer; green: Integer; blue: Integer; alpha: Integer);
begin
	_LeaderboardSetLabelColor(lb, red, green, blue, alpha);
end;

type TLeaderboardSetValueColorFunctionPrototype = procedure (lb: HLEADERBOARD; red: Int32; green: Int32; blue: Int32; alpha: Int32); cdecl;
var _LeaderboardSetValueColor: TLeaderboardSetValueColorFunctionPrototype;

procedure LeaderboardSetValueColor(lb: HLEADERBOARD; red: Integer; green: Integer; blue: Integer; alpha: Integer);
begin
	_LeaderboardSetValueColor(lb, red, green, blue, alpha);
end;

type TLeaderboardSetStyleFunctionPrototype = procedure (lb: HLEADERBOARD; showLabel: LongBool; showNames: LongBool; showValues: LongBool; showIcons: LongBool); cdecl;
var _LeaderboardSetStyle: TLeaderboardSetStyleFunctionPrototype;

procedure LeaderboardSetStyle(lb: HLEADERBOARD; showLabel: Boolean; showNames: Boolean; showValues: Boolean; showIcons: Boolean);
begin
	_LeaderboardSetStyle(lb, showLabel, showNames, showValues, showIcons);
end;

type TLeaderboardSetItemValueFunctionPrototype = procedure (lb: HLEADERBOARD; whichItem: Int32; val: Int32); cdecl;
var _LeaderboardSetItemValue: TLeaderboardSetItemValueFunctionPrototype;

procedure LeaderboardSetItemValue(lb: HLEADERBOARD; whichItem: Integer; val: Integer);
begin
	_LeaderboardSetItemValue(lb, whichItem, val);
end;

type TLeaderboardSetItemLabelFunctionPrototype = procedure (lb: HLEADERBOARD; whichItem: Int32; val: PJassString); cdecl;
var _LeaderboardSetItemLabel: TLeaderboardSetItemLabelFunctionPrototype;

procedure LeaderboardSetItemLabel(lb: HLEADERBOARD; whichItem: Integer; val: String);
var
	jval: PJassString;
begin
	jval:= CreateJassString(PChar(val));
	_LeaderboardSetItemLabel(lb, whichItem, jval);
	DestroyJassString(jval);
end;

type TLeaderboardSetItemStyleFunctionPrototype = procedure (lb: HLEADERBOARD; whichItem: Int32; showLabel: LongBool; showValue: LongBool; showIcon: LongBool); cdecl;
var _LeaderboardSetItemStyle: TLeaderboardSetItemStyleFunctionPrototype;

procedure LeaderboardSetItemStyle(lb: HLEADERBOARD; whichItem: Integer; showLabel: Boolean; showValue: Boolean; showIcon: Boolean);
begin
	_LeaderboardSetItemStyle(lb, whichItem, showLabel, showValue, showIcon);
end;

type TLeaderboardSetItemLabelColorFunctionPrototype = procedure (lb: HLEADERBOARD; whichItem: Int32; red: Int32; green: Int32; blue: Int32; alpha: Int32); cdecl;
var _LeaderboardSetItemLabelColor: TLeaderboardSetItemLabelColorFunctionPrototype;

procedure LeaderboardSetItemLabelColor(lb: HLEADERBOARD; whichItem: Integer; red: Integer; green: Integer; blue: Integer; alpha: Integer);
begin
	_LeaderboardSetItemLabelColor(lb, whichItem, red, green, blue, alpha);
end;

type TLeaderboardSetItemValueColorFunctionPrototype = procedure (lb: HLEADERBOARD; whichItem: Int32; red: Int32; green: Int32; blue: Int32; alpha: Int32); cdecl;
var _LeaderboardSetItemValueColor: TLeaderboardSetItemValueColorFunctionPrototype;

procedure LeaderboardSetItemValueColor(lb: HLEADERBOARD; whichItem: Integer; red: Integer; green: Integer; blue: Integer; alpha: Integer);
begin
	_LeaderboardSetItemValueColor(lb, whichItem, red, green, blue, alpha);
end;

type TCreateMultiboardFunctionPrototype = function: HMULTIBOARD; cdecl;
var _CreateMultiboard: TCreateMultiboardFunctionPrototype;

function CreateMultiboard: HMULTIBOARD;
begin
	Result:= _CreateMultiboard();
end;

type TDestroyMultiboardFunctionPrototype = procedure (lb: HMULTIBOARD); cdecl;
var _DestroyMultiboard: TDestroyMultiboardFunctionPrototype;

procedure DestroyMultiboard(lb: HMULTIBOARD);
begin
	_DestroyMultiboard(lb);
end;

type TMultiboardDisplayFunctionPrototype = procedure (lb: HMULTIBOARD; show: LongBool); cdecl;
var _MultiboardDisplay: TMultiboardDisplayFunctionPrototype;

procedure MultiboardDisplay(lb: HMULTIBOARD; show: Boolean);
begin
	_MultiboardDisplay(lb, show);
end;

type TIsMultiboardDisplayedFunctionPrototype = function (lb: HMULTIBOARD): LongBool; cdecl;
var _IsMultiboardDisplayed: TIsMultiboardDisplayedFunctionPrototype;

function IsMultiboardDisplayed(lb: HMULTIBOARD): Boolean;
begin
	Result:= _IsMultiboardDisplayed(lb);
end;

type TMultiboardMinimizeFunctionPrototype = procedure (lb: HMULTIBOARD; minimize: LongBool); cdecl;
var _MultiboardMinimize: TMultiboardMinimizeFunctionPrototype;

procedure MultiboardMinimize(lb: HMULTIBOARD; minimize: Boolean);
begin
	_MultiboardMinimize(lb, minimize);
end;

type TIsMultiboardMinimizedFunctionPrototype = function (lb: HMULTIBOARD): LongBool; cdecl;
var _IsMultiboardMinimized: TIsMultiboardMinimizedFunctionPrototype;

function IsMultiboardMinimized(lb: HMULTIBOARD): Boolean;
begin
	Result:= _IsMultiboardMinimized(lb);
end;

type TMultiboardClearFunctionPrototype = procedure (lb: HMULTIBOARD); cdecl;
var _MultiboardClear: TMultiboardClearFunctionPrototype;

procedure MultiboardClear(lb: HMULTIBOARD);
begin
	_MultiboardClear(lb);
end;

type TMultiboardSetTitleTextFunctionPrototype = procedure (lb: HMULTIBOARD; label_: PJassString); cdecl;
var _MultiboardSetTitleText: TMultiboardSetTitleTextFunctionPrototype;

procedure MultiboardSetTitleText(lb: HMULTIBOARD; label_: String);
var
	jlabel: PJassString;
begin
	jlabel:= CreateJassString(PChar(label_));
	_MultiboardSetTitleText(lb, jlabel);
	DestroyJassString(jlabel);
end;

type TMultiboardGetTitleTextFunctionPrototype = function (lb: HMULTIBOARD): TJassStringHandle; cdecl;
var _MultiboardGetTitleText: TMultiboardGetTitleTextFunctionPrototype;

function MultiboardGetTitleText(lb: HMULTIBOARD): String;
var
	hResult: TJassStringHandle;
begin
	hResult:= _MultiboardGetTitleText(lb);
	Result:= GetStringFromHandle(hResult);
	DecrementStringReferences(hResult);
end;

type TMultiboardSetTitleTextColorFunctionPrototype = procedure (lb: HMULTIBOARD; red: Int32; green: Int32; blue: Int32; alpha: Int32); cdecl;
var _MultiboardSetTitleTextColor: TMultiboardSetTitleTextColorFunctionPrototype;

procedure MultiboardSetTitleTextColor(lb: HMULTIBOARD; red: Integer; green: Integer; blue: Integer; alpha: Integer);
begin
	_MultiboardSetTitleTextColor(lb, red, green, blue, alpha);
end;

type TMultiboardGetRowCountFunctionPrototype = function (lb: HMULTIBOARD): Int32; cdecl;
var _MultiboardGetRowCount: TMultiboardGetRowCountFunctionPrototype;

function MultiboardGetRowCount(lb: HMULTIBOARD): Integer;
begin
	Result:= _MultiboardGetRowCount(lb);
end;

type TMultiboardGetColumnCountFunctionPrototype = function (lb: HMULTIBOARD): Int32; cdecl;
var _MultiboardGetColumnCount: TMultiboardGetColumnCountFunctionPrototype;

function MultiboardGetColumnCount(lb: HMULTIBOARD): Integer;
begin
	Result:= _MultiboardGetColumnCount(lb);
end;

type TMultiboardSetColumnCountFunctionPrototype = procedure (lb: HMULTIBOARD; count: Int32); cdecl;
var _MultiboardSetColumnCount: TMultiboardSetColumnCountFunctionPrototype;

procedure MultiboardSetColumnCount(lb: HMULTIBOARD; count: Integer);
begin
	_MultiboardSetColumnCount(lb, count);
end;

type TMultiboardSetRowCountFunctionPrototype = procedure (lb: HMULTIBOARD; count: Int32); cdecl;
var _MultiboardSetRowCount: TMultiboardSetRowCountFunctionPrototype;

procedure MultiboardSetRowCount(lb: HMULTIBOARD; count: Integer);
begin
	_MultiboardSetRowCount(lb, count);
end;

type TMultiboardSetItemsStyleFunctionPrototype = procedure (lb: HMULTIBOARD; showValues: LongBool; showIcons: LongBool); cdecl;
var _MultiboardSetItemsStyle: TMultiboardSetItemsStyleFunctionPrototype;

procedure MultiboardSetItemsStyle(lb: HMULTIBOARD; showValues: Boolean; showIcons: Boolean);
begin
	_MultiboardSetItemsStyle(lb, showValues, showIcons);
end;

type TMultiboardSetItemsValueFunctionPrototype = procedure (lb: HMULTIBOARD; value: PJassString); cdecl;
var _MultiboardSetItemsValue: TMultiboardSetItemsValueFunctionPrototype;

procedure MultiboardSetItemsValue(lb: HMULTIBOARD; value: String);
var
	jvalue: PJassString;
begin
	jvalue:= CreateJassString(PChar(value));
	_MultiboardSetItemsValue(lb, jvalue);
	DestroyJassString(jvalue);
end;

type TMultiboardSetItemsValueColorFunctionPrototype = procedure (lb: HMULTIBOARD; red: Int32; green: Int32; blue: Int32; alpha: Int32); cdecl;
var _MultiboardSetItemsValueColor: TMultiboardSetItemsValueColorFunctionPrototype;

procedure MultiboardSetItemsValueColor(lb: HMULTIBOARD; red: Integer; green: Integer; blue: Integer; alpha: Integer);
begin
	_MultiboardSetItemsValueColor(lb, red, green, blue, alpha);
end;

type TMultiboardSetItemsWidthFunctionPrototype = procedure (lb: HMULTIBOARD; width: PSingle); cdecl;
var _MultiboardSetItemsWidth: TMultiboardSetItemsWidthFunctionPrototype;

procedure MultiboardSetItemsWidth(lb: HMULTIBOARD; width: Single);
begin
	_MultiboardSetItemsWidth(lb, @width);
end;

type TMultiboardSetItemsIconFunctionPrototype = procedure (lb: HMULTIBOARD; iconPath: PJassString); cdecl;
var _MultiboardSetItemsIcon: TMultiboardSetItemsIconFunctionPrototype;

procedure MultiboardSetItemsIcon(lb: HMULTIBOARD; iconPath: String);
var
	jiconPath: PJassString;
begin
	jiconPath:= CreateJassString(PChar(iconPath));
	_MultiboardSetItemsIcon(lb, jiconPath);
	DestroyJassString(jiconPath);
end;

type TMultiboardGetItemFunctionPrototype = function (lb: HMULTIBOARD; row: Int32; column: Int32): HMULTIBOARDITEM; cdecl;
var _MultiboardGetItem: TMultiboardGetItemFunctionPrototype;

function MultiboardGetItem(lb: HMULTIBOARD; row: Integer; column: Integer): HMULTIBOARDITEM;
begin
	Result:= _MultiboardGetItem(lb, row, column);
end;

type TMultiboardReleaseItemFunctionPrototype = procedure (mbi: HMULTIBOARDITEM); cdecl;
var _MultiboardReleaseItem: TMultiboardReleaseItemFunctionPrototype;

procedure MultiboardReleaseItem(mbi: HMULTIBOARDITEM);
begin
	_MultiboardReleaseItem(mbi);
end;

type TMultiboardSetItemStyleFunctionPrototype = procedure (mbi: HMULTIBOARDITEM; showValue: LongBool; showIcon: LongBool); cdecl;
var _MultiboardSetItemStyle: TMultiboardSetItemStyleFunctionPrototype;

procedure MultiboardSetItemStyle(mbi: HMULTIBOARDITEM; showValue: Boolean; showIcon: Boolean);
begin
	_MultiboardSetItemStyle(mbi, showValue, showIcon);
end;

type TMultiboardSetItemValueFunctionPrototype = procedure (mbi: HMULTIBOARDITEM; val: PJassString); cdecl;
var _MultiboardSetItemValue: TMultiboardSetItemValueFunctionPrototype;

procedure MultiboardSetItemValue(mbi: HMULTIBOARDITEM; val: String);
var
	jval: PJassString;
begin
	jval:= CreateJassString(PChar(val));
	_MultiboardSetItemValue(mbi, jval);
	DestroyJassString(jval);
end;

type TMultiboardSetItemValueColorFunctionPrototype = procedure (mbi: HMULTIBOARDITEM; red: Int32; green: Int32; blue: Int32; alpha: Int32); cdecl;
var _MultiboardSetItemValueColor: TMultiboardSetItemValueColorFunctionPrototype;

procedure MultiboardSetItemValueColor(mbi: HMULTIBOARDITEM; red: Integer; green: Integer; blue: Integer; alpha: Integer);
begin
	_MultiboardSetItemValueColor(mbi, red, green, blue, alpha);
end;

type TMultiboardSetItemWidthFunctionPrototype = procedure (mbi: HMULTIBOARDITEM; width: PSingle); cdecl;
var _MultiboardSetItemWidth: TMultiboardSetItemWidthFunctionPrototype;

procedure MultiboardSetItemWidth(mbi: HMULTIBOARDITEM; width: Single);
begin
	_MultiboardSetItemWidth(mbi, @width);
end;

type TMultiboardSetItemIconFunctionPrototype = procedure (mbi: HMULTIBOARDITEM; iconFileName: PJassString); cdecl;
var _MultiboardSetItemIcon: TMultiboardSetItemIconFunctionPrototype;

procedure MultiboardSetItemIcon(mbi: HMULTIBOARDITEM; iconFileName: String);
var
	jiconFileName: PJassString;
begin
	jiconFileName:= CreateJassString(PChar(iconFileName));
	_MultiboardSetItemIcon(mbi, jiconFileName);
	DestroyJassString(jiconFileName);
end;

type TMultiboardSuppressDisplayFunctionPrototype = procedure (flag: LongBool); cdecl;
var _MultiboardSuppressDisplay: TMultiboardSuppressDisplayFunctionPrototype;

procedure MultiboardSuppressDisplay(flag: Boolean);
begin
	_MultiboardSuppressDisplay(flag);
end;

type TSetCameraPositionFunctionPrototype = procedure (x: PSingle; y: PSingle); cdecl;
var _SetCameraPosition: TSetCameraPositionFunctionPrototype;

procedure SetCameraPosition(x: Single; y: Single);
begin
	_SetCameraPosition(@x, @y);
end;

type TSetCameraQuickPositionFunctionPrototype = procedure (x: PSingle; y: PSingle); cdecl;
var _SetCameraQuickPosition: TSetCameraQuickPositionFunctionPrototype;

procedure SetCameraQuickPosition(x: Single; y: Single);
begin
	_SetCameraQuickPosition(@x, @y);
end;

type TSetCameraBoundsFunctionPrototype = procedure (x1: PSingle; y1: PSingle; x2: PSingle; y2: PSingle; x3: PSingle; y3: PSingle; x4: PSingle; y4: PSingle); cdecl;
var _SetCameraBounds: TSetCameraBoundsFunctionPrototype;

procedure SetCameraBounds(x1: Single; y1: Single; x2: Single; y2: Single; x3: Single; y3: Single; x4: Single; y4: Single);
begin
	_SetCameraBounds(@x1, @y1, @x2, @y2, @x3, @y3, @x4, @y4);
end;

type TStopCameraFunctionPrototype = procedure; cdecl;
var _StopCamera: TStopCameraFunctionPrototype;

procedure StopCamera;
begin
	_StopCamera();
end;

type TResetToGameCameraFunctionPrototype = procedure (duration: PSingle); cdecl;
var _ResetToGameCamera: TResetToGameCameraFunctionPrototype;

procedure ResetToGameCamera(duration: Single);
begin
	_ResetToGameCamera(@duration);
end;

type TPanCameraToFunctionPrototype = procedure (x: PSingle; y: PSingle); cdecl;
var _PanCameraTo: TPanCameraToFunctionPrototype;

procedure PanCameraTo(x: Single; y: Single);
begin
	_PanCameraTo(@x, @y);
end;

type TPanCameraToTimedFunctionPrototype = procedure (x: PSingle; y: PSingle; duration: PSingle); cdecl;
var _PanCameraToTimed: TPanCameraToTimedFunctionPrototype;

procedure PanCameraToTimed(x: Single; y: Single; duration: Single);
begin
	_PanCameraToTimed(@x, @y, @duration);
end;

type TPanCameraToWithZFunctionPrototype = procedure (x: PSingle; y: PSingle; zOffsetDest: PSingle); cdecl;
var _PanCameraToWithZ: TPanCameraToWithZFunctionPrototype;

procedure PanCameraToWithZ(x: Single; y: Single; zOffsetDest: Single);
begin
	_PanCameraToWithZ(@x, @y, @zOffsetDest);
end;

type TPanCameraToTimedWithZFunctionPrototype = procedure (x: PSingle; y: PSingle; zOffsetDest: PSingle; duration: PSingle); cdecl;
var _PanCameraToTimedWithZ: TPanCameraToTimedWithZFunctionPrototype;

procedure PanCameraToTimedWithZ(x: Single; y: Single; zOffsetDest: Single; duration: Single);
begin
	_PanCameraToTimedWithZ(@x, @y, @zOffsetDest, @duration);
end;

type TSetCinematicCameraFunctionPrototype = procedure (cameraModelFile: PJassString); cdecl;
var _SetCinematicCamera: TSetCinematicCameraFunctionPrototype;

procedure SetCinematicCamera(cameraModelFile: String);
var
	jcameraModelFile: PJassString;
begin
	jcameraModelFile:= CreateJassString(PChar(cameraModelFile));
	_SetCinematicCamera(jcameraModelFile);
	DestroyJassString(jcameraModelFile);
end;

type TSetCameraRotateModeFunctionPrototype = procedure (x: PSingle; y: PSingle; radiansToSweep: PSingle; duration: PSingle); cdecl;
var _SetCameraRotateMode: TSetCameraRotateModeFunctionPrototype;

procedure SetCameraRotateMode(x: Single; y: Single; radiansToSweep: Single; duration: Single);
begin
	_SetCameraRotateMode(@x, @y, @radiansToSweep, @duration);
end;

type TSetCameraFieldFunctionPrototype = procedure (whichField: HCAMERAFIELD; value: PSingle; duration: PSingle); cdecl;
var _SetCameraField: TSetCameraFieldFunctionPrototype;

procedure SetCameraField(whichField: HCAMERAFIELD; value: Single; duration: Single);
begin
	_SetCameraField(whichField, @value, @duration);
end;

type TAdjustCameraFieldFunctionPrototype = procedure (whichField: HCAMERAFIELD; offset: PSingle; duration: PSingle); cdecl;
var _AdjustCameraField: TAdjustCameraFieldFunctionPrototype;

procedure AdjustCameraField(whichField: HCAMERAFIELD; offset: Single; duration: Single);
begin
	_AdjustCameraField(whichField, @offset, @duration);
end;

type TSetCameraTargetControllerFunctionPrototype = procedure (whichUnit: HUNIT; xoffset: PSingle; yoffset: PSingle; inheritOrientation: LongBool); cdecl;
var _SetCameraTargetController: TSetCameraTargetControllerFunctionPrototype;

procedure SetCameraTargetController(whichUnit: HUNIT; xoffset: Single; yoffset: Single; inheritOrientation: Boolean);
begin
	_SetCameraTargetController(whichUnit, @xoffset, @yoffset, inheritOrientation);
end;

type TSetCameraOrientControllerFunctionPrototype = procedure (whichUnit: HUNIT; xoffset: PSingle; yoffset: PSingle); cdecl;
var _SetCameraOrientController: TSetCameraOrientControllerFunctionPrototype;

procedure SetCameraOrientController(whichUnit: HUNIT; xoffset: Single; yoffset: Single);
begin
	_SetCameraOrientController(whichUnit, @xoffset, @yoffset);
end;

type TCreateCameraSetupFunctionPrototype = function: HCAMERASETUP; cdecl;
var _CreateCameraSetup: TCreateCameraSetupFunctionPrototype;

function CreateCameraSetup: HCAMERASETUP;
begin
	Result:= _CreateCameraSetup();
end;

type TCameraSetupSetFieldFunctionPrototype = procedure (whichSetup: HCAMERASETUP; whichField: HCAMERAFIELD; value: PSingle; duration: PSingle); cdecl;
var _CameraSetupSetField: TCameraSetupSetFieldFunctionPrototype;

procedure CameraSetupSetField(whichSetup: HCAMERASETUP; whichField: HCAMERAFIELD; value: Single; duration: Single);
begin
	_CameraSetupSetField(whichSetup, whichField, @value, @duration);
end;

type TCameraSetupGetFieldFunctionPrototype = function (whichSetup: HCAMERASETUP; whichField: HCAMERAFIELD): TSingle; cdecl;
var _CameraSetupGetField: TCameraSetupGetFieldFunctionPrototype;

function CameraSetupGetField(whichSetup: HCAMERASETUP; whichField: HCAMERAFIELD): Single;
begin
	Result:= _CameraSetupGetField(whichSetup, whichField).Value;
end;

type TCameraSetupSetDestPositionFunctionPrototype = procedure (whichSetup: HCAMERASETUP; x: PSingle; y: PSingle; duration: PSingle); cdecl;
var _CameraSetupSetDestPosition: TCameraSetupSetDestPositionFunctionPrototype;

procedure CameraSetupSetDestPosition(whichSetup: HCAMERASETUP; x: Single; y: Single; duration: Single);
begin
	_CameraSetupSetDestPosition(whichSetup, @x, @y, @duration);
end;

type TCameraSetupGetDestPositionLocFunctionPrototype = function (whichSetup: HCAMERASETUP): HLOCATION; cdecl;
var _CameraSetupGetDestPositionLoc: TCameraSetupGetDestPositionLocFunctionPrototype;

function CameraSetupGetDestPositionLoc(whichSetup: HCAMERASETUP): HLOCATION;
begin
	Result:= _CameraSetupGetDestPositionLoc(whichSetup);
end;

type TCameraSetupGetDestPositionXFunctionPrototype = function (whichSetup: HCAMERASETUP): TSingle; cdecl;
var _CameraSetupGetDestPositionX: TCameraSetupGetDestPositionXFunctionPrototype;

function CameraSetupGetDestPositionX(whichSetup: HCAMERASETUP): Single;
begin
	Result:= _CameraSetupGetDestPositionX(whichSetup).Value;
end;

type TCameraSetupGetDestPositionYFunctionPrototype = function (whichSetup: HCAMERASETUP): TSingle; cdecl;
var _CameraSetupGetDestPositionY: TCameraSetupGetDestPositionYFunctionPrototype;

function CameraSetupGetDestPositionY(whichSetup: HCAMERASETUP): Single;
begin
	Result:= _CameraSetupGetDestPositionY(whichSetup).Value;
end;

type TCameraSetupApplyFunctionPrototype = procedure (whichSetup: HCAMERASETUP; doPan: LongBool; panTimed: LongBool); cdecl;
var _CameraSetupApply: TCameraSetupApplyFunctionPrototype;

procedure CameraSetupApply(whichSetup: HCAMERASETUP; doPan: Boolean; panTimed: Boolean);
begin
	_CameraSetupApply(whichSetup, doPan, panTimed);
end;

type TCameraSetupApplyWithZFunctionPrototype = procedure (whichSetup: HCAMERASETUP; zDestOffset: PSingle); cdecl;
var _CameraSetupApplyWithZ: TCameraSetupApplyWithZFunctionPrototype;

procedure CameraSetupApplyWithZ(whichSetup: HCAMERASETUP; zDestOffset: Single);
begin
	_CameraSetupApplyWithZ(whichSetup, @zDestOffset);
end;

type TCameraSetupApplyForceDurationFunctionPrototype = procedure (whichSetup: HCAMERASETUP; doPan: LongBool; forceDuration: PSingle); cdecl;
var _CameraSetupApplyForceDuration: TCameraSetupApplyForceDurationFunctionPrototype;

procedure CameraSetupApplyForceDuration(whichSetup: HCAMERASETUP; doPan: Boolean; forceDuration: Single);
begin
	_CameraSetupApplyForceDuration(whichSetup, doPan, @forceDuration);
end;

type TCameraSetupApplyForceDurationWithZFunctionPrototype = procedure (whichSetup: HCAMERASETUP; zDestOffset: PSingle; forceDuration: PSingle); cdecl;
var _CameraSetupApplyForceDurationWithZ: TCameraSetupApplyForceDurationWithZFunctionPrototype;

procedure CameraSetupApplyForceDurationWithZ(whichSetup: HCAMERASETUP; zDestOffset: Single; forceDuration: Single);
begin
	_CameraSetupApplyForceDurationWithZ(whichSetup, @zDestOffset, @forceDuration);
end;

type TCameraSetTargetNoiseFunctionPrototype = procedure (mag: PSingle; velocity: PSingle); cdecl;
var _CameraSetTargetNoise: TCameraSetTargetNoiseFunctionPrototype;

procedure CameraSetTargetNoise(mag: Single; velocity: Single);
begin
	_CameraSetTargetNoise(@mag, @velocity);
end;

type TCameraSetSourceNoiseFunctionPrototype = procedure (mag: PSingle; velocity: PSingle); cdecl;
var _CameraSetSourceNoise: TCameraSetSourceNoiseFunctionPrototype;

procedure CameraSetSourceNoise(mag: Single; velocity: Single);
begin
	_CameraSetSourceNoise(@mag, @velocity);
end;

type TCameraSetTargetNoiseExFunctionPrototype = procedure (mag: PSingle; velocity: PSingle; vertOnly: LongBool); cdecl;
var _CameraSetTargetNoiseEx: TCameraSetTargetNoiseExFunctionPrototype;

procedure CameraSetTargetNoiseEx(mag: Single; velocity: Single; vertOnly: Boolean);
begin
	_CameraSetTargetNoiseEx(@mag, @velocity, vertOnly);
end;

type TCameraSetSourceNoiseExFunctionPrototype = procedure (mag: PSingle; velocity: PSingle; vertOnly: LongBool); cdecl;
var _CameraSetSourceNoiseEx: TCameraSetSourceNoiseExFunctionPrototype;

procedure CameraSetSourceNoiseEx(mag: Single; velocity: Single; vertOnly: Boolean);
begin
	_CameraSetSourceNoiseEx(@mag, @velocity, vertOnly);
end;

type TCameraSetSmoothingFactorFunctionPrototype = procedure (factor: PSingle); cdecl;
var _CameraSetSmoothingFactor: TCameraSetSmoothingFactorFunctionPrototype;

procedure CameraSetSmoothingFactor(factor: Single);
begin
	_CameraSetSmoothingFactor(@factor);
end;

type TSetCineFilterTextureFunctionPrototype = procedure (filename: PJassString); cdecl;
var _SetCineFilterTexture: TSetCineFilterTextureFunctionPrototype;

procedure SetCineFilterTexture(filename: String);
var
	jfilename: PJassString;
begin
	jfilename:= CreateJassString(PChar(filename));
	_SetCineFilterTexture(jfilename);
	DestroyJassString(jfilename);
end;

type TSetCineFilterBlendModeFunctionPrototype = procedure (whichMode: HBLENDMODE); cdecl;
var _SetCineFilterBlendMode: TSetCineFilterBlendModeFunctionPrototype;

procedure SetCineFilterBlendMode(whichMode: HBLENDMODE);
begin
	_SetCineFilterBlendMode(whichMode);
end;

type TSetCineFilterTexMapFlagsFunctionPrototype = procedure (whichFlags: HTEXMAPFLAGS); cdecl;
var _SetCineFilterTexMapFlags: TSetCineFilterTexMapFlagsFunctionPrototype;

procedure SetCineFilterTexMapFlags(whichFlags: HTEXMAPFLAGS);
begin
	_SetCineFilterTexMapFlags(whichFlags);
end;

type TSetCineFilterStartUVFunctionPrototype = procedure (minu: PSingle; minv: PSingle; maxu: PSingle; maxv: PSingle); cdecl;
var _SetCineFilterStartUV: TSetCineFilterStartUVFunctionPrototype;

procedure SetCineFilterStartUV(minu: Single; minv: Single; maxu: Single; maxv: Single);
begin
	_SetCineFilterStartUV(@minu, @minv, @maxu, @maxv);
end;

type TSetCineFilterEndUVFunctionPrototype = procedure (minu: PSingle; minv: PSingle; maxu: PSingle; maxv: PSingle); cdecl;
var _SetCineFilterEndUV: TSetCineFilterEndUVFunctionPrototype;

procedure SetCineFilterEndUV(minu: Single; minv: Single; maxu: Single; maxv: Single);
begin
	_SetCineFilterEndUV(@minu, @minv, @maxu, @maxv);
end;

type TSetCineFilterStartColorFunctionPrototype = procedure (red: Int32; green: Int32; blue: Int32; alpha: Int32); cdecl;
var _SetCineFilterStartColor: TSetCineFilterStartColorFunctionPrototype;

procedure SetCineFilterStartColor(red: Integer; green: Integer; blue: Integer; alpha: Integer);
begin
	_SetCineFilterStartColor(red, green, blue, alpha);
end;

type TSetCineFilterEndColorFunctionPrototype = procedure (red: Int32; green: Int32; blue: Int32; alpha: Int32); cdecl;
var _SetCineFilterEndColor: TSetCineFilterEndColorFunctionPrototype;

procedure SetCineFilterEndColor(red: Integer; green: Integer; blue: Integer; alpha: Integer);
begin
	_SetCineFilterEndColor(red, green, blue, alpha);
end;

type TSetCineFilterDurationFunctionPrototype = procedure (duration: PSingle); cdecl;
var _SetCineFilterDuration: TSetCineFilterDurationFunctionPrototype;

procedure SetCineFilterDuration(duration: Single);
begin
	_SetCineFilterDuration(@duration);
end;

type TDisplayCineFilterFunctionPrototype = procedure (flag: LongBool); cdecl;
var _DisplayCineFilter: TDisplayCineFilterFunctionPrototype;

procedure DisplayCineFilter(flag: Boolean);
begin
	_DisplayCineFilter(flag);
end;

type TIsCineFilterDisplayedFunctionPrototype = function: LongBool; cdecl;
var _IsCineFilterDisplayed: TIsCineFilterDisplayedFunctionPrototype;

function IsCineFilterDisplayed: Boolean;
begin
	Result:= _IsCineFilterDisplayed();
end;

type TSetCinematicSceneFunctionPrototype = procedure (portraitUnitId: Int32; color: HPLAYERCOLOR; speakerTitle: PJassString; text: PJassString; sceneDuration: PSingle; voiceoverDuration: PSingle); cdecl;
var _SetCinematicScene: TSetCinematicSceneFunctionPrototype;

procedure SetCinematicScene(portraitUnitId: Integer; color: HPLAYERCOLOR; speakerTitle: String; text: String; sceneDuration: Single; voiceoverDuration: Single);
var
	jspeakerTitle: PJassString;
	jtext: PJassString;
begin
	jspeakerTitle:= CreateJassString(PChar(speakerTitle));
	jtext:= CreateJassString(PChar(text));
	_SetCinematicScene(portraitUnitId, color, jspeakerTitle, jtext, @sceneDuration, @voiceoverDuration);
	DestroyJassString(jspeakerTitle);
	DestroyJassString(jtext);
end;

type TEndCinematicSceneFunctionPrototype = procedure; cdecl;
var _EndCinematicScene: TEndCinematicSceneFunctionPrototype;

procedure EndCinematicScene;
begin
	_EndCinematicScene();
end;

type TForceCinematicSubtitlesFunctionPrototype = procedure (flag: LongBool); cdecl;
var _ForceCinematicSubtitles: TForceCinematicSubtitlesFunctionPrototype;

procedure ForceCinematicSubtitles(flag: Boolean);
begin
	_ForceCinematicSubtitles(flag);
end;

type TGetCameraMarginFunctionPrototype = function (whichMargin: Int32): TSingle; cdecl;
var _GetCameraMargin: TGetCameraMarginFunctionPrototype;

function GetCameraMargin(whichMargin: Integer): Single;
begin
	Result:= _GetCameraMargin(whichMargin).Value;
end;

type TGetCameraBoundMinXFunctionPrototype = function: TSingle; cdecl;
var _GetCameraBoundMinX: TGetCameraBoundMinXFunctionPrototype;

function GetCameraBoundMinX: Single;
begin
	Result:= _GetCameraBoundMinX().Value;
end;

type TGetCameraBoundMinYFunctionPrototype = function: TSingle; cdecl;
var _GetCameraBoundMinY: TGetCameraBoundMinYFunctionPrototype;

function GetCameraBoundMinY: Single;
begin
	Result:= _GetCameraBoundMinY().Value;
end;

type TGetCameraBoundMaxXFunctionPrototype = function: TSingle; cdecl;
var _GetCameraBoundMaxX: TGetCameraBoundMaxXFunctionPrototype;

function GetCameraBoundMaxX: Single;
begin
	Result:= _GetCameraBoundMaxX().Value;
end;

type TGetCameraBoundMaxYFunctionPrototype = function: TSingle; cdecl;
var _GetCameraBoundMaxY: TGetCameraBoundMaxYFunctionPrototype;

function GetCameraBoundMaxY: Single;
begin
	Result:= _GetCameraBoundMaxY().Value;
end;

type TGetCameraFieldFunctionPrototype = function (whichField: HCAMERAFIELD): TSingle; cdecl;
var _GetCameraField: TGetCameraFieldFunctionPrototype;

function GetCameraField(whichField: HCAMERAFIELD): Single;
begin
	Result:= _GetCameraField(whichField).Value;
end;

type TGetCameraTargetPositionXFunctionPrototype = function: TSingle; cdecl;
var _GetCameraTargetPositionX: TGetCameraTargetPositionXFunctionPrototype;

function GetCameraTargetPositionX: Single;
begin
	Result:= _GetCameraTargetPositionX().Value;
end;

type TGetCameraTargetPositionYFunctionPrototype = function: TSingle; cdecl;
var _GetCameraTargetPositionY: TGetCameraTargetPositionYFunctionPrototype;

function GetCameraTargetPositionY: Single;
begin
	Result:= _GetCameraTargetPositionY().Value;
end;

type TGetCameraTargetPositionZFunctionPrototype = function: TSingle; cdecl;
var _GetCameraTargetPositionZ: TGetCameraTargetPositionZFunctionPrototype;

function GetCameraTargetPositionZ: Single;
begin
	Result:= _GetCameraTargetPositionZ().Value;
end;

type TGetCameraTargetPositionLocFunctionPrototype = function: HLOCATION; cdecl;
var _GetCameraTargetPositionLoc: TGetCameraTargetPositionLocFunctionPrototype;

function GetCameraTargetPositionLoc: HLOCATION;
begin
	Result:= _GetCameraTargetPositionLoc();
end;

type TGetCameraEyePositionXFunctionPrototype = function: TSingle; cdecl;
var _GetCameraEyePositionX: TGetCameraEyePositionXFunctionPrototype;

function GetCameraEyePositionX: Single;
begin
	Result:= _GetCameraEyePositionX().Value;
end;

type TGetCameraEyePositionYFunctionPrototype = function: TSingle; cdecl;
var _GetCameraEyePositionY: TGetCameraEyePositionYFunctionPrototype;

function GetCameraEyePositionY: Single;
begin
	Result:= _GetCameraEyePositionY().Value;
end;

type TGetCameraEyePositionZFunctionPrototype = function: TSingle; cdecl;
var _GetCameraEyePositionZ: TGetCameraEyePositionZFunctionPrototype;

function GetCameraEyePositionZ: Single;
begin
	Result:= _GetCameraEyePositionZ().Value;
end;

type TGetCameraEyePositionLocFunctionPrototype = function: HLOCATION; cdecl;
var _GetCameraEyePositionLoc: TGetCameraEyePositionLocFunctionPrototype;

function GetCameraEyePositionLoc: HLOCATION;
begin
	Result:= _GetCameraEyePositionLoc();
end;

type TNewSoundEnvironmentFunctionPrototype = procedure (environmentName: PJassString); cdecl;
var _NewSoundEnvironment: TNewSoundEnvironmentFunctionPrototype;

procedure NewSoundEnvironment(environmentName: String);
var
	jenvironmentName: PJassString;
begin
	jenvironmentName:= CreateJassString(PChar(environmentName));
	_NewSoundEnvironment(jenvironmentName);
	DestroyJassString(jenvironmentName);
end;

type TCreateSoundFunctionPrototype = function (fileName: PJassString; looping: LongBool; is3D: LongBool; stopwhenoutofrange: LongBool; fadeInRate: Int32; fadeOutRate: Int32; eaxSetting: PJassString): HSOUND; cdecl;
var _CreateSound: TCreateSoundFunctionPrototype;

function CreateSound(fileName: String; looping: Boolean; is3D: Boolean; stopwhenoutofrange: Boolean; fadeInRate: Integer; fadeOutRate: Integer; eaxSetting: String): HSOUND;
var
	jfileName: PJassString;
	jeaxSetting: PJassString;
begin
	jfileName:= CreateJassString(PChar(fileName));
	jeaxSetting:= CreateJassString(PChar(eaxSetting));
	Result:= _CreateSound(jfileName, looping, is3D, stopwhenoutofrange, fadeInRate, fadeOutRate, jeaxSetting);
	DestroyJassString(jfileName);
	DestroyJassString(jeaxSetting);
end;

type TCreateSoundFilenameWithLabelFunctionPrototype = function (fileName: PJassString; looping: LongBool; is3D: LongBool; stopwhenoutofrange: LongBool; fadeInRate: Int32; fadeOutRate: Int32; SLKEntryName: PJassString): HSOUND; cdecl;
var _CreateSoundFilenameWithLabel: TCreateSoundFilenameWithLabelFunctionPrototype;

function CreateSoundFilenameWithLabel(fileName: String; looping: Boolean; is3D: Boolean; stopwhenoutofrange: Boolean; fadeInRate: Integer; fadeOutRate: Integer; SLKEntryName: String): HSOUND;
var
	jfileName: PJassString;
	jSLKEntryName: PJassString;
begin
	jfileName:= CreateJassString(PChar(fileName));
	jSLKEntryName:= CreateJassString(PChar(SLKEntryName));
	Result:= _CreateSoundFilenameWithLabel(jfileName, looping, is3D, stopwhenoutofrange, fadeInRate, fadeOutRate, jSLKEntryName);
	DestroyJassString(jfileName);
	DestroyJassString(jSLKEntryName);
end;

type TCreateSoundFromLabelFunctionPrototype = function (soundLabel: PJassString; looping: LongBool; is3D: LongBool; stopwhenoutofrange: LongBool; fadeInRate: Int32; fadeOutRate: Int32): HSOUND; cdecl;
var _CreateSoundFromLabel: TCreateSoundFromLabelFunctionPrototype;

function CreateSoundFromLabel(soundLabel: String; looping: Boolean; is3D: Boolean; stopwhenoutofrange: Boolean; fadeInRate: Integer; fadeOutRate: Integer): HSOUND;
var
	jsoundLabel: PJassString;
begin
	jsoundLabel:= CreateJassString(PChar(soundLabel));
	Result:= _CreateSoundFromLabel(jsoundLabel, looping, is3D, stopwhenoutofrange, fadeInRate, fadeOutRate);
	DestroyJassString(jsoundLabel);
end;

type TCreateMIDISoundFunctionPrototype = function (soundLabel: PJassString; fadeInRate: Int32; fadeOutRate: Int32): HSOUND; cdecl;
var _CreateMIDISound: TCreateMIDISoundFunctionPrototype;

function CreateMIDISound(soundLabel: String; fadeInRate: Integer; fadeOutRate: Integer): HSOUND;
var
	jsoundLabel: PJassString;
begin
	jsoundLabel:= CreateJassString(PChar(soundLabel));
	Result:= _CreateMIDISound(jsoundLabel, fadeInRate, fadeOutRate);
	DestroyJassString(jsoundLabel);
end;

type TSetSoundParamsFromLabelFunctionPrototype = procedure (soundHandle: HSOUND; soundLabel: PJassString); cdecl;
var _SetSoundParamsFromLabel: TSetSoundParamsFromLabelFunctionPrototype;

procedure SetSoundParamsFromLabel(soundHandle: HSOUND; soundLabel: String);
var
	jsoundLabel: PJassString;
begin
	jsoundLabel:= CreateJassString(PChar(soundLabel));
	_SetSoundParamsFromLabel(soundHandle, jsoundLabel);
	DestroyJassString(jsoundLabel);
end;

type TSetSoundDistanceCutoffFunctionPrototype = procedure (soundHandle: HSOUND; cutoff: PSingle); cdecl;
var _SetSoundDistanceCutoff: TSetSoundDistanceCutoffFunctionPrototype;

procedure SetSoundDistanceCutoff(soundHandle: HSOUND; cutoff: Single);
begin
	_SetSoundDistanceCutoff(soundHandle, @cutoff);
end;

type TSetSoundChannelFunctionPrototype = procedure (soundHandle: HSOUND; channel: Int32); cdecl;
var _SetSoundChannel: TSetSoundChannelFunctionPrototype;

procedure SetSoundChannel(soundHandle: HSOUND; channel: Integer);
begin
	_SetSoundChannel(soundHandle, channel);
end;

type TSetSoundVolumeFunctionPrototype = procedure (soundHandle: HSOUND; volume: Int32); cdecl;
var _SetSoundVolume: TSetSoundVolumeFunctionPrototype;

procedure SetSoundVolume(soundHandle: HSOUND; volume: Integer);
begin
	_SetSoundVolume(soundHandle, volume);
end;

type TSetSoundPitchFunctionPrototype = procedure (soundHandle: HSOUND; pitch: PSingle); cdecl;
var _SetSoundPitch: TSetSoundPitchFunctionPrototype;

procedure SetSoundPitch(soundHandle: HSOUND; pitch: Single);
begin
	_SetSoundPitch(soundHandle, @pitch);
end;

type TSetSoundPlayPositionFunctionPrototype = procedure (soundHandle: HSOUND; millisecs: Int32); cdecl;
var _SetSoundPlayPosition: TSetSoundPlayPositionFunctionPrototype;

procedure SetSoundPlayPosition(soundHandle: HSOUND; millisecs: Integer);
begin
	_SetSoundPlayPosition(soundHandle, millisecs);
end;

type TSetSoundDistancesFunctionPrototype = procedure (soundHandle: HSOUND; minDist: PSingle; maxDist: PSingle); cdecl;
var _SetSoundDistances: TSetSoundDistancesFunctionPrototype;

procedure SetSoundDistances(soundHandle: HSOUND; minDist: Single; maxDist: Single);
begin
	_SetSoundDistances(soundHandle, @minDist, @maxDist);
end;

type TSetSoundConeAnglesFunctionPrototype = procedure (soundHandle: HSOUND; inside: PSingle; outside: PSingle; outsideVolume: Int32); cdecl;
var _SetSoundConeAngles: TSetSoundConeAnglesFunctionPrototype;

procedure SetSoundConeAngles(soundHandle: HSOUND; inside: Single; outside: Single; outsideVolume: Integer);
begin
	_SetSoundConeAngles(soundHandle, @inside, @outside, outsideVolume);
end;

type TSetSoundConeOrientationFunctionPrototype = procedure (soundHandle: HSOUND; x: PSingle; y: PSingle; z: PSingle); cdecl;
var _SetSoundConeOrientation: TSetSoundConeOrientationFunctionPrototype;

procedure SetSoundConeOrientation(soundHandle: HSOUND; x: Single; y: Single; z: Single);
begin
	_SetSoundConeOrientation(soundHandle, @x, @y, @z);
end;

type TSetSoundPositionFunctionPrototype = procedure (soundHandle: HSOUND; x: PSingle; y: PSingle; z: PSingle); cdecl;
var _SetSoundPosition: TSetSoundPositionFunctionPrototype;

procedure SetSoundPosition(soundHandle: HSOUND; x: Single; y: Single; z: Single);
begin
	_SetSoundPosition(soundHandle, @x, @y, @z);
end;

type TSetSoundVelocityFunctionPrototype = procedure (soundHandle: HSOUND; x: PSingle; y: PSingle; z: PSingle); cdecl;
var _SetSoundVelocity: TSetSoundVelocityFunctionPrototype;

procedure SetSoundVelocity(soundHandle: HSOUND; x: Single; y: Single; z: Single);
begin
	_SetSoundVelocity(soundHandle, @x, @y, @z);
end;

type TAttachSoundToUnitFunctionPrototype = procedure (soundHandle: HSOUND; whichUnit: HUNIT); cdecl;
var _AttachSoundToUnit: TAttachSoundToUnitFunctionPrototype;

procedure AttachSoundToUnit(soundHandle: HSOUND; whichUnit: HUNIT);
begin
	_AttachSoundToUnit(soundHandle, whichUnit);
end;

type TStartSoundFunctionPrototype = procedure (soundHandle: HSOUND); cdecl;
var _StartSound: TStartSoundFunctionPrototype;

procedure StartSound(soundHandle: HSOUND);
begin
	_StartSound(soundHandle);
end;

type TStopSoundFunctionPrototype = procedure (soundHandle: HSOUND; killWhenDone: LongBool; fadeOut: LongBool); cdecl;
var _StopSound: TStopSoundFunctionPrototype;

procedure StopSound(soundHandle: HSOUND; killWhenDone: Boolean; fadeOut: Boolean);
begin
	_StopSound(soundHandle, killWhenDone, fadeOut);
end;

type TKillSoundWhenDoneFunctionPrototype = procedure (soundHandle: HSOUND); cdecl;
var _KillSoundWhenDone: TKillSoundWhenDoneFunctionPrototype;

procedure KillSoundWhenDone(soundHandle: HSOUND);
begin
	_KillSoundWhenDone(soundHandle);
end;

type TSetMapMusicFunctionPrototype = procedure (musicName: PJassString; random: LongBool; index: Int32); cdecl;
var _SetMapMusic: TSetMapMusicFunctionPrototype;

procedure SetMapMusic(musicName: String; random: Boolean; index: Integer);
var
	jmusicName: PJassString;
begin
	jmusicName:= CreateJassString(PChar(musicName));
	_SetMapMusic(jmusicName, random, index);
	DestroyJassString(jmusicName);
end;

type TClearMapMusicFunctionPrototype = procedure; cdecl;
var _ClearMapMusic: TClearMapMusicFunctionPrototype;

procedure ClearMapMusic;
begin
	_ClearMapMusic();
end;

type TPlayMusicFunctionPrototype = procedure (musicName: PJassString); cdecl;
var _PlayMusic: TPlayMusicFunctionPrototype;

procedure PlayMusic(musicName: String);
var
	jmusicName: PJassString;
begin
	jmusicName:= CreateJassString(PChar(musicName));
	_PlayMusic(jmusicName);
	DestroyJassString(jmusicName);
end;

type TPlayMusicExFunctionPrototype = procedure (musicName: PJassString; frommsecs: Int32; fadeinmsecs: Int32); cdecl;
var _PlayMusicEx: TPlayMusicExFunctionPrototype;

procedure PlayMusicEx(musicName: String; frommsecs: Integer; fadeinmsecs: Integer);
var
	jmusicName: PJassString;
begin
	jmusicName:= CreateJassString(PChar(musicName));
	_PlayMusicEx(jmusicName, frommsecs, fadeinmsecs);
	DestroyJassString(jmusicName);
end;

type TStopMusicFunctionPrototype = procedure (fadeOut: LongBool); cdecl;
var _StopMusic: TStopMusicFunctionPrototype;

procedure StopMusic(fadeOut: Boolean);
begin
	_StopMusic(fadeOut);
end;

type TResumeMusicFunctionPrototype = procedure; cdecl;
var _ResumeMusic: TResumeMusicFunctionPrototype;

procedure ResumeMusic;
begin
	_ResumeMusic();
end;

type TPlayThematicMusicFunctionPrototype = procedure (musicFileName: PJassString); cdecl;
var _PlayThematicMusic: TPlayThematicMusicFunctionPrototype;

procedure PlayThematicMusic(musicFileName: String);
var
	jmusicFileName: PJassString;
begin
	jmusicFileName:= CreateJassString(PChar(musicFileName));
	_PlayThematicMusic(jmusicFileName);
	DestroyJassString(jmusicFileName);
end;

type TPlayThematicMusicExFunctionPrototype = procedure (musicFileName: PJassString; frommsecs: Int32); cdecl;
var _PlayThematicMusicEx: TPlayThematicMusicExFunctionPrototype;

procedure PlayThematicMusicEx(musicFileName: String; frommsecs: Integer);
var
	jmusicFileName: PJassString;
begin
	jmusicFileName:= CreateJassString(PChar(musicFileName));
	_PlayThematicMusicEx(jmusicFileName, frommsecs);
	DestroyJassString(jmusicFileName);
end;

type TEndThematicMusicFunctionPrototype = procedure; cdecl;
var _EndThematicMusic: TEndThematicMusicFunctionPrototype;

procedure EndThematicMusic;
begin
	_EndThematicMusic();
end;

type TSetMusicVolumeFunctionPrototype = procedure (volume: Int32); cdecl;
var _SetMusicVolume: TSetMusicVolumeFunctionPrototype;

procedure SetMusicVolume(volume: Integer);
begin
	_SetMusicVolume(volume);
end;

type TSetMusicPlayPositionFunctionPrototype = procedure (millisecs: Int32); cdecl;
var _SetMusicPlayPosition: TSetMusicPlayPositionFunctionPrototype;

procedure SetMusicPlayPosition(millisecs: Integer);
begin
	_SetMusicPlayPosition(millisecs);
end;

type TSetThematicMusicPlayPositionFunctionPrototype = procedure (millisecs: Int32); cdecl;
var _SetThematicMusicPlayPosition: TSetThematicMusicPlayPositionFunctionPrototype;

procedure SetThematicMusicPlayPosition(millisecs: Integer);
begin
	_SetThematicMusicPlayPosition(millisecs);
end;

type TSetSoundDurationFunctionPrototype = procedure (soundHandle: HSOUND; duration: Int32); cdecl;
var _SetSoundDuration: TSetSoundDurationFunctionPrototype;

procedure SetSoundDuration(soundHandle: HSOUND; duration: Integer);
begin
	_SetSoundDuration(soundHandle, duration);
end;

type TGetSoundDurationFunctionPrototype = function (soundHandle: HSOUND): Int32; cdecl;
var _GetSoundDuration: TGetSoundDurationFunctionPrototype;

function GetSoundDuration(soundHandle: HSOUND): Integer;
begin
	Result:= _GetSoundDuration(soundHandle);
end;

type TGetSoundFileDurationFunctionPrototype = function (musicFileName: PJassString): Int32; cdecl;
var _GetSoundFileDuration: TGetSoundFileDurationFunctionPrototype;

function GetSoundFileDuration(musicFileName: String): Integer;
var
	jmusicFileName: PJassString;
begin
	jmusicFileName:= CreateJassString(PChar(musicFileName));
	Result:= _GetSoundFileDuration(jmusicFileName);
	DestroyJassString(jmusicFileName);
end;

type TVolumeGroupSetVolumeFunctionPrototype = procedure (vgroup: HVOLUMEGROUP; scale: PSingle); cdecl;
var _VolumeGroupSetVolume: TVolumeGroupSetVolumeFunctionPrototype;

procedure VolumeGroupSetVolume(vgroup: HVOLUMEGROUP; scale: Single);
begin
	_VolumeGroupSetVolume(vgroup, @scale);
end;

type TVolumeGroupResetFunctionPrototype = procedure; cdecl;
var _VolumeGroupReset: TVolumeGroupResetFunctionPrototype;

procedure VolumeGroupReset;
begin
	_VolumeGroupReset();
end;

type TGetSoundIsPlayingFunctionPrototype = function (soundHandle: HSOUND): LongBool; cdecl;
var _GetSoundIsPlaying: TGetSoundIsPlayingFunctionPrototype;

function GetSoundIsPlaying(soundHandle: HSOUND): Boolean;
begin
	Result:= _GetSoundIsPlaying(soundHandle);
end;

type TGetSoundIsLoadingFunctionPrototype = function (soundHandle: HSOUND): LongBool; cdecl;
var _GetSoundIsLoading: TGetSoundIsLoadingFunctionPrototype;

function GetSoundIsLoading(soundHandle: HSOUND): Boolean;
begin
	Result:= _GetSoundIsLoading(soundHandle);
end;

type TRegisterStackedSoundFunctionPrototype = procedure (soundHandle: HSOUND; byPosition: LongBool; rectwidth: PSingle; rectheight: PSingle); cdecl;
var _RegisterStackedSound: TRegisterStackedSoundFunctionPrototype;

procedure RegisterStackedSound(soundHandle: HSOUND; byPosition: Boolean; rectwidth: Single; rectheight: Single);
begin
	_RegisterStackedSound(soundHandle, byPosition, @rectwidth, @rectheight);
end;

type TUnregisterStackedSoundFunctionPrototype = procedure (soundHandle: HSOUND; byPosition: LongBool; rectwidth: PSingle; rectheight: PSingle); cdecl;
var _UnregisterStackedSound: TUnregisterStackedSoundFunctionPrototype;

procedure UnregisterStackedSound(soundHandle: HSOUND; byPosition: Boolean; rectwidth: Single; rectheight: Single);
begin
	_UnregisterStackedSound(soundHandle, byPosition, @rectwidth, @rectheight);
end;

type TAddWeatherEffectFunctionPrototype = function (where: HRECT; effectID: Int32): HWEATHEREFFECT; cdecl;
var _AddWeatherEffect: TAddWeatherEffectFunctionPrototype;

function AddWeatherEffect(where: HRECT; effectID: Integer): HWEATHEREFFECT;
begin
	Result:= _AddWeatherEffect(where, effectID);
end;

type TRemoveWeatherEffectFunctionPrototype = procedure (whichEffect: HWEATHEREFFECT); cdecl;
var _RemoveWeatherEffect: TRemoveWeatherEffectFunctionPrototype;

procedure RemoveWeatherEffect(whichEffect: HWEATHEREFFECT);
begin
	_RemoveWeatherEffect(whichEffect);
end;

type TEnableWeatherEffectFunctionPrototype = procedure (whichEffect: HWEATHEREFFECT; enable: LongBool); cdecl;
var _EnableWeatherEffect: TEnableWeatherEffectFunctionPrototype;

procedure EnableWeatherEffect(whichEffect: HWEATHEREFFECT; enable: Boolean);
begin
	_EnableWeatherEffect(whichEffect, enable);
end;

type TTerrainDeformCraterFunctionPrototype = function (x: PSingle; y: PSingle; radius: PSingle; depth: PSingle; duration: Int32; permanent: LongBool): HTERRAINDEFORMATION; cdecl;
var _TerrainDeformCrater: TTerrainDeformCraterFunctionPrototype;

function TerrainDeformCrater(x: Single; y: Single; radius: Single; depth: Single; duration: Integer; permanent: Boolean): HTERRAINDEFORMATION;
begin
	Result:= _TerrainDeformCrater(@x, @y, @radius, @depth, duration, permanent);
end;

type TTerrainDeformRippleFunctionPrototype = function (x: PSingle; y: PSingle; radius: PSingle; depth: PSingle; duration: Int32; count: Int32; spaceWaves: PSingle; timeWaves: PSingle; radiusStartPct: PSingle; limitNeg: LongBool): HTERRAINDEFORMATION; cdecl;
var _TerrainDeformRipple: TTerrainDeformRippleFunctionPrototype;

function TerrainDeformRipple(x: Single; y: Single; radius: Single; depth: Single; duration: Integer; count: Integer; spaceWaves: Single; timeWaves: Single; radiusStartPct: Single; limitNeg: Boolean): HTERRAINDEFORMATION;
begin
	Result:= _TerrainDeformRipple(@x, @y, @radius, @depth, duration, count, @spaceWaves, @timeWaves, @radiusStartPct, limitNeg);
end;

type TTerrainDeformWaveFunctionPrototype = function (x: PSingle; y: PSingle; dirX: PSingle; dirY: PSingle; distance: PSingle; speed: PSingle; radius: PSingle; depth: PSingle; trailTime: Int32; count: Int32): HTERRAINDEFORMATION; cdecl;
var _TerrainDeformWave: TTerrainDeformWaveFunctionPrototype;

function TerrainDeformWave(x: Single; y: Single; dirX: Single; dirY: Single; distance: Single; speed: Single; radius: Single; depth: Single; trailTime: Integer; count: Integer): HTERRAINDEFORMATION;
begin
	Result:= _TerrainDeformWave(@x, @y, @dirX, @dirY, @distance, @speed, @radius, @depth, trailTime, count);
end;

type TTerrainDeformRandomFunctionPrototype = function (x: PSingle; y: PSingle; radius: PSingle; minDelta: PSingle; maxDelta: PSingle; duration: Int32; updateInterval: Int32): HTERRAINDEFORMATION; cdecl;
var _TerrainDeformRandom: TTerrainDeformRandomFunctionPrototype;

function TerrainDeformRandom(x: Single; y: Single; radius: Single; minDelta: Single; maxDelta: Single; duration: Integer; updateInterval: Integer): HTERRAINDEFORMATION;
begin
	Result:= _TerrainDeformRandom(@x, @y, @radius, @minDelta, @maxDelta, duration, updateInterval);
end;

type TTerrainDeformStopFunctionPrototype = procedure (deformation: HTERRAINDEFORMATION; duration: Int32); cdecl;
var _TerrainDeformStop: TTerrainDeformStopFunctionPrototype;

procedure TerrainDeformStop(deformation: HTERRAINDEFORMATION; duration: Integer);
begin
	_TerrainDeformStop(deformation, duration);
end;

type TTerrainDeformStopAllFunctionPrototype = procedure; cdecl;
var _TerrainDeformStopAll: TTerrainDeformStopAllFunctionPrototype;

procedure TerrainDeformStopAll;
begin
	_TerrainDeformStopAll();
end;

type TAddSpecialEffectFunctionPrototype = function (modelName: PJassString; x: PSingle; y: PSingle): HEFFECT; cdecl;
var _AddSpecialEffect: TAddSpecialEffectFunctionPrototype;

function AddSpecialEffect(modelName: String; x: Single; y: Single): HEFFECT;
var
	jmodelName: PJassString;
begin
	jmodelName:= CreateJassString(PChar(modelName));
	Result:= _AddSpecialEffect(jmodelName, @x, @y);
	DestroyJassString(jmodelName);
end;

type TAddSpecialEffectLocFunctionPrototype = function (modelName: PJassString; where: HLOCATION): HEFFECT; cdecl;
var _AddSpecialEffectLoc: TAddSpecialEffectLocFunctionPrototype;

function AddSpecialEffectLoc(modelName: String; where: HLOCATION): HEFFECT;
var
	jmodelName: PJassString;
begin
	jmodelName:= CreateJassString(PChar(modelName));
	Result:= _AddSpecialEffectLoc(jmodelName, where);
	DestroyJassString(jmodelName);
end;

type TAddSpecialEffectTargetFunctionPrototype = function (modelName: PJassString; targetWidget: HWIDGET; attachPointName: PJassString): HEFFECT; cdecl;
var _AddSpecialEffectTarget: TAddSpecialEffectTargetFunctionPrototype;

function AddSpecialEffectTarget(modelName: String; targetWidget: HWIDGET; attachPointName: String): HEFFECT;
var
	jmodelName: PJassString;
	jattachPointName: PJassString;
begin
	jmodelName:= CreateJassString(PChar(modelName));
	jattachPointName:= CreateJassString(PChar(attachPointName));
	Result:= _AddSpecialEffectTarget(jmodelName, targetWidget, jattachPointName);
	DestroyJassString(jmodelName);
	DestroyJassString(jattachPointName);
end;

type TDestroyEffectFunctionPrototype = procedure (whichEffect: HEFFECT); cdecl;
var _DestroyEffect: TDestroyEffectFunctionPrototype;

procedure DestroyEffect(whichEffect: HEFFECT);
begin
	_DestroyEffect(whichEffect);
end;

type TAddSpellEffectFunctionPrototype = function (abilityString: PJassString; t: HEFFECTTYPE; x: PSingle; y: PSingle): HEFFECT; cdecl;
var _AddSpellEffect: TAddSpellEffectFunctionPrototype;

function AddSpellEffect(abilityString: String; t: HEFFECTTYPE; x: Single; y: Single): HEFFECT;
var
	jabilityString: PJassString;
begin
	jabilityString:= CreateJassString(PChar(abilityString));
	Result:= _AddSpellEffect(jabilityString, t, @x, @y);
	DestroyJassString(jabilityString);
end;

type TAddSpellEffectLocFunctionPrototype = function (abilityString: PJassString; t: HEFFECTTYPE; where: HLOCATION): HEFFECT; cdecl;
var _AddSpellEffectLoc: TAddSpellEffectLocFunctionPrototype;

function AddSpellEffectLoc(abilityString: String; t: HEFFECTTYPE; where: HLOCATION): HEFFECT;
var
	jabilityString: PJassString;
begin
	jabilityString:= CreateJassString(PChar(abilityString));
	Result:= _AddSpellEffectLoc(jabilityString, t, where);
	DestroyJassString(jabilityString);
end;

type TAddSpellEffectByIdFunctionPrototype = function (abilityId: Int32; t: HEFFECTTYPE; x: PSingle; y: PSingle): HEFFECT; cdecl;
var _AddSpellEffectById: TAddSpellEffectByIdFunctionPrototype;

function AddSpellEffectById(abilityId: Integer; t: HEFFECTTYPE; x: Single; y: Single): HEFFECT;
begin
	Result:= _AddSpellEffectById(abilityId, t, @x, @y);
end;

type TAddSpellEffectByIdLocFunctionPrototype = function (abilityId: Int32; t: HEFFECTTYPE; where: HLOCATION): HEFFECT; cdecl;
var _AddSpellEffectByIdLoc: TAddSpellEffectByIdLocFunctionPrototype;

function AddSpellEffectByIdLoc(abilityId: Integer; t: HEFFECTTYPE; where: HLOCATION): HEFFECT;
begin
	Result:= _AddSpellEffectByIdLoc(abilityId, t, where);
end;

type TAddSpellEffectTargetFunctionPrototype = function (modelName: PJassString; t: HEFFECTTYPE; targetWidget: HWIDGET; attachPoint: PJassString): HEFFECT; cdecl;
var _AddSpellEffectTarget: TAddSpellEffectTargetFunctionPrototype;

function AddSpellEffectTarget(modelName: String; t: HEFFECTTYPE; targetWidget: HWIDGET; attachPoint: String): HEFFECT;
var
	jmodelName: PJassString;
	jattachPoint: PJassString;
begin
	jmodelName:= CreateJassString(PChar(modelName));
	jattachPoint:= CreateJassString(PChar(attachPoint));
	Result:= _AddSpellEffectTarget(jmodelName, t, targetWidget, jattachPoint);
	DestroyJassString(jmodelName);
	DestroyJassString(jattachPoint);
end;

type TAddSpellEffectTargetByIdFunctionPrototype = function (abilityId: Int32; t: HEFFECTTYPE; targetWidget: HWIDGET; attachPoint: PJassString): HEFFECT; cdecl;
var _AddSpellEffectTargetById: TAddSpellEffectTargetByIdFunctionPrototype;

function AddSpellEffectTargetById(abilityId: Integer; t: HEFFECTTYPE; targetWidget: HWIDGET; attachPoint: String): HEFFECT;
var
	jattachPoint: PJassString;
begin
	jattachPoint:= CreateJassString(PChar(attachPoint));
	Result:= _AddSpellEffectTargetById(abilityId, t, targetWidget, jattachPoint);
	DestroyJassString(jattachPoint);
end;

type TAddLightningFunctionPrototype = function (codeName: PJassString; checkVisibility: LongBool; x1: PSingle; y1: PSingle; x2: PSingle; y2: PSingle): HLIGHTNING; cdecl;
var _AddLightning: TAddLightningFunctionPrototype;

function AddLightning(codeName: String; checkVisibility: Boolean; x1: Single; y1: Single; x2: Single; y2: Single): HLIGHTNING;
var
	jcodeName: PJassString;
begin
	jcodeName:= CreateJassString(PChar(codeName));
	Result:= _AddLightning(jcodeName, checkVisibility, @x1, @y1, @x2, @y2);
	DestroyJassString(jcodeName);
end;

type TAddLightningExFunctionPrototype = function (codeName: PJassString; checkVisibility: LongBool; x1: PSingle; y1: PSingle; z1: PSingle; x2: PSingle; y2: PSingle; z2: PSingle): HLIGHTNING; cdecl;
var _AddLightningEx: TAddLightningExFunctionPrototype;

function AddLightningEx(codeName: String; checkVisibility: Boolean; x1: Single; y1: Single; z1: Single; x2: Single; y2: Single; z2: Single): HLIGHTNING;
var
	jcodeName: PJassString;
begin
	jcodeName:= CreateJassString(PChar(codeName));
	Result:= _AddLightningEx(jcodeName, checkVisibility, @x1, @y1, @z1, @x2, @y2, @z2);
	DestroyJassString(jcodeName);
end;

type TDestroyLightningFunctionPrototype = function (whichBolt: HLIGHTNING): LongBool; cdecl;
var _DestroyLightning: TDestroyLightningFunctionPrototype;

function DestroyLightning(whichBolt: HLIGHTNING): Boolean;
begin
	Result:= _DestroyLightning(whichBolt);
end;

type TMoveLightningFunctionPrototype = function (whichBolt: HLIGHTNING; checkVisibility: LongBool; x1: PSingle; y1: PSingle; x2: PSingle; y2: PSingle): LongBool; cdecl;
var _MoveLightning: TMoveLightningFunctionPrototype;

function MoveLightning(whichBolt: HLIGHTNING; checkVisibility: Boolean; x1: Single; y1: Single; x2: Single; y2: Single): Boolean;
begin
	Result:= _MoveLightning(whichBolt, checkVisibility, @x1, @y1, @x2, @y2);
end;

type TMoveLightningExFunctionPrototype = function (whichBolt: HLIGHTNING; checkVisibility: LongBool; x1: PSingle; y1: PSingle; z1: PSingle; x2: PSingle; y2: PSingle; z2: PSingle): LongBool; cdecl;
var _MoveLightningEx: TMoveLightningExFunctionPrototype;

function MoveLightningEx(whichBolt: HLIGHTNING; checkVisibility: Boolean; x1: Single; y1: Single; z1: Single; x2: Single; y2: Single; z2: Single): Boolean;
begin
	Result:= _MoveLightningEx(whichBolt, checkVisibility, @x1, @y1, @z1, @x2, @y2, @z2);
end;

type TGetLightningColorAFunctionPrototype = function (whichBolt: HLIGHTNING): TSingle; cdecl;
var _GetLightningColorA: TGetLightningColorAFunctionPrototype;

function GetLightningColorA(whichBolt: HLIGHTNING): Single;
begin
	Result:= _GetLightningColorA(whichBolt).Value;
end;

type TGetLightningColorRFunctionPrototype = function (whichBolt: HLIGHTNING): TSingle; cdecl;
var _GetLightningColorR: TGetLightningColorRFunctionPrototype;

function GetLightningColorR(whichBolt: HLIGHTNING): Single;
begin
	Result:= _GetLightningColorR(whichBolt).Value;
end;

type TGetLightningColorGFunctionPrototype = function (whichBolt: HLIGHTNING): TSingle; cdecl;
var _GetLightningColorG: TGetLightningColorGFunctionPrototype;

function GetLightningColorG(whichBolt: HLIGHTNING): Single;
begin
	Result:= _GetLightningColorG(whichBolt).Value;
end;

type TGetLightningColorBFunctionPrototype = function (whichBolt: HLIGHTNING): TSingle; cdecl;
var _GetLightningColorB: TGetLightningColorBFunctionPrototype;

function GetLightningColorB(whichBolt: HLIGHTNING): Single;
begin
	Result:= _GetLightningColorB(whichBolt).Value;
end;

type TSetLightningColorFunctionPrototype = function (whichBolt: HLIGHTNING; r: PSingle; g: PSingle; b: PSingle; a: PSingle): LongBool; cdecl;
var _SetLightningColor: TSetLightningColorFunctionPrototype;

function SetLightningColor(whichBolt: HLIGHTNING; r: Single; g: Single; b: Single; a: Single): Boolean;
begin
	Result:= _SetLightningColor(whichBolt, @r, @g, @b, @a);
end;

type TGetAbilityEffectFunctionPrototype = function (abilityString: PJassString; t: HEFFECTTYPE; index: Int32): TJassStringHandle; cdecl;
var _GetAbilityEffect: TGetAbilityEffectFunctionPrototype;

function GetAbilityEffect(abilityString: String; t: HEFFECTTYPE; index: Integer): String;
var
	jabilityString: PJassString;
	hResult: TJassStringHandle;
begin
	jabilityString:= CreateJassString(PChar(abilityString));
	hResult:= _GetAbilityEffect(jabilityString, t, index);
	Result:= GetStringFromHandle(hResult);
	DecrementStringReferences(hResult);
	DestroyJassString(jabilityString);
end;

type TGetAbilityEffectByIdFunctionPrototype = function (abilityId: Int32; t: HEFFECTTYPE; index: Int32): TJassStringHandle; cdecl;
var _GetAbilityEffectById: TGetAbilityEffectByIdFunctionPrototype;

function GetAbilityEffectById(abilityId: Integer; t: HEFFECTTYPE; index: Integer): String;
var
	hResult: TJassStringHandle;
begin
	hResult:= _GetAbilityEffectById(abilityId, t, index);
	Result:= GetStringFromHandle(hResult);
	DecrementStringReferences(hResult);
end;

type TGetAbilitySoundFunctionPrototype = function (abilityString: PJassString; t: HSOUNDTYPE): TJassStringHandle; cdecl;
var _GetAbilitySound: TGetAbilitySoundFunctionPrototype;

function GetAbilitySound(abilityString: String; t: HSOUNDTYPE): String;
var
	jabilityString: PJassString;
	hResult: TJassStringHandle;
begin
	jabilityString:= CreateJassString(PChar(abilityString));
	hResult:= _GetAbilitySound(jabilityString, t);
	Result:= GetStringFromHandle(hResult);
	DecrementStringReferences(hResult);
	DestroyJassString(jabilityString);
end;

type TGetAbilitySoundByIdFunctionPrototype = function (abilityId: Int32; t: HSOUNDTYPE): TJassStringHandle; cdecl;
var _GetAbilitySoundById: TGetAbilitySoundByIdFunctionPrototype;

function GetAbilitySoundById(abilityId: Integer; t: HSOUNDTYPE): String;
var
	hResult: TJassStringHandle;
begin
	hResult:= _GetAbilitySoundById(abilityId, t);
	Result:= GetStringFromHandle(hResult);
	DecrementStringReferences(hResult);
end;

type TGetTerrainCliffLevelFunctionPrototype = function (x: PSingle; y: PSingle): Int32; cdecl;
var _GetTerrainCliffLevel: TGetTerrainCliffLevelFunctionPrototype;

function GetTerrainCliffLevel(x: Single; y: Single): Integer;
begin
	Result:= _GetTerrainCliffLevel(@x, @y);
end;

type TSetWaterBaseColorFunctionPrototype = procedure (red: Int32; green: Int32; blue: Int32; alpha: Int32); cdecl;
var _SetWaterBaseColor: TSetWaterBaseColorFunctionPrototype;

procedure SetWaterBaseColor(red: Integer; green: Integer; blue: Integer; alpha: Integer);
begin
	_SetWaterBaseColor(red, green, blue, alpha);
end;

type TSetWaterDeformsFunctionPrototype = procedure (val: LongBool); cdecl;
var _SetWaterDeforms: TSetWaterDeformsFunctionPrototype;

procedure SetWaterDeforms(val: Boolean);
begin
	_SetWaterDeforms(val);
end;

type TGetTerrainTypeFunctionPrototype = function (x: PSingle; y: PSingle): Int32; cdecl;
var _GetTerrainType: TGetTerrainTypeFunctionPrototype;

function GetTerrainType(x: Single; y: Single): Integer;
begin
	Result:= _GetTerrainType(@x, @y);
end;

type TGetTerrainVarianceFunctionPrototype = function (x: PSingle; y: PSingle): Int32; cdecl;
var _GetTerrainVariance: TGetTerrainVarianceFunctionPrototype;

function GetTerrainVariance(x: Single; y: Single): Integer;
begin
	Result:= _GetTerrainVariance(@x, @y);
end;

type TSetTerrainTypeFunctionPrototype = procedure (x: PSingle; y: PSingle; terrainType: Int32; variation: Int32; area: Int32; shape: Int32); cdecl;
var _SetTerrainType: TSetTerrainTypeFunctionPrototype;

procedure SetTerrainType(x: Single; y: Single; terrainType: Integer; variation: Integer; area: Integer; shape: Integer);
begin
	_SetTerrainType(@x, @y, terrainType, variation, area, shape);
end;

type TIsTerrainPathableFunctionPrototype = function (x: PSingle; y: PSingle; t: HPATHINGTYPE): LongBool; cdecl;
var _IsTerrainPathable: TIsTerrainPathableFunctionPrototype;

function IsTerrainPathable(x: Single; y: Single; t: HPATHINGTYPE): Boolean;
begin
	Result:= _IsTerrainPathable(@x, @y, t);
end;

type TSetTerrainPathableFunctionPrototype = procedure (x: PSingle; y: PSingle; t: HPATHINGTYPE; flag: LongBool); cdecl;
var _SetTerrainPathable: TSetTerrainPathableFunctionPrototype;

procedure SetTerrainPathable(x: Single; y: Single; t: HPATHINGTYPE; flag: Boolean);
begin
	_SetTerrainPathable(@x, @y, t, flag);
end;

type TCreateImageFunctionPrototype = function (file_: PJassString; sizeX: PSingle; sizeY: PSingle; sizeZ: PSingle; posX: PSingle; posY: PSingle; posZ: PSingle; originX: PSingle; originY: PSingle; originZ: PSingle; imageType: Int32): HIMAGE; cdecl;
var _CreateImage: TCreateImageFunctionPrototype;

function CreateImage(file_: String; sizeX: Single; sizeY: Single; sizeZ: Single; posX: Single; posY: Single; posZ: Single; originX: Single; originY: Single; originZ: Single; imageType: Integer): HIMAGE;
var
	jfile: PJassString;
begin
	jfile:= CreateJassString(PChar(file_));
	Result:= _CreateImage(jfile, @sizeX, @sizeY, @sizeZ, @posX, @posY, @posZ, @originX, @originY, @originZ, imageType);
	DestroyJassString(jfile);
end;

type TDestroyImageFunctionPrototype = procedure (whichImage: HIMAGE); cdecl;
var _DestroyImage: TDestroyImageFunctionPrototype;

procedure DestroyImage(whichImage: HIMAGE);
begin
	_DestroyImage(whichImage);
end;

type TShowImageFunctionPrototype = procedure (whichImage: HIMAGE; flag: LongBool); cdecl;
var _ShowImage: TShowImageFunctionPrototype;

procedure ShowImage(whichImage: HIMAGE; flag: Boolean);
begin
	_ShowImage(whichImage, flag);
end;

type TSetImageConstantHeightFunctionPrototype = procedure (whichImage: HIMAGE; flag: LongBool; height: PSingle); cdecl;
var _SetImageConstantHeight: TSetImageConstantHeightFunctionPrototype;

procedure SetImageConstantHeight(whichImage: HIMAGE; flag: Boolean; height: Single);
begin
	_SetImageConstantHeight(whichImage, flag, @height);
end;

type TSetImagePositionFunctionPrototype = procedure (whichImage: HIMAGE; x: PSingle; y: PSingle; z: PSingle); cdecl;
var _SetImagePosition: TSetImagePositionFunctionPrototype;

procedure SetImagePosition(whichImage: HIMAGE; x: Single; y: Single; z: Single);
begin
	_SetImagePosition(whichImage, @x, @y, @z);
end;

type TSetImageColorFunctionPrototype = procedure (whichImage: HIMAGE; red: Int32; green: Int32; blue: Int32; alpha: Int32); cdecl;
var _SetImageColor: TSetImageColorFunctionPrototype;

procedure SetImageColor(whichImage: HIMAGE; red: Integer; green: Integer; blue: Integer; alpha: Integer);
begin
	_SetImageColor(whichImage, red, green, blue, alpha);
end;

type TSetImageRenderFunctionPrototype = procedure (whichImage: HIMAGE; flag: LongBool); cdecl;
var _SetImageRender: TSetImageRenderFunctionPrototype;

procedure SetImageRender(whichImage: HIMAGE; flag: Boolean);
begin
	_SetImageRender(whichImage, flag);
end;

type TSetImageRenderAlwaysFunctionPrototype = procedure (whichImage: HIMAGE; flag: LongBool); cdecl;
var _SetImageRenderAlways: TSetImageRenderAlwaysFunctionPrototype;

procedure SetImageRenderAlways(whichImage: HIMAGE; flag: Boolean);
begin
	_SetImageRenderAlways(whichImage, flag);
end;

type TSetImageAboveWaterFunctionPrototype = procedure (whichImage: HIMAGE; flag: LongBool; useWaterAlpha: LongBool); cdecl;
var _SetImageAboveWater: TSetImageAboveWaterFunctionPrototype;

procedure SetImageAboveWater(whichImage: HIMAGE; flag: Boolean; useWaterAlpha: Boolean);
begin
	_SetImageAboveWater(whichImage, flag, useWaterAlpha);
end;

type TSetImageTypeFunctionPrototype = procedure (whichImage: HIMAGE; imageType: Int32); cdecl;
var _SetImageType: TSetImageTypeFunctionPrototype;

procedure SetImageType(whichImage: HIMAGE; imageType: Integer);
begin
	_SetImageType(whichImage, imageType);
end;

type TCreateUbersplatFunctionPrototype = function (x: PSingle; y: PSingle; name: PJassString; red: Int32; green: Int32; blue: Int32; alpha: Int32; forcePaused: LongBool; noBirthTime: LongBool): HUBERSPLAT; cdecl;
var _CreateUbersplat: TCreateUbersplatFunctionPrototype;

function CreateUbersplat(x: Single; y: Single; name: String; red: Integer; green: Integer; blue: Integer; alpha: Integer; forcePaused: Boolean; noBirthTime: Boolean): HUBERSPLAT;
var
	jname: PJassString;
begin
	jname:= CreateJassString(PChar(name));
	Result:= _CreateUbersplat(@x, @y, jname, red, green, blue, alpha, forcePaused, noBirthTime);
	DestroyJassString(jname);
end;

type TDestroyUbersplatFunctionPrototype = procedure (whichSplat: HUBERSPLAT); cdecl;
var _DestroyUbersplat: TDestroyUbersplatFunctionPrototype;

procedure DestroyUbersplat(whichSplat: HUBERSPLAT);
begin
	_DestroyUbersplat(whichSplat);
end;

type TResetUbersplatFunctionPrototype = procedure (whichSplat: HUBERSPLAT); cdecl;
var _ResetUbersplat: TResetUbersplatFunctionPrototype;

procedure ResetUbersplat(whichSplat: HUBERSPLAT);
begin
	_ResetUbersplat(whichSplat);
end;

type TFinishUbersplatFunctionPrototype = procedure (whichSplat: HUBERSPLAT); cdecl;
var _FinishUbersplat: TFinishUbersplatFunctionPrototype;

procedure FinishUbersplat(whichSplat: HUBERSPLAT);
begin
	_FinishUbersplat(whichSplat);
end;

type TShowUbersplatFunctionPrototype = procedure (whichSplat: HUBERSPLAT; flag: LongBool); cdecl;
var _ShowUbersplat: TShowUbersplatFunctionPrototype;

procedure ShowUbersplat(whichSplat: HUBERSPLAT; flag: Boolean);
begin
	_ShowUbersplat(whichSplat, flag);
end;

type TSetUbersplatRenderFunctionPrototype = procedure (whichSplat: HUBERSPLAT; flag: LongBool); cdecl;
var _SetUbersplatRender: TSetUbersplatRenderFunctionPrototype;

procedure SetUbersplatRender(whichSplat: HUBERSPLAT; flag: Boolean);
begin
	_SetUbersplatRender(whichSplat, flag);
end;

type TSetUbersplatRenderAlwaysFunctionPrototype = procedure (whichSplat: HUBERSPLAT; flag: LongBool); cdecl;
var _SetUbersplatRenderAlways: TSetUbersplatRenderAlwaysFunctionPrototype;

procedure SetUbersplatRenderAlways(whichSplat: HUBERSPLAT; flag: Boolean);
begin
	_SetUbersplatRenderAlways(whichSplat, flag);
end;

type TSetBlightFunctionPrototype = procedure (whichPlayer: HPLAYER; x: PSingle; y: PSingle; radius: PSingle; addBlight: LongBool); cdecl;
var _SetBlight: TSetBlightFunctionPrototype;

procedure SetBlight(whichPlayer: HPLAYER; x: Single; y: Single; radius: Single; addBlight: Boolean);
begin
	_SetBlight(whichPlayer, @x, @y, @radius, addBlight);
end;

type TSetBlightRectFunctionPrototype = procedure (whichPlayer: HPLAYER; r: HRECT; addBlight: LongBool); cdecl;
var _SetBlightRect: TSetBlightRectFunctionPrototype;

procedure SetBlightRect(whichPlayer: HPLAYER; r: HRECT; addBlight: Boolean);
begin
	_SetBlightRect(whichPlayer, r, addBlight);
end;

type TSetBlightPointFunctionPrototype = procedure (whichPlayer: HPLAYER; x: PSingle; y: PSingle; addBlight: LongBool); cdecl;
var _SetBlightPoint: TSetBlightPointFunctionPrototype;

procedure SetBlightPoint(whichPlayer: HPLAYER; x: Single; y: Single; addBlight: Boolean);
begin
	_SetBlightPoint(whichPlayer, @x, @y, addBlight);
end;

type TSetBlightLocFunctionPrototype = procedure (whichPlayer: HPLAYER; whichLocation: HLOCATION; radius: PSingle; addBlight: LongBool); cdecl;
var _SetBlightLoc: TSetBlightLocFunctionPrototype;

procedure SetBlightLoc(whichPlayer: HPLAYER; whichLocation: HLOCATION; radius: Single; addBlight: Boolean);
begin
	_SetBlightLoc(whichPlayer, whichLocation, @radius, addBlight);
end;

type TCreateBlightedGoldmineFunctionPrototype = function (id: HPLAYER; x: PSingle; y: PSingle; face: PSingle): HUNIT; cdecl;
var _CreateBlightedGoldmine: TCreateBlightedGoldmineFunctionPrototype;

function CreateBlightedGoldmine(id: HPLAYER; x: Single; y: Single; face: Single): HUNIT;
begin
	Result:= _CreateBlightedGoldmine(id, @x, @y, @face);
end;

type TIsPointBlightedFunctionPrototype = function (x: PSingle; y: PSingle): LongBool; cdecl;
var _IsPointBlighted: TIsPointBlightedFunctionPrototype;

function IsPointBlighted(x: Single; y: Single): Boolean;
begin
	Result:= _IsPointBlighted(@x, @y);
end;

type TSetDoodadAnimationFunctionPrototype = procedure (x: PSingle; y: PSingle; radius: PSingle; doodadID: Int32; nearestOnly: LongBool; animName: PJassString; animRandom: LongBool); cdecl;
var _SetDoodadAnimation: TSetDoodadAnimationFunctionPrototype;

procedure SetDoodadAnimation(x: Single; y: Single; radius: Single; doodadID: Integer; nearestOnly: Boolean; animName: String; animRandom: Boolean);
var
	janimName: PJassString;
begin
	janimName:= CreateJassString(PChar(animName));
	_SetDoodadAnimation(@x, @y, @radius, doodadID, nearestOnly, janimName, animRandom);
	DestroyJassString(janimName);
end;

type TSetDoodadAnimationRectFunctionPrototype = procedure (r: HRECT; doodadID: Int32; animName: PJassString; animRandom: LongBool); cdecl;
var _SetDoodadAnimationRect: TSetDoodadAnimationRectFunctionPrototype;

procedure SetDoodadAnimationRect(r: HRECT; doodadID: Integer; animName: String; animRandom: Boolean);
var
	janimName: PJassString;
begin
	janimName:= CreateJassString(PChar(animName));
	_SetDoodadAnimationRect(r, doodadID, janimName, animRandom);
	DestroyJassString(janimName);
end;

type TStartMeleeAIFunctionPrototype = procedure (num: HPLAYER; script: PJassString); cdecl;
var _StartMeleeAI: TStartMeleeAIFunctionPrototype;

procedure StartMeleeAI(num: HPLAYER; script: String);
var
	jscript: PJassString;
begin
	jscript:= CreateJassString(PChar(script));
	_StartMeleeAI(num, jscript);
	DestroyJassString(jscript);
end;

type TStartCampaignAIFunctionPrototype = procedure (num: HPLAYER; script: PJassString); cdecl;
var _StartCampaignAI: TStartCampaignAIFunctionPrototype;

procedure StartCampaignAI(num: HPLAYER; script: String);
var
	jscript: PJassString;
begin
	jscript:= CreateJassString(PChar(script));
	_StartCampaignAI(num, jscript);
	DestroyJassString(jscript);
end;

type TCommandAIFunctionPrototype = procedure (num: HPLAYER; command: Int32; data: Int32); cdecl;
var _CommandAI: TCommandAIFunctionPrototype;

procedure CommandAI(num: HPLAYER; command: Integer; data: Integer);
begin
	_CommandAI(num, command, data);
end;

type TPauseCompAIFunctionPrototype = procedure (p: HPLAYER; pause: LongBool); cdecl;
var _PauseCompAI: TPauseCompAIFunctionPrototype;

procedure PauseCompAI(p: HPLAYER; pause: Boolean);
begin
	_PauseCompAI(p, pause);
end;

type TGetAIDifficultyFunctionPrototype = function (num: HPLAYER): HAIDIFFICULTY; cdecl;
var _GetAIDifficulty: TGetAIDifficultyFunctionPrototype;

function GetAIDifficulty(num: HPLAYER): HAIDIFFICULTY;
begin
	Result:= _GetAIDifficulty(num);
end;

type TRemoveGuardPositionFunctionPrototype = procedure (hUnit: HUNIT); cdecl;
var _RemoveGuardPosition: TRemoveGuardPositionFunctionPrototype;

procedure RemoveGuardPosition(hUnit: HUNIT);
begin
	_RemoveGuardPosition(hUnit);
end;

type TRecycleGuardPositionFunctionPrototype = procedure (hUnit: HUNIT); cdecl;
var _RecycleGuardPosition: TRecycleGuardPositionFunctionPrototype;

procedure RecycleGuardPosition(hUnit: HUNIT);
begin
	_RecycleGuardPosition(hUnit);
end;

type TRemoveAllGuardPositionsFunctionPrototype = procedure (num: HPLAYER); cdecl;
var _RemoveAllGuardPositions: TRemoveAllGuardPositionsFunctionPrototype;

procedure RemoveAllGuardPositions(num: HPLAYER);
begin
	_RemoveAllGuardPositions(num);
end;

type TCheatFunctionPrototype = procedure (cheatStr: PJassString); cdecl;
var _Cheat: TCheatFunctionPrototype;

procedure Cheat(cheatStr: String);
var
	jcheatStr: PJassString;
begin
	jcheatStr:= CreateJassString(PChar(cheatStr));
	_Cheat(jcheatStr);
	DestroyJassString(jcheatStr);
end;

type TIsNoVictoryCheatFunctionPrototype = function: LongBool; cdecl;
var _IsNoVictoryCheat: TIsNoVictoryCheatFunctionPrototype;

function IsNoVictoryCheat: Boolean;
begin
	Result:= _IsNoVictoryCheat();
end;

type TIsNoDefeatCheatFunctionPrototype = function: LongBool; cdecl;
var _IsNoDefeatCheat: TIsNoDefeatCheatFunctionPrototype;

function IsNoDefeatCheat: Boolean;
begin
	Result:= _IsNoDefeatCheat();
end;

type TPreloadFunctionPrototype = procedure (filename: PJassString); cdecl;
var _Preload: TPreloadFunctionPrototype;

procedure Preload(filename: String);
var
	jfilename: PJassString;
begin
	jfilename:= CreateJassString(PChar(filename));
	_Preload(jfilename);
	DestroyJassString(jfilename);
end;

type TPreloadEndFunctionPrototype = procedure (timeout: PSingle); cdecl;
var _PreloadEnd: TPreloadEndFunctionPrototype;

procedure PreloadEnd(timeout: Single);
begin
	_PreloadEnd(@timeout);
end;

type TPreloadStartFunctionPrototype = procedure; cdecl;
var _PreloadStart: TPreloadStartFunctionPrototype;

procedure PreloadStart;
begin
	_PreloadStart();
end;

type TPreloadRefreshFunctionPrototype = procedure; cdecl;
var _PreloadRefresh: TPreloadRefreshFunctionPrototype;

procedure PreloadRefresh;
begin
	_PreloadRefresh();
end;

type TPreloadEndExFunctionPrototype = procedure; cdecl;
var _PreloadEndEx: TPreloadEndExFunctionPrototype;

procedure PreloadEndEx;
begin
	_PreloadEndEx();
end;

type TPreloadGenClearFunctionPrototype = procedure; cdecl;
var _PreloadGenClear: TPreloadGenClearFunctionPrototype;

procedure PreloadGenClear;
begin
	_PreloadGenClear();
end;

type TPreloadGenStartFunctionPrototype = procedure; cdecl;
var _PreloadGenStart: TPreloadGenStartFunctionPrototype;

procedure PreloadGenStart;
begin
	_PreloadGenStart();
end;

type TPreloadGenEndFunctionPrototype = procedure (filename: PJassString); cdecl;
var _PreloadGenEnd: TPreloadGenEndFunctionPrototype;

procedure PreloadGenEnd(filename: String);
var
	jfilename: PJassString;
begin
	jfilename:= CreateJassString(PChar(filename));
	_PreloadGenEnd(jfilename);
	DestroyJassString(jfilename);
end;

type TPreloaderFunctionPrototype = procedure (filename: PJassString); cdecl;
var _Preloader: TPreloaderFunctionPrototype;

procedure Preloader(filename: String);
var
	jfilename: PJassString;
begin
	jfilename:= CreateJassString(PChar(filename));
	_Preloader(jfilename);
	DestroyJassString(jfilename);
end;

procedure Init;
begin
	Pointer(_ConvertRace):= GetJassNative('ConvertRace');
	Pointer(_ConvertAllianceType):= GetJassNative('ConvertAllianceType');
	Pointer(_ConvertRacePref):= GetJassNative('ConvertRacePref');
	Pointer(_ConvertIGameState):= GetJassNative('ConvertIGameState');
	Pointer(_ConvertFGameState):= GetJassNative('ConvertFGameState');
	Pointer(_ConvertPlayerState):= GetJassNative('ConvertPlayerState');
	Pointer(_ConvertPlayerScore):= GetJassNative('ConvertPlayerScore');
	Pointer(_ConvertPlayerGameResult):= GetJassNative('ConvertPlayerGameResult');
	Pointer(_ConvertUnitState):= GetJassNative('ConvertUnitState');
	Pointer(_ConvertAIDifficulty):= GetJassNative('ConvertAIDifficulty');
	Pointer(_ConvertGameEvent):= GetJassNative('ConvertGameEvent');
	Pointer(_ConvertPlayerEvent):= GetJassNative('ConvertPlayerEvent');
	Pointer(_ConvertPlayerUnitEvent):= GetJassNative('ConvertPlayerUnitEvent');
	Pointer(_ConvertWidgetEvent):= GetJassNative('ConvertWidgetEvent');
	Pointer(_ConvertDialogEvent):= GetJassNative('ConvertDialogEvent');
	Pointer(_ConvertUnitEvent):= GetJassNative('ConvertUnitEvent');
	Pointer(_ConvertLimitOp):= GetJassNative('ConvertLimitOp');
	Pointer(_ConvertUnitType):= GetJassNative('ConvertUnitType');
	Pointer(_ConvertGameSpeed):= GetJassNative('ConvertGameSpeed');
	Pointer(_ConvertPlacement):= GetJassNative('ConvertPlacement');
	Pointer(_ConvertStartLocPrio):= GetJassNative('ConvertStartLocPrio');
	Pointer(_ConvertGameDifficulty):= GetJassNative('ConvertGameDifficulty');
	Pointer(_ConvertGameType):= GetJassNative('ConvertGameType');
	Pointer(_ConvertMapFlag):= GetJassNative('ConvertMapFlag');
	Pointer(_ConvertMapVisibility):= GetJassNative('ConvertMapVisibility');
	Pointer(_ConvertMapSetting):= GetJassNative('ConvertMapSetting');
	Pointer(_ConvertMapDensity):= GetJassNative('ConvertMapDensity');
	Pointer(_ConvertMapControl):= GetJassNative('ConvertMapControl');
	Pointer(_ConvertPlayerColor):= GetJassNative('ConvertPlayerColor');
	Pointer(_ConvertPlayerSlotState):= GetJassNative('ConvertPlayerSlotState');
	Pointer(_ConvertVolumeGroup):= GetJassNative('ConvertVolumeGroup');
	Pointer(_ConvertCameraField):= GetJassNative('ConvertCameraField');
	Pointer(_ConvertBlendMode):= GetJassNative('ConvertBlendMode');
	Pointer(_ConvertRarityControl):= GetJassNative('ConvertRarityControl');
	Pointer(_ConvertTexMapFlags):= GetJassNative('ConvertTexMapFlags');
	Pointer(_ConvertFogState):= GetJassNative('ConvertFogState');
	Pointer(_ConvertEffectType):= GetJassNative('ConvertEffectType');
	Pointer(_ConvertVersion):= GetJassNative('ConvertVersion');
	Pointer(_ConvertItemType):= GetJassNative('ConvertItemType');
	Pointer(_ConvertAttackType):= GetJassNative('ConvertAttackType');
	Pointer(_ConvertDamageType):= GetJassNative('ConvertDamageType');
	Pointer(_ConvertWeaponType):= GetJassNative('ConvertWeaponType');
	Pointer(_ConvertSoundType):= GetJassNative('ConvertSoundType');
	Pointer(_ConvertPathingType):= GetJassNative('ConvertPathingType');
	Pointer(_OrderId):= GetJassNative('OrderId');
	Pointer(_OrderId2String):= GetJassNative('OrderId2String');
	Pointer(_UnitId):= GetJassNative('UnitId');
	Pointer(_UnitId2String):= GetJassNative('UnitId2String');
	Pointer(_AbilityId):= GetJassNative('AbilityId');
	Pointer(_AbilityId2String):= GetJassNative('AbilityId2String');
	Pointer(_GetObjectName):= GetJassNative('GetObjectName');
	Pointer(_Deg2Rad):= GetJassNative('Deg2Rad');
	Pointer(_Rad2Deg):= GetJassNative('Rad2Deg');
	Pointer(_Sin):= GetJassNative('Sin');
	Pointer(_Cos):= GetJassNative('Cos');
	Pointer(_Tan):= GetJassNative('Tan');
	Pointer(_Asin):= GetJassNative('Asin');
	Pointer(_Acos):= GetJassNative('Acos');
	Pointer(_Atan):= GetJassNative('Atan');
	Pointer(_Atan2):= GetJassNative('Atan2');
	Pointer(_SquareRoot):= GetJassNative('SquareRoot');
	Pointer(_Pow):= GetJassNative('Pow');
	Pointer(_I2R):= GetJassNative('I2R');
	Pointer(_R2I):= GetJassNative('R2I');
	Pointer(_I2S):= GetJassNative('I2S');
	Pointer(_R2S):= GetJassNative('R2S');
	Pointer(_R2SW):= GetJassNative('R2SW');
	Pointer(_S2I):= GetJassNative('S2I');
	Pointer(_S2R):= GetJassNative('S2R');
	Pointer(_GetHandleId):= GetJassNative('GetHandleId');
	Pointer(_SubString):= GetJassNative('SubString');
	Pointer(_StringLength):= GetJassNative('StringLength');
	Pointer(_StringCase):= GetJassNative('StringCase');
	Pointer(_StringHash):= GetJassNative('StringHash');
	Pointer(_GetLocalizedString):= GetJassNative('GetLocalizedString');
	Pointer(_GetLocalizedHotkey):= GetJassNative('GetLocalizedHotkey');
	Pointer(_SetMapName):= GetJassNative('SetMapName');
	Pointer(_SetMapDescription):= GetJassNative('SetMapDescription');
	Pointer(_SetTeams):= GetJassNative('SetTeams');
	Pointer(_SetPlayers):= GetJassNative('SetPlayers');
	Pointer(_DefineStartLocation):= GetJassNative('DefineStartLocation');
	Pointer(_DefineStartLocationLoc):= GetJassNative('DefineStartLocationLoc');
	Pointer(_SetStartLocPrioCount):= GetJassNative('SetStartLocPrioCount');
	Pointer(_SetStartLocPrio):= GetJassNative('SetStartLocPrio');
	Pointer(_GetStartLocPrioSlot):= GetJassNative('GetStartLocPrioSlot');
	Pointer(_GetStartLocPrio):= GetJassNative('GetStartLocPrio');
	Pointer(_SetGameTypeSupported):= GetJassNative('SetGameTypeSupported');
	Pointer(_SetMapFlag):= GetJassNative('SetMapFlag');
	Pointer(_SetGamePlacement):= GetJassNative('SetGamePlacement');
	Pointer(_SetGameSpeed):= GetJassNative('SetGameSpeed');
	Pointer(_SetGameDifficulty):= GetJassNative('SetGameDifficulty');
	Pointer(_SetResourceDensity):= GetJassNative('SetResourceDensity');
	Pointer(_SetCreatureDensity):= GetJassNative('SetCreatureDensity');
	Pointer(_GetTeams):= GetJassNative('GetTeams');
	Pointer(_GetPlayers):= GetJassNative('GetPlayers');
	Pointer(_IsGameTypeSupported):= GetJassNative('IsGameTypeSupported');
	Pointer(_GetGameTypeSelected):= GetJassNative('GetGameTypeSelected');
	Pointer(_IsMapFlagSet):= GetJassNative('IsMapFlagSet');
	Pointer(_GetGamePlacement):= GetJassNative('GetGamePlacement');
	Pointer(_GetGameSpeed):= GetJassNative('GetGameSpeed');
	Pointer(_GetGameDifficulty):= GetJassNative('GetGameDifficulty');
	Pointer(_GetResourceDensity):= GetJassNative('GetResourceDensity');
	Pointer(_GetCreatureDensity):= GetJassNative('GetCreatureDensity');
	Pointer(_GetStartLocationX):= GetJassNative('GetStartLocationX');
	Pointer(_GetStartLocationY):= GetJassNative('GetStartLocationY');
	Pointer(_GetStartLocationLoc):= GetJassNative('GetStartLocationLoc');
	Pointer(_SetPlayerTeam):= GetJassNative('SetPlayerTeam');
	Pointer(_SetPlayerStartLocation):= GetJassNative('SetPlayerStartLocation');
	Pointer(_ForcePlayerStartLocation):= GetJassNative('ForcePlayerStartLocation');
	Pointer(_SetPlayerColor):= GetJassNative('SetPlayerColor');
	Pointer(_SetPlayerAlliance):= GetJassNative('SetPlayerAlliance');
	Pointer(_SetPlayerTaxRate):= GetJassNative('SetPlayerTaxRate');
	Pointer(_SetPlayerRacePreference):= GetJassNative('SetPlayerRacePreference');
	Pointer(_SetPlayerRaceSelectable):= GetJassNative('SetPlayerRaceSelectable');
	Pointer(_SetPlayerController):= GetJassNative('SetPlayerController');
	Pointer(_SetPlayerName):= GetJassNative('SetPlayerName');
	Pointer(_SetPlayerOnScoreScreen):= GetJassNative('SetPlayerOnScoreScreen');
	Pointer(_GetPlayerTeam):= GetJassNative('GetPlayerTeam');
	Pointer(_GetPlayerStartLocation):= GetJassNative('GetPlayerStartLocation');
	Pointer(_GetPlayerColor):= GetJassNative('GetPlayerColor');
	Pointer(_GetPlayerSelectable):= GetJassNative('GetPlayerSelectable');
	Pointer(_GetPlayerController):= GetJassNative('GetPlayerController');
	Pointer(_GetPlayerSlotState):= GetJassNative('GetPlayerSlotState');
	Pointer(_GetPlayerTaxRate):= GetJassNative('GetPlayerTaxRate');
	Pointer(_IsPlayerRacePrefSet):= GetJassNative('IsPlayerRacePrefSet');
	Pointer(_GetPlayerName):= GetJassNative('GetPlayerName');
	Pointer(_CreateTimer):= GetJassNative('CreateTimer');
	Pointer(_DestroyTimer):= GetJassNative('DestroyTimer');
	Pointer(_TimerStart):= GetJassNative('TimerStart');
	Pointer(_TimerGetElapsed):= GetJassNative('TimerGetElapsed');
	Pointer(_TimerGetRemaining):= GetJassNative('TimerGetRemaining');
	Pointer(_TimerGetTimeout):= GetJassNative('TimerGetTimeout');
	Pointer(_PauseTimer):= GetJassNative('PauseTimer');
	Pointer(_ResumeTimer):= GetJassNative('ResumeTimer');
	Pointer(_GetExpiredTimer):= GetJassNative('GetExpiredTimer');
	Pointer(_CreateGroup):= GetJassNative('CreateGroup');
	Pointer(_DestroyGroup):= GetJassNative('DestroyGroup');
	Pointer(_GroupAddUnit):= GetJassNative('GroupAddUnit');
	Pointer(_GroupRemoveUnit):= GetJassNative('GroupRemoveUnit');
	Pointer(_GroupClear):= GetJassNative('GroupClear');
	Pointer(_GroupEnumUnitsOfType):= GetJassNative('GroupEnumUnitsOfType');
	Pointer(_GroupEnumUnitsOfPlayer):= GetJassNative('GroupEnumUnitsOfPlayer');
	Pointer(_GroupEnumUnitsOfTypeCounted):= GetJassNative('GroupEnumUnitsOfTypeCounted');
	Pointer(_GroupEnumUnitsInRect):= GetJassNative('GroupEnumUnitsInRect');
	Pointer(_GroupEnumUnitsInRectCounted):= GetJassNative('GroupEnumUnitsInRectCounted');
	Pointer(_GroupEnumUnitsInRange):= GetJassNative('GroupEnumUnitsInRange');
	Pointer(_GroupEnumUnitsInRangeOfLoc):= GetJassNative('GroupEnumUnitsInRangeOfLoc');
	Pointer(_GroupEnumUnitsInRangeCounted):= GetJassNative('GroupEnumUnitsInRangeCounted');
	Pointer(_GroupEnumUnitsInRangeOfLocCounted):= GetJassNative('GroupEnumUnitsInRangeOfLocCounted');
	Pointer(_GroupEnumUnitsSelected):= GetJassNative('GroupEnumUnitsSelected');
	Pointer(_GroupImmediateOrder):= GetJassNative('GroupImmediateOrder');
	Pointer(_GroupImmediateOrderById):= GetJassNative('GroupImmediateOrderById');
	Pointer(_GroupPointOrder):= GetJassNative('GroupPointOrder');
	Pointer(_GroupPointOrderLoc):= GetJassNative('GroupPointOrderLoc');
	Pointer(_GroupPointOrderById):= GetJassNative('GroupPointOrderById');
	Pointer(_GroupPointOrderByIdLoc):= GetJassNative('GroupPointOrderByIdLoc');
	Pointer(_GroupTargetOrder):= GetJassNative('GroupTargetOrder');
	Pointer(_GroupTargetOrderById):= GetJassNative('GroupTargetOrderById');
	Pointer(_ForGroup):= GetJassNative('ForGroup');
	Pointer(_FirstOfGroup):= GetJassNative('FirstOfGroup');
	Pointer(_CreateForce):= GetJassNative('CreateForce');
	Pointer(_DestroyForce):= GetJassNative('DestroyForce');
	Pointer(_ForceAddPlayer):= GetJassNative('ForceAddPlayer');
	Pointer(_ForceRemovePlayer):= GetJassNative('ForceRemovePlayer');
	Pointer(_ForceClear):= GetJassNative('ForceClear');
	Pointer(_ForceEnumPlayers):= GetJassNative('ForceEnumPlayers');
	Pointer(_ForceEnumPlayersCounted):= GetJassNative('ForceEnumPlayersCounted');
	Pointer(_ForceEnumAllies):= GetJassNative('ForceEnumAllies');
	Pointer(_ForceEnumEnemies):= GetJassNative('ForceEnumEnemies');
	Pointer(_ForForce):= GetJassNative('ForForce');
	Pointer(_Rect):= GetJassNative('Rect');
	Pointer(_RectFromLoc):= GetJassNative('RectFromLoc');
	Pointer(_RemoveRect):= GetJassNative('RemoveRect');
	Pointer(_SetRect):= GetJassNative('SetRect');
	Pointer(_SetRectFromLoc):= GetJassNative('SetRectFromLoc');
	Pointer(_MoveRectTo):= GetJassNative('MoveRectTo');
	Pointer(_MoveRectToLoc):= GetJassNative('MoveRectToLoc');
	Pointer(_GetRectCenterX):= GetJassNative('GetRectCenterX');
	Pointer(_GetRectCenterY):= GetJassNative('GetRectCenterY');
	Pointer(_GetRectMinX):= GetJassNative('GetRectMinX');
	Pointer(_GetRectMinY):= GetJassNative('GetRectMinY');
	Pointer(_GetRectMaxX):= GetJassNative('GetRectMaxX');
	Pointer(_GetRectMaxY):= GetJassNative('GetRectMaxY');
	Pointer(_CreateRegion):= GetJassNative('CreateRegion');
	Pointer(_RemoveRegion):= GetJassNative('RemoveRegion');
	Pointer(_RegionAddRect):= GetJassNative('RegionAddRect');
	Pointer(_RegionClearRect):= GetJassNative('RegionClearRect');
	Pointer(_RegionAddCell):= GetJassNative('RegionAddCell');
	Pointer(_RegionAddCellAtLoc):= GetJassNative('RegionAddCellAtLoc');
	Pointer(_RegionClearCell):= GetJassNative('RegionClearCell');
	Pointer(_RegionClearCellAtLoc):= GetJassNative('RegionClearCellAtLoc');
	Pointer(_Location):= GetJassNative('Location');
	Pointer(_RemoveLocation):= GetJassNative('RemoveLocation');
	Pointer(_MoveLocation):= GetJassNative('MoveLocation');
	Pointer(_GetLocationX):= GetJassNative('GetLocationX');
	Pointer(_GetLocationY):= GetJassNative('GetLocationY');
	Pointer(_GetLocationZ):= GetJassNative('GetLocationZ');
	Pointer(_IsUnitInRegion):= GetJassNative('IsUnitInRegion');
	Pointer(_IsPointInRegion):= GetJassNative('IsPointInRegion');
	Pointer(_IsLocationInRegion):= GetJassNative('IsLocationInRegion');
	Pointer(_GetWorldBounds):= GetJassNative('GetWorldBounds');
	Pointer(_CreateTrigger):= GetJassNative('CreateTrigger');
	Pointer(_DestroyTrigger):= GetJassNative('DestroyTrigger');
	Pointer(_ResetTrigger):= GetJassNative('ResetTrigger');
	Pointer(_EnableTrigger):= GetJassNative('EnableTrigger');
	Pointer(_DisableTrigger):= GetJassNative('DisableTrigger');
	Pointer(_IsTriggerEnabled):= GetJassNative('IsTriggerEnabled');
	Pointer(_TriggerWaitOnSleeps):= GetJassNative('TriggerWaitOnSleeps');
	Pointer(_IsTriggerWaitOnSleeps):= GetJassNative('IsTriggerWaitOnSleeps');
	Pointer(_GetFilterUnit):= GetJassNative('GetFilterUnit');
	Pointer(_GetEnumUnit):= GetJassNative('GetEnumUnit');
	Pointer(_GetFilterDestructable):= GetJassNative('GetFilterDestructable');
	Pointer(_GetEnumDestructable):= GetJassNative('GetEnumDestructable');
	Pointer(_GetFilterItem):= GetJassNative('GetFilterItem');
	Pointer(_GetEnumItem):= GetJassNative('GetEnumItem');
	Pointer(_GetFilterPlayer):= GetJassNative('GetFilterPlayer');
	Pointer(_GetEnumPlayer):= GetJassNative('GetEnumPlayer');
	Pointer(_GetTriggeringTrigger):= GetJassNative('GetTriggeringTrigger');
	Pointer(_GetTriggerEventId):= GetJassNative('GetTriggerEventId');
	Pointer(_GetTriggerEvalCount):= GetJassNative('GetTriggerEvalCount');
	Pointer(_GetTriggerExecCount):= GetJassNative('GetTriggerExecCount');
	Pointer(_ExecuteFunc):= GetJassNative('ExecuteFunc');
	Pointer(_And):= GetJassNative('And');
	Pointer(_Or):= GetJassNative('Or');
	Pointer(_Not):= GetJassNative('Not');
	Pointer(_Condition):= GetJassNative('Condition');
	Pointer(_DestroyCondition):= GetJassNative('DestroyCondition');
	Pointer(_Filter):= GetJassNative('Filter');
	Pointer(_DestroyFilter):= GetJassNative('DestroyFilter');
	Pointer(_DestroyBoolExpr):= GetJassNative('DestroyBoolExpr');
	Pointer(_TriggerRegisterVariableEvent):= GetJassNative('TriggerRegisterVariableEvent');
	Pointer(_TriggerRegisterTimerEvent):= GetJassNative('TriggerRegisterTimerEvent');
	Pointer(_TriggerRegisterTimerExpireEvent):= GetJassNative('TriggerRegisterTimerExpireEvent');
	Pointer(_TriggerRegisterGameStateEvent):= GetJassNative('TriggerRegisterGameStateEvent');
	Pointer(_TriggerRegisterDialogEvent):= GetJassNative('TriggerRegisterDialogEvent');
	Pointer(_TriggerRegisterDialogButtonEvent):= GetJassNative('TriggerRegisterDialogButtonEvent');
	Pointer(_GetEventGameState):= GetJassNative('GetEventGameState');
	Pointer(_TriggerRegisterGameEvent):= GetJassNative('TriggerRegisterGameEvent');
	Pointer(_GetWinningPlayer):= GetJassNative('GetWinningPlayer');
	Pointer(_TriggerRegisterEnterRegion):= GetJassNative('TriggerRegisterEnterRegion');
	Pointer(_GetTriggeringRegion):= GetJassNative('GetTriggeringRegion');
	Pointer(_GetEnteringUnit):= GetJassNative('GetEnteringUnit');
	Pointer(_TriggerRegisterLeaveRegion):= GetJassNative('TriggerRegisterLeaveRegion');
	Pointer(_GetLeavingUnit):= GetJassNative('GetLeavingUnit');
	Pointer(_TriggerRegisterTrackableHitEvent):= GetJassNative('TriggerRegisterTrackableHitEvent');
	Pointer(_TriggerRegisterTrackableTrackEvent):= GetJassNative('TriggerRegisterTrackableTrackEvent');
	Pointer(_GetTriggeringTrackable):= GetJassNative('GetTriggeringTrackable');
	Pointer(_GetClickedButton):= GetJassNative('GetClickedButton');
	Pointer(_GetClickedDialog):= GetJassNative('GetClickedDialog');
	Pointer(_GetTournamentFinishSoonTimeRemaining):= GetJassNative('GetTournamentFinishSoonTimeRemaining');
	Pointer(_GetTournamentFinishNowRule):= GetJassNative('GetTournamentFinishNowRule');
	Pointer(_GetTournamentFinishNowPlayer):= GetJassNative('GetTournamentFinishNowPlayer');
	Pointer(_GetTournamentScore):= GetJassNative('GetTournamentScore');
	Pointer(_GetSaveBasicFilename):= GetJassNative('GetSaveBasicFilename');
	Pointer(_TriggerRegisterPlayerEvent):= GetJassNative('TriggerRegisterPlayerEvent');
	Pointer(_GetTriggerPlayer):= GetJassNative('GetTriggerPlayer');
	Pointer(_TriggerRegisterPlayerUnitEvent):= GetJassNative('TriggerRegisterPlayerUnitEvent');
	Pointer(_GetLevelingUnit):= GetJassNative('GetLevelingUnit');
	Pointer(_GetLearningUnit):= GetJassNative('GetLearningUnit');
	Pointer(_GetLearnedSkill):= GetJassNative('GetLearnedSkill');
	Pointer(_GetLearnedSkillLevel):= GetJassNative('GetLearnedSkillLevel');
	Pointer(_GetRevivableUnit):= GetJassNative('GetRevivableUnit');
	Pointer(_GetRevivingUnit):= GetJassNative('GetRevivingUnit');
	Pointer(_GetAttacker):= GetJassNative('GetAttacker');
	Pointer(_GetRescuer):= GetJassNative('GetRescuer');
	Pointer(_GetDyingUnit):= GetJassNative('GetDyingUnit');
	Pointer(_GetKillingUnit):= GetJassNative('GetKillingUnit');
	Pointer(_GetDecayingUnit):= GetJassNative('GetDecayingUnit');
	Pointer(_GetConstructingStructure):= GetJassNative('GetConstructingStructure');
	Pointer(_GetCancelledStructure):= GetJassNative('GetCancelledStructure');
	Pointer(_GetConstructedStructure):= GetJassNative('GetConstructedStructure');
	Pointer(_GetResearchingUnit):= GetJassNative('GetResearchingUnit');
	Pointer(_GetResearched):= GetJassNative('GetResearched');
	Pointer(_GetTrainedUnitType):= GetJassNative('GetTrainedUnitType');
	Pointer(_GetTrainedUnit):= GetJassNative('GetTrainedUnit');
	Pointer(_GetDetectedUnit):= GetJassNative('GetDetectedUnit');
	Pointer(_GetSummoningUnit):= GetJassNative('GetSummoningUnit');
	Pointer(_GetSummonedUnit):= GetJassNative('GetSummonedUnit');
	Pointer(_GetTransportUnit):= GetJassNative('GetTransportUnit');
	Pointer(_GetLoadedUnit):= GetJassNative('GetLoadedUnit');
	Pointer(_GetSellingUnit):= GetJassNative('GetSellingUnit');
	Pointer(_GetSoldUnit):= GetJassNative('GetSoldUnit');
	Pointer(_GetBuyingUnit):= GetJassNative('GetBuyingUnit');
	Pointer(_GetSoldItem):= GetJassNative('GetSoldItem');
	Pointer(_GetChangingUnit):= GetJassNative('GetChangingUnit');
	Pointer(_GetChangingUnitPrevOwner):= GetJassNative('GetChangingUnitPrevOwner');
	Pointer(_GetManipulatingUnit):= GetJassNative('GetManipulatingUnit');
	Pointer(_GetManipulatedItem):= GetJassNative('GetManipulatedItem');
	Pointer(_GetOrderedUnit):= GetJassNative('GetOrderedUnit');
	Pointer(_GetIssuedOrderId):= GetJassNative('GetIssuedOrderId');
	Pointer(_GetOrderPointX):= GetJassNative('GetOrderPointX');
	Pointer(_GetOrderPointY):= GetJassNative('GetOrderPointY');
	Pointer(_GetOrderPointLoc):= GetJassNative('GetOrderPointLoc');
	Pointer(_GetOrderTarget):= GetJassNative('GetOrderTarget');
	Pointer(_GetOrderTargetDestructable):= GetJassNative('GetOrderTargetDestructable');
	Pointer(_GetOrderTargetItem):= GetJassNative('GetOrderTargetItem');
	Pointer(_GetOrderTargetUnit):= GetJassNative('GetOrderTargetUnit');
	Pointer(_GetSpellAbilityUnit):= GetJassNative('GetSpellAbilityUnit');
	Pointer(_GetSpellAbilityId):= GetJassNative('GetSpellAbilityId');
	Pointer(_GetSpellAbility):= GetJassNative('GetSpellAbility');
	Pointer(_GetSpellTargetLoc):= GetJassNative('GetSpellTargetLoc');
	Pointer(_GetSpellTargetX):= GetJassNative('GetSpellTargetX');
	Pointer(_GetSpellTargetY):= GetJassNative('GetSpellTargetY');
	Pointer(_GetSpellTargetDestructable):= GetJassNative('GetSpellTargetDestructable');
	Pointer(_GetSpellTargetItem):= GetJassNative('GetSpellTargetItem');
	Pointer(_GetSpellTargetUnit):= GetJassNative('GetSpellTargetUnit');
	Pointer(_TriggerRegisterPlayerAllianceChange):= GetJassNative('TriggerRegisterPlayerAllianceChange');
	Pointer(_TriggerRegisterPlayerStateEvent):= GetJassNative('TriggerRegisterPlayerStateEvent');
	Pointer(_GetEventPlayerState):= GetJassNative('GetEventPlayerState');
	Pointer(_TriggerRegisterPlayerChatEvent):= GetJassNative('TriggerRegisterPlayerChatEvent');
	Pointer(_GetEventPlayerChatString):= GetJassNative('GetEventPlayerChatString');
	Pointer(_GetEventPlayerChatStringMatched):= GetJassNative('GetEventPlayerChatStringMatched');
	Pointer(_TriggerRegisterDeathEvent):= GetJassNative('TriggerRegisterDeathEvent');
	Pointer(_GetTriggerUnit):= GetJassNative('GetTriggerUnit');
	Pointer(_TriggerRegisterUnitStateEvent):= GetJassNative('TriggerRegisterUnitStateEvent');
	Pointer(_GetEventUnitState):= GetJassNative('GetEventUnitState');
	Pointer(_TriggerRegisterUnitEvent):= GetJassNative('TriggerRegisterUnitEvent');
	Pointer(_GetEventDamage):= GetJassNative('GetEventDamage');
	Pointer(_GetEventDamageSource):= GetJassNative('GetEventDamageSource');
	Pointer(_GetEventDetectingPlayer):= GetJassNative('GetEventDetectingPlayer');
	Pointer(_TriggerRegisterFilterUnitEvent):= GetJassNative('TriggerRegisterFilterUnitEvent');
	Pointer(_GetEventTargetUnit):= GetJassNative('GetEventTargetUnit');
	Pointer(_TriggerRegisterUnitInRange):= GetJassNative('TriggerRegisterUnitInRange');
	Pointer(_TriggerAddCondition):= GetJassNative('TriggerAddCondition');
	Pointer(_TriggerRemoveCondition):= GetJassNative('TriggerRemoveCondition');
	Pointer(_TriggerClearConditions):= GetJassNative('TriggerClearConditions');
	Pointer(_TriggerAddAction):= GetJassNative('TriggerAddAction');
	Pointer(_TriggerRemoveAction):= GetJassNative('TriggerRemoveAction');
	Pointer(_TriggerClearActions):= GetJassNative('TriggerClearActions');
	Pointer(_TriggerSleepAction):= GetJassNative('TriggerSleepAction');
	Pointer(_TriggerWaitForSound):= GetJassNative('TriggerWaitForSound');
	Pointer(_TriggerEvaluate):= GetJassNative('TriggerEvaluate');
	Pointer(_TriggerExecute):= GetJassNative('TriggerExecute');
	Pointer(_TriggerExecuteWait):= GetJassNative('TriggerExecuteWait');
	Pointer(_TriggerSyncStart):= GetJassNative('TriggerSyncStart');
	Pointer(_TriggerSyncReady):= GetJassNative('TriggerSyncReady');
	Pointer(_GetWidgetLife):= GetJassNative('GetWidgetLife');
	Pointer(_SetWidgetLife):= GetJassNative('SetWidgetLife');
	Pointer(_GetWidgetX):= GetJassNative('GetWidgetX');
	Pointer(_GetWidgetY):= GetJassNative('GetWidgetY');
	Pointer(_GetTriggerWidget):= GetJassNative('GetTriggerWidget');
	Pointer(_CreateDestructable):= GetJassNative('CreateDestructable');
	Pointer(_CreateDestructableZ):= GetJassNative('CreateDestructableZ');
	Pointer(_CreateDeadDestructable):= GetJassNative('CreateDeadDestructable');
	Pointer(_CreateDeadDestructableZ):= GetJassNative('CreateDeadDestructableZ');
	Pointer(_RemoveDestructable):= GetJassNative('RemoveDestructable');
	Pointer(_KillDestructable):= GetJassNative('KillDestructable');
	Pointer(_SetDestructableInvulnerable):= GetJassNative('SetDestructableInvulnerable');
	Pointer(_IsDestructableInvulnerable):= GetJassNative('IsDestructableInvulnerable');
	Pointer(_EnumDestructablesInRect):= GetJassNative('EnumDestructablesInRect');
	Pointer(_GetDestructableTypeId):= GetJassNative('GetDestructableTypeId');
	Pointer(_GetDestructableX):= GetJassNative('GetDestructableX');
	Pointer(_GetDestructableY):= GetJassNative('GetDestructableY');
	Pointer(_SetDestructableLife):= GetJassNative('SetDestructableLife');
	Pointer(_GetDestructableLife):= GetJassNative('GetDestructableLife');
	Pointer(_SetDestructableMaxLife):= GetJassNative('SetDestructableMaxLife');
	Pointer(_GetDestructableMaxLife):= GetJassNative('GetDestructableMaxLife');
	Pointer(_DestructableRestoreLife):= GetJassNative('DestructableRestoreLife');
	Pointer(_QueueDestructableAnimation):= GetJassNative('QueueDestructableAnimation');
	Pointer(_SetDestructableAnimation):= GetJassNative('SetDestructableAnimation');
	Pointer(_SetDestructableAnimationSpeed):= GetJassNative('SetDestructableAnimationSpeed');
	Pointer(_ShowDestructable):= GetJassNative('ShowDestructable');
	Pointer(_GetDestructableOccluderHeight):= GetJassNative('GetDestructableOccluderHeight');
	Pointer(_SetDestructableOccluderHeight):= GetJassNative('SetDestructableOccluderHeight');
	Pointer(_GetDestructableName):= GetJassNative('GetDestructableName');
	Pointer(_GetTriggerDestructable):= GetJassNative('GetTriggerDestructable');
	Pointer(_CreateItem):= GetJassNative('CreateItem');
	Pointer(_RemoveItem):= GetJassNative('RemoveItem');
	Pointer(_GetItemPlayer):= GetJassNative('GetItemPlayer');
	Pointer(_GetItemTypeId):= GetJassNative('GetItemTypeId');
	Pointer(_GetItemX):= GetJassNative('GetItemX');
	Pointer(_GetItemY):= GetJassNative('GetItemY');
	Pointer(_SetItemPosition):= GetJassNative('SetItemPosition');
	Pointer(_SetItemDropOnDeath):= GetJassNative('SetItemDropOnDeath');
	Pointer(_SetItemDroppable):= GetJassNative('SetItemDroppable');
	Pointer(_SetItemPawnable):= GetJassNative('SetItemPawnable');
	Pointer(_SetItemPlayer):= GetJassNative('SetItemPlayer');
	Pointer(_SetItemInvulnerable):= GetJassNative('SetItemInvulnerable');
	Pointer(_IsItemInvulnerable):= GetJassNative('IsItemInvulnerable');
	Pointer(_SetItemVisible):= GetJassNative('SetItemVisible');
	Pointer(_IsItemVisible):= GetJassNative('IsItemVisible');
	Pointer(_IsItemOwned):= GetJassNative('IsItemOwned');
	Pointer(_IsItemPowerup):= GetJassNative('IsItemPowerup');
	Pointer(_IsItemSellable):= GetJassNative('IsItemSellable');
	Pointer(_IsItemPawnable):= GetJassNative('IsItemPawnable');
	Pointer(_IsItemIdPowerup):= GetJassNative('IsItemIdPowerup');
	Pointer(_IsItemIdSellable):= GetJassNative('IsItemIdSellable');
	Pointer(_IsItemIdPawnable):= GetJassNative('IsItemIdPawnable');
	Pointer(_EnumItemsInRect):= GetJassNative('EnumItemsInRect');
	Pointer(_GetItemLevel):= GetJassNative('GetItemLevel');
	Pointer(_GetItemType):= GetJassNative('GetItemType');
	Pointer(_SetItemDropID):= GetJassNative('SetItemDropID');
	Pointer(_GetItemName):= GetJassNative('GetItemName');
	Pointer(_GetItemCharges):= GetJassNative('GetItemCharges');
	Pointer(_SetItemCharges):= GetJassNative('SetItemCharges');
	Pointer(_GetItemUserData):= GetJassNative('GetItemUserData');
	Pointer(_SetItemUserData):= GetJassNative('SetItemUserData');
	Pointer(_CreateUnit):= GetJassNative('CreateUnit');
	Pointer(_CreateUnitByName):= GetJassNative('CreateUnitByName');
	Pointer(_CreateUnitAtLoc):= GetJassNative('CreateUnitAtLoc');
	Pointer(_CreateUnitAtLocByName):= GetJassNative('CreateUnitAtLocByName');
	Pointer(_CreateCorpse):= GetJassNative('CreateCorpse');
	Pointer(_KillUnit):= GetJassNative('KillUnit');
	Pointer(_RemoveUnit):= GetJassNative('RemoveUnit');
	Pointer(_ShowUnit):= GetJassNative('ShowUnit');
	Pointer(_SetUnitState):= GetJassNative('SetUnitState');
	Pointer(_SetUnitX):= GetJassNative('SetUnitX');
	Pointer(_SetUnitY):= GetJassNative('SetUnitY');
	Pointer(_SetUnitPosition):= GetJassNative('SetUnitPosition');
	Pointer(_SetUnitPositionLoc):= GetJassNative('SetUnitPositionLoc');
	Pointer(_SetUnitFacing):= GetJassNative('SetUnitFacing');
	Pointer(_SetUnitFacingTimed):= GetJassNative('SetUnitFacingTimed');
	Pointer(_SetUnitMoveSpeed):= GetJassNative('SetUnitMoveSpeed');
	Pointer(_SetUnitFlyHeight):= GetJassNative('SetUnitFlyHeight');
	Pointer(_SetUnitTurnSpeed):= GetJassNative('SetUnitTurnSpeed');
	Pointer(_SetUnitPropWindow):= GetJassNative('SetUnitPropWindow');
	Pointer(_SetUnitAcquireRange):= GetJassNative('SetUnitAcquireRange');
	Pointer(_SetUnitCreepGuard):= GetJassNative('SetUnitCreepGuard');
	Pointer(_GetUnitAcquireRange):= GetJassNative('GetUnitAcquireRange');
	Pointer(_GetUnitTurnSpeed):= GetJassNative('GetUnitTurnSpeed');
	Pointer(_GetUnitPropWindow):= GetJassNative('GetUnitPropWindow');
	Pointer(_GetUnitFlyHeight):= GetJassNative('GetUnitFlyHeight');
	Pointer(_GetUnitDefaultAcquireRange):= GetJassNative('GetUnitDefaultAcquireRange');
	Pointer(_GetUnitDefaultTurnSpeed):= GetJassNative('GetUnitDefaultTurnSpeed');
	Pointer(_GetUnitDefaultPropWindow):= GetJassNative('GetUnitDefaultPropWindow');
	Pointer(_GetUnitDefaultFlyHeight):= GetJassNative('GetUnitDefaultFlyHeight');
	Pointer(_SetUnitOwner):= GetJassNative('SetUnitOwner');
	Pointer(_SetUnitColor):= GetJassNative('SetUnitColor');
	Pointer(_SetUnitScale):= GetJassNative('SetUnitScale');
	Pointer(_SetUnitTimeScale):= GetJassNative('SetUnitTimeScale');
	Pointer(_SetUnitBlendTime):= GetJassNative('SetUnitBlendTime');
	Pointer(_SetUnitVertexColor):= GetJassNative('SetUnitVertexColor');
	Pointer(_QueueUnitAnimation):= GetJassNative('QueueUnitAnimation');
	Pointer(_SetUnitAnimation):= GetJassNative('SetUnitAnimation');
	Pointer(_SetUnitAnimationByIndex):= GetJassNative('SetUnitAnimationByIndex');
	Pointer(_SetUnitAnimationWithRarity):= GetJassNative('SetUnitAnimationWithRarity');
	Pointer(_AddUnitAnimationProperties):= GetJassNative('AddUnitAnimationProperties');
	Pointer(_SetUnitLookAt):= GetJassNative('SetUnitLookAt');
	Pointer(_ResetUnitLookAt):= GetJassNative('ResetUnitLookAt');
	Pointer(_SetUnitRescuable):= GetJassNative('SetUnitRescuable');
	Pointer(_SetUnitRescueRange):= GetJassNative('SetUnitRescueRange');
	Pointer(_SetHeroStr):= GetJassNative('SetHeroStr');
	Pointer(_SetHeroAgi):= GetJassNative('SetHeroAgi');
	Pointer(_SetHeroInt):= GetJassNative('SetHeroInt');
	Pointer(_GetHeroStr):= GetJassNative('GetHeroStr');
	Pointer(_GetHeroAgi):= GetJassNative('GetHeroAgi');
	Pointer(_GetHeroInt):= GetJassNative('GetHeroInt');
	Pointer(_UnitStripHeroLevel):= GetJassNative('UnitStripHeroLevel');
	Pointer(_GetHeroXP):= GetJassNative('GetHeroXP');
	Pointer(_SetHeroXP):= GetJassNative('SetHeroXP');
	Pointer(_GetHeroSkillPoints):= GetJassNative('GetHeroSkillPoints');
	Pointer(_UnitModifySkillPoints):= GetJassNative('UnitModifySkillPoints');
	Pointer(_AddHeroXP):= GetJassNative('AddHeroXP');
	Pointer(_SetHeroLevel):= GetJassNative('SetHeroLevel');
	Pointer(_GetHeroLevel):= GetJassNative('GetHeroLevel');
	Pointer(_GetUnitLevel):= GetJassNative('GetUnitLevel');
	Pointer(_GetHeroProperName):= GetJassNative('GetHeroProperName');
	Pointer(_SuspendHeroXP):= GetJassNative('SuspendHeroXP');
	Pointer(_IsSuspendedXP):= GetJassNative('IsSuspendedXP');
	Pointer(_SelectHeroSkill):= GetJassNative('SelectHeroSkill');
	Pointer(_GetUnitAbilityLevel):= GetJassNative('GetUnitAbilityLevel');
	Pointer(_DecUnitAbilityLevel):= GetJassNative('DecUnitAbilityLevel');
	Pointer(_IncUnitAbilityLevel):= GetJassNative('IncUnitAbilityLevel');
	Pointer(_SetUnitAbilityLevel):= GetJassNative('SetUnitAbilityLevel');
	Pointer(_ReviveHero):= GetJassNative('ReviveHero');
	Pointer(_ReviveHeroLoc):= GetJassNative('ReviveHeroLoc');
	Pointer(_SetUnitExploded):= GetJassNative('SetUnitExploded');
	Pointer(_SetUnitInvulnerable):= GetJassNative('SetUnitInvulnerable');
	Pointer(_PauseUnit):= GetJassNative('PauseUnit');
	Pointer(_IsUnitPaused):= GetJassNative('IsUnitPaused');
	Pointer(_SetUnitPathing):= GetJassNative('SetUnitPathing');
	Pointer(_ClearSelection):= GetJassNative('ClearSelection');
	Pointer(_SelectUnit):= GetJassNative('SelectUnit');
	Pointer(_GetUnitPointValue):= GetJassNative('GetUnitPointValue');
	Pointer(_GetUnitPointValueByType):= GetJassNative('GetUnitPointValueByType');
	Pointer(_UnitAddItem):= GetJassNative('UnitAddItem');
	Pointer(_UnitAddItemById):= GetJassNative('UnitAddItemById');
	Pointer(_UnitAddItemToSlotById):= GetJassNative('UnitAddItemToSlotById');
	Pointer(_UnitRemoveItem):= GetJassNative('UnitRemoveItem');
	Pointer(_UnitRemoveItemFromSlot):= GetJassNative('UnitRemoveItemFromSlot');
	Pointer(_UnitHasItem):= GetJassNative('UnitHasItem');
	Pointer(_UnitItemInSlot):= GetJassNative('UnitItemInSlot');
	Pointer(_UnitInventorySize):= GetJassNative('UnitInventorySize');
	Pointer(_UnitDropItemPoint):= GetJassNative('UnitDropItemPoint');
	Pointer(_UnitDropItemSlot):= GetJassNative('UnitDropItemSlot');
	Pointer(_UnitDropItemTarget):= GetJassNative('UnitDropItemTarget');
	Pointer(_UnitUseItem):= GetJassNative('UnitUseItem');
	Pointer(_UnitUseItemPoint):= GetJassNative('UnitUseItemPoint');
	Pointer(_UnitUseItemTarget):= GetJassNative('UnitUseItemTarget');
	Pointer(_GetUnitX):= GetJassNative('GetUnitX');
	Pointer(_GetUnitY):= GetJassNative('GetUnitY');
	Pointer(_GetUnitLoc):= GetJassNative('GetUnitLoc');
	Pointer(_GetUnitFacing):= GetJassNative('GetUnitFacing');
	Pointer(_GetUnitMoveSpeed):= GetJassNative('GetUnitMoveSpeed');
	Pointer(_GetUnitDefaultMoveSpeed):= GetJassNative('GetUnitDefaultMoveSpeed');
	Pointer(_GetUnitState):= GetJassNative('GetUnitState');
	Pointer(_GetOwningPlayer):= GetJassNative('GetOwningPlayer');
	Pointer(_GetUnitTypeId):= GetJassNative('GetUnitTypeId');
	Pointer(_GetUnitRace):= GetJassNative('GetUnitRace');
	Pointer(_GetUnitName):= GetJassNative('GetUnitName');
	Pointer(_GetUnitFoodUsed):= GetJassNative('GetUnitFoodUsed');
	Pointer(_GetUnitFoodMade):= GetJassNative('GetUnitFoodMade');
	Pointer(_GetFoodMade):= GetJassNative('GetFoodMade');
	Pointer(_GetFoodUsed):= GetJassNative('GetFoodUsed');
	Pointer(_SetUnitUseFood):= GetJassNative('SetUnitUseFood');
	Pointer(_GetUnitRallyPoint):= GetJassNative('GetUnitRallyPoint');
	Pointer(_GetUnitRallyUnit):= GetJassNative('GetUnitRallyUnit');
	Pointer(_GetUnitRallyDestructable):= GetJassNative('GetUnitRallyDestructable');
	Pointer(_IsUnitInGroup):= GetJassNative('IsUnitInGroup');
	Pointer(_IsUnitInForce):= GetJassNative('IsUnitInForce');
	Pointer(_IsUnitOwnedByPlayer):= GetJassNative('IsUnitOwnedByPlayer');
	Pointer(_IsUnitAlly):= GetJassNative('IsUnitAlly');
	Pointer(_IsUnitEnemy):= GetJassNative('IsUnitEnemy');
	Pointer(_IsUnitVisible):= GetJassNative('IsUnitVisible');
	Pointer(_IsUnitDetected):= GetJassNative('IsUnitDetected');
	Pointer(_IsUnitInvisible):= GetJassNative('IsUnitInvisible');
	Pointer(_IsUnitFogged):= GetJassNative('IsUnitFogged');
	Pointer(_IsUnitMasked):= GetJassNative('IsUnitMasked');
	Pointer(_IsUnitSelected):= GetJassNative('IsUnitSelected');
	Pointer(_IsUnitRace):= GetJassNative('IsUnitRace');
	Pointer(_IsUnitType):= GetJassNative('IsUnitType');
	Pointer(_IsUnit):= GetJassNative('IsUnit');
	Pointer(_IsUnitInRange):= GetJassNative('IsUnitInRange');
	Pointer(_IsUnitInRangeXY):= GetJassNative('IsUnitInRangeXY');
	Pointer(_IsUnitInRangeLoc):= GetJassNative('IsUnitInRangeLoc');
	Pointer(_IsUnitHidden):= GetJassNative('IsUnitHidden');
	Pointer(_IsUnitIllusion):= GetJassNative('IsUnitIllusion');
	Pointer(_IsUnitInTransport):= GetJassNative('IsUnitInTransport');
	Pointer(_IsUnitLoaded):= GetJassNative('IsUnitLoaded');
	Pointer(_IsHeroUnitId):= GetJassNative('IsHeroUnitId');
	Pointer(_IsUnitIdType):= GetJassNative('IsUnitIdType');
	Pointer(_UnitShareVision):= GetJassNative('UnitShareVision');
	Pointer(_UnitSuspendDecay):= GetJassNative('UnitSuspendDecay');
	Pointer(_UnitAddType):= GetJassNative('UnitAddType');
	Pointer(_UnitRemoveType):= GetJassNative('UnitRemoveType');
	Pointer(_UnitAddAbility):= GetJassNative('UnitAddAbility');
	Pointer(_UnitRemoveAbility):= GetJassNative('UnitRemoveAbility');
	Pointer(_UnitMakeAbilityPermanent):= GetJassNative('UnitMakeAbilityPermanent');
	Pointer(_UnitRemoveBuffs):= GetJassNative('UnitRemoveBuffs');
	Pointer(_UnitRemoveBuffsEx):= GetJassNative('UnitRemoveBuffsEx');
	Pointer(_UnitHasBuffsEx):= GetJassNative('UnitHasBuffsEx');
	Pointer(_UnitCountBuffsEx):= GetJassNative('UnitCountBuffsEx');
	Pointer(_UnitAddSleep):= GetJassNative('UnitAddSleep');
	Pointer(_UnitCanSleep):= GetJassNative('UnitCanSleep');
	Pointer(_UnitAddSleepPerm):= GetJassNative('UnitAddSleepPerm');
	Pointer(_UnitCanSleepPerm):= GetJassNative('UnitCanSleepPerm');
	Pointer(_UnitIsSleeping):= GetJassNative('UnitIsSleeping');
	Pointer(_UnitWakeUp):= GetJassNative('UnitWakeUp');
	Pointer(_UnitApplyTimedLife):= GetJassNative('UnitApplyTimedLife');
	Pointer(_UnitIgnoreAlarm):= GetJassNative('UnitIgnoreAlarm');
	Pointer(_UnitIgnoreAlarmToggled):= GetJassNative('UnitIgnoreAlarmToggled');
	Pointer(_UnitResetCooldown):= GetJassNative('UnitResetCooldown');
	Pointer(_UnitSetConstructionProgress):= GetJassNative('UnitSetConstructionProgress');
	Pointer(_UnitSetUpgradeProgress):= GetJassNative('UnitSetUpgradeProgress');
	Pointer(_UnitPauseTimedLife):= GetJassNative('UnitPauseTimedLife');
	Pointer(_UnitSetUsesAltIcon):= GetJassNative('UnitSetUsesAltIcon');
	Pointer(_UnitDamagePoint):= GetJassNative('UnitDamagePoint');
	Pointer(_UnitDamageTarget):= GetJassNative('UnitDamageTarget');
	Pointer(_IssueImmediateOrder):= GetJassNative('IssueImmediateOrder');
	Pointer(_IssueImmediateOrderById):= GetJassNative('IssueImmediateOrderById');
	Pointer(_IssuePointOrder):= GetJassNative('IssuePointOrder');
	Pointer(_IssuePointOrderLoc):= GetJassNative('IssuePointOrderLoc');
	Pointer(_IssuePointOrderById):= GetJassNative('IssuePointOrderById');
	Pointer(_IssuePointOrderByIdLoc):= GetJassNative('IssuePointOrderByIdLoc');
	Pointer(_IssueTargetOrder):= GetJassNative('IssueTargetOrder');
	Pointer(_IssueTargetOrderById):= GetJassNative('IssueTargetOrderById');
	Pointer(_IssueInstantPointOrder):= GetJassNative('IssueInstantPointOrder');
	Pointer(_IssueInstantPointOrderById):= GetJassNative('IssueInstantPointOrderById');
	Pointer(_IssueInstantTargetOrder):= GetJassNative('IssueInstantTargetOrder');
	Pointer(_IssueInstantTargetOrderById):= GetJassNative('IssueInstantTargetOrderById');
	Pointer(_IssueBuildOrder):= GetJassNative('IssueBuildOrder');
	Pointer(_IssueBuildOrderById):= GetJassNative('IssueBuildOrderById');
	Pointer(_IssueNeutralImmediateOrder):= GetJassNative('IssueNeutralImmediateOrder');
	Pointer(_IssueNeutralImmediateOrderById):= GetJassNative('IssueNeutralImmediateOrderById');
	Pointer(_IssueNeutralPointOrder):= GetJassNative('IssueNeutralPointOrder');
	Pointer(_IssueNeutralPointOrderById):= GetJassNative('IssueNeutralPointOrderById');
	Pointer(_IssueNeutralTargetOrder):= GetJassNative('IssueNeutralTargetOrder');
	Pointer(_IssueNeutralTargetOrderById):= GetJassNative('IssueNeutralTargetOrderById');
	Pointer(_GetUnitCurrentOrder):= GetJassNative('GetUnitCurrentOrder');
	Pointer(_SetResourceAmount):= GetJassNative('SetResourceAmount');
	Pointer(_AddResourceAmount):= GetJassNative('AddResourceAmount');
	Pointer(_GetResourceAmount):= GetJassNative('GetResourceAmount');
	Pointer(_WaygateGetDestinationX):= GetJassNative('WaygateGetDestinationX');
	Pointer(_WaygateGetDestinationY):= GetJassNative('WaygateGetDestinationY');
	Pointer(_WaygateSetDestination):= GetJassNative('WaygateSetDestination');
	Pointer(_WaygateActivate):= GetJassNative('WaygateActivate');
	Pointer(_WaygateIsActive):= GetJassNative('WaygateIsActive');
	Pointer(_AddItemToAllStock):= GetJassNative('AddItemToAllStock');
	Pointer(_AddItemToStock):= GetJassNative('AddItemToStock');
	Pointer(_AddUnitToAllStock):= GetJassNative('AddUnitToAllStock');
	Pointer(_AddUnitToStock):= GetJassNative('AddUnitToStock');
	Pointer(_RemoveItemFromAllStock):= GetJassNative('RemoveItemFromAllStock');
	Pointer(_RemoveItemFromStock):= GetJassNative('RemoveItemFromStock');
	Pointer(_RemoveUnitFromAllStock):= GetJassNative('RemoveUnitFromAllStock');
	Pointer(_RemoveUnitFromStock):= GetJassNative('RemoveUnitFromStock');
	Pointer(_SetAllItemTypeSlots):= GetJassNative('SetAllItemTypeSlots');
	Pointer(_SetAllUnitTypeSlots):= GetJassNative('SetAllUnitTypeSlots');
	Pointer(_SetItemTypeSlots):= GetJassNative('SetItemTypeSlots');
	Pointer(_SetUnitTypeSlots):= GetJassNative('SetUnitTypeSlots');
	Pointer(_GetUnitUserData):= GetJassNative('GetUnitUserData');
	Pointer(_SetUnitUserData):= GetJassNative('SetUnitUserData');
	Pointer(_Player):= GetJassNative('Player');
	Pointer(_GetLocalPlayer):= GetJassNative('GetLocalPlayer');
	Pointer(_IsPlayerAlly):= GetJassNative('IsPlayerAlly');
	Pointer(_IsPlayerEnemy):= GetJassNative('IsPlayerEnemy');
	Pointer(_IsPlayerInForce):= GetJassNative('IsPlayerInForce');
	Pointer(_IsPlayerObserver):= GetJassNative('IsPlayerObserver');
	Pointer(_IsVisibleToPlayer):= GetJassNative('IsVisibleToPlayer');
	Pointer(_IsLocationVisibleToPlayer):= GetJassNative('IsLocationVisibleToPlayer');
	Pointer(_IsFoggedToPlayer):= GetJassNative('IsFoggedToPlayer');
	Pointer(_IsLocationFoggedToPlayer):= GetJassNative('IsLocationFoggedToPlayer');
	Pointer(_IsMaskedToPlayer):= GetJassNative('IsMaskedToPlayer');
	Pointer(_IsLocationMaskedToPlayer):= GetJassNative('IsLocationMaskedToPlayer');
	Pointer(_GetPlayerRace):= GetJassNative('GetPlayerRace');
	Pointer(_GetPlayerId):= GetJassNative('GetPlayerId');
	Pointer(_GetPlayerUnitCount):= GetJassNative('GetPlayerUnitCount');
	Pointer(_GetPlayerTypedUnitCount):= GetJassNative('GetPlayerTypedUnitCount');
	Pointer(_GetPlayerStructureCount):= GetJassNative('GetPlayerStructureCount');
	Pointer(_GetPlayerState):= GetJassNative('GetPlayerState');
	Pointer(_GetPlayerScore):= GetJassNative('GetPlayerScore');
	Pointer(_GetPlayerAlliance):= GetJassNative('GetPlayerAlliance');
	Pointer(_GetPlayerHandicap):= GetJassNative('GetPlayerHandicap');
	Pointer(_GetPlayerHandicapXP):= GetJassNative('GetPlayerHandicapXP');
	Pointer(_SetPlayerHandicap):= GetJassNative('SetPlayerHandicap');
	Pointer(_SetPlayerHandicapXP):= GetJassNative('SetPlayerHandicapXP');
	Pointer(_SetPlayerTechMaxAllowed):= GetJassNative('SetPlayerTechMaxAllowed');
	Pointer(_GetPlayerTechMaxAllowed):= GetJassNative('GetPlayerTechMaxAllowed');
	Pointer(_AddPlayerTechResearched):= GetJassNative('AddPlayerTechResearched');
	Pointer(_SetPlayerTechResearched):= GetJassNative('SetPlayerTechResearched');
	Pointer(_GetPlayerTechResearched):= GetJassNative('GetPlayerTechResearched');
	Pointer(_GetPlayerTechCount):= GetJassNative('GetPlayerTechCount');
	Pointer(_SetPlayerUnitsOwner):= GetJassNative('SetPlayerUnitsOwner');
	Pointer(_CripplePlayer):= GetJassNative('CripplePlayer');
	Pointer(_SetPlayerAbilityAvailable):= GetJassNative('SetPlayerAbilityAvailable');
	Pointer(_SetPlayerState):= GetJassNative('SetPlayerState');
	Pointer(_RemovePlayer):= GetJassNative('RemovePlayer');
	Pointer(_CachePlayerHeroData):= GetJassNative('CachePlayerHeroData');
	Pointer(_SetFogStateRect):= GetJassNative('SetFogStateRect');
	Pointer(_SetFogStateRadius):= GetJassNative('SetFogStateRadius');
	Pointer(_SetFogStateRadiusLoc):= GetJassNative('SetFogStateRadiusLoc');
	Pointer(_FogMaskEnable):= GetJassNative('FogMaskEnable');
	Pointer(_IsFogMaskEnabled):= GetJassNative('IsFogMaskEnabled');
	Pointer(_FogEnable):= GetJassNative('FogEnable');
	Pointer(_IsFogEnabled):= GetJassNative('IsFogEnabled');
	Pointer(_CreateFogModifierRect):= GetJassNative('CreateFogModifierRect');
	Pointer(_CreateFogModifierRadius):= GetJassNative('CreateFogModifierRadius');
	Pointer(_CreateFogModifierRadiusLoc):= GetJassNative('CreateFogModifierRadiusLoc');
	Pointer(_DestroyFogModifier):= GetJassNative('DestroyFogModifier');
	Pointer(_FogModifierStart):= GetJassNative('FogModifierStart');
	Pointer(_FogModifierStop):= GetJassNative('FogModifierStop');
	Pointer(_VersionGet):= GetJassNative('VersionGet');
	Pointer(_VersionCompatible):= GetJassNative('VersionCompatible');
	Pointer(_VersionSupported):= GetJassNative('VersionSupported');
	Pointer(_EndGame):= GetJassNative('EndGame');
	Pointer(_ChangeLevel):= GetJassNative('ChangeLevel');
	Pointer(_RestartGame):= GetJassNative('RestartGame');
	Pointer(_ReloadGame):= GetJassNative('ReloadGame');
	Pointer(_SetCampaignMenuRace):= GetJassNative('SetCampaignMenuRace');
	Pointer(_SetCampaignMenuRaceEx):= GetJassNative('SetCampaignMenuRaceEx');
	Pointer(_ForceCampaignSelectScreen):= GetJassNative('ForceCampaignSelectScreen');
	Pointer(_LoadGame):= GetJassNative('LoadGame');
	Pointer(_SaveGame):= GetJassNative('SaveGame');
	Pointer(_RenameSaveDirectory):= GetJassNative('RenameSaveDirectory');
	Pointer(_RemoveSaveDirectory):= GetJassNative('RemoveSaveDirectory');
	Pointer(_CopySaveGame):= GetJassNative('CopySaveGame');
	Pointer(_SaveGameExists):= GetJassNative('SaveGameExists');
	Pointer(_SyncSelections):= GetJassNative('SyncSelections');
	Pointer(_SetFloatGameState):= GetJassNative('SetFloatGameState');
	Pointer(_GetFloatGameState):= GetJassNative('GetFloatGameState');
	Pointer(_SetIntegerGameState):= GetJassNative('SetIntegerGameState');
	Pointer(_GetIntegerGameState):= GetJassNative('GetIntegerGameState');
	Pointer(_SetTutorialCleared):= GetJassNative('SetTutorialCleared');
	Pointer(_SetMissionAvailable):= GetJassNative('SetMissionAvailable');
	Pointer(_SetCampaignAvailable):= GetJassNative('SetCampaignAvailable');
	Pointer(_SetOpCinematicAvailable):= GetJassNative('SetOpCinematicAvailable');
	Pointer(_SetEdCinematicAvailable):= GetJassNative('SetEdCinematicAvailable');
	Pointer(_GetDefaultDifficulty):= GetJassNative('GetDefaultDifficulty');
	Pointer(_SetDefaultDifficulty):= GetJassNative('SetDefaultDifficulty');
	Pointer(_SetCustomCampaignButtonVisible):= GetJassNative('SetCustomCampaignButtonVisible');
	Pointer(_GetCustomCampaignButtonVisible):= GetJassNative('GetCustomCampaignButtonVisible');
	Pointer(_DoNotSaveReplay):= GetJassNative('DoNotSaveReplay');
	Pointer(_DialogCreate):= GetJassNative('DialogCreate');
	Pointer(_DialogDestroy):= GetJassNative('DialogDestroy');
	Pointer(_DialogClear):= GetJassNative('DialogClear');
	Pointer(_DialogSetMessage):= GetJassNative('DialogSetMessage');
	Pointer(_DialogAddButton):= GetJassNative('DialogAddButton');
	Pointer(_DialogAddQuitButton):= GetJassNative('DialogAddQuitButton');
	Pointer(_DialogDisplay):= GetJassNative('DialogDisplay');
	Pointer(_ReloadGameCachesFromDisk):= GetJassNative('ReloadGameCachesFromDisk');
	Pointer(_InitGameCache):= GetJassNative('InitGameCache');
	Pointer(_SaveGameCache):= GetJassNative('SaveGameCache');
	Pointer(_StoreInteger):= GetJassNative('StoreInteger');
	Pointer(_StoreReal):= GetJassNative('StoreReal');
	Pointer(_StoreBoolean):= GetJassNative('StoreBoolean');
	Pointer(_StoreUnit):= GetJassNative('StoreUnit');
	Pointer(_StoreString):= GetJassNative('StoreString');
	Pointer(_SyncStoredInteger):= GetJassNative('SyncStoredInteger');
	Pointer(_SyncStoredReal):= GetJassNative('SyncStoredReal');
	Pointer(_SyncStoredBoolean):= GetJassNative('SyncStoredBoolean');
	Pointer(_SyncStoredUnit):= GetJassNative('SyncStoredUnit');
	Pointer(_SyncStoredString):= GetJassNative('SyncStoredString');
	Pointer(_HaveStoredInteger):= GetJassNative('HaveStoredInteger');
	Pointer(_HaveStoredReal):= GetJassNative('HaveStoredReal');
	Pointer(_HaveStoredBoolean):= GetJassNative('HaveStoredBoolean');
	Pointer(_HaveStoredUnit):= GetJassNative('HaveStoredUnit');
	Pointer(_HaveStoredString):= GetJassNative('HaveStoredString');
	Pointer(_FlushGameCache):= GetJassNative('FlushGameCache');
	Pointer(_FlushStoredMission):= GetJassNative('FlushStoredMission');
	Pointer(_FlushStoredInteger):= GetJassNative('FlushStoredInteger');
	Pointer(_FlushStoredReal):= GetJassNative('FlushStoredReal');
	Pointer(_FlushStoredBoolean):= GetJassNative('FlushStoredBoolean');
	Pointer(_FlushStoredUnit):= GetJassNative('FlushStoredUnit');
	Pointer(_FlushStoredString):= GetJassNative('FlushStoredString');
	Pointer(_GetStoredInteger):= GetJassNative('GetStoredInteger');
	Pointer(_GetStoredReal):= GetJassNative('GetStoredReal');
	Pointer(_GetStoredBoolean):= GetJassNative('GetStoredBoolean');
	Pointer(_GetStoredString):= GetJassNative('GetStoredString');
	Pointer(_RestoreUnit):= GetJassNative('RestoreUnit');
	Pointer(_InitHashtable):= GetJassNative('InitHashtable');
	Pointer(_SaveInteger):= GetJassNative('SaveInteger');
	Pointer(_SaveReal):= GetJassNative('SaveReal');
	Pointer(_SaveBoolean):= GetJassNative('SaveBoolean');
	Pointer(_SaveStr):= GetJassNative('SaveStr');
	Pointer(_SavePlayerHandle):= GetJassNative('SavePlayerHandle');
	Pointer(_SaveWidgetHandle):= GetJassNative('SaveWidgetHandle');
	Pointer(_SaveDestructableHandle):= GetJassNative('SaveDestructableHandle');
	Pointer(_SaveItemHandle):= GetJassNative('SaveItemHandle');
	Pointer(_SaveUnitHandle):= GetJassNative('SaveUnitHandle');
	Pointer(_SaveAbilityHandle):= GetJassNative('SaveAbilityHandle');
	Pointer(_SaveTimerHandle):= GetJassNative('SaveTimerHandle');
	Pointer(_SaveTriggerHandle):= GetJassNative('SaveTriggerHandle');
	Pointer(_SaveTriggerConditionHandle):= GetJassNative('SaveTriggerConditionHandle');
	Pointer(_SaveTriggerActionHandle):= GetJassNative('SaveTriggerActionHandle');
	Pointer(_SaveTriggerEventHandle):= GetJassNative('SaveTriggerEventHandle');
	Pointer(_SaveForceHandle):= GetJassNative('SaveForceHandle');
	Pointer(_SaveGroupHandle):= GetJassNative('SaveGroupHandle');
	Pointer(_SaveLocationHandle):= GetJassNative('SaveLocationHandle');
	Pointer(_SaveRectHandle):= GetJassNative('SaveRectHandle');
	Pointer(_SaveBooleanExprHandle):= GetJassNative('SaveBooleanExprHandle');
	Pointer(_SaveSoundHandle):= GetJassNative('SaveSoundHandle');
	Pointer(_SaveEffectHandle):= GetJassNative('SaveEffectHandle');
	Pointer(_SaveUnitPoolHandle):= GetJassNative('SaveUnitPoolHandle');
	Pointer(_SaveItemPoolHandle):= GetJassNative('SaveItemPoolHandle');
	Pointer(_SaveQuestHandle):= GetJassNative('SaveQuestHandle');
	Pointer(_SaveQuestItemHandle):= GetJassNative('SaveQuestItemHandle');
	Pointer(_SaveDefeatConditionHandle):= GetJassNative('SaveDefeatConditionHandle');
	Pointer(_SaveTimerDialogHandle):= GetJassNative('SaveTimerDialogHandle');
	Pointer(_SaveLeaderboardHandle):= GetJassNative('SaveLeaderboardHandle');
	Pointer(_SaveMultiboardHandle):= GetJassNative('SaveMultiboardHandle');
	Pointer(_SaveMultiboardItemHandle):= GetJassNative('SaveMultiboardItemHandle');
	Pointer(_SaveTrackableHandle):= GetJassNative('SaveTrackableHandle');
	Pointer(_SaveDialogHandle):= GetJassNative('SaveDialogHandle');
	Pointer(_SaveButtonHandle):= GetJassNative('SaveButtonHandle');
	Pointer(_SaveTextTagHandle):= GetJassNative('SaveTextTagHandle');
	Pointer(_SaveLightningHandle):= GetJassNative('SaveLightningHandle');
	Pointer(_SaveImageHandle):= GetJassNative('SaveImageHandle');
	Pointer(_SaveUbersplatHandle):= GetJassNative('SaveUbersplatHandle');
	Pointer(_SaveRegionHandle):= GetJassNative('SaveRegionHandle');
	Pointer(_SaveFogStateHandle):= GetJassNative('SaveFogStateHandle');
	Pointer(_SaveFogModifierHandle):= GetJassNative('SaveFogModifierHandle');
	Pointer(_SaveAgentHandle):= GetJassNative('SaveAgentHandle');
	Pointer(_SaveHashtableHandle):= GetJassNative('SaveHashtableHandle');
	Pointer(_LoadInteger):= GetJassNative('LoadInteger');
	Pointer(_LoadReal):= GetJassNative('LoadReal');
	Pointer(_LoadBoolean):= GetJassNative('LoadBoolean');
	Pointer(_LoadStr):= GetJassNative('LoadStr');
	Pointer(_LoadPlayerHandle):= GetJassNative('LoadPlayerHandle');
	Pointer(_LoadWidgetHandle):= GetJassNative('LoadWidgetHandle');
	Pointer(_LoadDestructableHandle):= GetJassNative('LoadDestructableHandle');
	Pointer(_LoadItemHandle):= GetJassNative('LoadItemHandle');
	Pointer(_LoadUnitHandle):= GetJassNative('LoadUnitHandle');
	Pointer(_LoadAbilityHandle):= GetJassNative('LoadAbilityHandle');
	Pointer(_LoadTimerHandle):= GetJassNative('LoadTimerHandle');
	Pointer(_LoadTriggerHandle):= GetJassNative('LoadTriggerHandle');
	Pointer(_LoadTriggerConditionHandle):= GetJassNative('LoadTriggerConditionHandle');
	Pointer(_LoadTriggerActionHandle):= GetJassNative('LoadTriggerActionHandle');
	Pointer(_LoadTriggerEventHandle):= GetJassNative('LoadTriggerEventHandle');
	Pointer(_LoadForceHandle):= GetJassNative('LoadForceHandle');
	Pointer(_LoadGroupHandle):= GetJassNative('LoadGroupHandle');
	Pointer(_LoadLocationHandle):= GetJassNative('LoadLocationHandle');
	Pointer(_LoadRectHandle):= GetJassNative('LoadRectHandle');
	Pointer(_LoadBooleanExprHandle):= GetJassNative('LoadBooleanExprHandle');
	Pointer(_LoadSoundHandle):= GetJassNative('LoadSoundHandle');
	Pointer(_LoadEffectHandle):= GetJassNative('LoadEffectHandle');
	Pointer(_LoadUnitPoolHandle):= GetJassNative('LoadUnitPoolHandle');
	Pointer(_LoadItemPoolHandle):= GetJassNative('LoadItemPoolHandle');
	Pointer(_LoadQuestHandle):= GetJassNative('LoadQuestHandle');
	Pointer(_LoadQuestItemHandle):= GetJassNative('LoadQuestItemHandle');
	Pointer(_LoadDefeatConditionHandle):= GetJassNative('LoadDefeatConditionHandle');
	Pointer(_LoadTimerDialogHandle):= GetJassNative('LoadTimerDialogHandle');
	Pointer(_LoadLeaderboardHandle):= GetJassNative('LoadLeaderboardHandle');
	Pointer(_LoadMultiboardHandle):= GetJassNative('LoadMultiboardHandle');
	Pointer(_LoadMultiboardItemHandle):= GetJassNative('LoadMultiboardItemHandle');
	Pointer(_LoadTrackableHandle):= GetJassNative('LoadTrackableHandle');
	Pointer(_LoadDialogHandle):= GetJassNative('LoadDialogHandle');
	Pointer(_LoadButtonHandle):= GetJassNative('LoadButtonHandle');
	Pointer(_LoadTextTagHandle):= GetJassNative('LoadTextTagHandle');
	Pointer(_LoadLightningHandle):= GetJassNative('LoadLightningHandle');
	Pointer(_LoadImageHandle):= GetJassNative('LoadImageHandle');
	Pointer(_LoadUbersplatHandle):= GetJassNative('LoadUbersplatHandle');
	Pointer(_LoadRegionHandle):= GetJassNative('LoadRegionHandle');
	Pointer(_LoadFogStateHandle):= GetJassNative('LoadFogStateHandle');
	Pointer(_LoadFogModifierHandle):= GetJassNative('LoadFogModifierHandle');
	Pointer(_LoadHashtableHandle):= GetJassNative('LoadHashtableHandle');
	Pointer(_HaveSavedInteger):= GetJassNative('HaveSavedInteger');
	Pointer(_HaveSavedReal):= GetJassNative('HaveSavedReal');
	Pointer(_HaveSavedBoolean):= GetJassNative('HaveSavedBoolean');
	Pointer(_HaveSavedString):= GetJassNative('HaveSavedString');
	Pointer(_HaveSavedHandle):= GetJassNative('HaveSavedHandle');
	Pointer(_RemoveSavedInteger):= GetJassNative('RemoveSavedInteger');
	Pointer(_RemoveSavedReal):= GetJassNative('RemoveSavedReal');
	Pointer(_RemoveSavedBoolean):= GetJassNative('RemoveSavedBoolean');
	Pointer(_RemoveSavedString):= GetJassNative('RemoveSavedString');
	Pointer(_RemoveSavedHandle):= GetJassNative('RemoveSavedHandle');
	Pointer(_FlushParentHashtable):= GetJassNative('FlushParentHashtable');
	Pointer(_FlushChildHashtable):= GetJassNative('FlushChildHashtable');
	Pointer(_GetRandomInt):= GetJassNative('GetRandomInt');
	Pointer(_GetRandomReal):= GetJassNative('GetRandomReal');
	Pointer(_CreateUnitPool):= GetJassNative('CreateUnitPool');
	Pointer(_DestroyUnitPool):= GetJassNative('DestroyUnitPool');
	Pointer(_UnitPoolAddUnitType):= GetJassNative('UnitPoolAddUnitType');
	Pointer(_UnitPoolRemoveUnitType):= GetJassNative('UnitPoolRemoveUnitType');
	Pointer(_PlaceRandomUnit):= GetJassNative('PlaceRandomUnit');
	Pointer(_CreateItemPool):= GetJassNative('CreateItemPool');
	Pointer(_DestroyItemPool):= GetJassNative('DestroyItemPool');
	Pointer(_ItemPoolAddItemType):= GetJassNative('ItemPoolAddItemType');
	Pointer(_ItemPoolRemoveItemType):= GetJassNative('ItemPoolRemoveItemType');
	Pointer(_PlaceRandomItem):= GetJassNative('PlaceRandomItem');
	Pointer(_ChooseRandomCreep):= GetJassNative('ChooseRandomCreep');
	Pointer(_ChooseRandomNPBuilding):= GetJassNative('ChooseRandomNPBuilding');
	Pointer(_ChooseRandomItem):= GetJassNative('ChooseRandomItem');
	Pointer(_ChooseRandomItemEx):= GetJassNative('ChooseRandomItemEx');
	Pointer(_SetRandomSeed):= GetJassNative('SetRandomSeed');
	Pointer(_SetTerrainFog):= GetJassNative('SetTerrainFog');
	Pointer(_ResetTerrainFog):= GetJassNative('ResetTerrainFog');
	Pointer(_SetUnitFog):= GetJassNative('SetUnitFog');
	Pointer(_SetTerrainFogEx):= GetJassNative('SetTerrainFogEx');
	Pointer(_DisplayTextToPlayer):= GetJassNative('DisplayTextToPlayer');
	Pointer(_DisplayTimedTextToPlayer):= GetJassNative('DisplayTimedTextToPlayer');
	Pointer(_DisplayTimedTextFromPlayer):= GetJassNative('DisplayTimedTextFromPlayer');
	Pointer(_ClearTextMessages):= GetJassNative('ClearTextMessages');
	Pointer(_SetDayNightModels):= GetJassNative('SetDayNightModels');
	Pointer(_SetSkyModel):= GetJassNative('SetSkyModel');
	Pointer(_EnableUserControl):= GetJassNative('EnableUserControl');
	Pointer(_EnableUserUI):= GetJassNative('EnableUserUI');
	Pointer(_SuspendTimeOfDay):= GetJassNative('SuspendTimeOfDay');
	Pointer(_SetTimeOfDayScale):= GetJassNative('SetTimeOfDayScale');
	Pointer(_GetTimeOfDayScale):= GetJassNative('GetTimeOfDayScale');
	Pointer(_ShowInterface):= GetJassNative('ShowInterface');
	Pointer(_PauseGame):= GetJassNative('PauseGame');
	Pointer(_UnitAddIndicator):= GetJassNative('UnitAddIndicator');
	Pointer(_AddIndicator):= GetJassNative('AddIndicator');
	Pointer(_PingMinimap):= GetJassNative('PingMinimap');
	Pointer(_PingMinimapEx):= GetJassNative('PingMinimapEx');
	Pointer(_EnableOcclusion):= GetJassNative('EnableOcclusion');
	Pointer(_SetIntroShotText):= GetJassNative('SetIntroShotText');
	Pointer(_SetIntroShotModel):= GetJassNative('SetIntroShotModel');
	Pointer(_EnableWorldFogBoundary):= GetJassNative('EnableWorldFogBoundary');
	Pointer(_PlayModelCinematic):= GetJassNative('PlayModelCinematic');
	Pointer(_PlayCinematic):= GetJassNative('PlayCinematic');
	Pointer(_ForceUIKey):= GetJassNative('ForceUIKey');
	Pointer(_ForceUICancel):= GetJassNative('ForceUICancel');
	Pointer(_DisplayLoadDialog):= GetJassNative('DisplayLoadDialog');
	Pointer(_SetAltMinimapIcon):= GetJassNative('SetAltMinimapIcon');
	Pointer(_DisableRestartMission):= GetJassNative('DisableRestartMission');
	Pointer(_CreateTextTag):= GetJassNative('CreateTextTag');
	Pointer(_DestroyTextTag):= GetJassNative('DestroyTextTag');
	Pointer(_SetTextTagText):= GetJassNative('SetTextTagText');
	Pointer(_SetTextTagPos):= GetJassNative('SetTextTagPos');
	Pointer(_SetTextTagPosUnit):= GetJassNative('SetTextTagPosUnit');
	Pointer(_SetTextTagColor):= GetJassNative('SetTextTagColor');
	Pointer(_SetTextTagVelocity):= GetJassNative('SetTextTagVelocity');
	Pointer(_SetTextTagVisibility):= GetJassNative('SetTextTagVisibility');
	Pointer(_SetTextTagSuspended):= GetJassNative('SetTextTagSuspended');
	Pointer(_SetTextTagPermanent):= GetJassNative('SetTextTagPermanent');
	Pointer(_SetTextTagAge):= GetJassNative('SetTextTagAge');
	Pointer(_SetTextTagLifespan):= GetJassNative('SetTextTagLifespan');
	Pointer(_SetTextTagFadepoint):= GetJassNative('SetTextTagFadepoint');
	Pointer(_SetReservedLocalHeroButtons):= GetJassNative('SetReservedLocalHeroButtons');
	Pointer(_GetAllyColorFilterState):= GetJassNative('GetAllyColorFilterState');
	Pointer(_SetAllyColorFilterState):= GetJassNative('SetAllyColorFilterState');
	Pointer(_GetCreepCampFilterState):= GetJassNative('GetCreepCampFilterState');
	Pointer(_SetCreepCampFilterState):= GetJassNative('SetCreepCampFilterState');
	Pointer(_EnableMinimapFilterButtons):= GetJassNative('EnableMinimapFilterButtons');
	Pointer(_EnableDragSelect):= GetJassNative('EnableDragSelect');
	Pointer(_EnablePreSelect):= GetJassNative('EnablePreSelect');
	Pointer(_EnableSelect):= GetJassNative('EnableSelect');
	Pointer(_CreateTrackable):= GetJassNative('CreateTrackable');
	Pointer(_CreateQuest):= GetJassNative('CreateQuest');
	Pointer(_DestroyQuest):= GetJassNative('DestroyQuest');
	Pointer(_QuestSetTitle):= GetJassNative('QuestSetTitle');
	Pointer(_QuestSetDescription):= GetJassNative('QuestSetDescription');
	Pointer(_QuestSetIconPath):= GetJassNative('QuestSetIconPath');
	Pointer(_QuestSetRequired):= GetJassNative('QuestSetRequired');
	Pointer(_QuestSetCompleted):= GetJassNative('QuestSetCompleted');
	Pointer(_QuestSetDiscovered):= GetJassNative('QuestSetDiscovered');
	Pointer(_QuestSetFailed):= GetJassNative('QuestSetFailed');
	Pointer(_QuestSetEnabled):= GetJassNative('QuestSetEnabled');
	Pointer(_IsQuestRequired):= GetJassNative('IsQuestRequired');
	Pointer(_IsQuestCompleted):= GetJassNative('IsQuestCompleted');
	Pointer(_IsQuestDiscovered):= GetJassNative('IsQuestDiscovered');
	Pointer(_IsQuestFailed):= GetJassNative('IsQuestFailed');
	Pointer(_IsQuestEnabled):= GetJassNative('IsQuestEnabled');
	Pointer(_QuestCreateItem):= GetJassNative('QuestCreateItem');
	Pointer(_QuestItemSetDescription):= GetJassNative('QuestItemSetDescription');
	Pointer(_QuestItemSetCompleted):= GetJassNative('QuestItemSetCompleted');
	Pointer(_IsQuestItemCompleted):= GetJassNative('IsQuestItemCompleted');
	Pointer(_CreateDefeatCondition):= GetJassNative('CreateDefeatCondition');
	Pointer(_DestroyDefeatCondition):= GetJassNative('DestroyDefeatCondition');
	Pointer(_DefeatConditionSetDescription):= GetJassNative('DefeatConditionSetDescription');
	Pointer(_FlashQuestDialogButton):= GetJassNative('FlashQuestDialogButton');
	Pointer(_ForceQuestDialogUpdate):= GetJassNative('ForceQuestDialogUpdate');
	Pointer(_CreateTimerDialog):= GetJassNative('CreateTimerDialog');
	Pointer(_DestroyTimerDialog):= GetJassNative('DestroyTimerDialog');
	Pointer(_TimerDialogSetTitle):= GetJassNative('TimerDialogSetTitle');
	Pointer(_TimerDialogSetTitleColor):= GetJassNative('TimerDialogSetTitleColor');
	Pointer(_TimerDialogSetTimeColor):= GetJassNative('TimerDialogSetTimeColor');
	Pointer(_TimerDialogSetSpeed):= GetJassNative('TimerDialogSetSpeed');
	Pointer(_TimerDialogDisplay):= GetJassNative('TimerDialogDisplay');
	Pointer(_IsTimerDialogDisplayed):= GetJassNative('IsTimerDialogDisplayed');
	Pointer(_TimerDialogSetRealTimeRemaining):= GetJassNative('TimerDialogSetRealTimeRemaining');
	Pointer(_CreateLeaderboard):= GetJassNative('CreateLeaderboard');
	Pointer(_DestroyLeaderboard):= GetJassNative('DestroyLeaderboard');
	Pointer(_LeaderboardDisplay):= GetJassNative('LeaderboardDisplay');
	Pointer(_IsLeaderboardDisplayed):= GetJassNative('IsLeaderboardDisplayed');
	Pointer(_LeaderboardGetItemCount):= GetJassNative('LeaderboardGetItemCount');
	Pointer(_LeaderboardSetSizeByItemCount):= GetJassNative('LeaderboardSetSizeByItemCount');
	Pointer(_LeaderboardAddItem):= GetJassNative('LeaderboardAddItem');
	Pointer(_LeaderboardRemoveItem):= GetJassNative('LeaderboardRemoveItem');
	Pointer(_LeaderboardRemovePlayerItem):= GetJassNative('LeaderboardRemovePlayerItem');
	Pointer(_LeaderboardClear):= GetJassNative('LeaderboardClear');
	Pointer(_LeaderboardSortItemsByValue):= GetJassNative('LeaderboardSortItemsByValue');
	Pointer(_LeaderboardSortItemsByPlayer):= GetJassNative('LeaderboardSortItemsByPlayer');
	Pointer(_LeaderboardSortItemsByLabel):= GetJassNative('LeaderboardSortItemsByLabel');
	Pointer(_LeaderboardHasPlayerItem):= GetJassNative('LeaderboardHasPlayerItem');
	Pointer(_LeaderboardGetPlayerIndex):= GetJassNative('LeaderboardGetPlayerIndex');
	Pointer(_LeaderboardSetLabel):= GetJassNative('LeaderboardSetLabel');
	Pointer(_LeaderboardGetLabelText):= GetJassNative('LeaderboardGetLabelText');
	Pointer(_PlayerSetLeaderboard):= GetJassNative('PlayerSetLeaderboard');
	Pointer(_PlayerGetLeaderboard):= GetJassNative('PlayerGetLeaderboard');
	Pointer(_LeaderboardSetLabelColor):= GetJassNative('LeaderboardSetLabelColor');
	Pointer(_LeaderboardSetValueColor):= GetJassNative('LeaderboardSetValueColor');
	Pointer(_LeaderboardSetStyle):= GetJassNative('LeaderboardSetStyle');
	Pointer(_LeaderboardSetItemValue):= GetJassNative('LeaderboardSetItemValue');
	Pointer(_LeaderboardSetItemLabel):= GetJassNative('LeaderboardSetItemLabel');
	Pointer(_LeaderboardSetItemStyle):= GetJassNative('LeaderboardSetItemStyle');
	Pointer(_LeaderboardSetItemLabelColor):= GetJassNative('LeaderboardSetItemLabelColor');
	Pointer(_LeaderboardSetItemValueColor):= GetJassNative('LeaderboardSetItemValueColor');
	Pointer(_CreateMultiboard):= GetJassNative('CreateMultiboard');
	Pointer(_DestroyMultiboard):= GetJassNative('DestroyMultiboard');
	Pointer(_MultiboardDisplay):= GetJassNative('MultiboardDisplay');
	Pointer(_IsMultiboardDisplayed):= GetJassNative('IsMultiboardDisplayed');
	Pointer(_MultiboardMinimize):= GetJassNative('MultiboardMinimize');
	Pointer(_IsMultiboardMinimized):= GetJassNative('IsMultiboardMinimized');
	Pointer(_MultiboardClear):= GetJassNative('MultiboardClear');
	Pointer(_MultiboardSetTitleText):= GetJassNative('MultiboardSetTitleText');
	Pointer(_MultiboardGetTitleText):= GetJassNative('MultiboardGetTitleText');
	Pointer(_MultiboardSetTitleTextColor):= GetJassNative('MultiboardSetTitleTextColor');
	Pointer(_MultiboardGetRowCount):= GetJassNative('MultiboardGetRowCount');
	Pointer(_MultiboardGetColumnCount):= GetJassNative('MultiboardGetColumnCount');
	Pointer(_MultiboardSetColumnCount):= GetJassNative('MultiboardSetColumnCount');
	Pointer(_MultiboardSetRowCount):= GetJassNative('MultiboardSetRowCount');
	Pointer(_MultiboardSetItemsStyle):= GetJassNative('MultiboardSetItemsStyle');
	Pointer(_MultiboardSetItemsValue):= GetJassNative('MultiboardSetItemsValue');
	Pointer(_MultiboardSetItemsValueColor):= GetJassNative('MultiboardSetItemsValueColor');
	Pointer(_MultiboardSetItemsWidth):= GetJassNative('MultiboardSetItemsWidth');
	Pointer(_MultiboardSetItemsIcon):= GetJassNative('MultiboardSetItemsIcon');
	Pointer(_MultiboardGetItem):= GetJassNative('MultiboardGetItem');
	Pointer(_MultiboardReleaseItem):= GetJassNative('MultiboardReleaseItem');
	Pointer(_MultiboardSetItemStyle):= GetJassNative('MultiboardSetItemStyle');
	Pointer(_MultiboardSetItemValue):= GetJassNative('MultiboardSetItemValue');
	Pointer(_MultiboardSetItemValueColor):= GetJassNative('MultiboardSetItemValueColor');
	Pointer(_MultiboardSetItemWidth):= GetJassNative('MultiboardSetItemWidth');
	Pointer(_MultiboardSetItemIcon):= GetJassNative('MultiboardSetItemIcon');
	Pointer(_MultiboardSuppressDisplay):= GetJassNative('MultiboardSuppressDisplay');
	Pointer(_SetCameraPosition):= GetJassNative('SetCameraPosition');
	Pointer(_SetCameraQuickPosition):= GetJassNative('SetCameraQuickPosition');
	Pointer(_SetCameraBounds):= GetJassNative('SetCameraBounds');
	Pointer(_StopCamera):= GetJassNative('StopCamera');
	Pointer(_ResetToGameCamera):= GetJassNative('ResetToGameCamera');
	Pointer(_PanCameraTo):= GetJassNative('PanCameraTo');
	Pointer(_PanCameraToTimed):= GetJassNative('PanCameraToTimed');
	Pointer(_PanCameraToWithZ):= GetJassNative('PanCameraToWithZ');
	Pointer(_PanCameraToTimedWithZ):= GetJassNative('PanCameraToTimedWithZ');
	Pointer(_SetCinematicCamera):= GetJassNative('SetCinematicCamera');
	Pointer(_SetCameraRotateMode):= GetJassNative('SetCameraRotateMode');
	Pointer(_SetCameraField):= GetJassNative('SetCameraField');
	Pointer(_AdjustCameraField):= GetJassNative('AdjustCameraField');
	Pointer(_SetCameraTargetController):= GetJassNative('SetCameraTargetController');
	Pointer(_SetCameraOrientController):= GetJassNative('SetCameraOrientController');
	Pointer(_CreateCameraSetup):= GetJassNative('CreateCameraSetup');
	Pointer(_CameraSetupSetField):= GetJassNative('CameraSetupSetField');
	Pointer(_CameraSetupGetField):= GetJassNative('CameraSetupGetField');
	Pointer(_CameraSetupSetDestPosition):= GetJassNative('CameraSetupSetDestPosition');
	Pointer(_CameraSetupGetDestPositionLoc):= GetJassNative('CameraSetupGetDestPositionLoc');
	Pointer(_CameraSetupGetDestPositionX):= GetJassNative('CameraSetupGetDestPositionX');
	Pointer(_CameraSetupGetDestPositionY):= GetJassNative('CameraSetupGetDestPositionY');
	Pointer(_CameraSetupApply):= GetJassNative('CameraSetupApply');
	Pointer(_CameraSetupApplyWithZ):= GetJassNative('CameraSetupApplyWithZ');
	Pointer(_CameraSetupApplyForceDuration):= GetJassNative('CameraSetupApplyForceDuration');
	Pointer(_CameraSetupApplyForceDurationWithZ):= GetJassNative('CameraSetupApplyForceDurationWithZ');
	Pointer(_CameraSetTargetNoise):= GetJassNative('CameraSetTargetNoise');
	Pointer(_CameraSetSourceNoise):= GetJassNative('CameraSetSourceNoise');
	Pointer(_CameraSetTargetNoiseEx):= GetJassNative('CameraSetTargetNoiseEx');
	Pointer(_CameraSetSourceNoiseEx):= GetJassNative('CameraSetSourceNoiseEx');
	Pointer(_CameraSetSmoothingFactor):= GetJassNative('CameraSetSmoothingFactor');
	Pointer(_SetCineFilterTexture):= GetJassNative('SetCineFilterTexture');
	Pointer(_SetCineFilterBlendMode):= GetJassNative('SetCineFilterBlendMode');
	Pointer(_SetCineFilterTexMapFlags):= GetJassNative('SetCineFilterTexMapFlags');
	Pointer(_SetCineFilterStartUV):= GetJassNative('SetCineFilterStartUV');
	Pointer(_SetCineFilterEndUV):= GetJassNative('SetCineFilterEndUV');
	Pointer(_SetCineFilterStartColor):= GetJassNative('SetCineFilterStartColor');
	Pointer(_SetCineFilterEndColor):= GetJassNative('SetCineFilterEndColor');
	Pointer(_SetCineFilterDuration):= GetJassNative('SetCineFilterDuration');
	Pointer(_DisplayCineFilter):= GetJassNative('DisplayCineFilter');
	Pointer(_IsCineFilterDisplayed):= GetJassNative('IsCineFilterDisplayed');
	Pointer(_SetCinematicScene):= GetJassNative('SetCinematicScene');
	Pointer(_EndCinematicScene):= GetJassNative('EndCinematicScene');
	Pointer(_ForceCinematicSubtitles):= GetJassNative('ForceCinematicSubtitles');
	Pointer(_GetCameraMargin):= GetJassNative('GetCameraMargin');
	Pointer(_GetCameraBoundMinX):= GetJassNative('GetCameraBoundMinX');
	Pointer(_GetCameraBoundMinY):= GetJassNative('GetCameraBoundMinY');
	Pointer(_GetCameraBoundMaxX):= GetJassNative('GetCameraBoundMaxX');
	Pointer(_GetCameraBoundMaxY):= GetJassNative('GetCameraBoundMaxY');
	Pointer(_GetCameraField):= GetJassNative('GetCameraField');
	Pointer(_GetCameraTargetPositionX):= GetJassNative('GetCameraTargetPositionX');
	Pointer(_GetCameraTargetPositionY):= GetJassNative('GetCameraTargetPositionY');
	Pointer(_GetCameraTargetPositionZ):= GetJassNative('GetCameraTargetPositionZ');
	Pointer(_GetCameraTargetPositionLoc):= GetJassNative('GetCameraTargetPositionLoc');
	Pointer(_GetCameraEyePositionX):= GetJassNative('GetCameraEyePositionX');
	Pointer(_GetCameraEyePositionY):= GetJassNative('GetCameraEyePositionY');
	Pointer(_GetCameraEyePositionZ):= GetJassNative('GetCameraEyePositionZ');
	Pointer(_GetCameraEyePositionLoc):= GetJassNative('GetCameraEyePositionLoc');
	Pointer(_NewSoundEnvironment):= GetJassNative('NewSoundEnvironment');
	Pointer(_CreateSound):= GetJassNative('CreateSound');
	Pointer(_CreateSoundFilenameWithLabel):= GetJassNative('CreateSoundFilenameWithLabel');
	Pointer(_CreateSoundFromLabel):= GetJassNative('CreateSoundFromLabel');
	Pointer(_CreateMIDISound):= GetJassNative('CreateMIDISound');
	Pointer(_SetSoundParamsFromLabel):= GetJassNative('SetSoundParamsFromLabel');
	Pointer(_SetSoundDistanceCutoff):= GetJassNative('SetSoundDistanceCutoff');
	Pointer(_SetSoundChannel):= GetJassNative('SetSoundChannel');
	Pointer(_SetSoundVolume):= GetJassNative('SetSoundVolume');
	Pointer(_SetSoundPitch):= GetJassNative('SetSoundPitch');
	Pointer(_SetSoundPlayPosition):= GetJassNative('SetSoundPlayPosition');
	Pointer(_SetSoundDistances):= GetJassNative('SetSoundDistances');
	Pointer(_SetSoundConeAngles):= GetJassNative('SetSoundConeAngles');
	Pointer(_SetSoundConeOrientation):= GetJassNative('SetSoundConeOrientation');
	Pointer(_SetSoundPosition):= GetJassNative('SetSoundPosition');
	Pointer(_SetSoundVelocity):= GetJassNative('SetSoundVelocity');
	Pointer(_AttachSoundToUnit):= GetJassNative('AttachSoundToUnit');
	Pointer(_StartSound):= GetJassNative('StartSound');
	Pointer(_StopSound):= GetJassNative('StopSound');
	Pointer(_KillSoundWhenDone):= GetJassNative('KillSoundWhenDone');
	Pointer(_SetMapMusic):= GetJassNative('SetMapMusic');
	Pointer(_ClearMapMusic):= GetJassNative('ClearMapMusic');
	Pointer(_PlayMusic):= GetJassNative('PlayMusic');
	Pointer(_PlayMusicEx):= GetJassNative('PlayMusicEx');
	Pointer(_StopMusic):= GetJassNative('StopMusic');
	Pointer(_ResumeMusic):= GetJassNative('ResumeMusic');
	Pointer(_PlayThematicMusic):= GetJassNative('PlayThematicMusic');
	Pointer(_PlayThematicMusicEx):= GetJassNative('PlayThematicMusicEx');
	Pointer(_EndThematicMusic):= GetJassNative('EndThematicMusic');
	Pointer(_SetMusicVolume):= GetJassNative('SetMusicVolume');
	Pointer(_SetMusicPlayPosition):= GetJassNative('SetMusicPlayPosition');
	Pointer(_SetThematicMusicPlayPosition):= GetJassNative('SetThematicMusicPlayPosition');
	Pointer(_SetSoundDuration):= GetJassNative('SetSoundDuration');
	Pointer(_GetSoundDuration):= GetJassNative('GetSoundDuration');
	Pointer(_GetSoundFileDuration):= GetJassNative('GetSoundFileDuration');
	Pointer(_VolumeGroupSetVolume):= GetJassNative('VolumeGroupSetVolume');
	Pointer(_VolumeGroupReset):= GetJassNative('VolumeGroupReset');
	Pointer(_GetSoundIsPlaying):= GetJassNative('GetSoundIsPlaying');
	Pointer(_GetSoundIsLoading):= GetJassNative('GetSoundIsLoading');
	Pointer(_RegisterStackedSound):= GetJassNative('RegisterStackedSound');
	Pointer(_UnregisterStackedSound):= GetJassNative('UnregisterStackedSound');
	Pointer(_AddWeatherEffect):= GetJassNative('AddWeatherEffect');
	Pointer(_RemoveWeatherEffect):= GetJassNative('RemoveWeatherEffect');
	Pointer(_EnableWeatherEffect):= GetJassNative('EnableWeatherEffect');
	Pointer(_TerrainDeformCrater):= GetJassNative('TerrainDeformCrater');
	Pointer(_TerrainDeformRipple):= GetJassNative('TerrainDeformRipple');
	Pointer(_TerrainDeformWave):= GetJassNative('TerrainDeformWave');
	Pointer(_TerrainDeformRandom):= GetJassNative('TerrainDeformRandom');
	Pointer(_TerrainDeformStop):= GetJassNative('TerrainDeformStop');
	Pointer(_TerrainDeformStopAll):= GetJassNative('TerrainDeformStopAll');
	Pointer(_AddSpecialEffect):= GetJassNative('AddSpecialEffect');
	Pointer(_AddSpecialEffectLoc):= GetJassNative('AddSpecialEffectLoc');
	Pointer(_AddSpecialEffectTarget):= GetJassNative('AddSpecialEffectTarget');
	Pointer(_DestroyEffect):= GetJassNative('DestroyEffect');
	Pointer(_AddSpellEffect):= GetJassNative('AddSpellEffect');
	Pointer(_AddSpellEffectLoc):= GetJassNative('AddSpellEffectLoc');
	Pointer(_AddSpellEffectById):= GetJassNative('AddSpellEffectById');
	Pointer(_AddSpellEffectByIdLoc):= GetJassNative('AddSpellEffectByIdLoc');
	Pointer(_AddSpellEffectTarget):= GetJassNative('AddSpellEffectTarget');
	Pointer(_AddSpellEffectTargetById):= GetJassNative('AddSpellEffectTargetById');
	Pointer(_AddLightning):= GetJassNative('AddLightning');
	Pointer(_AddLightningEx):= GetJassNative('AddLightningEx');
	Pointer(_DestroyLightning):= GetJassNative('DestroyLightning');
	Pointer(_MoveLightning):= GetJassNative('MoveLightning');
	Pointer(_MoveLightningEx):= GetJassNative('MoveLightningEx');
	Pointer(_GetLightningColorA):= GetJassNative('GetLightningColorA');
	Pointer(_GetLightningColorR):= GetJassNative('GetLightningColorR');
	Pointer(_GetLightningColorG):= GetJassNative('GetLightningColorG');
	Pointer(_GetLightningColorB):= GetJassNative('GetLightningColorB');
	Pointer(_SetLightningColor):= GetJassNative('SetLightningColor');
	Pointer(_GetAbilityEffect):= GetJassNative('GetAbilityEffect');
	Pointer(_GetAbilityEffectById):= GetJassNative('GetAbilityEffectById');
	Pointer(_GetAbilitySound):= GetJassNative('GetAbilitySound');
	Pointer(_GetAbilitySoundById):= GetJassNative('GetAbilitySoundById');
	Pointer(_GetTerrainCliffLevel):= GetJassNative('GetTerrainCliffLevel');
	Pointer(_SetWaterBaseColor):= GetJassNative('SetWaterBaseColor');
	Pointer(_SetWaterDeforms):= GetJassNative('SetWaterDeforms');
	Pointer(_GetTerrainType):= GetJassNative('GetTerrainType');
	Pointer(_GetTerrainVariance):= GetJassNative('GetTerrainVariance');
	Pointer(_SetTerrainType):= GetJassNative('SetTerrainType');
	Pointer(_IsTerrainPathable):= GetJassNative('IsTerrainPathable');
	Pointer(_SetTerrainPathable):= GetJassNative('SetTerrainPathable');
	Pointer(_CreateImage):= GetJassNative('CreateImage');
	Pointer(_DestroyImage):= GetJassNative('DestroyImage');
	Pointer(_ShowImage):= GetJassNative('ShowImage');
	Pointer(_SetImageConstantHeight):= GetJassNative('SetImageConstantHeight');
	Pointer(_SetImagePosition):= GetJassNative('SetImagePosition');
	Pointer(_SetImageColor):= GetJassNative('SetImageColor');
	Pointer(_SetImageRender):= GetJassNative('SetImageRender');
	Pointer(_SetImageRenderAlways):= GetJassNative('SetImageRenderAlways');
	Pointer(_SetImageAboveWater):= GetJassNative('SetImageAboveWater');
	Pointer(_SetImageType):= GetJassNative('SetImageType');
	Pointer(_CreateUbersplat):= GetJassNative('CreateUbersplat');
	Pointer(_DestroyUbersplat):= GetJassNative('DestroyUbersplat');
	Pointer(_ResetUbersplat):= GetJassNative('ResetUbersplat');
	Pointer(_FinishUbersplat):= GetJassNative('FinishUbersplat');
	Pointer(_ShowUbersplat):= GetJassNative('ShowUbersplat');
	Pointer(_SetUbersplatRender):= GetJassNative('SetUbersplatRender');
	Pointer(_SetUbersplatRenderAlways):= GetJassNative('SetUbersplatRenderAlways');
	Pointer(_SetBlight):= GetJassNative('SetBlight');
	Pointer(_SetBlightRect):= GetJassNative('SetBlightRect');
	Pointer(_SetBlightPoint):= GetJassNative('SetBlightPoint');
	Pointer(_SetBlightLoc):= GetJassNative('SetBlightLoc');
	Pointer(_CreateBlightedGoldmine):= GetJassNative('CreateBlightedGoldmine');
	Pointer(_IsPointBlighted):= GetJassNative('IsPointBlighted');
	Pointer(_SetDoodadAnimation):= GetJassNative('SetDoodadAnimation');
	Pointer(_SetDoodadAnimationRect):= GetJassNative('SetDoodadAnimationRect');
	Pointer(_StartMeleeAI):= GetJassNative('StartMeleeAI');
	Pointer(_StartCampaignAI):= GetJassNative('StartCampaignAI');
	Pointer(_CommandAI):= GetJassNative('CommandAI');
	Pointer(_PauseCompAI):= GetJassNative('PauseCompAI');
	Pointer(_GetAIDifficulty):= GetJassNative('GetAIDifficulty');
	Pointer(_RemoveGuardPosition):= GetJassNative('RemoveGuardPosition');
	Pointer(_RecycleGuardPosition):= GetJassNative('RecycleGuardPosition');
	Pointer(_RemoveAllGuardPositions):= GetJassNative('RemoveAllGuardPositions');
	Pointer(_Cheat):= GetJassNative('Cheat');
	Pointer(_IsNoVictoryCheat):= GetJassNative('IsNoVictoryCheat');
	Pointer(_IsNoDefeatCheat):= GetJassNative('IsNoDefeatCheat');
	Pointer(_Preload):= GetJassNative('Preload');
	Pointer(_PreloadEnd):= GetJassNative('PreloadEnd');
	Pointer(_PreloadStart):= GetJassNative('PreloadStart');
	Pointer(_PreloadRefresh):= GetJassNative('PreloadRefresh');
	Pointer(_PreloadEndEx):= GetJassNative('PreloadEndEx');
	Pointer(_PreloadGenClear):= GetJassNative('PreloadGenClear');
	Pointer(_PreloadGenStart):= GetJassNative('PreloadGenStart');
	Pointer(_PreloadGenEnd):= GetJassNative('PreloadGenEnd');
	Pointer(_Preloader):= GetJassNative('Preloader');
	FALSE_:= True;
	TRUE_:= True;
	JASS_MAX_ARRAY_SIZE:= 8192;
	PLAYER_NEUTRAL_PASSIVE:= 15;
	PLAYER_NEUTRAL_AGGRESSIVE:= 12;
	PLAYER_COLOR_RED:= ConvertPlayerColor(0);
	PLAYER_COLOR_BLUE:= ConvertPlayerColor(1);
	PLAYER_COLOR_CYAN:= ConvertPlayerColor(2);
	PLAYER_COLOR_PURPLE:= ConvertPlayerColor(3);
	PLAYER_COLOR_YELLOW:= ConvertPlayerColor(4);
	PLAYER_COLOR_ORANGE:= ConvertPlayerColor(5);
	PLAYER_COLOR_GREEN:= ConvertPlayerColor(6);
	PLAYER_COLOR_PINK:= ConvertPlayerColor(7);
	PLAYER_COLOR_LIGHT_GRAY:= ConvertPlayerColor(8);
	PLAYER_COLOR_LIGHT_BLUE:= ConvertPlayerColor(9);
	PLAYER_COLOR_AQUA:= ConvertPlayerColor(10);
	PLAYER_COLOR_BROWN:= ConvertPlayerColor(11);
	RACE_HUMAN:= ConvertRace(1);
	RACE_ORC:= ConvertRace(2);
	RACE_UNDEAD:= ConvertRace(3);
	RACE_NIGHTELF:= ConvertRace(4);
	RACE_DEMON:= ConvertRace(5);
	RACE_OTHER:= ConvertRace(7);
	PLAYER_GAME_RESULT_VICTORY:= ConvertPlayerGameResult(0);
	PLAYER_GAME_RESULT_DEFEAT:= ConvertPlayerGameResult(1);
	PLAYER_GAME_RESULT_TIE:= ConvertPlayerGameResult(2);
	PLAYER_GAME_RESULT_NEUTRAL:= ConvertPlayerGameResult(3);
	ALLIANCE_PASSIVE:= ConvertAllianceType(0);
	ALLIANCE_HELP_REQUEST:= ConvertAllianceType(1);
	ALLIANCE_HELP_RESPONSE:= ConvertAllianceType(2);
	ALLIANCE_SHARED_XP:= ConvertAllianceType(3);
	ALLIANCE_SHARED_SPELLS:= ConvertAllianceType(4);
	ALLIANCE_SHARED_VISION:= ConvertAllianceType(5);
	ALLIANCE_SHARED_CONTROL:= ConvertAllianceType(6);
	ALLIANCE_SHARED_ADVANCED_CONTROL:= ConvertAllianceType(7);
	ALLIANCE_RESCUABLE:= ConvertAllianceType(8);
	ALLIANCE_SHARED_VISION_FORCED:= ConvertAllianceType(9);
	VERSION_REIGN_OF_CHAOS:= ConvertVersion(0);
	VERSION_FROZEN_THRONE:= ConvertVersion(1);
	ATTACK_TYPE_NORMAL:= ConvertAttackType(0);
	ATTACK_TYPE_MELEE:= ConvertAttackType(1);
	ATTACK_TYPE_PIERCE:= ConvertAttackType(2);
	ATTACK_TYPE_SIEGE:= ConvertAttackType(3);
	ATTACK_TYPE_MAGIC:= ConvertAttackType(4);
	ATTACK_TYPE_CHAOS:= ConvertAttackType(5);
	ATTACK_TYPE_HERO:= ConvertAttackType(6);
	DAMAGE_TYPE_UNKNOWN:= ConvertDamageType(0);
	DAMAGE_TYPE_NORMAL:= ConvertDamageType(4);
	DAMAGE_TYPE_ENHANCED:= ConvertDamageType(5);
	DAMAGE_TYPE_FIRE:= ConvertDamageType(8);
	DAMAGE_TYPE_COLD:= ConvertDamageType(9);
	DAMAGE_TYPE_LIGHTNING:= ConvertDamageType(10);
	DAMAGE_TYPE_POISON:= ConvertDamageType(11);
	DAMAGE_TYPE_DISEASE:= ConvertDamageType(12);
	DAMAGE_TYPE_DIVINE:= ConvertDamageType(13);
	DAMAGE_TYPE_MAGIC:= ConvertDamageType(14);
	DAMAGE_TYPE_SONIC:= ConvertDamageType(15);
	DAMAGE_TYPE_ACID:= ConvertDamageType(16);
	DAMAGE_TYPE_FORCE:= ConvertDamageType(17);
	DAMAGE_TYPE_DEATH:= ConvertDamageType(18);
	DAMAGE_TYPE_MIND:= ConvertDamageType(19);
	DAMAGE_TYPE_PLANT:= ConvertDamageType(20);
	DAMAGE_TYPE_DEFENSIVE:= ConvertDamageType(21);
	DAMAGE_TYPE_DEMOLITION:= ConvertDamageType(22);
	DAMAGE_TYPE_SLOW_POISON:= ConvertDamageType(23);
	DAMAGE_TYPE_SPIRIT_LINK:= ConvertDamageType(24);
	DAMAGE_TYPE_SHADOW_STRIKE:= ConvertDamageType(25);
	DAMAGE_TYPE_UNIVERSAL:= ConvertDamageType(26);
	WEAPON_TYPE_WHOKNOWS:= ConvertWeaponType(0);
	WEAPON_TYPE_METAL_LIGHT_CHOP:= ConvertWeaponType(1);
	WEAPON_TYPE_METAL_MEDIUM_CHOP:= ConvertWeaponType(2);
	WEAPON_TYPE_METAL_HEAVY_CHOP:= ConvertWeaponType(3);
	WEAPON_TYPE_METAL_LIGHT_SLICE:= ConvertWeaponType(4);
	WEAPON_TYPE_METAL_MEDIUM_SLICE:= ConvertWeaponType(5);
	WEAPON_TYPE_METAL_HEAVY_SLICE:= ConvertWeaponType(6);
	WEAPON_TYPE_METAL_MEDIUM_BASH:= ConvertWeaponType(7);
	WEAPON_TYPE_METAL_HEAVY_BASH:= ConvertWeaponType(8);
	WEAPON_TYPE_METAL_MEDIUM_STAB:= ConvertWeaponType(9);
	WEAPON_TYPE_METAL_HEAVY_STAB:= ConvertWeaponType(10);
	WEAPON_TYPE_WOOD_LIGHT_SLICE:= ConvertWeaponType(11);
	WEAPON_TYPE_WOOD_MEDIUM_SLICE:= ConvertWeaponType(12);
	WEAPON_TYPE_WOOD_HEAVY_SLICE:= ConvertWeaponType(13);
	WEAPON_TYPE_WOOD_LIGHT_BASH:= ConvertWeaponType(14);
	WEAPON_TYPE_WOOD_MEDIUM_BASH:= ConvertWeaponType(15);
	WEAPON_TYPE_WOOD_HEAVY_BASH:= ConvertWeaponType(16);
	WEAPON_TYPE_WOOD_LIGHT_STAB:= ConvertWeaponType(17);
	WEAPON_TYPE_WOOD_MEDIUM_STAB:= ConvertWeaponType(18);
	WEAPON_TYPE_CLAW_LIGHT_SLICE:= ConvertWeaponType(19);
	WEAPON_TYPE_CLAW_MEDIUM_SLICE:= ConvertWeaponType(20);
	WEAPON_TYPE_CLAW_HEAVY_SLICE:= ConvertWeaponType(21);
	WEAPON_TYPE_AXE_MEDIUM_CHOP:= ConvertWeaponType(22);
	WEAPON_TYPE_ROCK_HEAVY_BASH:= ConvertWeaponType(23);
	PATHING_TYPE_ANY:= ConvertPathingType(0);
	PATHING_TYPE_WALKABILITY:= ConvertPathingType(1);
	PATHING_TYPE_FLYABILITY:= ConvertPathingType(2);
	PATHING_TYPE_BUILDABILITY:= ConvertPathingType(3);
	PATHING_TYPE_PEONHARVESTPATHING:= ConvertPathingType(4);
	PATHING_TYPE_BLIGHTPATHING:= ConvertPathingType(5);
	PATHING_TYPE_FLOATABILITY:= ConvertPathingType(6);
	PATHING_TYPE_AMPHIBIOUSPATHING:= ConvertPathingType(7);
	RACE_PREF_HUMAN:= ConvertRacePref(1);
	RACE_PREF_ORC:= ConvertRacePref(2);
	RACE_PREF_NIGHTELF:= ConvertRacePref(4);
	RACE_PREF_UNDEAD:= ConvertRacePref(8);
	RACE_PREF_DEMON:= ConvertRacePref(16);
	RACE_PREF_RANDOM:= ConvertRacePref(32);
	RACE_PREF_USER_SELECTABLE:= ConvertRacePref(64);
	MAP_CONTROL_USER:= ConvertMapControl(0);
	MAP_CONTROL_COMPUTER:= ConvertMapControl(1);
	MAP_CONTROL_RESCUABLE:= ConvertMapControl(2);
	MAP_CONTROL_NEUTRAL:= ConvertMapControl(3);
	MAP_CONTROL_CREEP:= ConvertMapControl(4);
	MAP_CONTROL_NONE:= ConvertMapControl(5);
	GAME_TYPE_MELEE:= ConvertGameType(1);
	GAME_TYPE_FFA:= ConvertGameType(2);
	GAME_TYPE_USE_MAP_SETTINGS:= ConvertGameType(4);
	GAME_TYPE_BLIZ:= ConvertGameType(8);
	GAME_TYPE_ONE_ON_ONE:= ConvertGameType(16);
	GAME_TYPE_TWO_TEAM_PLAY:= ConvertGameType(32);
	GAME_TYPE_THREE_TEAM_PLAY:= ConvertGameType(64);
	GAME_TYPE_FOUR_TEAM_PLAY:= ConvertGameType(128);
	MAP_FOG_HIDE_TERRAIN:= ConvertMapFlag(1);
	MAP_FOG_MAP_EXPLORED:= ConvertMapFlag(2);
	MAP_FOG_ALWAYS_VISIBLE:= ConvertMapFlag(4);
	MAP_USE_HANDICAPS:= ConvertMapFlag(8);
	MAP_OBSERVERS:= ConvertMapFlag(16);
	MAP_OBSERVERS_ON_DEATH:= ConvertMapFlag(32);
	MAP_FIXED_COLORS:= ConvertMapFlag(128);
	MAP_LOCK_RESOURCE_TRADING:= ConvertMapFlag(256);
	MAP_RESOURCE_TRADING_ALLIES_ONLY:= ConvertMapFlag(512);
	MAP_LOCK_ALLIANCE_CHANGES:= ConvertMapFlag(1024);
	MAP_ALLIANCE_CHANGES_HIDDEN:= ConvertMapFlag(2048);
	MAP_CHEATS:= ConvertMapFlag(4096);
	MAP_CHEATS_HIDDEN:= ConvertMapFlag(8192);
	MAP_LOCK_SPEED:= ConvertMapFlag(8192*2);
	MAP_LOCK_RANDOM_SEED:= ConvertMapFlag(8192*4);
	MAP_SHARED_ADVANCED_CONTROL:= ConvertMapFlag(8192*8);
	MAP_RANDOM_HERO:= ConvertMapFlag(8192*16);
	MAP_RANDOM_RACES:= ConvertMapFlag(8192*32);
	MAP_RELOADED:= ConvertMapFlag(8192*64);
	MAP_PLACEMENT_RANDOM:= ConvertPlacement(0);
	MAP_PLACEMENT_FIXED:= ConvertPlacement(1);
	MAP_PLACEMENT_USE_MAP_SETTINGS:= ConvertPlacement(2);
	MAP_PLACEMENT_TEAMS_TOGETHER:= ConvertPlacement(3);
	MAP_LOC_PRIO_LOW:= ConvertStartLocPrio(0);
	MAP_LOC_PRIO_HIGH:= ConvertStartLocPrio(1);
	MAP_LOC_PRIO_NOT:= ConvertStartLocPrio(2);
	MAP_DENSITY_NONE:= ConvertMapDensity(0);
	MAP_DENSITY_LIGHT:= ConvertMapDensity(1);
	MAP_DENSITY_MEDIUM:= ConvertMapDensity(2);
	MAP_DENSITY_HEAVY:= ConvertMapDensity(3);
	MAP_DIFFICULTY_EASY:= ConvertGameDifficulty(0);
	MAP_DIFFICULTY_NORMAL:= ConvertGameDifficulty(1);
	MAP_DIFFICULTY_HARD:= ConvertGameDifficulty(2);
	MAP_DIFFICULTY_INSANE:= ConvertGameDifficulty(3);
	MAP_SPEED_SLOWEST:= ConvertGameSpeed(0);
	MAP_SPEED_SLOW:= ConvertGameSpeed(1);
	MAP_SPEED_NORMAL:= ConvertGameSpeed(2);
	MAP_SPEED_FAST:= ConvertGameSpeed(3);
	MAP_SPEED_FASTEST:= ConvertGameSpeed(4);
	PLAYER_SLOT_STATE_EMPTY:= ConvertPlayerSlotState(0);
	PLAYER_SLOT_STATE_PLAYING:= ConvertPlayerSlotState(1);
	PLAYER_SLOT_STATE_LEFT:= ConvertPlayerSlotState(2);
	SOUND_VOLUMEGROUP_UNITMOVEMENT:= ConvertVolumeGroup(0);
	SOUND_VOLUMEGROUP_UNITSOUNDS:= ConvertVolumeGroup(1);
	SOUND_VOLUMEGROUP_COMBAT:= ConvertVolumeGroup(2);
	SOUND_VOLUMEGROUP_SPELLS:= ConvertVolumeGroup(3);
	SOUND_VOLUMEGROUP_UI:= ConvertVolumeGroup(4);
	SOUND_VOLUMEGROUP_MUSIC:= ConvertVolumeGroup(5);
	SOUND_VOLUMEGROUP_AMBIENTSOUNDS:= ConvertVolumeGroup(6);
	SOUND_VOLUMEGROUP_FIRE:= ConvertVolumeGroup(7);
	GAME_STATE_DIVINE_INTERVENTION:= ConvertIGameState(0);
	GAME_STATE_DISCONNECTED:= ConvertIGameState(1);
	GAME_STATE_TIME_OF_DAY:= ConvertFGameState(2);
	PLAYER_STATE_GAME_RESULT:= ConvertPlayerState(0);
	PLAYER_STATE_RESOURCE_GOLD:= ConvertPlayerState(1);
	PLAYER_STATE_RESOURCE_LUMBER:= ConvertPlayerState(2);
	PLAYER_STATE_RESOURCE_HERO_TOKENS:= ConvertPlayerState(3);
	PLAYER_STATE_RESOURCE_FOOD_CAP:= ConvertPlayerState(4);
	PLAYER_STATE_RESOURCE_FOOD_USED:= ConvertPlayerState(5);
	PLAYER_STATE_FOOD_CAP_CEILING:= ConvertPlayerState(6);
	PLAYER_STATE_GIVES_BOUNTY:= ConvertPlayerState(7);
	PLAYER_STATE_ALLIED_VICTORY:= ConvertPlayerState(8);
	PLAYER_STATE_PLACED:= ConvertPlayerState(9);
	PLAYER_STATE_OBSERVER_ON_DEATH:= ConvertPlayerState(10);
	PLAYER_STATE_OBSERVER:= ConvertPlayerState(11);
	PLAYER_STATE_UNFOLLOWABLE:= ConvertPlayerState(12);
	PLAYER_STATE_GOLD_UPKEEP_RATE:= ConvertPlayerState(13);
	PLAYER_STATE_LUMBER_UPKEEP_RATE:= ConvertPlayerState(14);
	PLAYER_STATE_GOLD_GATHERED:= ConvertPlayerState(15);
	PLAYER_STATE_LUMBER_GATHERED:= ConvertPlayerState(16);
	PLAYER_STATE_NO_CREEP_SLEEP:= ConvertPlayerState(25);
	UNIT_STATE_LIFE:= ConvertUnitState(0);
	UNIT_STATE_MAX_LIFE:= ConvertUnitState(1);
	UNIT_STATE_MANA:= ConvertUnitState(2);
	UNIT_STATE_MAX_MANA:= ConvertUnitState(3);
	AI_DIFFICULTY_NEWBIE:= ConvertAIDifficulty(0);
	AI_DIFFICULTY_NORMAL:= ConvertAIDifficulty(1);
	AI_DIFFICULTY_INSANE:= ConvertAIDifficulty(2);
	PLAYER_SCORE_UNITS_TRAINED:= ConvertPlayerScore(0);
	PLAYER_SCORE_UNITS_KILLED:= ConvertPlayerScore(1);
	PLAYER_SCORE_STRUCT_BUILT:= ConvertPlayerScore(2);
	PLAYER_SCORE_STRUCT_RAZED:= ConvertPlayerScore(3);
	PLAYER_SCORE_TECH_PERCENT:= ConvertPlayerScore(4);
	PLAYER_SCORE_FOOD_MAXPROD:= ConvertPlayerScore(5);
	PLAYER_SCORE_FOOD_MAXUSED:= ConvertPlayerScore(6);
	PLAYER_SCORE_HEROES_KILLED:= ConvertPlayerScore(7);
	PLAYER_SCORE_ITEMS_GAINED:= ConvertPlayerScore(8);
	PLAYER_SCORE_MERCS_HIRED:= ConvertPlayerScore(9);
	PLAYER_SCORE_GOLD_MINED_TOTAL:= ConvertPlayerScore(10);
	PLAYER_SCORE_GOLD_MINED_UPKEEP:= ConvertPlayerScore(11);
	PLAYER_SCORE_GOLD_LOST_UPKEEP:= ConvertPlayerScore(12);
	PLAYER_SCORE_GOLD_LOST_TAX:= ConvertPlayerScore(13);
	PLAYER_SCORE_GOLD_GIVEN:= ConvertPlayerScore(14);
	PLAYER_SCORE_GOLD_RECEIVED:= ConvertPlayerScore(15);
	PLAYER_SCORE_LUMBER_TOTAL:= ConvertPlayerScore(16);
	PLAYER_SCORE_LUMBER_LOST_UPKEEP:= ConvertPlayerScore(17);
	PLAYER_SCORE_LUMBER_LOST_TAX:= ConvertPlayerScore(18);
	PLAYER_SCORE_LUMBER_GIVEN:= ConvertPlayerScore(19);
	PLAYER_SCORE_LUMBER_RECEIVED:= ConvertPlayerScore(20);
	PLAYER_SCORE_UNIT_TOTAL:= ConvertPlayerScore(21);
	PLAYER_SCORE_HERO_TOTAL:= ConvertPlayerScore(22);
	PLAYER_SCORE_RESOURCE_TOTAL:= ConvertPlayerScore(23);
	PLAYER_SCORE_TOTAL:= ConvertPlayerScore(24);
	EVENT_GAME_VICTORY:= ConvertGameEvent(0);
	EVENT_GAME_END_LEVEL:= ConvertGameEvent(1);
	EVENT_GAME_VARIABLE_LIMIT:= ConvertGameEvent(2);
	EVENT_GAME_STATE_LIMIT:= ConvertGameEvent(3);
	EVENT_GAME_TIMER_EXPIRED:= ConvertGameEvent(4);
	EVENT_GAME_ENTER_REGION:= ConvertGameEvent(5);
	EVENT_GAME_LEAVE_REGION:= ConvertGameEvent(6);
	EVENT_GAME_TRACKABLE_HIT:= ConvertGameEvent(7);
	EVENT_GAME_TRACKABLE_TRACK:= ConvertGameEvent(8);
	EVENT_GAME_SHOW_SKILL:= ConvertGameEvent(9);
	EVENT_GAME_BUILD_SUBMENU:= ConvertGameEvent(10);
	EVENT_PLAYER_STATE_LIMIT:= ConvertPlayerEvent(11);
	EVENT_PLAYER_ALLIANCE_CHANGED:= ConvertPlayerEvent(12);
	EVENT_PLAYER_DEFEAT:= ConvertPlayerEvent(13);
	EVENT_PLAYER_VICTORY:= ConvertPlayerEvent(14);
	EVENT_PLAYER_LEAVE:= ConvertPlayerEvent(15);
	EVENT_PLAYER_CHAT:= ConvertPlayerEvent(16);
	EVENT_PLAYER_END_CINEMATIC:= ConvertPlayerEvent(17);
	EVENT_PLAYER_UNIT_ATTACKED:= ConvertPlayerUnitEvent(18);
	EVENT_PLAYER_UNIT_RESCUED:= ConvertPlayerUnitEvent(19);
	EVENT_PLAYER_UNIT_DEATH:= ConvertPlayerUnitEvent(20);
	EVENT_PLAYER_UNIT_DECAY:= ConvertPlayerUnitEvent(21);
	EVENT_PLAYER_UNIT_DETECTED:= ConvertPlayerUnitEvent(22);
	EVENT_PLAYER_UNIT_HIDDEN:= ConvertPlayerUnitEvent(23);
	EVENT_PLAYER_UNIT_SELECTED:= ConvertPlayerUnitEvent(24);
	EVENT_PLAYER_UNIT_DESELECTED:= ConvertPlayerUnitEvent(25);
	EVENT_PLAYER_UNIT_CONSTRUCT_START:= ConvertPlayerUnitEvent(26);
	EVENT_PLAYER_UNIT_CONSTRUCT_CANCEL:= ConvertPlayerUnitEvent(27);
	EVENT_PLAYER_UNIT_CONSTRUCT_FINISH:= ConvertPlayerUnitEvent(28);
	EVENT_PLAYER_UNIT_UPGRADE_START:= ConvertPlayerUnitEvent(29);
	EVENT_PLAYER_UNIT_UPGRADE_CANCEL:= ConvertPlayerUnitEvent(30);
	EVENT_PLAYER_UNIT_UPGRADE_FINISH:= ConvertPlayerUnitEvent(31);
	EVENT_PLAYER_UNIT_TRAIN_START:= ConvertPlayerUnitEvent(32);
	EVENT_PLAYER_UNIT_TRAIN_CANCEL:= ConvertPlayerUnitEvent(33);
	EVENT_PLAYER_UNIT_TRAIN_FINISH:= ConvertPlayerUnitEvent(34);
	EVENT_PLAYER_UNIT_RESEARCH_START:= ConvertPlayerUnitEvent(35);
	EVENT_PLAYER_UNIT_RESEARCH_CANCEL:= ConvertPlayerUnitEvent(36);
	EVENT_PLAYER_UNIT_RESEARCH_FINISH:= ConvertPlayerUnitEvent(37);
	EVENT_PLAYER_UNIT_ISSUED_ORDER:= ConvertPlayerUnitEvent(38);
	EVENT_PLAYER_UNIT_ISSUED_POINT_ORDER:= ConvertPlayerUnitEvent(39);
	EVENT_PLAYER_UNIT_ISSUED_TARGET_ORDER:= ConvertPlayerUnitEvent(40);
	EVENT_PLAYER_UNIT_ISSUED_UNIT_ORDER:= ConvertPlayerUnitEvent(40);
	EVENT_PLAYER_HERO_LEVEL:= ConvertPlayerUnitEvent(41);
	EVENT_PLAYER_HERO_SKILL:= ConvertPlayerUnitEvent(42);
	EVENT_PLAYER_HERO_REVIVABLE:= ConvertPlayerUnitEvent(43);
	EVENT_PLAYER_HERO_REVIVE_START:= ConvertPlayerUnitEvent(44);
	EVENT_PLAYER_HERO_REVIVE_CANCEL:= ConvertPlayerUnitEvent(45);
	EVENT_PLAYER_HERO_REVIVE_FINISH:= ConvertPlayerUnitEvent(46);
	EVENT_PLAYER_UNIT_SUMMON:= ConvertPlayerUnitEvent(47);
	EVENT_PLAYER_UNIT_DROP_ITEM:= ConvertPlayerUnitEvent(48);
	EVENT_PLAYER_UNIT_PICKUP_ITEM:= ConvertPlayerUnitEvent(49);
	EVENT_PLAYER_UNIT_USE_ITEM:= ConvertPlayerUnitEvent(50);
	EVENT_PLAYER_UNIT_LOADED:= ConvertPlayerUnitEvent(51);
	EVENT_UNIT_DAMAGED:= ConvertUnitEvent(52);
	EVENT_UNIT_DEATH:= ConvertUnitEvent(53);
	EVENT_UNIT_DECAY:= ConvertUnitEvent(54);
	EVENT_UNIT_DETECTED:= ConvertUnitEvent(55);
	EVENT_UNIT_HIDDEN:= ConvertUnitEvent(56);
	EVENT_UNIT_SELECTED:= ConvertUnitEvent(57);
	EVENT_UNIT_DESELECTED:= ConvertUnitEvent(58);
	EVENT_UNIT_STATE_LIMIT:= ConvertUnitEvent(59);
	EVENT_UNIT_ACQUIRED_TARGET:= ConvertUnitEvent(60);
	EVENT_UNIT_TARGET_IN_RANGE:= ConvertUnitEvent(61);
	EVENT_UNIT_ATTACKED:= ConvertUnitEvent(62);
	EVENT_UNIT_RESCUED:= ConvertUnitEvent(63);
	EVENT_UNIT_CONSTRUCT_CANCEL:= ConvertUnitEvent(64);
	EVENT_UNIT_CONSTRUCT_FINISH:= ConvertUnitEvent(65);
	EVENT_UNIT_UPGRADE_START:= ConvertUnitEvent(66);
	EVENT_UNIT_UPGRADE_CANCEL:= ConvertUnitEvent(67);
	EVENT_UNIT_UPGRADE_FINISH:= ConvertUnitEvent(68);
	EVENT_UNIT_TRAIN_START:= ConvertUnitEvent(69);
	EVENT_UNIT_TRAIN_CANCEL:= ConvertUnitEvent(70);
	EVENT_UNIT_TRAIN_FINISH:= ConvertUnitEvent(71);
	EVENT_UNIT_RESEARCH_START:= ConvertUnitEvent(72);
	EVENT_UNIT_RESEARCH_CANCEL:= ConvertUnitEvent(73);
	EVENT_UNIT_RESEARCH_FINISH:= ConvertUnitEvent(74);
	EVENT_UNIT_ISSUED_ORDER:= ConvertUnitEvent(75);
	EVENT_UNIT_ISSUED_POINT_ORDER:= ConvertUnitEvent(76);
	EVENT_UNIT_ISSUED_TARGET_ORDER:= ConvertUnitEvent(77);
	EVENT_UNIT_HERO_LEVEL:= ConvertUnitEvent(78);
	EVENT_UNIT_HERO_SKILL:= ConvertUnitEvent(79);
	EVENT_UNIT_HERO_REVIVABLE:= ConvertUnitEvent(80);
	EVENT_UNIT_HERO_REVIVE_START:= ConvertUnitEvent(81);
	EVENT_UNIT_HERO_REVIVE_CANCEL:= ConvertUnitEvent(82);
	EVENT_UNIT_HERO_REVIVE_FINISH:= ConvertUnitEvent(83);
	EVENT_UNIT_SUMMON:= ConvertUnitEvent(84);
	EVENT_UNIT_DROP_ITEM:= ConvertUnitEvent(85);
	EVENT_UNIT_PICKUP_ITEM:= ConvertUnitEvent(86);
	EVENT_UNIT_USE_ITEM:= ConvertUnitEvent(87);
	EVENT_UNIT_LOADED:= ConvertUnitEvent(88);
	EVENT_WIDGET_DEATH:= ConvertWidgetEvent(89);
	EVENT_DIALOG_BUTTON_CLICK:= ConvertDialogEvent(90);
	EVENT_DIALOG_CLICK:= ConvertDialogEvent(91);
	EVENT_GAME_LOADED:= ConvertGameEvent(256);
	EVENT_GAME_TOURNAMENT_FINISH_SOON:= ConvertGameEvent(257);
	EVENT_GAME_TOURNAMENT_FINISH_NOW:= ConvertGameEvent(258);
	EVENT_GAME_SAVE:= ConvertGameEvent(259);
	EVENT_PLAYER_ARROW_LEFT_DOWN:= ConvertPlayerEvent(261);
	EVENT_PLAYER_ARROW_LEFT_UP:= ConvertPlayerEvent(262);
	EVENT_PLAYER_ARROW_RIGHT_DOWN:= ConvertPlayerEvent(263);
	EVENT_PLAYER_ARROW_RIGHT_UP:= ConvertPlayerEvent(264);
	EVENT_PLAYER_ARROW_DOWN_DOWN:= ConvertPlayerEvent(265);
	EVENT_PLAYER_ARROW_DOWN_UP:= ConvertPlayerEvent(266);
	EVENT_PLAYER_ARROW_UP_DOWN:= ConvertPlayerEvent(267);
	EVENT_PLAYER_ARROW_UP_UP:= ConvertPlayerEvent(268);
	EVENT_PLAYER_UNIT_SELL:= ConvertPlayerUnitEvent(269);
	EVENT_PLAYER_UNIT_CHANGE_OWNER:= ConvertPlayerUnitEvent(270);
	EVENT_PLAYER_UNIT_SELL_ITEM:= ConvertPlayerUnitEvent(271);
	EVENT_PLAYER_UNIT_SPELL_CHANNEL:= ConvertPlayerUnitEvent(272);
	EVENT_PLAYER_UNIT_SPELL_CAST:= ConvertPlayerUnitEvent(273);
	EVENT_PLAYER_UNIT_SPELL_EFFECT:= ConvertPlayerUnitEvent(274);
	EVENT_PLAYER_UNIT_SPELL_FINISH:= ConvertPlayerUnitEvent(275);
	EVENT_PLAYER_UNIT_SPELL_ENDCAST:= ConvertPlayerUnitEvent(276);
	EVENT_PLAYER_UNIT_PAWN_ITEM:= ConvertPlayerUnitEvent(277);
	EVENT_UNIT_SELL:= ConvertUnitEvent(286);
	EVENT_UNIT_CHANGE_OWNER:= ConvertUnitEvent(287);
	EVENT_UNIT_SELL_ITEM:= ConvertUnitEvent(288);
	EVENT_UNIT_SPELL_CHANNEL:= ConvertUnitEvent(289);
	EVENT_UNIT_SPELL_CAST:= ConvertUnitEvent(290);
	EVENT_UNIT_SPELL_EFFECT:= ConvertUnitEvent(291);
	EVENT_UNIT_SPELL_FINISH:= ConvertUnitEvent(292);
	EVENT_UNIT_SPELL_ENDCAST:= ConvertUnitEvent(293);
	EVENT_UNIT_PAWN_ITEM:= ConvertUnitEvent(294);
	LESS_THAN:= ConvertLimitOp(0);
	LESS_THAN_OR_EQUAL:= ConvertLimitOp(1);
	EQUAL:= ConvertLimitOp(2);
	GREATER_THAN_OR_EQUAL:= ConvertLimitOp(3);
	GREATER_THAN:= ConvertLimitOp(4);
	NOT_EQUAL:= ConvertLimitOp(5);
	UNIT_TYPE_HERO:= ConvertUnitType(0);
	UNIT_TYPE_DEAD:= ConvertUnitType(1);
	UNIT_TYPE_STRUCTURE:= ConvertUnitType(2);
	UNIT_TYPE_FLYING:= ConvertUnitType(3);
	UNIT_TYPE_GROUND:= ConvertUnitType(4);
	UNIT_TYPE_ATTACKS_FLYING:= ConvertUnitType(5);
	UNIT_TYPE_ATTACKS_GROUND:= ConvertUnitType(6);
	UNIT_TYPE_MELEE_ATTACKER:= ConvertUnitType(7);
	UNIT_TYPE_RANGED_ATTACKER:= ConvertUnitType(8);
	UNIT_TYPE_GIANT:= ConvertUnitType(9);
	UNIT_TYPE_SUMMONED:= ConvertUnitType(10);
	UNIT_TYPE_STUNNED:= ConvertUnitType(11);
	UNIT_TYPE_PLAGUED:= ConvertUnitType(12);
	UNIT_TYPE_SNARED:= ConvertUnitType(13);
	UNIT_TYPE_UNDEAD:= ConvertUnitType(14);
	UNIT_TYPE_MECHANICAL:= ConvertUnitType(15);
	UNIT_TYPE_PEON:= ConvertUnitType(16);
	UNIT_TYPE_SAPPER:= ConvertUnitType(17);
	UNIT_TYPE_TOWNHALL:= ConvertUnitType(18);
	UNIT_TYPE_ANCIENT:= ConvertUnitType(19);
	UNIT_TYPE_TAUREN:= ConvertUnitType(20);
	UNIT_TYPE_POISONED:= ConvertUnitType(21);
	UNIT_TYPE_POLYMORPHED:= ConvertUnitType(22);
	UNIT_TYPE_SLEEPING:= ConvertUnitType(23);
	UNIT_TYPE_RESISTANT:= ConvertUnitType(24);
	UNIT_TYPE_ETHEREAL:= ConvertUnitType(25);
	UNIT_TYPE_MAGIC_IMMUNE:= ConvertUnitType(26);
	ITEM_TYPE_PERMANENT:= ConvertItemType(0);
	ITEM_TYPE_CHARGED:= ConvertItemType(1);
	ITEM_TYPE_POWERUP:= ConvertItemType(2);
	ITEM_TYPE_ARTIFACT:= ConvertItemType(3);
	ITEM_TYPE_PURCHASABLE:= ConvertItemType(4);
	ITEM_TYPE_CAMPAIGN:= ConvertItemType(5);
	ITEM_TYPE_MISCELLANEOUS:= ConvertItemType(6);
	ITEM_TYPE_UNKNOWN:= ConvertItemType(7);
	ITEM_TYPE_ANY:= ConvertItemType(8);
	ITEM_TYPE_TOME:= ConvertItemType(2);
	CAMERA_FIELD_TARGET_DISTANCE:= ConvertCameraField(0);
	CAMERA_FIELD_FARZ:= ConvertCameraField(1);
	CAMERA_FIELD_ANGLE_OF_ATTACK:= ConvertCameraField(2);
	CAMERA_FIELD_FIELD_OF_VIEW:= ConvertCameraField(3);
	CAMERA_FIELD_ROLL:= ConvertCameraField(4);
	CAMERA_FIELD_ROTATION:= ConvertCameraField(5);
	CAMERA_FIELD_ZOFFSET:= ConvertCameraField(6);
	BLEND_MODE_NONE:= ConvertBlendMode(0);
	BLEND_MODE_DONT_CARE:= ConvertBlendMode(0);
	BLEND_MODE_KEYALPHA:= ConvertBlendMode(1);
	BLEND_MODE_BLEND:= ConvertBlendMode(2);
	BLEND_MODE_ADDITIVE:= ConvertBlendMode(3);
	BLEND_MODE_MODULATE:= ConvertBlendMode(4);
	BLEND_MODE_MODULATE_2X:= ConvertBlendMode(5);
	RARITY_FREQUENT:= ConvertRarityControl(0);
	RARITY_RARE:= ConvertRarityControl(1);
	TEXMAP_FLAG_NONE:= ConvertTexMapFlags(0);
	TEXMAP_FLAG_WRAP_U:= ConvertTexMapFlags(1);
	TEXMAP_FLAG_WRAP_V:= ConvertTexMapFlags(2);
	TEXMAP_FLAG_WRAP_UV:= ConvertTexMapFlags(3);
	FOG_OF_WAR_MASKED:= ConvertFogState(1);
	FOG_OF_WAR_FOGGED:= ConvertFogState(2);
	FOG_OF_WAR_VISIBLE:= ConvertFogState(4);
	CAMERA_MARGIN_LEFT:= 0;
	CAMERA_MARGIN_RIGHT:= 1;
	CAMERA_MARGIN_TOP:= 2;
	CAMERA_MARGIN_BOTTOM:= 3;
	EFFECT_TYPE_EFFECT:= ConvertEffectType(0);
	EFFECT_TYPE_TARGET:= ConvertEffectType(1);
	EFFECT_TYPE_CASTER:= ConvertEffectType(2);
	EFFECT_TYPE_SPECIAL:= ConvertEffectType(3);
	EFFECT_TYPE_AREA_EFFECT:= ConvertEffectType(4);
	EFFECT_TYPE_MISSILE:= ConvertEffectType(5);
	EFFECT_TYPE_LIGHTNING:= ConvertEffectType(6);
	SOUND_TYPE_EFFECT:= ConvertSoundType(0);
	SOUND_TYPE_EFFECT_LOOPED:= ConvertSoundType(1);
end;

procedure OnMainBeingCalled({%H-}AParameter: Pointer); stdcall;
begin
	Init;
end;

var
	EventRegistrationHandle: TEventRegistrationHandle;

initialization
	EventRegistrationHandle:= AddEventHandler(
		jeMainBeingCalled,
		@OnMainBeingCalled,
		nil
	);
	Init;

finalization
	RemoveEventHandler(EventRegistrationHandle);

end.

